//=========================================================
//
// AI_実装ファイル_評価関数関係
//
//=========================================================
#include "pch.h"

#include <stdio.h>
#include "AI.h"
#include "InnerExpression.h"
#include "../Utils/Utils_Cal.h"
#include "../Utils/Utils_Convert.h"
#include "../Utils/Allocator.h"


using namespace AI_Modules;


//=========================================================
// 指定位置から相手陣までの最短論理距離（手数）を求める
//【引数】局面、どっちの立場で評価しますか？
//=========================================================
int AI::GetDistanceToGoal ( InnerExpression* innerExpression, int forThisTurn, int x, int y, int entryAngle, int stepsSoFar, int momentumSoFar ) {
	
	//_passedGridList_GetDistanceToGoal.clear();
	
	/*
	int length = sizeof(_passReminderY_GetDistanceToGoal) / sizeof(int);
	for ( int i = 0; i < length; ++i ) {
		_passReminderY_GetDistanceToGoal[i] = 0;
	}
	*/
	/*
	for ( unsigned int y = 0; y < 9; ++y ) {
		for ( unsigned int x = 0; x < 9; ++x ) {
			_passReminderYX_GetDistanceToGoal[y][x] = 0;
		}
	}
	*/
	memcpy ( _passReminderYX_GetDistanceToGoal, _passReminderYX_GetDistanceToGoal_Init, sizeof(_passReminderYX_GetDistanceToGoal_Init));
	
	
	_ie_GetDistanceToGoal = innerExpression;
	
	//int result = GetDistanceToGoal ( 99999, _passedGridList_GetDistanceToGoal, forThisTurn, x, y, entryAngle, stepsSoFar, momentumSoFar );
	int result = GetDistanceToGoal ( 99999, forThisTurn, x, y, entryAngle, stepsSoFar, momentumSoFar );
	
	//printf ( "LeftOver : [%d]\n", _passedGridList_GetDistanceToGoal.size() );
	
	//_passedGridList_GetDistanceToGoal.clear();
	
	return result;
	
}
//int AI::GetDistanceToGoal ( int currentMinSteps,  set<int> &passedGridList_GetDistanceToGoal, const int &forThisTurn, const int &x, const int &y, int entryAngle, int stepsSoFar, int momentumSoFar ) {
int AI::GetDistanceToGoal ( int currentMinSteps,  const int &forThisTurn, const int &x, const int &y, int entryAngle, int stepsSoFar, int momentumSoFar ) {
	
	Parameters_DistanceToGoal params = _parameters_PieceEvaluation.parameters_DistanceToGoal;
	
	int result = stepsSoFar;
	
	//int gridIndex = y * 100 + x;
	
	//printf ("%s(%d, %d) %d\n", (forThisTurn == TURN::BLACK)?"Black":"White", x, y, gridIndex);
	
	// 遠すぎる場合、適当に打ち切る
	if ( stepsSoFar > params.distanceLimit ) {
		return stepsSoFar;
	}
	
	/* これは各方向への分岐の際に、「もぐるかどうか」で判定しているので、不要のはず
	// これまでの最短を超過しているなら、ここで打ち切る
	if ( stepsSoFar >= currentMinSteps ) {
		return 99999;//stepsSoFar;
	}
	*/
	
	// 通行済みのグリッドに達したらそこで終わる
	if ( _passReminderYX_GetDistanceToGoal[y][x] == 1 ) {
		
		//printf ("EntryAngle[%d] already passed[%d] :  %s(%d, %d) %d\n",entryAngle ,passedGridList_GetDistanceToGoal.size(), (forThisTurn == TURN::BLACK)?"Black":"White", x, y, gridIndex);
		return 99999;
		
	} else {
		_passReminderYX_GetDistanceToGoal[y][x] = 1;
	}
	
	
	int myUp        = DIRECTION::UP;
	int myUpLeft    = DIRECTION::LEFT_UP;
	int myUpRight   = DIRECTION::RIGHT_UP;
	int myDown      = DIRECTION::DOWN;
	int myDownLeft  = DIRECTION::LEFT_DOWN;
	int myDownRight = DIRECTION::RIGHT_DOWN;
	
	int myColor = GRID::BLACK;
	int opColor = GRID::WHITE;
	int myGoalY = 0 + params.goalHeight;
	int myGoalYSign = -1;
	int myMustToUp   = THROUGHABLE_INFO::MUST_TO_UP;
	int myMustToDown = THROUGHABLE_INFO::MUST_TO_DOWN;
	
	if ( forThisTurn == TURN::WHITE ) {
		myUp        = DIRECTION::DOWN;
		myUpLeft    = DIRECTION::LEFT_DOWN;
		myUpRight   = DIRECTION::RIGHT_DOWN;
		myDown      = DIRECTION::UP;
		myDownLeft  = DIRECTION::LEFT_UP;
		myDownRight = DIRECTION::RIGHT_UP;
		
		myColor = GRID::WHITE;
		opColor = GRID::BLACK;
		myGoalY = (_rule.boardHeight - 1) - params.goalHeight;
		myGoalYSign = 1;
		myMustToUp   = THROUGHABLE_INFO::MUST_TO_DOWN;
		myMustToDown = THROUGHABLE_INFO::MUST_TO_UP;
	}
	
	// ゴール判定
	bool isReached = false;
	if ( forThisTurn == TURN::BLACK ) {
		if ( y <= myGoalY ) { isReached = true; }
	}
	else if ( forThisTurn == TURN::WHITE ) {
		if ( y >= myGoalY ) { isReached = true; }
	}
	
	if ( isReached ) {
		
		//printf ("Goal Reached : EntryAngle[%d] already passed[%d] :  %s(%d, %d) %d\n",entryAngle ,passedGridList_GetDistanceToGoal.size(), (forThisTurn == TURN::BLACK)?"Black":"White", x, y, gridIndex);
		
		_passReminderYX_GetDistanceToGoal[y][x] = 0;
		return result;
	}
	
	// 現在地の通行可能情報を見る
	int throughableInfoHere = _ie_GetDistanceToGoal->_gridList_ThrouableInfo[y][x];
	
	// 上に
	int case_toUp = 99999;
	if ( entryAngle != myDown ) 
	{	
		int direction = myUp;

		int stepCost = 0;
		if ( entryAngle != direction ) {
			stepCost += params.moveCostDirectionChange;
			momentumSoFar = 0;
		} else {
			++momentumSoFar;
		}
		
		int nextX = x;
		int nextY = y + myGoalYSign;
		
		if ( nextY < 0 || nextY >= _rule.boardHeight ) {
			case_toUp = 99999;
		} else {
		
			// 現在地の通行可能情報で移動コストを求める
			if ( throughableInfoHere == THROUGHABLE_INFO::THROUGHABLE ) {
				stepCost += 0;
			}
			else if ( throughableInfoHere == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostFromBlank;
			}
			else if ( throughableInfoHere != myMustToUp ) {
				stepCost += params.moveCostArrow;
			}
			
			// 移動先の通行可能情報で移動コストを求める
			if ( _ie_GetDistanceToGoal->_gridList_ThrouableInfo[nextY][nextX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostToBlank;
			}
			
			// 移動先の駒状況で移動コストを求める
			if ( momentumSoFar < 1 ) {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPieceClose; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPieceClose; momentumSoFar = 0;
				}
			}
			else {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPiece; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPiece; momentumSoFar = 0;
				}
			}
			
			if ( stepsSoFar + stepCost < currentMinSteps ) {
			
				//case_toUp = GetDistanceToGoal ( currentMinSteps, passedGridList_GetDistanceToGoal, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				case_toUp = GetDistanceToGoal ( currentMinSteps, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				currentMinSteps = ( currentMinSteps > case_toUp ) ? case_toUp : currentMinSteps;
			}
		}
	}
	
	
	
	
	
	// 左上に
	int case_toUpLeft = 99999;
	if ( entryAngle != myDownRight ) 
	{
		int direction = myUpLeft;
		
		int stepCost = 0;
		if ( entryAngle != direction ) {
			stepCost += params.moveCostDirectionChange;
			momentumSoFar = 0;
		} else {
			++momentumSoFar;
		}
		
		int nextX = x - 1;
		int nextY = y + myGoalYSign;
		
		if ( nextX < 0 || nextY < 0 || nextY >= _rule.boardHeight) {
			
			case_toUpLeft = 99999;
		
		} else {
		
			// 現在地の通行可能情報で移動コストを求める
			if ( throughableInfoHere == THROUGHABLE_INFO::THROUGHABLE ) {
				stepCost += 0;
			}
			else if ( throughableInfoHere == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostFromBlank;
			}
			else {
				stepCost += params.moveCostArrow;
			}
			
			// 移動先の通行可能情報で移動コストを求める
			if ( _ie_GetDistanceToGoal->_gridList_ThrouableInfo[nextY][nextX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostToBlank;
			}
			
			// 移動先の駒状況で移動コストを求める
			if ( momentumSoFar < 1 ) {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPieceClose; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPieceClose; momentumSoFar = 0;
				}
			}
			else {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPiece; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPiece; momentumSoFar = 0;
				}
			}
			
			if ( stepsSoFar + stepCost < currentMinSteps ) {
			
				//case_toUpLeft = GetDistanceToGoal ( currentMinSteps, passedGridList_GetDistanceToGoal, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				case_toUpLeft = GetDistanceToGoal ( currentMinSteps, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				currentMinSteps = ( currentMinSteps > case_toUpLeft ) ? case_toUpLeft : currentMinSteps;
			}
			
		}
	}
	
	
	
	
	// 右上に
	int case_toUpRight = 99999;
	if ( entryAngle != myDownLeft ) 
	{
		int direction = myUpRight;
		
		int stepCost = 0;
		if ( entryAngle != direction ) {
			stepCost += params.moveCostDirectionChange;
			momentumSoFar = 0;
		} else {
			++momentumSoFar;
		}
		
		int nextX = x + 1;
		int nextY = y + myGoalYSign;
		
		if ( nextX >= _rule.boardWidth || nextY < 0 || nextY >= _rule.boardHeight ) {
			
			case_toUpRight = 99999;
		
		} else {
		
			// 現在地の通行可能情報で移動コストを求める
			if ( throughableInfoHere == THROUGHABLE_INFO::THROUGHABLE ) {
				stepCost += 0;
			}
			else if ( throughableInfoHere == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostFromBlank;
			}
			else {
				stepCost += params.moveCostArrow;
			}
			
			// 移動先の通行可能情報で移動コストを求める
			if ( _ie_GetDistanceToGoal->_gridList_ThrouableInfo[nextY][nextX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostToBlank;
			}
			
			// 移動先の駒状況で移動コストを求める
			if ( momentumSoFar < 1 ) {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPieceClose; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPieceClose; momentumSoFar = 0;
				}
			}
			else {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPiece; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPiece; momentumSoFar = 0;
				}
			}
			
			if ( stepsSoFar + stepCost < currentMinSteps ) {
			
				//case_toUpRight = GetDistanceToGoal ( currentMinSteps, passedGridList_GetDistanceToGoal, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				case_toUpRight = GetDistanceToGoal ( currentMinSteps, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				currentMinSteps = ( currentMinSteps > case_toUpRight ) ? case_toUpRight : currentMinSteps;
			}
			
		}
	}
	
	
	// 左に
	int case_toLeft = 99999;
	if ( entryAngle != DIRECTION::RIGHT ) 
	{
		int direction = DIRECTION::LEFT;
		
		int stepCost = 0;
		if ( entryAngle != direction ) {
			stepCost += params.moveCostDirectionChange;
			momentumSoFar = 0;
		} else {
			++momentumSoFar;
		}
		
		int nextX = x - 1;
		int nextY = y;
		
		if ( nextX < 0 ) {
			
			case_toLeft = 99999;
			
		} else {
		
			// 現在地の通行可能情報で移動コストを求める
			if ( throughableInfoHere == THROUGHABLE_INFO::THROUGHABLE ) {
				stepCost += 0;
			}
			else if ( throughableInfoHere == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostFromBlank;
			}
			else if ( throughableInfoHere != THROUGHABLE_INFO::MUST_TO_LEFT ) {
				stepCost += params.moveCostArrow;
			}
			
			// 移動先の通行可能情報で移動コストを求める
			if ( _ie_GetDistanceToGoal->_gridList_ThrouableInfo[nextY][nextX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostToBlank;
			}
			
			// 移動先の駒状況で移動コストを求める
			if ( momentumSoFar < 1 ) {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPieceClose; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPieceClose; momentumSoFar = 0;
				}
			}
			else {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPiece; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPiece; momentumSoFar = 0;
				}
			}
			
			if ( stepsSoFar + stepCost < currentMinSteps ) {
				//case_toLeft = GetDistanceToGoal ( currentMinSteps, passedGridList_GetDistanceToGoal, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				case_toLeft = GetDistanceToGoal ( currentMinSteps, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				currentMinSteps = ( currentMinSteps > case_toLeft ) ? case_toLeft : currentMinSteps;
			}
			
		}
	}
	// 右に
	int case_toRight = 99999;
	if ( entryAngle != DIRECTION::LEFT ) 
	{
		int direction = DIRECTION::RIGHT;
		
		int stepCost = 0;
		if ( entryAngle != direction ) {
			stepCost += params.moveCostDirectionChange;
			momentumSoFar = 0;
		} else {
			++momentumSoFar;
		}
		
		int nextX = x + 1;
		int nextY = y;
		
		if ( nextX >= _rule.boardWidth ) {
			
			case_toRight = 99999;
			
		} else {
		
			// 現在地の通行可能情報で移動コストを求める
			if ( throughableInfoHere == THROUGHABLE_INFO::THROUGHABLE ) {
				stepCost += 0;
			}
			else if ( throughableInfoHere == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostFromBlank;
			}
			else if ( throughableInfoHere != THROUGHABLE_INFO::MUST_TO_RIGHT ) {
				stepCost += params.moveCostArrow;
			}
			
			// 移動先の通行可能情報で移動コストを求める
			if ( _ie_GetDistanceToGoal->_gridList_ThrouableInfo[nextY][nextX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostToBlank;
			}
			
			// 移動先の駒状況で移動コストを求める
			if ( momentumSoFar < 1 ) {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPieceClose; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPieceClose; momentumSoFar = 0;
				}
			}
			else {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPiece; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPiece; momentumSoFar = 0;
				}
			}
			
			if ( stepsSoFar + stepCost < currentMinSteps ) {
			
				//case_toRight = GetDistanceToGoal ( currentMinSteps, passedGridList_GetDistanceToGoal, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				case_toRight = GetDistanceToGoal ( currentMinSteps, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				
				currentMinSteps = ( currentMinSteps > case_toRight ) ? case_toRight : currentMinSteps;
			}
			
		}
	}
	



	
	// 左下に
	int case_toDownLeft = 99999;
	if ( entryAngle != myUpRight ) 
	{
		int direction = myDownLeft;
		
		int stepCost = 0;
		if ( entryAngle != direction ) {
			stepCost += params.moveCostDirectionChange;
			momentumSoFar = 0;
		} else {
			++momentumSoFar;
		}
		
		int nextX = x - 1;
		int nextY = y - myGoalYSign;
		
		if ( nextX < 0 || nextY < 0 || nextY >= _rule.boardHeight ) {
			
			case_toDownLeft = 99999;
		
		} else {
		
			// 現在地の通行可能情報で移動コストを求める
			if ( throughableInfoHere == THROUGHABLE_INFO::THROUGHABLE ) {
				stepCost += 0;
			}
			else if ( throughableInfoHere == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostFromBlank;
			}
			else {
				stepCost += params.moveCostArrow;
			}
			
			// 移動先の通行可能情報で移動コストを求める
			if ( _ie_GetDistanceToGoal->_gridList_ThrouableInfo[nextY][nextX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostToBlank;
			}
			
			// 移動先の駒状況で移動コストを求める
			if ( momentumSoFar < 1 ) {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPieceClose; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPieceClose; momentumSoFar = 0;
				}
			}
			else {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPiece; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPiece; momentumSoFar = 0;
				}
			}
			
			if ( stepsSoFar + stepCost < currentMinSteps ) {
			
				//case_toDownLeft = GetDistanceToGoal ( currentMinSteps, passedGridList_GetDistanceToGoal, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				case_toDownLeft = GetDistanceToGoal ( currentMinSteps, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				currentMinSteps = ( currentMinSteps > case_toDownLeft ) ? case_toDownLeft : currentMinSteps;
			}
			
		}
	}
	// 右下に
	int case_toDownRight = 99999;
	if ( entryAngle != myUpLeft ) 
	{
		int direction = myDownRight;
		
		int stepCost = 0;
		if ( entryAngle != direction ) {
			stepCost += params.moveCostDirectionChange;
			momentumSoFar = 0;
		} else {
			++momentumSoFar;
		}
		
		int nextX = x + 1;
		int nextY = y - myGoalYSign;
		
		if ( nextX >= _rule.boardWidth || nextY < 0 || nextY >= _rule.boardHeight ) {
			
			case_toDownRight = 99999;
		
		} else {
		
			// 現在地の通行可能情報で移動コストを求める
			if ( throughableInfoHere == THROUGHABLE_INFO::THROUGHABLE ) {
				stepCost += 0;
			}
			else if ( throughableInfoHere == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostFromBlank;
			}
			else {
				stepCost += params.moveCostArrow;
			}
			
			// 移動先の通行可能情報で移動コストを求める
			if ( _ie_GetDistanceToGoal->_gridList_ThrouableInfo[nextY][nextX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostToBlank;
			}
			
			// 移動先の駒状況で移動コストを求める
			if ( momentumSoFar < 1 ) {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPieceClose; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPieceClose; momentumSoFar = 0;
				}
			}
			else {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPiece; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPiece; momentumSoFar = 0;
				}
			}
			
			if ( stepsSoFar + stepCost < currentMinSteps ) {
			
				//case_toDownRight = GetDistanceToGoal ( currentMinSteps, passedGridList_GetDistanceToGoal, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				case_toDownRight = GetDistanceToGoal ( currentMinSteps, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				currentMinSteps = ( currentMinSteps > case_toDownRight ) ? case_toDownRight : currentMinSteps;
			}
			
		}
	}
	// 下に
	int case_toDown = 99999;
	if ( entryAngle != myUp ) 
	{
		int direction = myDown;
		
		int stepCost = 0;
		if ( entryAngle != direction ) {
			stepCost += params.moveCostDirectionChange;
			momentumSoFar = 0;
		} else {
			++momentumSoFar;
		}
		
		int nextX = x;
		int nextY = y - myGoalYSign;
		
		if ( nextY < 0 || nextY >= _rule.boardHeight ) {
			case_toDown = 99999;
		} else {

			// 現在地の通行可能情報で移動コストを求める
			if ( throughableInfoHere == THROUGHABLE_INFO::THROUGHABLE ) {
				stepCost += 0;
			}
			else if ( throughableInfoHere == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostFromBlank;
			}
			else if ( throughableInfoHere != myMustToDown ) {
				stepCost += params.moveCostArrow;
			}
			
			// 移動先の通行可能情報で移動コストを求める
			if ( _ie_GetDistanceToGoal->_gridList_ThrouableInfo[nextY][nextX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				stepCost += params.moveCostToBlank;
			}
			
			// 移動先の駒状況で移動コストを求める
			if ( momentumSoFar < 1 ) {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPieceClose; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPieceClose; momentumSoFar = 0;
				}
			}
			else {
				if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == myColor ) {
					stepCost += params.moveCostMyPiece; momentumSoFar = 0;
				}
				else if ( _ie_GetDistanceToGoal->_gridList_Piece[nextY][nextX] == opColor ) {
					stepCost += params.moveCostOpPiece; momentumSoFar = 0;
				}
			}
			
			
			if ( stepsSoFar + stepCost < currentMinSteps ) {
			
				//case_toDown = GetDistanceToGoal ( currentMinSteps, passedGridList_GetDistanceToGoal, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				case_toDown = GetDistanceToGoal ( currentMinSteps, forThisTurn, nextX, nextY, direction, stepsSoFar + stepCost, momentumSoFar );
				currentMinSteps = ( currentMinSteps > case_toDown ) ? case_toDown : currentMinSteps;
			}
		}
	}
	
	
	int minCost = case_toUp;
	minCost = ( minCost > case_toLeft      ) ? case_toLeft      : minCost;
	minCost = ( minCost > case_toRight     ) ? case_toRight     : minCost;
	minCost = ( minCost > case_toUpLeft    ) ? case_toUpLeft    : minCost;
	minCost = ( minCost > case_toUpRight   ) ? case_toUpRight   : minCost;
	minCost = ( minCost > case_toDown      ) ? case_toDown      : minCost;
	minCost = ( minCost > case_toDownLeft  ) ? case_toDownLeft  : minCost;
	minCost = ( minCost > case_toDownRight ) ? case_toDownRight : minCost;
	
	
	//passedGridList_GetDistanceToGoal.erase ( gridIndex );
	//GetDistanceToGoal_RemovePass(x, y);
	_passReminderYX_GetDistanceToGoal[y][x] = 0;
	
	return minCost;
	//stepsSoFar += minCost;
	//return stepsSoFar;
}






//=========================================================
// ゴールまでの論理距離に基づいて局面を判定
//=========================================================
int AI::Evaluate_DistanceToGoal ( InnerExpression* innerExpression, int forThisTurn ) {
	
	Parameters_DistanceToGoal params = _parameters_PieceEvaluation.parameters_DistanceToGoal;
	
	int result = 0;
	
	int myColor = GRID::BLACK;
	int opColor = GRID::WHITE;
	
	int myTurn = TURN::BLACK;
	int opTurn = TURN::WHITE;
	
	int myBaseY = _rule.boardHeight - 1;
	int opBaseY = 0;
	
	bool isMyHandPeaceExist = (innerExpression->_handPiece_BLACK > 0);
	bool isOpHandPeaceExist = (innerExpression->_handPiece_WHITE > 0);
	
	if ( forThisTurn == TURN::WHITE ) {
		myColor = GRID::WHITE;
		opColor = GRID::BLACK;
		myTurn = TURN::WHITE;
		opTurn = TURN::BLACK;
	
		myBaseY = 0;
		opBaseY = _rule.boardHeight - 1;
		
		isMyHandPeaceExist = (innerExpression->_handPiece_WHITE > 0);
		isOpHandPeaceExist = (innerExpression->_handPiece_BLACK > 0);
	}
	
	
	
	///// 数字の「大きさ」で「近さ」を表すこととする。
	int myDistancePoint = 0;
	int opDistancePoint = 0;
	
	///// 駒がある位置でだけ算出
	for ( unsigned int y = 0; y < _rule.boardHeight; ++y ) {
		for ( unsigned int x = 0; x < _rule.boardWidth; ++x ) {
			
			if ( innerExpression->_gridList_Piece[y][x] == myColor ) {
				
				int distance = GetDistanceToGoal ( innerExpression, myTurn, x, y, DIRECTION::NONE, 0, 0 );
				
				int distancePoint = Evaluate_DistanceToGoal_DistanceRate (distance); 
				
				myDistancePoint += distancePoint;
				
			}
			else if ( innerExpression->_gridList_Piece[y][x] == opColor ) {
				
				int distance = GetDistanceToGoal ( innerExpression, opTurn, x, y, 0, 0 );
				
				int distancePoint = Evaluate_DistanceToGoal_DistanceRate (distance); 
				
				opDistancePoint += distancePoint;
				
			}
		}
	}
	
	
	///// 駒台の駒を考慮する：手前の列のグリッドから出発すると仮定
	// 重くなるので休止
	
	for ( unsigned int x = 0; x < _rule.boardWidth; ++x ) {
		
		if ( innerExpression->_gridList_Piece[myBaseY][x] == GRID::ENPTY ) {
			
			
			if ( innerExpression->_gridList_ThrouableInfo[myBaseY][x] == THROUGHABLE_INFO::THROUGHABLE ) {
			
				int distance = GetDistanceToGoal ( innerExpression, myTurn, x, myBaseY, 0, 0 );
				
				int distancePoint = Evaluate_DistanceToGoal_DistanceRate (distance); 
				
				if ( isMyHandPeaceExist ) {
					distancePoint = distancePoint * params.handPieceBias_exist / 100;
				} else {
					distancePoint = distancePoint * params.handPieceBias_absent / 100;
				} 
				
				myDistancePoint += distancePoint;
			}
			
		}
		else if ( innerExpression->_gridList_Piece[opBaseY][x] == GRID::ENPTY ) {
			
			if ( innerExpression->_gridList_ThrouableInfo[opBaseY][x] == THROUGHABLE_INFO::THROUGHABLE ) {
			
				int distance = GetDistanceToGoal ( innerExpression, opTurn, x, opBaseY, 0, 0 );
				
				int distancePoint = Evaluate_DistanceToGoal_DistanceRate (distance); 
				
				if ( isOpHandPeaceExist ) {
					distancePoint = distancePoint * params.handPieceBias_exist / 100;
				} else {
					distancePoint = distancePoint * params.handPieceBias_absent / 100;
				} 

				opDistancePoint += distancePoint;
			}
			
		}
	}
	
	
	// バイアスをかけたりかけなかったり
	myDistancePoint = myDistancePoint * params.attackBias / 100;
	opDistancePoint = opDistancePoint * params.goalHeight / 100;
	
	
	result = (myDistancePoint - opDistancePoint);
	
	
	return result;
}




//=========================================================
// 距離判定関連
//=========================================================
int AI::Evaluate_DistanceToGoal_DistanceRate ( int distance ) {
	
	int result = 0;
	
	Parameters_DistanceToGoal params = _parameters_PieceEvaluation.parameters_DistanceToGoal;
	
	if ( distance < params.distanceRateList.size() ) {
		
		result = params.distanceRateList[ distance ];
		
	} else {
		
		result = 0;
		
	}
	
	return result;
}





//=========================================================
// 距離比べ判定の準備
//=========================================================
void AI::Evaluate_Move_by_Distance_Init ( InnerExpression *currentIe ) {
	
	
	int forThisTurn = currentIe->_currentTurn;
	int opTurn = ( forThisTurn == TURN::BLACK ) ? TURN::WHITE : TURN::BLACK;
	
	_Evaluate_Move_by_Distance_currentMyDistance = GetMinDistanceToGoal ( currentIe, forThisTurn );
	_Evaluate_Move_by_Distance_currentOpDistance = GetMinDistanceToGoal ( currentIe, opTurn );
	
	printf ("AI::Evaluate_Move_by_Distance_Init\n");
	printf ("\t currentMyDistance[%d] currentOpDistance[%d]\n ", _Evaluate_Move_by_Distance_currentMyDistance, _Evaluate_Move_by_Distance_currentOpDistance );
	
	
}


//=========================================================
// 相手陣地までの最短距離を求める
//=========================================================
int AI::GetMinDistanceToGoal ( InnerExpression *currentIe, int forThisTurn ) {
	
	//printf ( "AI::GetMinDistanceToGoal start for (%d) \n", forThisTurn );
	
	DistanceDiffScreening params =  _parameters_PieceEvaluation.parameters_DistanceToGoal.distanceDiffScreening;
	
	int minDistanceDefault = 9999;
	
	int minDistance = minDistanceDefault;
	
	int myColor = ( forThisTurn == TURN::BLACK ) ? GRID::BLACK : GRID::WHITE;
	int opColor = ( forThisTurn == TURN::BLACK ) ? GRID::WHITE : GRID::BLACK;
	int myBaseY = ( forThisTurn == TURN::BLACK ) ? _rule.boardHeight - 1 : 0;
	int myHandsPieceNum = ( forThisTurn == TURN::BLACK ) ? currentIe->_handPiece_BLACK : currentIe->_handPiece_WHITE;
	
	int myMustToUp   = ( forThisTurn == TURN::BLACK ) ? THROUGHABLE_INFO::MUST_TO_UP   : THROUGHABLE_INFO::MUST_TO_DOWN;
	int myMustToDown = ( forThisTurn == TURN::BLACK ) ? THROUGHABLE_INFO::MUST_TO_DOWN : THROUGHABLE_INFO::MUST_TO_UP;
	
	
	///// 盤面に設置されている自駒から相手陣への距離を見る
	for ( unsigned int y = 0; y < _rule.boardHeight; ++y ) {
		for ( unsigned int x = 0; x < _rule.boardWidth; ++x ) {
			
			if ( currentIe->_gridList_Piece[y][x] == myColor ) {
				
				int distance = GetDistanceToGoal (currentIe, forThisTurn, x, y, DIRECTION::NONE, 0, 0);
				
				// 最短を更新
				minDistance = ( distance < minDistance ) ? distance : minDistance;
			}
		}
	}
	
	///// 駒台の駒を考慮する
	if ( myHandsPieceNum > 0 &&  ( minDistance == minDistanceDefault || !params.handPieceConsideringMethod_onlyWhenNoPieceOnBoard ) ) {
		
		if ( params.handPieceConsideringMethod == params.handPieceConsideringMethod_NONE ) {
			// 処理なし
		}
		else if ( params.handPieceConsideringMethod == params.handPieceConsideringMethod_ALL_BOTTOM_GRIDS ) {

			//printf ("ALL_BOTTOM_GRIDS turn(%d)\n", forThisTurn);
			/*
				通行不可マスでも何でも自陣最下段を全部見る
				これは重い。
			*/
			for ( unsigned int x = 0; x < _rule.boardWidth; ++x ) {
				
				if ( currentIe->_gridList_Piece[myBaseY][x] == GRID::ENPTY ) {
					
					int distance = GetDistanceToGoal (currentIe, forThisTurn, x, myBaseY, DIRECTION::NONE, 0, 0);
					
					// 駒設置の手数分、論理距離が増加すると見なす
					distance += params.putPieceCost;
					
					// 最短を更新
					minDistance = ( distance < minDistance ) ? distance : minDistance;
					
				}
				
			}
		}
		else if ( params.handPieceConsideringMethod == params.handPieceConsideringMethod_SWEEP ) {

			//printf ("SWEEP from : %d,  to : %d  turn(%d)\n", params.handPieceConsideringMethod_sweepFrom, params.handPieceConsideringMethod_sweepTo, forThisTurn);
			
			/*
				手前の段から徐々に上げていく。同じ値ならば一段のみ実行
			*/
			int sweepFrom = params.handPieceConsideringMethod_sweepFrom;
			int sweepTo   = params.handPieceConsideringMethod_sweepTo;
			
			bool isDoneSomething = false;
			//for ( unsigned int y = 0; y < _rule.boardHeight; ++y ) {
			for ( unsigned int y = sweepFrom; y <= sweepTo; ++y ) {
				
				if ( y >= _rule.boardHeight ) { break; }
				
				int logicalY = ( forThisTurn == TURN::WHITE ) ? y : _rule.boardHeight -1 - y;
				
				for ( unsigned int x = 0; x < _rule.boardWidth; ++x ) {
					
					if ( currentIe->_gridList_Piece[logicalY][x] == GRID::ENPTY && currentIe->_gridList_ThrouableInfo[logicalY][x] == THROUGHABLE_INFO::THROUGHABLE ) {
						
						// ここは myBaseY を使っている
						int distance = GetDistanceToGoal (currentIe, forThisTurn, x, myBaseY, DIRECTION::NONE, 0, 0);
						
						// 駒設置の手数分、論理距離が増加すると見なす
						distance += params.putPieceCost;
						
						// 最短を更新
						minDistance = ( distance < minDistance ) ? distance : minDistance;
						
						isDoneSomething = true;
						
						//printf ( "done at Y[%d]\n", logicalY );
					}
					
				}
				
				// 判定できていたら終了
				if ( isDoneSomething ) {
					break;
				}
			}
		
		}
		else if ( params.handPieceConsideringMethod == params.handPieceConsideringMethod_MORE_THROUABLE_COLUMNS ) {

			//printf ("MORE_THROUABLE_COLUMNS, than : %d  turn(%d)\n", params.handPieceConsideringMethod_than, forThisTurn);
			/*
				通行可能マスの論理個数が一定数以上の軸を見る
			*/
			int than = params.handPieceConsideringMethod_than;
			bool isMaxOnly = ( than < 0 ); // ちなみに 0 の場合は、つまり、「全部」ということになる。
			
			// どのX軸を見ましょうか?
			bool toSeeOrNotList[9] = { false,false,false,false,false,false,false,false,false };
			
			bool maxNum = -9999;
			for ( unsigned int x = 0; x < _rule.boardWidth; ++x ) {
				
				// この軸の、通行可能グリッド数の、論理個数
				int logicalNum = 0;
				
				for ( unsigned int y = 0; y < _rule.boardHeight; ++y ) {
					
					int logicalY = ( forThisTurn == TURN::WHITE ) ? y : _rule.boardHeight -1 - y;
					
						int upX = 0;
						int leftX  = x - y;
						int rightX = x + y;
						
						///// 真上の分
						int gridInfo_UP  = currentIe->_gridList_ThrouableInfo[logicalY][x];
						int pieceInfo_UP = currentIe->_gridList_Piece[logicalY][x];
						
						// カードについて
						if      ( gridInfo_UP == THROUGHABLE_INFO::THROUGHABLE   ) { logicalNum += 1; }
						else if ( gridInfo_UP == myMustToUp                      ) { logicalNum += 2; }
						else if ( gridInfo_UP == myMustToDown                    ) { logicalNum += -2; }
						else if ( gridInfo_UP == THROUGHABLE_INFO::MUST_TO_LEFT  ) { logicalNum += -1; }
						else if ( gridInfo_UP == THROUGHABLE_INFO::MUST_TO_RIGHT ) { logicalNum += -1; }
						
						// 相手の駒があった場合：自分の駒があることはありえない。わけでもないか。
						if      ( pieceInfo_UP == myColor  ) { logicalNum += -1; }
						else if ( pieceInfo_UP == opColor  ) { logicalNum += -2; }
						
						
						///// 左上方向の分
						if ( y > 0 && leftX >= 0 ) {
							
							int gridInfo_leftUP  = currentIe->_gridList_ThrouableInfo[logicalY][leftX];
							int pieceInfo_leftUP = currentIe->_gridList_Piece[logicalY][leftX];
							
							// カードについて
							if      ( gridInfo_leftUP == THROUGHABLE_INFO::THROUGHABLE   ) { logicalNum += 1; }
							else if ( gridInfo_leftUP == myMustToUp                      ) { logicalNum += -1; }
							else if ( gridInfo_leftUP == myMustToDown                    ) { logicalNum += -2; }
							else if ( gridInfo_leftUP == THROUGHABLE_INFO::MUST_TO_LEFT  ) { logicalNum += -1; }
							else if ( gridInfo_leftUP == THROUGHABLE_INFO::MUST_TO_RIGHT ) { logicalNum += -1; }
							
							// 相手の駒があった場合：自分の駒があることはありえない。わけでもないか。
							if      ( pieceInfo_leftUP == myColor  ) { logicalNum += -1; }
							else if ( pieceInfo_leftUP == opColor  ) { logicalNum += -2; }
						}
						
						
						///// 右上方向の分
						if ( y > 0 && rightX < _rule.boardWidth ) {
							
							int gridInfo_rightUP  = currentIe->_gridList_ThrouableInfo[logicalY][rightX];
							int pieceInfo_rightUP = currentIe->_gridList_Piece[logicalY][rightX];
							
							// カードについて
							if      ( gridInfo_rightUP == THROUGHABLE_INFO::THROUGHABLE   ) { logicalNum += 1; }
							else if ( gridInfo_rightUP == myMustToUp                      ) { logicalNum += -1; }
							else if ( gridInfo_rightUP == myMustToDown                    ) { logicalNum += -2; }
							else if ( gridInfo_rightUP == THROUGHABLE_INFO::MUST_TO_LEFT  ) { logicalNum += -1; }
							else if ( gridInfo_rightUP == THROUGHABLE_INFO::MUST_TO_RIGHT ) { logicalNum += -1; }
							
							// 相手の駒があった場合：自分の駒があることはありえない。わけでもないか。
							if      ( pieceInfo_rightUP == myColor  ) { logicalNum += -1; }
							else if ( pieceInfo_rightUP == opColor  ) { logicalNum += -2; }
							
						}
					
				}
				
				
				///// 見るべき軸ですか？：最大値のみの場合（同率の場合は複数件）
				if ( isMaxOnly ) {
				
					///// 最大値更新
					if ( maxNum < logicalNum ) {
						
						// 他を全部 false に。今回のみ true
						for ( int n = 0; n < x; ++n ) {
							toSeeOrNotList[n] = false;
						}
						toSeeOrNotList[x] = true;
						
					}
					// 同率
					else if ( maxNum == logicalNum ) {
						
						// これまでの分を false にはせず、今回の分を true とする
						toSeeOrNotList[x] = true;
						
					// 最大値に届かなかった
					} else {
						// 何もしない
					}
					
				///// 見るべき軸ですか？：指定個数以上の場合
				} else {
					if ( logicalNum >= than ) {
						toSeeOrNotList[x] = true;
					}
				}
				
			} // 軸走査 for 閉じ
			
			
			///// 見ることになった軸の分、見る
			for ( unsigned int x = 0; x < 9; ++x ) {
				
				if ( x >= _rule.boardWidth ) { break; } // もう結局ボードのサイズは 9*9 固定なのだけれど、一応
				
				if ( toSeeOrNotList[x] ) {
					
					//printf ("done at X[%d]\n", x);
					if ( currentIe->_gridList_Piece[myBaseY][x] == GRID::ENPTY ) {
						
						int distance = GetDistanceToGoal (currentIe, forThisTurn, x, myBaseY, DIRECTION::NONE, 0, 0);
						
						// 駒設置の手数分、論理距離が増加すると見なす
						distance += params.putPieceCost;
						
						// 最短を更新
						minDistance = ( distance < minDistance ) ? distance : minDistance;
						
					}
					
				}
			}
			
			
		}
		
	}
	
	//printf ( "AI::GetMinDistanceToGoal end with minDistance(%d) \n", minDistance );
	
	return minDistance;
}
//=========================================================
// 距離比べ判定
//【引数】
// 現状、こう指して、こうなった、という指定を想定していたけれど、
// 結局「こうなった」しか使ってないので、インターフェイスを変更。これなら地形探索の中でも使える
//=========================================================
//int AI::Evaluate_Move_by_Distance ( InnerExpression *currentIe, const Move &move, InnerExpression *nextIe, int forThisTurn ) {
int AI::Evaluate_DistanceDiff ( InnerExpression *nextIe, int forThisTurn ) {

	int result = 0;
	
	///// 準備は出来ている前提
	/*
		_Evaluate_Move_by_Distance_currentMyDistance;
		_Evaluate_Move_by_Distance_currentOpDistance;
	*/
	
	DistanceDiffScreening params =  _parameters_PieceEvaluation.parameters_DistanceToGoal.distanceDiffScreening;
	
	///// 下駄を履かせるなら履かせる
	int offseted_Evaluate_Move_by_Distance_currentMyDistance = _Evaluate_Move_by_Distance_currentMyDistance + params.distanceOffset_forMe;
	int offseted_Evaluate_Move_by_Distance_currentOpDistance = _Evaluate_Move_by_Distance_currentOpDistance + params.distanceOffset_forOp;
	
	int opTurn = ( forThisTurn == TURN::BLACK ) ? TURN::WHITE : TURN::BLACK;
	
	
	///// 使う予定のあるものを用意しておく
	vector<Move> nextOpCollideMoveList;
	if ( params.oneStepFutureTelling_Ahead_forMe || params.oneStepFutureTelling_Ahead_againstOp || params.oneStepFutureTelling_Backward_forMe || params.oneStepFutureTelling_Backward_againstOp ) {
	
		nextIe->GetLegalNextMoveList ( nextOpCollideMoveList, MOVE::ACTION::MOVE_PIECE );
		
	}

	
	///// 自分の方が論理距離で有利である場合：自分の距離をより縮める手を優先する
	if ( 
		offseted_Evaluate_Move_by_Distance_currentMyDistance <= offseted_Evaluate_Move_by_Distance_currentOpDistance 
		|| 
		_Evaluate_Move_by_Distance_currentMyDistance == 9999
	) 
	{
		
		// 自分の距離を縮める手の判定をする
		if ( params.achievePoint_Ahead_forMe != 0 ) {
			
			// 次の局面での相手の指し手の中に「駒をぶつける」がある場合、その後の局面を考慮する
			int oneStepFutureDistance = -9999;
			
			if ( params.oneStepFutureTelling_Ahead_forMe ) {
				oneStepFutureDistance = Evaluate_Move_by_Distance_OneStepFutureTelling ( nextIe, nextOpCollideMoveList, forThisTurn, true );
			}
			
			//printf ( "nextOpCollideMoveList[%d]\n", nextOpCollideMoveList.size() );
			
			int distance    = GetMinDistanceToGoal ( nextIe, forThisTurn );
			distance = ( oneStepFutureDistance > distance ) ? oneStepFutureDistance : distance;
			
			int achievement = offseted_Evaluate_Move_by_Distance_currentMyDistance - distance;
			result += achievement * params.achievePoint_Ahead_forMe;
			
		}
		// 相手の距離を伸ばす手の判定をする
		if ( params.achievePoint_Ahead_againstOp != 0 ) {
			
			// 次の局面での相手の指し手の中に「駒をぶつける」がある場合、その後の局面を考慮する
			int oneStepFutureDistance = 9999;
			
			if ( params.oneStepFutureTelling_Ahead_againstOp ) {
				oneStepFutureDistance = Evaluate_Move_by_Distance_OneStepFutureTelling ( nextIe, nextOpCollideMoveList, opTurn, false );
			}
			
			int distance = GetMinDistanceToGoal ( nextIe, opTurn );
			distance = ( oneStepFutureDistance < distance ) ? oneStepFutureDistance : distance;
			
			int achievement = distance - offseted_Evaluate_Move_by_Distance_currentOpDistance;
			result += achievement * params.achievePoint_Ahead_againstOp;
		}
		
		//printf ( "achievement[%d] = _Evaluate_Move_by_Distance_currentMyDistance[%d] - distance[%d]\n", achievement, _Evaluate_Move_by_Distance_currentMyDistance, distance );
		
		
		
		
		
		
	///// 相手の方が論理距離で有利である場合：相手の論理距離を増加させる手を優先する
	} else {
		
		int nextOpDistance = -9999; // params.achievePoint_Backward_againstOp が未設定により算出していない、の意味の初期値
		if ( params.achievePoint_Backward_againstOp != 0 ) {
			
			//printf ("came here 3.\n");
			
			// 次の局面での相手の指し手の中に「駒をぶつける」がある場合、その後の局面を考慮する
			int oneStepFutureDistance = 9999;
			
			if ( params.oneStepFutureTelling_Backward_againstOp ) {
				oneStepFutureDistance = Evaluate_Move_by_Distance_OneStepFutureTelling ( nextIe, nextOpCollideMoveList, opTurn, false );
			}
			//printf ( "oneStepFutureDistance : %d\n", oneStepFutureDistance );
			
			nextOpDistance    = GetMinDistanceToGoal ( nextIe, opTurn );
			nextOpDistance = ( oneStepFutureDistance < nextOpDistance ) ? oneStepFutureDistance : nextOpDistance;
			
			int achievement = nextOpDistance - offseted_Evaluate_Move_by_Distance_currentOpDistance;
			result += achievement * params.achievePoint_Backward_againstOp;
		
		}
		if ( params.achievePoint_Backward_forMe != 0 || params.achievePoint_Backward_turnBack != 0 ) {
			
			// 次の局面での相手の指し手の中に「駒をぶつける」がある場合、その後の局面を考慮する
			int oneStepFutureDistance = -9999;
			
			if ( params.oneStepFutureTelling_Backward_forMe ) {
				oneStepFutureDistance = Evaluate_Move_by_Distance_OneStepFutureTelling ( nextIe, nextOpCollideMoveList, forThisTurn, true );
			}
			
			int distance    = GetMinDistanceToGoal ( nextIe, forThisTurn );
			distance = ( oneStepFutureDistance > distance ) ? oneStepFutureDistance : distance;
			
			int achievement = offseted_Evaluate_Move_by_Distance_currentMyDistance - distance;
			result += achievement * params.achievePoint_Backward_forMe;
			
			// 相手の距離：次の距離を求めているなら、それを使う。ないなら、現時点での距離を使う。
			int opDistacne = ( nextOpDistance != -9999 ) ? nextOpDistance : offseted_Evaluate_Move_by_Distance_currentOpDistance;
			
			
			// 形勢逆転か？ イコール（追いつく）は含めない。次が相手の手番だから、という理由。
			if ( distance < opDistacne  ) {
				
				result += achievement * params.achievePoint_Backward_turnBack;
			}
			
		}
		
	}
	
	
	return result;
}

//=========================================================
// 論理距離比較サブ処理：駒をぶつける手に限定して一歩だけ先読み
//=========================================================
int AI::Evaluate_Move_by_Distance_OneStepFutureTelling ( InnerExpression *nextIe, const vector<Move> &nextMoveList, int forThisTurn, bool isGetMaxOrMin ) {
	
	// 次の局面での相手の指し手の中に「駒をぶつける」がある場合、その後の局面を考慮する
	
	int oneStepFutureDistance = 0;
	
	// 最大値が欲しいのか、最小値が欲しいのか
	if ( isGetMaxOrMin ) {
		oneStepFutureDistance = -9999;
	} else {
		oneStepFutureDistance = 9999;
	}
	
	int collideTargetColor = ( nextIe->_currentTurn == TURN::BLACK ) ? GRID::WHITE : GRID::BLACK;
	
	
	// 次の局面での相手の指し手の中に「駒をぶつける」がある場合、その後の局面を考慮する
	for ( unsigned int i = 0; i < nextMoveList.size(); ++i ) {
		
		Move m = nextMoveList[i];
		if ( m.action == MOVE::ACTION::MOVE_PIECE && m.movePieceAndIsCllide && m.movePieceAndCllidedPieceColor == collideTargetColor ) {
			
			nextIe->GoNext(m);
			
			int d = GetMinDistanceToGoal ( nextIe, forThisTurn );
			
			// 最大値が欲しいのか、最小値が欲しいのか
			if ( isGetMaxOrMin ) {
				oneStepFutureDistance = ( oneStepFutureDistance < d  ) ? d : oneStepFutureDistance;
			} else {
				oneStepFutureDistance = ( oneStepFutureDistance > d  ) ? d : oneStepFutureDistance;
			}
			
			//printf ("came here. d[%d] collideTargetColor[%d]   --->  oneStepFutureDistance[%d]\n", d, collideTargetColor, oneStepFutureDistance);
			
			nextIe->GoBack();
		}
	}
	
	
	return oneStepFutureDistance;

}

//=========================================================
// 論理距離比較による絞込みをするかどうか
//=========================================================
bool AI::Evaluate_Move_by_Distance_isScreeningEnabled ( InnerExpression *currentIe ) {
	
	bool result = false;
	
	DistanceDiffScreening params = _parameters_PieceEvaluation.parameters_DistanceToGoal.distanceDiffScreening;
	
	if ( params.isEnabled ) {
		
		result = true;
		
		int progressRate = GetGameProgressDegree ( currentIe );
		
		if ( params.enabledTurn_from > 0 ) {
			
			result = ( params.enabledTurn_from <= progressRate );
			
		}
	
		if ( params.enabledTurn_to >= 0 ) {
			
			result = ( params.enabledTurn_to >= progressRate );
			
		}
	
	}
	
	return result;
}




/*
//=========================================================
// 論理距離調査用の経路記録確認処置群
//=========================================================
void AI::GetDistanceToGoal_AddPass ( const int &x, const int &y ) {
	
	_passReminderY_GetDistanceToGoal[y] |=  (1 << x);
}

void AI::GetDistanceToGoal_RemovePass ( const int &x, const int &y ) {
	
	_passReminderY_GetDistanceToGoal[y] ^=  (1 << x);
}

bool AI::GetDistanceToGoal_IsExistPass ( const int &x, const int &y  ) {
	
	bool result = false;
	
	result = ( 	( _passReminderY_GetDistanceToGoal[y] & (1 << x) ) == (1 << x)  );
	
	
	return result;
}
*/













//=========================================================
// デバッグ用・設定値を表示
//=========================================================
void AI::Evaluate_DistanceToGoal_ShowSettingsForDebug() {
	
	Parameters_DistanceToGoal params = _parameters_PieceEvaluation.parameters_DistanceToGoal;
	
	printf ("<DISTANCE_TO_GOAL>\n");
	
	printf ("\t<ENABLED>%s<ENABLED>\n", ( params.isEnabled) ? "on" : "off");
	
	printf ("\t<GOAL_HEIGHT>%d</GOAL_HEIGHT>\n", params.goalHeight);
		
	printf ("\t<ATTACK_BIAS>%d</ATTACK_BIAS>\n", params.attackBias);
	
	printf ("\t<GUARD_BIAS>%d</GUARD_BIAS>\n", params.guardBias);
	
	printf ("\t<DISTANCE_LIMIT>%d</DISTANCE_LIMIT>\n", params.distanceLimit);
	
	printf ("\t<MOVE_COST type=\"directionChange\" value=\"%d\" />\n", params.moveCostDirectionChange );
	printf ("\t<MOVE_COST type=\"arrow\"           value=\"%d\" />\n", params.moveCostArrow );
	printf ("\t<MOVE_COST type=\"fromBlank\"       value=\"%d\" />\n", params.moveCostFromBlank );
	printf ("\t<MOVE_COST type=\"toBlank\"         value=\"%d\" />\n", params.moveCostToBlank );
	printf ("\t<MOVE_COST type=\"myPiece\"         value=\"%d\" />\n", params.moveCostMyPiece );
	printf ("\t<MOVE_COST type=\"myPieceClose\"    value=\"%d\" />\n", params.moveCostMyPieceClose );
	printf ("\t<MOVE_COST type=\"opPiece\"         value=\"%d\" />\n", params.moveCostOpPiece );
	printf ("\t<MOVE_COST type=\"opPieceClose\"    value=\"%d\" />\n", params.moveCostOpPieceClose );
	
	printf ("\t<HAND_PIECE_BIAS type=\"exist\"  value=\"%d\" />\n", params.handPieceBias_exist);
	printf ("\t<HAND_PIECE_BIAS type=\"absent\" value=\"%d\" />\n", params.handPieceBias_absent);
		
	printf ("\t<DISTANCE_POINTS>\n");
		
		for ( unsigned int i = 0; i < params.distanceRateList.size(); ++i ) {
			printf ("\t\t<POINT>%d</POINT>\n", params.distanceRateList[i]);
		}
		
	printf ("\t</DISTANCE_POINTS>\n");
	
	
	printf ("\t<DIFF_SCREENING>\n");
		
	printf ("\t\t<ENABLED>%s</ENABLED>\n", params.distanceDiffScreening.isEnabled ? "on" : "off");
		
	printf ("\t\t<GAME_PROGRESS from=\"%d\" to=\"%d\" />\n", params.distanceDiffScreening.enabledTurn_from, params.distanceDiffScreening.enabledTurn_to);
		
	printf ("\t\t<APPLY_FOR_TERRAIN_SEARCH>%d</APPLY_FOR_TERRAIN_SEARCH>\n", params.distanceDiffScreening.bias_TerrainEvaluate);
		
	printf ("\t\t<SCREENING_LENGTH>%d</SCREENING_LENGTH>\n", params.distanceDiffScreening.screeningLength);
		
	printf ("\t\t<PUT_PIECE_COST>%d</PUT_PIECE_COST>\n", params.distanceDiffScreening.putPieceCost);
	
	string method = "NONE";
	if      ( params.distanceDiffScreening.handPieceConsideringMethod == params.distanceDiffScreening.handPieceConsideringMethod_ALL_BOTTOM_GRIDS ) { method = "ALL_BOTTOM_GRIDS"; }
	else if ( params.distanceDiffScreening.handPieceConsideringMethod == params.distanceDiffScreening.handPieceConsideringMethod_SWEEP            ) { method = "SWEEP"; }
	else if ( params.distanceDiffScreening.handPieceConsideringMethod == params.distanceDiffScreening.handPieceConsideringMethod_MORE_THROUABLE_COLUMNS ) { method = "MORE_THROUABLE_COLUMNS"; }
	
	string than = "maxOnly";
	if ( params.distanceDiffScreening.handPieceConsideringMethod == params.distanceDiffScreening.handPieceConsideringMethod_than != -1 ) { 
		than = Utils_Convert::Int_to_String ( params.distanceDiffScreening.handPieceConsideringMethod_than ); 
	}
	
	printf ("\t\t<HAND_PIECE_CONSIDERING_METHOD onlyWhenNoPieceOnBoard=\"%s\" method=\"%s\" from=\"%d\" to=\"%d\" than=\"%s\" />\n", 
		params.distanceDiffScreening.handPieceConsideringMethod_onlyWhenNoPieceOnBoard ? "true" : "false",
		method.c_str(),
		params.distanceDiffScreening.handPieceConsideringMethod == params.distanceDiffScreening.handPieceConsideringMethod_sweepFrom,
		params.distanceDiffScreening.handPieceConsideringMethod == params.distanceDiffScreening.handPieceConsideringMethod_sweepTo,
		than.c_str()
	);
		
	printf ("\t\t<ACHIEVE_POINT status=\"ahead\" type=\"forMe\"     value=\"%d\" />\n", params.distanceDiffScreening.achievePoint_Ahead_forMe);
	printf ("\t\t<ACHIEVE_POINT status=\"ahead\" type=\"againstOp\" value=\"%d\" />\n", params.distanceDiffScreening.achievePoint_Ahead_againstOp);
	printf ("\t\t<ACHIEVE_POINT status=\"backward\" type=\"forMe\"     value=\"%d\" />\n", params.distanceDiffScreening.achievePoint_Backward_forMe);
	printf ("\t\t<ACHIEVE_POINT status=\"backward\" type=\"againstOp\" value=\"%d\" />\n", params.distanceDiffScreening.achievePoint_Backward_againstOp);
	printf ("\t\t<ACHIEVE_POINT status=\"backward\" type=\"turnBack\" value=\"%d\" />\n", params.distanceDiffScreening.achievePoint_Backward_turnBack);
		
	printf ("\t\t<OneStepFutureTelling status=\"ahead\" type=\"forMe\"     enabled=\"%s\" />\n", params.distanceDiffScreening.oneStepFutureTelling_Ahead_forMe ? "on" : "off");
	printf ("\t\t<OneStepFutureTelling status=\"ahead\" type=\"againstOp\" enabled=\"%s\" />\n", params.distanceDiffScreening.oneStepFutureTelling_Ahead_againstOp ? "on" : "off");
	printf ("\t\t<OneStepFutureTelling status=\"backward\" type=\"forMe\"     enabled=\"%s\" />\n", params.distanceDiffScreening.oneStepFutureTelling_Backward_forMe ? "on" : "off");
	printf ("\t\t<OneStepFutureTelling status=\"backward\" type=\"againstOp\" enabled=\"%s\" />\n", params.distanceDiffScreening.oneStepFutureTelling_Backward_againstOp ? "on" : "off");
	
	printf ("\t\t<DISTANCE_OFFSET type=\"forMe\" value=\"%d\" />\n", params.distanceDiffScreening.distanceOffset_forMe );
	printf ("\t\t<DISTANCE_OFFSET type=\"forOp\" value=\"%d\" />\n", params.distanceDiffScreening.distanceOffset_forOp );
		
	printf ("\t</DIFF_SCREENING>\n" );
	
	printf ("</DISTANCE_TO_GOAL>\n");
	
}























