//=========================================================
//
// AI_実装ファイル_評価関数関係
//
//=========================================================
#include "pch.h"

#include <stdio.h>
#include "AI.h"
#include "InnerExpression.h"
#include "../Utils/Utils_Cal.h"
#include "../Utils/Allocator.h"


using namespace AI_Modules;


//==========================================================
// 柱と傘での評価
//==========================================================
int AI::Evaluate_PC_S ( const InnerExpression* innerExpression, int forThisTurn ) {
	++_PC_InvokeCount;
	int result = 0;

	/*
		[手順]

		・黒攻→白 で 柱構造体リストを作る：危険度も入れる
		・白攻→黒 で 柱構造体リストを作る：危険度も入れる

		・黒駒の位置リストを用意しておく＋黒の手駒があるかどうか
		・白駒の位置リストを用意しておく＋白の手駒があるかどうか

		・黒攻→白 で、白にとっての危険度を求める
		・白攻→黒 で、黒にとっての危険度を求める

		・両者の危険度を？ 合計（打ち消し合う）？

		・forThisTurn に合わせて、符号を決める

		結局、その時点でどっちの手番か、というのは、評価値そのものには反映させない、のですね。

	*/
	
	int riskForWhite = Evaluate_PC_GetRisk_forThisTurn ( innerExpression, TURN::WHITE );
	int riskForBlack = Evaluate_PC_GetRisk_forThisTurn ( innerExpression, TURN::BLACK );
	/*
	///// 柱リストを作成：黒攻め→白
	//for (int n = 0; n < _pillarMold_Black.size(); ++n) { pillarList_Black_to_White_S[n].Clear();}
	//Evaluate_PC_S_MakePillarList_withPreparedMold_and_CaliculatePotentialRiskDegree ( _pillarMold_Black, TURN::BLACK, innerExpression, pillarList_Black_to_White_S );

	for (int n = 0; n < pillarListSize_Black; ++n) { 
		pillarList_Black_to_White_S[n].Clear();
	}

	Evaluate_PC_S_MakePillarList_withPreparedMold_and_CaliculatePotentialRiskDegree ( 
		_pillarMold_Black_S, TURN::BLACK, innerExpression, pillarList_Black_to_White_S
		, pillarListSize_Black, _pillarMold_Black_SizeList
	);

	///// 柱リストを作成：白攻め→黒
	//for (int n = 0; n < _pillarMold_Black.size(); ++n) { pillarList_White_to_Black_S[n].Clear();}
	//Evaluate_PC_S_MakePillarList_withPreparedMold_and_CaliculatePotentialRiskDegree ( _pillarMold_White, TURN::WHITE, innerExpression, pillarList_White_to_Black_S );
	
	for (int n = 0; n < pillarListSize_White; ++n) { 
		pillarList_White_to_Black_S[n].Clear();
	}

	Evaluate_PC_S_MakePillarList_withPreparedMold_and_CaliculatePotentialRiskDegree ( 
		_pillarMold_White_S, TURN::WHITE, innerExpression, pillarList_White_to_Black_S 
		, pillarListSize_White, _pillarMold_White_SizeList
	);

	///// 駒の位置リスト：手駒は「(-1, -1)で表現」複数あっても１つ。
	int pieceListSize_Black = Evaluate_PC_S_MakePiecePositionList( innerExpression, piecePositionList_Black, GRID::BLACK );
	int pieceListSize_White = Evaluate_PC_S_MakePiecePositionList( innerExpression, piecePositionList_White, GRID::WHITE );

	///// 危険度：白にとっての
	int riskForWhite = Evaluate_PC_S_CalicurateApparedRiskDegree ( 
		pillarList_Black_to_White_S, piecePositionList_Black, innerExpression
		, pillarListSize_Black, pieceListSize_Black
		);

	///// 危険度：黒にとっての
	int riskForBlack = Evaluate_PC_S_CalicurateApparedRiskDegree ( 
		pillarList_White_to_Black_S, piecePositionList_White, innerExpression
		, pillarListSize_White, pieceListSize_White
	);
	
	*/

	//printf ("riskForWhite : %d\n", riskForWhite);
	//printf ("riskForBlack : %d\n", riskForBlack);
	
	///// 手番じゃない方の危険度をｎ倍する、みたいな処理があってもいいのかも
	
	
	///// 駒をぶつけられる手を考慮して、一歩だけ先読み
	bool isOneStepFutureTelling = _parameters_PieceEvaluation.pcEvalInfo.oneStepFutureTelling;
	vector<Move> nextOpCollideMoveList;
	if ( isOneStepFutureTelling ) {
	
		innerExpression->GetLegalNextMoveList ( nextOpCollideMoveList, MOVE::ACTION::MOVE_PIECE );
		
	}
	
	///// 自分にとっての危険度を、マイナスにする（相手の危険度は自分の有利さ）
	if ( forThisTurn == TURN::BLACK ) {
		
		if ( isOneStepFutureTelling ) {
		
			int oneStepFuture_riskForBlack = Evaluate_PC_GetRisk_forThisTurn_OneStepFutureTelling ( innerExpression, nextOpCollideMoveList, TURN::BLACK, true );
			int oneStepFuture_riskForWhite = Evaluate_PC_GetRisk_forThisTurn_OneStepFutureTelling ( innerExpression, nextOpCollideMoveList, TURN::WHITE, false );
			
			riskForBlack = ( riskForBlack < oneStepFuture_riskForBlack ) ? oneStepFuture_riskForBlack : riskForBlack;
			riskForWhite = ( riskForWhite > oneStepFuture_riskForWhite ) ? oneStepFuture_riskForWhite : riskForWhite;
		}
		
		riskForBlack *= -1;
		
		riskForBlack *= (float)_parameters_PieceEvaluation.pcEvalInfo.guardBias  / 100.0f;
		riskForWhite *= (float)_parameters_PieceEvaluation.pcEvalInfo.attackBias / 100.0f;

	} else if ( forThisTurn == TURN::WHITE ) {
	
		if ( isOneStepFutureTelling ) {
		
			int oneStepFuture_riskForBlack = Evaluate_PC_GetRisk_forThisTurn_OneStepFutureTelling ( innerExpression, nextOpCollideMoveList, TURN::BLACK, false );
			int oneStepFuture_riskForWhite = Evaluate_PC_GetRisk_forThisTurn_OneStepFutureTelling ( innerExpression, nextOpCollideMoveList, TURN::WHITE, true );
			
			riskForWhite = ( riskForWhite < oneStepFuture_riskForWhite ) ? oneStepFuture_riskForWhite : riskForWhite;
			riskForBlack = ( riskForBlack > oneStepFuture_riskForBlack ) ? oneStepFuture_riskForBlack : riskForBlack;
		}
		
		riskForWhite *= -1; 

		riskForWhite *= (float)_parameters_PieceEvaluation.pcEvalInfo.guardBias  / 100.0f;
		riskForBlack *= (float)_parameters_PieceEvaluation.pcEvalInfo.attackBias / 100.0f;
	}

	///// 加算合成。
	result = riskForBlack + riskForWhite;


	return result;
}


//==========================================================
// 危険度求める：手番を指定して別個に
//==========================================================
int AI::Evaluate_PC_GetRisk_forThisTurn (  const InnerExpression *innerExpression, int turn ) {
	
	int result = 0;
	
	if ( turn == TURN::BLACK ) {
		
		///// 柱リストを作成：白攻め→黒
		for (int n = 0; n < pillarListSize_White; ++n) { 
			pillarList_White_to_Black_S[n].Clear();
		}

		Evaluate_PC_S_MakePillarList_withPreparedMold_and_CaliculatePotentialRiskDegree ( 
			_pillarMold_White_S, TURN::WHITE, innerExpression, pillarList_White_to_Black_S 
			, pillarListSize_White, _pillarMold_White_SizeList
		);
		
		///// 駒の位置リスト：手駒は「(-1, -1)で表現」複数あっても１つ。
		int pieceListSize_White = Evaluate_PC_S_MakePiecePositionList( innerExpression, piecePositionList_White, GRID::WHITE );
		
		
		///// 危険度：黒にとっての
		int riskForBlack = Evaluate_PC_S_CalicurateApparedRiskDegree ( 
			pillarList_White_to_Black_S, piecePositionList_White, innerExpression
			, pillarListSize_White, pieceListSize_White
		);
		
		result = riskForBlack;
		
		
	} else if ( turn == TURN::WHITE ) {
		
		///// 柱リストを作成：黒攻め→白
		for (int n = 0; n < pillarListSize_Black; ++n) { 
			pillarList_Black_to_White_S[n].Clear();
		}

		Evaluate_PC_S_MakePillarList_withPreparedMold_and_CaliculatePotentialRiskDegree ( 
			_pillarMold_Black_S, TURN::BLACK, innerExpression, pillarList_Black_to_White_S
			, pillarListSize_Black, _pillarMold_Black_SizeList
		);
		
		///// 駒の位置リスト：手駒は「(-1, -1)で表現」複数あっても１つ。
		int pieceListSize_Black = Evaluate_PC_S_MakePiecePositionList( innerExpression, piecePositionList_Black, GRID::BLACK );
		
		///// 危険度：白にとっての
		int riskForWhite = Evaluate_PC_S_CalicurateApparedRiskDegree ( 
			pillarList_Black_to_White_S, piecePositionList_Black, innerExpression
			, pillarListSize_Black, pieceListSize_Black
			);
		
		result = riskForWhite;
	}
	
	
	
	
	return result;
}


//=========================================================
// 駒をぶつける手に関して、一歩先読み
//=========================================================
int AI::Evaluate_PC_GetRisk_forThisTurn_OneStepFutureTelling ( InnerExpression *innerExpression, const vector<Move> &nextMoveList, int forThisTurn, bool isGetMaxOrMin ) {
	
	// 次の局面での相手の指し手の中に「駒をぶつける」がある場合、その後の局面を考慮する
	
	int oneStepFutureRisk = 0;
	
	// 最大値が欲しいのか、最小値が欲しいのか
	if ( isGetMaxOrMin ) {
		oneStepFutureRisk = -9999;
	} else {
		oneStepFutureRisk = 9999;
	}
	
	int collideTargetColor = ( innerExpression->_currentTurn == TURN::BLACK ) ? GRID::WHITE : GRID::BLACK;
	
	
	// 次の局面での相手の指し手の中に「駒をぶつける」がある場合、その後の局面を考慮する
	for ( unsigned int i = 0; i < nextMoveList.size(); ++i ) {
		
		Move m = nextMoveList[i];
		if ( m.action == MOVE::ACTION::MOVE_PIECE && m.movePieceAndIsCllide && m.movePieceAndCllidedPieceColor == collideTargetColor ) {
			
			innerExpression->GoNext(m);
			
			//int d = GetMinDistanceToGoal ( innerExpression, forThisTurn );
			int risk = Evaluate_PC_GetRisk_forThisTurn ( innerExpression, forThisTurn );
			
			// 最大値が欲しいのか、最小値が欲しいのか
			if ( isGetMaxOrMin ) {
				oneStepFutureRisk = ( oneStepFutureRisk < risk  ) ? risk : oneStepFutureRisk;
			} else {
				oneStepFutureRisk = ( oneStepFutureRisk > risk  ) ? risk : oneStepFutureRisk;
			}
			
			//printf ("came here. d[%d] collideTargetColor[%d]   --->  oneStepFutureRisk[%d]\n", d, collideTargetColor, oneStepFutureRisk);
			
			innerExpression->GoBack();
		}
	}
	
	
	return oneStepFutureRisk;
	
	
	
}


//==========================================================
// 危険度を合計
//==========================================================
int AI::Evaluate_PC_S_CalicurateApparedRiskDegree ( 
	Pillar* &pillarList, Position* &piecePositionList, const InnerExpression *innerExpression, 
	int pillarListSize, int pieceListSize ) 
{

	int result = 0;

	///// 柱の顕在的な危険度を求める
	for ( unsigned int i = 0; i < pillarListSize; ++i  ) {

		// 潜在的な危険度がゼロの柱は素通りする
		if ( pillarList[i].riskDegree == 0 ) {
			continue;
		}

		int apparedRiskDegree = 0;

		// 攻め駒でループ
		for ( unsigned int n = 0; n < pieceListSize; ++n ) {

			// 柱に対する駒の位置を求める
			int pieceHeight = -1;
			int positionState = Evaluate_PC_S_GetPiecePositionTowardThePillar( pillarList[i], piecePositionList[n].x, piecePositionList[n].y, pieceHeight );

			// 潜在的危険度を引き出す割合
			int rate = 0;
			if      ( positionState == PILLAR_COVER::PIECE_POSITION::IN_THE_BOX             ) { rate = _parameters_PieceEvaluation.pcEvalInfo.pieceWeight_IN_THE_BOX;}
			else if ( positionState == PILLAR_COVER::PIECE_POSITION::ABOVE_COVER            ) { rate = _parameters_PieceEvaluation.pcEvalInfo.pieceWeight_ABOVE_COVER;}
			else if ( positionState == PILLAR_COVER::PIECE_POSITION::ABOVE_COVER_DIAGONALLY ) { rate = _parameters_PieceEvaluation.pcEvalInfo.pieceWeight_ABOVE_COVER_DIAGONALLY;}
			else if ( positionState == PILLAR_COVER::PIECE_POSITION::UNDER_COVER_SIDE       ) { rate = _parameters_PieceEvaluation.pcEvalInfo.pieceWeight_UNDER_COVER_SIDE;}
			else if ( positionState == PILLAR_COVER::PIECE_POSITION::UNDER_COVER            ) { rate = _parameters_PieceEvaluation.pcEvalInfo.pieceWeight_UNDER_COVER;}
			else if ( positionState == PILLAR_COVER::PIECE_POSITION::NOT_INVOLVED           ) { rate = _parameters_PieceEvaluation.pcEvalInfo.pieceWeight_NOT_INVOLVED;}

			// この駒がこの柱に対して起こす危険度
			int apparedRiskDegree_ByPiece = 
				(int) ((float)pillarList[i].riskDegree * ((float)rate / 100.0f));

			// 傘の斜め上だった場合は、経路を考慮する
			if ( positionState == PILLAR_COVER::PIECE_POSITION::ABOVE_COVER_DIAGONALLY ) {
				apparedRiskDegree_ByPiece = Evaluate_PC_S_HowFarPieceFromPillar ( pillarList[i], piecePositionList[n].x, piecePositionList[n].y, innerExpression); 
			}

			// 駒の高さを考慮する
			if ( pieceHeight >= 0 && positionState == PILLAR_COVER::PIECE_POSITION::ABOVE_COVER ) {

				// 何パーセント登っているか？
				int pillarHeight = pillarList[i].contentList.size();
				float climbRate  = (float)pieceHeight / (float)pillarHeight; 

				// 柱の最大危険度に、登り度を掛ける
				int climbRiskDegree = (int)((float)pillarList[i].maxRiskDegree * climbRate);

				// この値をどれだけ重く見るか？
				int pieceHeightWeight = _parameters_PieceEvaluation.pcEvalInfo.pieceHeightWeight;

				climbRiskDegree = (float)climbRiskDegree * (float)pieceHeightWeight / 100.0f;

				// 危険度、として加算する。
				apparedRiskDegree_ByPiece += climbRiskDegree;
			}

			// アルゴリズム：加算
			if ( _parameters_PieceEvaluation.pcEvalInfo.addingAlgorism == PILLAR_COVER::ALGORISM_FOR_RISK_DEGREE_ADDITION_TO_A_PILLAR::ADD ) {
				
				apparedRiskDegree += apparedRiskDegree_ByPiece;

			// アルゴリズム：最大値のみ
			} else if ( _parameters_PieceEvaluation.pcEvalInfo.addingAlgorism == PILLAR_COVER::ALGORISM_FOR_RISK_DEGREE_ADDITION_TO_A_PILLAR::MAX_ONLY ) {

				if ( apparedRiskDegree < apparedRiskDegree_ByPiece) {
					apparedRiskDegree = apparedRiskDegree_ByPiece;
				}
			}

		}

		// 攻められ側にとっての危険度、として加算
		result += apparedRiskDegree;
	}

	return result;
}


//==========================================================
// 柱に対する、駒の位置を求める
// 戻り値は PILLAR_COVER::PIECE_POSITION
//==========================================================
int AI::Evaluate_PC_S_GetPiecePositionTowardThePillar ( const Pillar &pillar, int pieceX, int pieceY, int &result_PieceHeight) {

	/*
		Pillar構造体が「根本」「先端」を持っているので、
		白黒は指定しなくていい。

		手駒の位置はどうなるか？
		根本が自陣である柱全てに対して、IN_THE_BOX
		根本が自陣ではない柱には、NOT_INVOLVED
	*/

	int result = PILLAR_COVER::PIECE_POSITION::NOT_INVOLVED;

	// 駒が柱のどの高さまで登っているか？ 駒が柱に乗っているときのみ、意味を持つ。
	result_PieceHeight = -1;

	///// 黒白は引数では問わないけど、柱の topY/bottomY の値から割り出せる
	int attackerTurn = 0;
	int goalY = 0;
	if ( pillar.bottomY > pillar.topY ) {
		attackerTurn  = TURN::BLACK;
		goalY         = 0;
	}
	else if ( pillar.bottomY < pillar.topY ) {
		attackerTurn  = TURN::WHITE;
		goalY         = _rule.boardHeight - 1;

	// 何？ 盤の縦幅が１ってこと？
	} else {
		// ゲームにならんですよね？
	}


	///// 手駒？
	if ( pieceX == -1 && pieceY == -1) {

		result = PILLAR_COVER::PIECE_POSITION::NOT_INVOLVED;

		// 黒→白？
		if ( attackerTurn == TURN::BLACK) {

			// 根本に、駒を設置できる
			if ( pillar.bottomY == _rule.boardHeight - 1 ) {

				// その柱の傘があるなら、傘の下
				if ( pillar.coverTopHeight >= 0  ) {

					result = PILLAR_COVER::PIECE_POSITION::UNDER_COVER;

				// 傘がないなら、手駒（いつでも効果を発揮する）
				} else {
					result = PILLAR_COVER::PIECE_POSITION::IN_THE_BOX;
				}
			}

		// 白→黒？
		} else if (attackerTurn == TURN::WHITE) {

			// 根本に、駒を設置できる
			if ( pillar.bottomY == 0 ) {

				// その柱の傘があるなら、傘の下
				if ( pillar.coverTopHeight >= 0  ) {

					result = PILLAR_COVER::PIECE_POSITION::UNDER_COVER;

				// 傘がないなら、手駒（いつでも効果を発揮する）
				} else {
					result = PILLAR_COVER::PIECE_POSITION::IN_THE_BOX;
				}
			}

		// 何？ 盤の縦幅が１ってこと？
		} else {

			// ゲームにならんですよね。
		}

		// 解決。めでたしめでたし。
		result_PieceHeight = -1;
		return result;
	}



	///// 柱の上に乗っているかどうか。
	bool isOnPillar = false;

	// 縦柱の場合
	if ( pillar.topX == pillar.bottomX ) {

		if ( pillar.topX == pieceX ) {
			isOnPillar = true;
		}

		int pieceHeight   = Utils_Cal::Abs ( pieceY - pillar.bottomY ); // 駒の高さ
		int converHeight  = pillar.coverTopHeight;                      // 傘の高さ

		// 柱の上に乗っている
		if ( isOnPillar ) {

			bool isUnderCover = ( pieceHeight <= converHeight );

			// 傘の下か？：駒位置が、柱の底から見て、傘の手前かどうか
			//if ( Utils_Cal::Abs ( pieceY - pillar.bottomY ) <= pillar.coverTopHeight ) {
			if ( isUnderCover ) {
				result = PILLAR_COVER::PIECE_POSITION::UNDER_COVER;
			} else {
				result = PILLAR_COVER::PIECE_POSITION::ABOVE_COVER;
			}

			// 駒の高さ＝駒の高さ
			result_PieceHeight = pieceHeight;

		// 柱の上には乗っていない
		} else {

			// 駒の高さ＝計測不能
			result_PieceHeight = -1;

			// 柱との、X方向の距離
			int distanceFromPillar = Utils_Cal::Abs ( pieceX - pillar.bottomX ); 

			// 傘の下か？：駒位置が、柱の底から見て、傘の手前かどうか
			// 柱から横に離れるほど、傘の位置が下がってくる、と考える（右辺の "- distance"）。
			bool isUnderCover = ( pieceHeight <= converHeight - distanceFromPillar );

			//if ( Utils_Cal::Abs ( pieceY - pillar.bottomY ) <= pillar.coverTopHeight - distanceFromPillar ) {
			if ( isUnderCover ) {
				
				result = PILLAR_COVER::PIECE_POSITION::UNDER_COVER_SIDE;

			// 傘の上。
			} else {

				/*
					柱からの距離（X方向）と、ゴールまでの距離（Y方向）を見比べる
					ゴールまでの距離の方が、より短い（<）場合、無関係。
				*/
				int distanceFromGoal = Utils_Cal::Abs( goalY - pieceY );

				if ( distanceFromGoal < distanceFromPillar ) {

					result = PILLAR_COVER::PIECE_POSITION::NOT_INVOLVED;

				} else {
					result = PILLAR_COVER::PIECE_POSITION::ABOVE_COVER_DIAGONALLY;
				}
			}
		}

		result_PieceHeight = pieceHeight;

	// 斜めの場合：縦と斜め45度しかないので、縦じゃないなら斜めってことで。
	} else {

		// 根本点に対して、斜め45度の位置？
		if ( Utils_Cal::Abs( pillar.bottomX - pieceX ) == Utils_Cal::Abs( pillar.bottomY - pieceY ) ) {

			// 先端点に対して、斜め45度の位置？
			if ( Utils_Cal::Abs( pillar.topX - pieceX ) == Utils_Cal::Abs( pillar.topY - pieceY ) ) {

				// じゃあ、乗ってるはず
				isOnPillar = true;
			}
		}

		/*
			傘先と柱底が構成する矩形の中に入っていれば、
			その駒は傘の下にいる、と言える。
		*/
		int directionX = Utils_Cal::Sign( pillar.topX - pillar.bottomX );
		int directionY = Utils_Cal::Sign( pillar.topY - pillar.bottomY );
		int  coverTopX = pillar.bottomX +  pillar.coverTopHeight * directionX;
		int  coverTopY = pillar.bottomY +  pillar.coverTopHeight * directionY;

		bool underCover = false;
		if ( Utils_Cal::IsBetween( pieceX, pillar.bottomX, coverTopX, true ) && Utils_Cal::IsBetween( pieceY, pillar.bottomY, coverTopY, true )  ) {
			underCover = true;
		}

		// 傘の下
		if (underCover) {

			// 柱の上？
			if (isOnPillar) {
				result = PILLAR_COVER::PIECE_POSITION::UNDER_COVER;

				// 駒の高さ＝柱底からの距離
				result_PieceHeight = Utils_Cal::Abs ( pillar.bottomY - pieceY );
			} else {
				result = PILLAR_COVER::PIECE_POSITION::UNDER_COVER_SIDE;
			}

		// 傘の上
		} else {

			// 柱の上？
			if (isOnPillar) {
				result = PILLAR_COVER::PIECE_POSITION::ABOVE_COVER;

				// 駒の高さ＝柱底からの距離
				result_PieceHeight = Utils_Cal::Abs ( pillar.bottomY - pieceY );

			} else {

				// 駒の高さ＝計測不能
				result_PieceHeight = -1;

				// 無関係かもしれない？
				/*
					柱の先端と根本が構成する矩形、の内側ならば、関係あり
				*/
				if ( Utils_Cal::IsBetween( pieceX, pillar.bottomX, pillar.topX, true ) && Utils_Cal::IsBetween( pieceY, pillar.bottomY, pillar.topY, true )  ) {

					result = PILLAR_COVER::PIECE_POSITION::ABOVE_COVER_DIAGONALLY;

				} else {
					result = PILLAR_COVER::PIECE_POSITION::NOT_INVOLVED;
				}
			}
		}
	}

	return result;
}

//==========================================================
// 駒から柱までの移動コストを考慮
// 駒は傘の斜め上であることが確定している、とする。
//==========================================================
int AI::Evaluate_PC_S_HowFarPieceFromPillar ( const Pillar &pillar, int pieceX, int pieceY, const InnerExpression* innerExpression) {

	//  戻り値は何？ What does the return value mean?
	// 「傘の斜め上」の危険度に、経路上の通れる箇所率を掛けた値。経路がふさがっている場合はゼロ。
	int result = 0;

	// 危険度引き出しレート
	float rate = (float)_parameters_PieceEvaluation.pcEvalInfo.pieceWeight_ABOVE_COVER_DIAGONALLY;

	// 最大危険度：このケースでの。経路上が全て通行可なら、この値になる。
	float riskDegreeMax = pillar.riskDegree * (rate / 100.0f);

	//printf ("傘の斜め上の危険度を計算\n");

	///// 縦の柱
	if ( pillar.bottomX == pillar.topX ) {

		///// X軸方向に柱に近づく
		float throuableRateAlongX = -1.0f;
		int   arrivedY_AlongX     = -1;
		do {

			// 柱に到達したとして、その高さは？
			int arrivedY = pieceY;
			int arrivedY_heightInThePillar = Utils_Cal::Abs ( pillar.bottomY - arrivedY );

			// 傘の下になってしまうなら、この経路はナシ。
			if ( arrivedY_heightInThePillar <= pillar.coverTopHeight ) {
				break;
			}

			// 柱までの距離（と方向）
			int distanceToPillar  = Utils_Cal::Abs ( pillar.bottomX - pieceX );
			int directionToPillar = Utils_Cal::Sign ( pillar.bottomX - pieceX );

			// 通れる矢印。（ここに来ている時点で、「柱の上」ではない前提。条件式にイコール入れない）
			int throuableArrow    = ( directionToPillar < 0 ) ? THROUGHABLE_INFO::MUST_TO_LEFT : THROUGHABLE_INFO::MUST_TO_RIGHT;

			// 経路上にある通行可能マスの数：途中に壁があったら「-1」とする
			int pathNum = 0;
			for ( int x = pieceX; x != pillar.bottomX; x += directionToPillar ) {

				int grid = innerExpression->_gridList_ThrouableInfo[pieceY][x];

				// 通行可能、または柱に向く矢印なら、通行可としてカウントする。
				if ( grid == THROUGHABLE_INFO::THROUGHABLE || grid == throuableArrow) {
					++pathNum;

				// 通れない。壁がある。カウント終了。
				} else if ( grid != THROUGHABLE_INFO::NOT_THROUGHABLE) {
					pathNum = -1;
					break;
				}
			}

			// 経路上に壁があったなら、この経路はナシ
			if ( pathNum == -1 ) {
				break;
			}

			// 柱までの距離に対する、通行可能マスの割合を求める。柱の真上じゃないので「distanceToPillar」はゼロじゃない前提。
			throuableRateAlongX = (float)pathNum / (float)distanceToPillar;

			// 辿り着いたとして、駒の高さ
			arrivedY_AlongX = arrivedY_heightInThePillar;

		} while (false);


		///// 斜め下方向に柱に近づく：手番に関係ない、絶対軸での上下
		float throuableRateAlongDiagonalDown = -1.0f;
		int   arrivedY_DiagonalDown = -1;
		do {

			// 柱までの距離（と方向）
			int distanceToPillar  = Utils_Cal::Abs ( pillar.bottomX - pieceX );
			int directionToPillar = Utils_Cal::Sign ( pillar.bottomX - pieceX );

			// 柱に到達したとして、その高さは？
			int arrivedY = pieceY + distanceToPillar;
			int arrivedY_heightInThePillar = Utils_Cal::Abs ( pillar.bottomY - arrivedY );

			// 盤をハミ出すなら、この経路はナシ
			if ( arrivedY >= _rule.boardHeight ) {
				break;
			}

			// 傘の下になってしまうなら、この経路はナシ。
			if ( arrivedY_heightInThePillar <= pillar.coverTopHeight ) {
				break;
			}

			// 経路上にある通行可能マスの数：途中に壁があったら「-1」とする
			// 通れる矢印はない。どの矢印も壁。
			int pathNum = 0;
			int currentY = pieceY;
			for ( int x = pieceX; x != pillar.bottomX; x += directionToPillar ) {

				int grid = innerExpression->_gridList_ThrouableInfo[currentY][x];

				// 通行可能、または柱に向く矢印なら、通行可としてカウントする。
				if ( grid == THROUGHABLE_INFO::THROUGHABLE) {
					++pathNum;

				// 通れない。壁がある。カウント終了。
				} else if ( grid != THROUGHABLE_INFO::NOT_THROUGHABLE) {
					pathNum = -1;
					break;
				}

				// 下に移動
				++currentY;
			}

			// 経路上に壁があったなら、この経路はナシ
			if ( pathNum == -1 ) {
				break;
			}

			// 柱までの距離に対する、通行可能マスの割合を求める。柱の真上じゃないので「distanceToPillar」はゼロじゃない前提。
			throuableRateAlongDiagonalDown = (float)pathNum / (float)distanceToPillar;

			// 辿りついたとして、駒の高さ
			arrivedY_DiagonalDown = arrivedY_heightInThePillar;

		} while (false);

		///// 斜め上方向に柱に近づく
		float throuableRateAlongDiagonalUp = -1.0f;
		int   arrivedY_DiagonalUp          = -1;
		do {

			// 柱までの距離（と方向）
			int distanceToPillar  = Utils_Cal::Abs ( pillar.bottomX - pieceX );
			int directionToPillar = Utils_Cal::Sign ( pillar.bottomX - pieceX );

			// 柱に到達したとして、その高さは？
			int arrivedY = pieceY - distanceToPillar;
			int arrivedY_heightInThePillar = Utils_Cal::Abs ( pillar.bottomY - arrivedY );

			// 盤をハミ出すなら、この経路はナシ
			if ( arrivedY < 0 ) {
				break;
			}

			// 傘の下になってしまうなら、この経路はナシ。
			if ( arrivedY_heightInThePillar <= pillar.coverTopHeight ) {
				break;
			}

			// 経路上にある通行可能マスの数：途中に壁があったら「-1」とする
			// 通れる矢印はない。どの矢印も壁。
			int pathNum = 0;
			int currentY = pieceY;
			for ( int x = pieceX; x != pillar.bottomX; x += directionToPillar ) {

				int grid = innerExpression->_gridList_ThrouableInfo[currentY][x];

				// 通行可能、または柱に向く矢印なら、通行可としてカウントする。
				if ( grid == THROUGHABLE_INFO::THROUGHABLE) {
					++pathNum;

				// 通れない。壁がある。カウント終了。
				} else if ( grid != THROUGHABLE_INFO::NOT_THROUGHABLE) {
					pathNum = -1;
					break;
				}

				// 上に移動
				--currentY;
			}

			// 経路上に壁があったなら、この経路はナシ
			if ( pathNum == -1 ) {
				break;
			}

			// 柱までの距離に対する、通行可能マスの割合を求める。柱の真上じゃないので「distanceToPillar」はゼロじゃない前提。
			throuableRateAlongDiagonalUp = (float)pathNum / (float)distanceToPillar;

			// 辿りついたとして、駒の高さ
			arrivedY_DiagonalUp = arrivedY_heightInThePillar;

		} while (false);

		float rateList[3];
		float heightList[3];
		int index = 0;
		if ( throuableRateAlongX            != -1.0f ) { rateList[index] = throuableRateAlongX; heightList[index] = arrivedY_AlongX; ++index; }
		if ( throuableRateAlongDiagonalDown != -1.0f ) { rateList[index] = throuableRateAlongDiagonalDown; heightList[index] = arrivedY_DiagonalDown; ++index; }
		if ( throuableRateAlongDiagonalUp   != -1.0f ) { rateList[index] = throuableRateAlongDiagonalUp; heightList[index] = arrivedY_DiagonalUp; ++index; }

		// 経路がふさがっているなら、危険度はゼロとする。
		result = 0;
		for ( unsigned int i = 0; i < index; ++i ) {

			// つまり、この値を見る。
			int n = (int)(riskDegreeMax * rateList[i]);

			///// 高さを考慮する
			// 何パーセント登っているか？
			int pillarHeight = pillar.contentList.size();
			float climbRate  = (float)heightList[i] / (float)pillarHeight; 
			
			// 柱の最大危険度に、登り度を掛ける
			// ここで riskDegreeMax を最大危険度として使う。この文脈での最大危険度、ということ。
			int climbRiskDegree = (int)((float)riskDegreeMax * climbRate);

			// この値をどれだけ重く見るか？
			int pieceHeightWeight = _parameters_PieceEvaluation.pcEvalInfo.pieceHeightWeight;

			climbRiskDegree = (float)climbRiskDegree * (float)pieceHeightWeight / 100.0f;

			// 危険度、として加算する。
			n += climbRiskDegree;


			// 最大になる値を残す。
			if ( n > result ) {
				result = n;
			}
		}

		
	///// 斜めの柱
	} else {

		//printf("斜めの柱\n");

		///// 斜め方向に柱に近づく
		float throuableRateDiagonal = -1.0f;
		int   arrivedY_Diagonal     = -1;
		do {

			// 縦方向の接点を求める。
			int contactX_Virtical = Utils_Cal::Nearlize ( pillar.bottomX, pillar.topX, Utils_Cal::Abs ( pillar.bottomX - pieceX )) ;
			int contactY_Virtical = Utils_Cal::Nearlize ( pillar.bottomY, pillar.topY, Utils_Cal::Abs ( pillar.bottomX - pieceX )) ;

			// 横方向の接点を求める。
			int contactY_Hrizonal = Utils_Cal::Nearlize ( pillar.bottomY, pillar.topY, Utils_Cal::Abs ( pillar.bottomY - pieceY )) ;
			int contactX_Hrizonal = Utils_Cal::Nearlize ( pillar.bottomX, pillar.topX, Utils_Cal::Abs ( pillar.bottomY - pieceY )) ;

			// 間をすり抜けるなら、この経路はナシ
			if ( (contactX_Virtical - contactX_Hrizonal) % 2 != 0  ) {
				break;
			}

			// 斜め方向の接点を求める。
			int contactX = (contactX_Virtical + contactX_Hrizonal) / 2;
			int contactY = (contactY_Virtical + contactY_Hrizonal) / 2;

			// 盤からハミ出るなら、この経路はナシ
			if ( !Evaluate_PC_IsOnTheBoard ( contactX, contactY ) ) {
				break;
			}

			// 柱に到達したとして、その高さは？
			int arrivedY_heightInThePillar = Utils_Cal::Abs ( pillar.bottomY - contactY );

			// 傘の下になってしまうなら、この経路はナシ。
			if ( arrivedY_heightInThePillar <= pillar.coverTopHeight ) {
				break;
			}

			// 柱までの距離（と方向）
			int distanceToPillar  = Utils_Cal::Abs  ( contactY - pieceY );
			int directionToPillar_X = Utils_Cal::Sign ( contactX - pieceX );
			int directionToPillar_Y = Utils_Cal::Sign ( contactY - pieceY );


			// 経路上にある通行可能マスの数：途中に壁があったら「-1」とする
			// 通れる矢印は、なし
			int pathNum = 0;
			int y = pieceY;
			for ( int x = pieceX; x != contactX; x += directionToPillar_X ) {

				int grid = innerExpression->_gridList_ThrouableInfo[y][x];

				// 通行可能ならば通行可としてカウントする。
				if ( grid == THROUGHABLE_INFO::THROUGHABLE) {
					++pathNum;

				// 通れない。壁がある。カウント終了。
				} else if ( grid != THROUGHABLE_INFO::NOT_THROUGHABLE) {
					pathNum = -1;
					break;
				}

				// Y方向にも動く
				y += directionToPillar_Y;
			}

			// 経路上に壁があったなら、この経路はナシ
			if ( pathNum == -1 ) {
				break;
			}

			// 柱までの距離に対する、通行可能マスの割合を求める。柱の真上じゃないので「distanceToPillar」はゼロじゃない前提。
			throuableRateDiagonal = (float)pathNum / (float)distanceToPillar;

			// 到達したとして、柱上での高さ
			arrivedY_Diagonal = arrivedY_heightInThePillar;

		} while (false);


		///// Y軸方向に柱に近づく
		float throuableRateAlongY = -1.0f;
		int   arrivedY_AlongY     = -1;
		do {

			// 縦方向の接点を求める。
			int contactX = Utils_Cal::Nearlize ( pillar.bottomX, pillar.topX, Utils_Cal::Abs ( pillar.bottomX - pieceX )) ;
			int contactY = Utils_Cal::Nearlize ( pillar.bottomY, pillar.topY, Utils_Cal::Abs ( pillar.bottomX - pieceX )) ;

			// 盤からハミ出るなら、この経路はナシ
			if ( !Evaluate_PC_IsOnTheBoard ( contactX, contactY ) ) {
				break;
			}

			// 柱に到達したとして、その高さは？
			int arrivedY_heightInThePillar = Utils_Cal::Abs ( pillar.bottomY - contactY );

			// 傘の下になってしまうなら、この経路はナシ。
			if ( arrivedY_heightInThePillar <= pillar.coverTopHeight ) {
				break;
			}

			// 柱までの距離（と方向）
			int distanceToPillar  = Utils_Cal::Abs  ( contactY - pieceY );
			int directionToPillar = Utils_Cal::Sign ( contactY - pieceY );

			// 通れる矢印。（ここに来ている時点で、「柱の上」ではない前提。条件式にイコール入れない）
			int throuableArrow    = ( directionToPillar < 0 ) ? THROUGHABLE_INFO::MUST_TO_UP : THROUGHABLE_INFO::MUST_TO_DOWN;

			// 経路上にある通行可能マスの数：途中に壁があったら「-1」とする
			int pathNum = 0;
			for ( int y = pieceY; y != contactY; y += directionToPillar ) {

				int grid = innerExpression->_gridList_ThrouableInfo[y][pieceX];

				// 通行可能、または柱に向く矢印なら、通行可としてカウントする。
				if ( grid == THROUGHABLE_INFO::THROUGHABLE || grid == throuableArrow) {
					++pathNum;

				// 通れない。壁がある。カウント終了。
				} else if ( grid != THROUGHABLE_INFO::NOT_THROUGHABLE) {
					pathNum = -1;
					break;
				}
			}

			// 経路上に壁があったなら、この経路はナシ
			if ( pathNum == -1 ) {
				break;
			}

			// 柱までの距離に対する、通行可能マスの割合を求める。柱の真上じゃないので「distanceToPillar」はゼロじゃない前提。
			throuableRateAlongY = (float)pathNum / (float)distanceToPillar;

			// 到達したとして、柱上での高さ
			arrivedY_AlongY = arrivedY_heightInThePillar;

		} while (false);



		///// X軸方向に柱に近づく
		float throuableRateAlongX = -1.0f;
		int   arrivedY_AlongX     = -1;
		do {

			// 横方向の接点を求める。
			int contactY = Utils_Cal::Nearlize ( pillar.bottomY, pillar.topY, Utils_Cal::Abs ( pillar.bottomY - pieceY )) ;
			int contactX = Utils_Cal::Nearlize ( pillar.bottomX, pillar.topX, Utils_Cal::Abs ( pillar.bottomY - pieceY )) ;

			// 盤からハミ出るなら、この経路はナシ
			if ( !Evaluate_PC_IsOnTheBoard ( contactX, contactY ) ) {
				break;
			}

			// 柱に到達したとして、その高さは？
			int arrivedY_heightInThePillar = Utils_Cal::Abs ( pillar.bottomY - contactY );

			// 傘の下になってしまうなら、この経路はナシ。
			if ( arrivedY_heightInThePillar <= pillar.coverTopHeight ) {
				break;
			}

			// 柱までの距離（と方向）
			int distanceToPillar  = Utils_Cal::Abs  ( contactX - pieceX );
			int directionToPillar = Utils_Cal::Sign ( contactX - pieceX );

			// 通れる矢印。（ここに来ている時点で、「柱の上」ではない前提。条件式にイコール入れない）
			int throuableArrow    = ( directionToPillar < 0 ) ? THROUGHABLE_INFO::MUST_TO_LEFT : THROUGHABLE_INFO::MUST_TO_RIGHT;

			// 経路上にある通行可能マスの数：途中に壁があったら「-1」とする
			int pathNum = 0;
			for ( int x = pieceX; x != contactX; x += directionToPillar ) {

				int grid = innerExpression->_gridList_ThrouableInfo[pieceY][x];

				// 通行可能、または柱に向く矢印なら、通行可としてカウントする。
				if ( grid == THROUGHABLE_INFO::THROUGHABLE || grid == throuableArrow) {
					++pathNum;

				// 通れない。壁がある。カウント終了。
				} else if ( grid != THROUGHABLE_INFO::NOT_THROUGHABLE) {
					pathNum = -1;
					break;
				}
			}

			// 経路上に壁があったなら、この経路はナシ
			if ( pathNum == -1 ) {
				break;
			}

			// 柱までの距離に対する、通行可能マスの割合を求める。柱の真上じゃないので「distanceToPillar」はゼロじゃない前提。
			throuableRateAlongX = (float)pathNum / (float)distanceToPillar;

			// 到達したとして、柱上での高さ
			arrivedY_AlongX = arrivedY_heightInThePillar;

		} while (false);

		float rateList[3];
		int   heightList[3];
		int index = 0;
		if ( throuableRateAlongX   != -1.0f ) { rateList[index] = throuableRateAlongX;   heightList[index] = arrivedY_AlongX; ++index; }
		if ( throuableRateAlongY   != -1.0f ) { rateList[index] = throuableRateAlongY;   heightList[index] = arrivedY_AlongY; ++index;}
		if ( throuableRateDiagonal != -1.0f ) { rateList[index] = throuableRateDiagonal; heightList[index] = arrivedY_Diagonal; ++index;}

		// 経路がふさがっているなら、危険度はゼロとする。
		result = 0;
		for ( unsigned int i = 0; i < index; ++i ) {

			// つまり、この値を見る。
			int n = (int)(riskDegreeMax * rateList[i]);

			///// 高さを考慮する
			// 何パーセント登っているか？
			int pillarHeight = pillar.contentList.size();
			float climbRate  = (float)heightList[i] / (float)pillarHeight; 
			
			// 柱の最大危険度に、登り度を掛ける
			// ここで riskDegreeMax を最大危険度として使う。この文脈での最大危険度、ということ。
			int climbRiskDegree = (int)((float)riskDegreeMax * climbRate);

			// この値をどれだけ重く見るか？
			int pieceHeightWeight = _parameters_PieceEvaluation.pcEvalInfo.pieceHeightWeight;

			climbRiskDegree = (float)climbRiskDegree * (float)pieceHeightWeight / 100.0f;

			// 危険度、として加算する。
			n += climbRiskDegree;


			// 最大になる値を残す。
			if ( n > result ) {
				result = n;
			}

		}
	}


	return result;
}

//==========================================================
// 駒の位置リストを作成
// どっちの色の駒かを指定のこと GRID;;BLACK/WHITE
// 手駒は、位置(-1, -1)で表現。複数あっても１つ扱い
//
//【戻り値】件数
//
//==========================================================
int AI::Evaluate_PC_S_MakePiecePositionList ( const InnerExpression *innerExpression, Position* &piecePisitionList, int gridColor) {

	///// まずはクリアしてしまいますよ。
	for (int i = 0; i < _rule.boardWidth * _rule.boardHeight; ++i) { // 件数は盤上にあるマス目の数
		piecePisitionList[i].Clear();
	}

	int index = 0;

	///// 手駒の分
	if ( gridColor == GRID::BLACK ) {

		if ( innerExpression->_handPiece_BLACK > 0 ) {

			piecePisitionList[index].x = -1;
			piecePisitionList[index].y = -1;
			++index;
		}

	}
	else if ( gridColor == GRID::WHITE ) {

		if ( innerExpression->_handPiece_WHITE > 0 ) {

			piecePisitionList[index].x = -1;
			piecePisitionList[index].y = -1;
			++index;
		}

	}

	///// 盤上に出ている分
	for ( int y = 0; y < _rule.boardHeight; ++y ) {
		for ( int x = 0; x < _rule.boardWidth; ++x ) {

			// 指定の色があったか。
			if ( innerExpression->_gridList_Piece[y][x] == gridColor ) {

				piecePisitionList[index].x = x;
				piecePisitionList[index].y = y;
				++index;
			}
		}
	}

	// つまり、この値は件数を表していると考えてよいはず。
	return index;
}


//==========================================================
// 柱リストを作成：黒攻め白へ
//==========================================================
void AI::Evaluate_PC_S_MakePillarList_BlackToWhite ( const InnerExpression *innerExpression, vector<Pillar> &pillarList ) {

	///// 縦柱
	for ( int x = 0; x < _rule.boardWidth; ++x) {

		Pillar pillar;
		pillar.bottomX = x; pillar.bottomY = _rule.boardHeight - 1;
		pillar.topX    = x; pillar.topY    = 0;


		///// 下（根本）から上（先端）へ
		int height = 0;
		for (int y = _rule.boardHeight - 1; y >= 0; --y) {
			
			int pathOrWall = Evaluate_PC_Translate_THROUGHABLE_into_OneSidePath ( innerExpression->_gridList_ThrouableInfo[y][x], TURN::BLACK, false );

			///// 通れる、通れない、の成分
			pillar.contentList.push_back ( pathOrWall );

			///// 一番最後に出てきた「壁」が、攻め側の攻めを止める「傘」の先端、ということ
			if ( pathOrWall == PILLAR_COVER::THROUGHABLE_INFO::WALL) {

				// でもすでに柱の先端だったら、傘としては機能しませんよ
				if ( y > 0 ) {
					pillar.coverTopHeight = height;
				}
			}

			++height;
		}

		// 柱構造体 を リストに入れる。
		pillarList.push_back ( pillar );

	}
	

	///// 斜め／柱
	{
		///// 柱の根本位置のリストを作成
		/*
			盤の左端を上から下へ、盤の下端を左から右へ
		*/
		vector< pair<int, int> > bottomPositionList;

		// 盤の左端を上から下へ
		for ( int y = 0; y < _rule.boardHeight; ++y ) {

			pair<int, int> bottomPosition;
			bottomPosition.first  = 0;
			bottomPosition.second = y;
			bottomPositionList.push_back( bottomPosition );
		}
		// 盤の下端を左から右へ
		for ( int x = 1; x < _rule.boardWidth; ++x ) {

			pair<int, int> bottomPosition;
			bottomPosition.first  = x;
			bottomPosition.second = _rule.boardHeight - 1;
			bottomPositionList.push_back( bottomPosition );
		}

		///// 根本から先端へ向かう：根本でループ
		for (unsigned int i = 0; i < bottomPositionList.size(); ++i) {

			Pillar pillar;
			pillar.bottomX = bottomPositionList[i].first;
			pillar.bottomY = bottomPositionList[i].second;

			int currentX = pillar.bottomX;
			int currentY = pillar.bottomY;

			int height = 0;
			bool isKeepLoop = true;
			do {

				// 次の位置
				int nextX = currentX + 1;
				int nextY = currentY - 1;

				// 次の位置が盤面からハミ出るならば、現在の位置が「柱の先端」
				if ( !Evaluate_PC_IsOnTheBoard( nextX, nextY ) ) {

					pillar.topX = currentX;
					pillar.topY = currentY;
					isKeepLoop = false;
				}

				int pathOrWall = Evaluate_PC_Translate_THROUGHABLE_into_OneSidePath ( innerExpression->_gridList_ThrouableInfo[currentY][currentX], TURN::BLACK, true );

				///// 通れる、通れない、の成分
				pillar.contentList.push_back ( pathOrWall );

				///// 一番最後に出てきた「壁」が、攻め側の攻めを止める「傘」の先端、ということ
				if ( pathOrWall == PILLAR_COVER::THROUGHABLE_INFO::WALL) {

					// でも、すでに傘の先端だったら、「傘」としては機能しないですよ
					if ( pillar.topX != currentX || pillar.topY != currentY ) {
						pillar.coverTopHeight = height;
					}
				}

				// 次の位置へ、柱を昇る
				currentX = nextX;
				currentY = nextY;

				++height;

			} while (isKeepLoop);

			///// 高さが足りていれば、追加
			if ( pillar.contentList.size() >= _parameters_PieceEvaluation.pcEvalInfo.reqiredHeightForPillar ) {
				pillarList.push_back( pillar );
			}
		}
	}

	///// 斜め＼柱
	{
		///// 柱の根本位置のリストを作成
		/*
			盤の右端を上から下へ、盤の下端を右から左へ
		*/
		vector< pair<int, int> > bottomPositionList;

		// 盤の右端を上から下へ
		for ( int y = 0; y < _rule.boardHeight; ++y ) {

			pair<int, int> bottomPosition;
			bottomPosition.first  = _rule.boardWidth - 1;
			bottomPosition.second = y;
			bottomPositionList.push_back( bottomPosition );
		}
		// 盤の下端を右から左へ
		for ( int x = _rule.boardWidth - 2; x >= 0; --x ) {

			pair<int, int> bottomPosition;
			bottomPosition.first  = x;
			bottomPosition.second = _rule.boardHeight - 1;
			bottomPositionList.push_back( bottomPosition );
		}

		///// 根本から先端へ向かう：根本でループ
		for (unsigned int i = 0; i < bottomPositionList.size(); ++i) {

			Pillar pillar;
			pillar.bottomX = bottomPositionList[i].first;
			pillar.bottomY = bottomPositionList[i].second;

			int currentX = pillar.bottomX;
			int currentY = pillar.bottomY;

			int height = 0;
			bool isKeepLoop = true;
			do {

				// 次の位置
				int nextX = currentX - 1;
				int nextY = currentY - 1;

				// 次の位置が盤面からハミ出るならば、現在の位置が「柱の先端」
				if ( !Evaluate_PC_IsOnTheBoard( nextX, nextY ) ) {

					pillar.topX = currentX;
					pillar.topY = currentY;
					isKeepLoop = false;
				}

				int pathOrWall = Evaluate_PC_Translate_THROUGHABLE_into_OneSidePath ( innerExpression->_gridList_ThrouableInfo[currentY][currentX], TURN::BLACK, true );

				///// 通れる、通れない、の成分
				pillar.contentList.push_back ( pathOrWall );

				///// 一番最後に出てきた「壁」が、攻め側の攻めを止める「傘」の先端、ということ
				if ( pathOrWall == PILLAR_COVER::THROUGHABLE_INFO::WALL) {

					// でも、すでに傘の先端だったら、「傘」としては機能しないですよ
					if ( pillar.topX != currentX || pillar.topY != currentY ) {
						pillar.coverTopHeight = height;
					}
				}

				// 次の位置へ、柱を昇る
				currentX = nextX;
				currentY = nextY;

				++height;

			} while (isKeepLoop);

			///// 高さが足りていれば、追加
			if ( pillar.contentList.size() == _parameters_PieceEvaluation.pcEvalInfo.reqiredHeightForPillar ) {
				pillarList.push_back( pillar );
			}
		}
	}

}
//==========================================================
// 柱リストを作成：白攻め黒へ
//==========================================================
void AI::Evaluate_PC_S_MakePillarList_WhiteToBlack ( const InnerExpression *innerExpression, vector<Pillar> &pillarList ) {

	///// 縦柱
	for ( int x = 0; x < _rule.boardWidth; ++x) {

		Pillar pillar;
		pillar.bottomX = x; pillar.bottomY = 0;
		pillar.topX    = x; pillar.topY    = _rule.boardHeight - 1;


		///// 上（根本）から下（先端）へ
		int height = 0;
		for (int y = 0; y < _rule.boardHeight; ++y) {

			int pathOrWall = Evaluate_PC_Translate_THROUGHABLE_into_OneSidePath ( innerExpression->_gridList_ThrouableInfo[y][x], TURN::WHITE, false );

			///// 通れる、通れない、の成分
			pillar.contentList.push_back ( pathOrWall );

			///// 一番最後に出てきた「壁」が、攻め側の攻めを止める「傘」の先端、ということ
			if ( pathOrWall == PILLAR_COVER::THROUGHABLE_INFO::WALL) {

				// でもすでに柱の先端だったら、傘としては機能しませんよ
				if ( y  <= _rule.boardHeight - 1  ) {
					pillar.coverTopHeight = height;
				}
			}

			++height;
		}

		// 柱構造体 を リストに入れる。
		pillarList.push_back ( pillar );
	}

	///// 斜め／柱
	{
		///// 柱の根本位置のリストを作成
		/*
			盤の左端を上から下へ、盤の下端を右から左へ
		*/
		vector< pair<int, int> > bottomPositionList;

		// 盤の右端を下から上へ
		for ( int y = _rule.boardHeight - 1; y >= 0; --y ) {

			pair<int, int> bottomPosition;
			bottomPosition.first  = _rule.boardWidth - 1;
			bottomPosition.second = y;
			bottomPositionList.push_back( bottomPosition );
		}
		// 盤の上端を右から左へ
		for ( int x = _rule.boardWidth - 2; x >= 0; --x ) {

			pair<int, int> bottomPosition;
			bottomPosition.first  = x;
			bottomPosition.second = 0;
			bottomPositionList.push_back( bottomPosition );
		}

		///// 根本から先端へ向かう：根本でループ
		for (unsigned int i = 0; i < bottomPositionList.size(); ++i) {

			Pillar pillar;
			pillar.bottomX = bottomPositionList[i].first;
			pillar.bottomY = bottomPositionList[i].second;

			int currentX = pillar.bottomX;
			int currentY = pillar.bottomY;

			int height = 0;
			bool isKeepLoop = true;
			do {

				// 次の位置
				int nextX = currentX - 1;
				int nextY = currentY + 1;

				// 次の位置が盤面からハミ出るならば、現在の位置が「柱の先端」
				if ( !Evaluate_PC_IsOnTheBoard( nextX, nextY ) ) {

					pillar.topX = currentX;
					pillar.topY = currentY;
					isKeepLoop = false;
				}

				int pathOrWall = Evaluate_PC_Translate_THROUGHABLE_into_OneSidePath ( innerExpression->_gridList_ThrouableInfo[currentY][currentX], TURN::WHITE, true );

				///// 通れる、通れない、の成分
				pillar.contentList.push_back ( pathOrWall );

				///// 一番最後に出てきた「壁」が、攻め側の攻めを止める「傘」の先端、ということ
				if ( pathOrWall == PILLAR_COVER::THROUGHABLE_INFO::WALL) {

					// でもすでに柱の先端だったらダメですよ
					if ( pillar.topX != currentX || pillar.topY != currentY ) {
						pillar.coverTopHeight = height;
					}
				}

				// 次の位置へ、柱を昇る
				currentX = nextX;
				currentY = nextY;

				++height;

			} while (isKeepLoop);

			///// 高さが足りていれば、追加
			if ( pillar.contentList.size() >= _parameters_PieceEvaluation.pcEvalInfo.reqiredHeightForPillar ) {
				pillarList.push_back( pillar );
			}
		}
	}

	///// 斜め＼柱
	{
		///// 柱の根本位置のリストを作成
		/*
			盤の左端を下から上へ、盤の上端を左から右へ
		*/
		vector< pair<int, int> > bottomPositionList;

		// 盤の左端を下から上へ
		for ( int y = _rule.boardHeight - 1; y >= 0; --y ) {

			pair<int, int> bottomPosition;
			bottomPosition.first  = 0;
			bottomPosition.second = y;
			bottomPositionList.push_back( bottomPosition );
		}
		// 盤の上端を左から右へ
		for ( int x = 1; x < _rule.boardWidth; ++x ) {

			pair<int, int> bottomPosition;
			bottomPosition.first  = x;
			bottomPosition.second = 0;
			bottomPositionList.push_back( bottomPosition );
		}

		///// 根本から先端へ向かう：根本でループ
		for (unsigned int i = 0; i < bottomPositionList.size(); ++i) {

			Pillar pillar;
			pillar.bottomX = bottomPositionList[i].first;
			pillar.bottomY = bottomPositionList[i].second;

			int currentX = pillar.bottomX;
			int currentY = pillar.bottomY;

			int height = 0;
			bool isKeepLoop = true;
			do {

				// 次の位置
				int nextX = currentX + 1;
				int nextY = currentY + 1;

				// 次の位置が盤面からハミ出るならば、現在の位置が「柱の先端」
				if ( !Evaluate_PC_IsOnTheBoard( nextX, nextY ) ) {

					pillar.topX = currentX;
					pillar.topY = currentY;
					isKeepLoop = false;
				}

				int pathOrWall = Evaluate_PC_Translate_THROUGHABLE_into_OneSidePath ( innerExpression->_gridList_ThrouableInfo[currentY][currentX], TURN::WHITE, true );

				///// 通れる、通れない、の成分
				pillar.contentList.push_back ( pathOrWall );

				///// 一番最後に出てきた「壁」が、攻め側の攻めを止める「傘」の先端、ということ
				if ( pathOrWall == PILLAR_COVER::THROUGHABLE_INFO::WALL) {
	
					// でもすでに柱の先端だったらダメですよ
					if ( pillar.topX != currentX || pillar.topY != currentY ) {
						pillar.coverTopHeight = height;
					}
				}

				// 次の位置へ、柱を昇る
				currentX = nextX;
				currentY = nextY;

				++height;

			} while (isKeepLoop);

			///// 高さが足りていれば、追加
			if ( pillar.contentList.size() >= _parameters_PieceEvaluation.pcEvalInfo.reqiredHeightForPillar ) {
				pillarList.push_back( pillar );
			}
		}
	}
}

//==========================================================
// 柱の潜在的な危険度を計算
// 「攻め」が黒か白かを指定のこと
//==========================================================
void AI::Evaluate_PC_S_RiskDegreeUpdate ( vector<Pillar> &pillarList, int attackerTurn ) {

	for ( unsigned int i = 0; i < pillarList.size(); ++i ) {

		// ゴール位置：「攻め側」が黒か白かで変わるところ
		int goalHeight = 0;
		if ( attackerTurn == TURN::BLACK ) {
			goalHeight = 0;
		} else if ( attackerTurn == TURN::WHITE ) {
			goalHeight = _rule.boardHeight - 1;
		}

		// 柱の先端が相手陣にどれだけ近いかを計算
		int fromGoal = Utils_Cal::Abs ( goalHeight - pillarList[i].topY );

		// 想定内？
		if ( fromGoal <  _parameters_PieceEvaluation.pcEvalInfo.goalValueList.size()) {

			// 危険度の最大値
			int maxRiskDegree = _parameters_PieceEvaluation.pcEvalInfo.goalValueList[ fromGoal ];
			pillarList[i].maxRiskDegree = maxRiskDegree;

			// 通行可能マスの数
			int pathNumber = 0;
			for ( unsigned int n = 0; n < pillarList[i].contentList.size(); ++n ) {

				if (pillarList[i].contentList[n] == PILLAR_COVER::THROUGHABLE_INFO::PATH) {
					++pathNumber;
				}
			}
			// 通行可能マスの割合：通行可能マスが０個だったら、割合もゼロ。危険度もゼロ
			float pathRate = ( pillarList[i].contentList.size() == 0 ) ? 0.0f : (float)pathNumber / pillarList[i].contentList.size() * 100.0f;

			// 通行可能マスの割合で、危険度を決める
			pillarList[i].riskDegree = (int) ((float)maxRiskDegree * pathRate / 100.0f);


		// 想定外の低さ
		} else {
			// 内容に関わらず、危険度ゼロ。
			pillarList[i].riskDegree = 0;
		}

	}

}

//==========================================================
// Evaluate_PC 子処理群：_rule に照らして、盤の上なら true
//==========================================================
bool AI::Evaluate_PC_S_IsOnTheBoard ( int x, int y) {

	bool result = false;

	if ( x >= 0 && x < _rule.boardWidth ) {
		if ( y >= 0 && y < _rule.boardHeight ) {
			result = true;
		}
	}

	return result;
}


//==========================================================
// Evaluate_PC 子処理群：柱内、黒から白への通行可能パネルか？
//==========================================================
int AI::Evaluate_PC_S_Translate_THROUGHABLE_into_OneSidePath ( int throuableInfo, int forThisTurn, bool isDiagonal ) {

	int result = PILLAR_COVER::THROUGHABLE_INFO::EMPTY;

	///// 黒、白、共通部分
	if      ( throuableInfo == THROUGHABLE_INFO::THROUGHABLE     ) { result = PILLAR_COVER::THROUGHABLE_INFO::PATH; }
	else if ( throuableInfo == THROUGHABLE_INFO::NOT_THROUGHABLE ) { result = PILLAR_COVER::THROUGHABLE_INFO::EMPTY;}
	else if ( throuableInfo == THROUGHABLE_INFO::MUST_TO_LEFT  ) { result = PILLAR_COVER::THROUGHABLE_INFO::WALL;}
	else if ( throuableInfo == THROUGHABLE_INFO::MUST_TO_RIGHT ) { result = PILLAR_COVER::THROUGHABLE_INFO::WALL;}

	///// 黒、白、で入れ替わる部分
	else {

		// 斜め柱であれば、上矢印も下矢印も、どっちも壁
		if ( isDiagonal ) {
			if      ( throuableInfo == THROUGHABLE_INFO::MUST_TO_UP   ) { result = PILLAR_COVER::THROUGHABLE_INFO::WALL; }
			else if ( throuableInfo == THROUGHABLE_INFO::MUST_TO_DOWN ) { result = PILLAR_COVER::THROUGHABLE_INFO::WALL; }

		// 縦柱であれば、黒白で、縦矢印の意味が異なる。
		} else {

			// 黒→白へ通れるか？
			if ( forThisTurn == TURN::BLACK ) {
				if      ( throuableInfo == THROUGHABLE_INFO::MUST_TO_UP   ) { result = PILLAR_COVER::THROUGHABLE_INFO::PATH; }
				else if ( throuableInfo == THROUGHABLE_INFO::MUST_TO_DOWN ) { result = PILLAR_COVER::THROUGHABLE_INFO::WALL; }
			}
			// 白→黒へ通れるか？
			else if ( forThisTurn == TURN::WHITE ) {
				if      ( throuableInfo == THROUGHABLE_INFO::MUST_TO_UP   ) { result = PILLAR_COVER::THROUGHABLE_INFO::WALL; }
				else if ( throuableInfo == THROUGHABLE_INFO::MUST_TO_DOWN ) { result = PILLAR_COVER::THROUGHABLE_INFO::PATH; }

			}
		}
	}

	return result;
}

//==========================================================
// Evaluate_PC 子処理群：
// 盤面上のマス目数を想定した割り算。
// 奇数マスのとき、中間の値が出るように。
// たとえば、９マス÷２＝５
//==========================================================
int AI::Evaluate_PC_S_DevideSubstansialNumber ( int value, int divider ) {

	/*
		というか、「÷２」以外、ないのかも？
	*/

	int result = 0;

	// 一応、ゼロ除算対策
	if ( divider == 0 ) {
		printf ( "ゼロ除算：Evaluate_PC_DevideSubstansialNumber (%d, %d)", value, divider );
		return result;
	}

	// 元の数が偶数
	if ( value % 2 == 0 ) {

		result = value / divider;

	// 元の数が奇数
	} else {

		result = (value + 1) / divider;
	}

	return result;
}



//=========================================================
// 柱とする枠・型を生成：現時点のルールに基づいて
//=========================================================
void AI::Evaluate_PC_S_Prepare_PillarMold() {

	Evaluate_PC_S_Prepare_PillarMold_Clear();
	Evaluate_PC_S_Prepare_PillarMold_Black();
	Evaluate_PC_S_Prepare_PillarMold_White();

	/*
	printf ( "pillarListSize_Black : %d\n", pillarListSize_Black );
	for (int i = 0; i < pillarListSize_Black; ++i) {

		printf("[%d] ", i);
		for ( int n = 0; n < _pillarMold_Black_SizeList[i]; ++n ) {

			printf ( "(%d, %d) ",
				_pillarMold_Black_S[i][n].x, _pillarMold_Black_S[i][n].y
			);
		}
		printf("\n");
	}


	printf ( "pillarListSize_White : %d\n", pillarListSize_White );
	for (int i = 0; i < pillarListSize_White; ++i) {

		printf("[%d] ", i);
		for ( int n = 0; n < _pillarMold_White_SizeList[i]; ++n ) {

			printf ( "(%d, %d) ",
				_pillarMold_White_S[i][n].x, _pillarMold_White_S[i][n].y
			);
		}
		printf("\n");
	}
	*/

	delete[] pillarList_Black_to_White_S;
	delete[] pillarList_White_to_Black_S;
	pillarList_Black_to_White_S = new Pillar [ pillarListSize_Black ];
	pillarList_White_to_Black_S = new Pillar [ pillarListSize_White ];

	delete[] piecePositionList_Black;
	delete[] piecePositionList_White;
	piecePositionList_Black = new Position[ _rule.boardHeight * _rule.boardWidth ];
	piecePositionList_White = new Position[ _rule.boardHeight * _rule.boardWidth ];

}

//=========================================================
// 柱とする枠・型を生成：旧メモリをクリア
//=========================================================
void AI::Evaluate_PC_S_Prepare_PillarMold_Clear() {

	///// クリア、黒の分
	for ( int i = 0; i < pillarListSizeMax_Black; ++i ) {
		delete[] _pillarMold_Black_S[i];
	}
	delete[] _pillarMold_Black_S;
	_pillarMold_Black_S = NULL;

	delete[] _pillarMold_Black_SizeList;
	_pillarMold_Black_SizeList = NULL;

	///// クリア、白の分
	for ( int i = 0; i < pillarListSizeMax_White; ++i ) {
		delete[] _pillarMold_White_S[i];
	}
	delete[] _pillarMold_White_S;
	_pillarMold_White_S = NULL;

	delete[] _pillarMold_White_SizeList;
	_pillarMold_White_SizeList = NULL;
}

//=========================================================
// 柱とする枠・型を生成：現時点のルールに基づいて：黒
//=========================================================
void AI::Evaluate_PC_S_Prepare_PillarMold_Black() {

	// 柱は最大、何本になり得るか？
	pillarListSizeMax_Black = 
		_rule.boardWidth +                               // 縦柱
		(_rule.boardWidth + _rule.boardHeight - 1) * 2; // 斜柱

	// 実際の柱の本数：さしあたり０。
	pillarListSize_Black    = 0;

	// 柱内のグリッド数は最大でいくつになり得るか？：盤の高さに等しい
	pillarGridListSizeMax_Black = _rule.boardHeight; 


	// 最大サイズ分、メモリを確保	
	_pillarMold_Black_S = new Position*[pillarListSizeMax_Black];
	_pillarMold_Black_SizeList = new int[pillarListSizeMax_Black];
	for (int i = 0; i < pillarListSizeMax_Black; ++i) {

		_pillarMold_Black_S[i] = new Position[pillarGridListSizeMax_Black];
	}


	///// 縦柱
	for ( int x = 0; x < _rule.boardWidth; ++x) {

		int gridIndex = 0;
		for (int y = _rule.boardHeight - 1; y >= 0; --y) {

			_pillarMold_Black_S[pillarListSize_Black][gridIndex].x = x;
			_pillarMold_Black_S[pillarListSize_Black][gridIndex].y = y;
			++gridIndex;
		}
		// 柱のサイズを記録
		_pillarMold_Black_SizeList[pillarListSize_Black] = gridIndex;

		// 柱リストのインデックスを進める
		++pillarListSize_Black;
	}

	///// 斜め／柱
	{
		///// 柱の根本位置のリストを作成
		/*
			盤の左端を上から下へ、盤の下端を左から右へ
		*/
		vector< Position > bottomPositionList;

		// 盤の左端を上から下へ
		for ( int y = 0; y < _rule.boardHeight; ++y ) {

			Position bottomPosition ( 0, y );
			bottomPositionList.push_back( bottomPosition );
		}
		// 盤の下端を左から右へ
		for ( int x = 1; x < _rule.boardWidth; ++x ) {

			Position bottomPosition ( x, _rule.boardHeight - 1 );
			bottomPositionList.push_back( bottomPosition );
		}

		///// 根本から先端へ向かう：根本でループ
		for (unsigned int i = 0; i < bottomPositionList.size(); ++i) {

			int gridIndex = 0;

			// 根本、を入れる。
			_pillarMold_Black_S[pillarListSize_Black][gridIndex].x = bottomPositionList[i].x;
			_pillarMold_Black_S[pillarListSize_Black][gridIndex].y = bottomPositionList[i].y;
			++gridIndex;

			// 根本から出発。これから、先端へ向かう。
			int currentX = bottomPositionList[i].x;
			int currentY = bottomPositionList[i].y;

			bool isKeepLoop = true;
			do {

				// 次の位置
				int nextX = currentX + 1;
				int nextY = currentY - 1;

				// 次の位置が盤面からハミ出るならば、現在の位置が「柱の先端」
				if ( !Evaluate_PC_IsOnTheBoard( nextX, nextY ) ) {

					// ループから出る
					isKeepLoop = false;

				} else {

					// 次の位置、を 柱の型 に加える
					_pillarMold_Black_S[pillarListSize_Black][gridIndex].x = nextX;
					_pillarMold_Black_S[pillarListSize_Black][gridIndex].y = nextY;
					++gridIndex;

					// 次の位置へ、柱を昇る
					currentX = nextX;
					currentY = nextY;
				}

			} while (isKeepLoop);

			///// 高さが足りていなければ破棄
			if ( gridIndex < _parameters_PieceEvaluation.pcEvalInfo.reqiredHeightForPillar ) {

				// 特になにもしなくてもいいはず。

			// 高さが足りていれば、インデックスを進める
			} else {

				// 柱のサイズを記録
				_pillarMold_Black_SizeList [ pillarListSize_Black ]  = gridIndex;

				// インデックスを進める
				++pillarListSize_Black;
			}

		}
	}

	///// 斜め＼柱
	{
		///// 柱の根本位置のリストを作成
		/*
			盤の右端を上から下へ、盤の下端を右から左へ
		*/
		vector< Position > bottomPositionList;

		// 盤の右端を上から下へ
		for ( int y = 0; y < _rule.boardHeight; ++y ) {

			Position bottomPosition ( _rule.boardWidth - 1, y);
			bottomPositionList.push_back( bottomPosition );
		}
		// 盤の下端を右から左へ
		for ( int x = _rule.boardWidth - 2; x >= 0; --x ) {

			Position bottomPosition ( x, _rule.boardHeight - 1);
			bottomPositionList.push_back( bottomPosition );
		}

		///// 根本から先端へ向かう：根本でループ
		for (unsigned int i = 0; i < bottomPositionList.size(); ++i) {

			int gridIndex = 0;

			// 柱の型、を用意して、根本、を入れる。
			_pillarMold_Black_S [ pillarListSize_Black ][gridIndex].x = bottomPositionList[i].x;
			_pillarMold_Black_S [ pillarListSize_Black ][gridIndex].y = bottomPositionList[i].y;
			++gridIndex;

			// ここから出発。先端へ向かう
			int currentX = bottomPositionList[i].x;
			int currentY = bottomPositionList[i].y;

			bool isKeepLoop = true;
			do {

				// 次の位置
				int nextX = currentX - 1;
				int nextY = currentY - 1;

				// 次の位置が盤面からハミ出るならば、現在の位置が「柱の先端」
				if ( !Evaluate_PC_IsOnTheBoard( nextX, nextY ) ) {

					isKeepLoop = false;

				} else {

					// 柱の型、に、この位置を追加
					_pillarMold_Black_S [ pillarListSize_Black ][gridIndex].x = nextX;
					_pillarMold_Black_S [ pillarListSize_Black ][gridIndex].y = nextY;
					++gridIndex;

					// 次の位置へ、柱を昇る
					currentX = nextX;
					currentY = nextY;
				}



			} while (isKeepLoop);

			///// 高さが足りていなければ破棄
			if ( gridIndex < _parameters_PieceEvaluation.pcEvalInfo.reqiredHeightForPillar ) {

				// 特になにもしなくてもいいはず。

			// 高さが足りていれば、インデックスを進める
			} else {

				// 柱のサイズを記録
				_pillarMold_Black_SizeList [ pillarListSize_Black ]  = gridIndex;

				// インデックスを進める
				++pillarListSize_Black;
			}
		}
	}
	//printf ("関数末尾：pillarListSize_Black : %d\n", pillarListSize_Black);
}

//=========================================================
// 柱とする枠・型を生成：現時点のルールに基づいて：白
//=========================================================
void AI::Evaluate_PC_S_Prepare_PillarMold_White() {

	// 柱は最大、何本になり得るか？
	pillarListSizeMax_White = 
		_rule.boardWidth +                               // 縦柱
		(_rule.boardWidth + _rule.boardHeight - 1) * 2; // 斜柱

	// 実際の柱の本数：さしあたり０。
	pillarListSize_White    = 0;

	// 柱内のグリッド数は最大でいくつになり得るか？：盤の高さに等しい
	pillarGridListSizeMax_White = _rule.boardHeight; 


	// 最大サイズ分、メモリを確保	
	_pillarMold_White_S = new Position*[pillarListSizeMax_White];
	_pillarMold_White_SizeList = new int[pillarListSizeMax_White];
	for (int i = 0; i < pillarListSizeMax_White; ++i) {

		_pillarMold_White_S[i] = new Position[pillarGridListSizeMax_White];
	}



	///// 縦柱
	for ( int x = 0; x < _rule.boardWidth; ++x) {

		vector<Position> pillarMold;

		///// 上（根本）から下（先端）へ
		int gridIndex = 0;
		for (int y = 0; y < _rule.boardHeight; ++y) {

			_pillarMold_White_S[pillarListSize_White][gridIndex].x = x;
			_pillarMold_White_S[pillarListSize_White][gridIndex].y = y;
			++gridIndex;
		}

		// 柱のサイズを記録
		_pillarMold_White_SizeList[pillarListSize_White] = gridIndex;

		// 柱リストのインデックスを進める
		++pillarListSize_White;
	}

	///// 斜め／柱
	{
		///// 柱の根本位置のリストを作成
		/*
			盤の左端を上から下へ、盤の下端を右から左へ
		*/
		vector< Position > bottomPositionList;

		// 盤の右端を下から上へ
		for ( int y = _rule.boardHeight - 1; y >= 0; --y ) {

			Position bottomPosition ( _rule.boardWidth - 1, y);
			bottomPositionList.push_back( bottomPosition );
		}
		// 盤の上端を右から左へ
		for ( int x = _rule.boardWidth - 2; x >= 0; --x ) {

			Position bottomPosition ( x, 0);
			bottomPositionList.push_back( bottomPosition );
		}

		///// 根本から先端へ向かう：根本でループ
		for (unsigned int i = 0; i < bottomPositionList.size(); ++i) {

			int gridIndex = 0;

			// 根本、を入れる。
			_pillarMold_White_S[pillarListSize_White][gridIndex].x = bottomPositionList[i].x;
			_pillarMold_White_S[pillarListSize_White][gridIndex].y = bottomPositionList[i].y;
			++gridIndex;

			// 根本から出発。先端に向かう。
			int currentX = bottomPositionList[i].x;
			int currentY = bottomPositionList[i].y;

			bool isKeepLoop = true;
			do {

				// 次の位置
				int nextX = currentX - 1;
				int nextY = currentY + 1;

				// 次の位置が盤面からハミ出るならば、現在の位置が「柱の先端」
				if ( !Evaluate_PC_IsOnTheBoard( nextX, nextY ) ) {

					isKeepLoop = false;

				} else {

					// 次の位置、を柱の型、に追加
					_pillarMold_White_S[pillarListSize_White][gridIndex].x = nextX;
					_pillarMold_White_S[pillarListSize_White][gridIndex].y = nextY;
					++gridIndex;

					// 次の位置へ、柱を昇る
					currentX = nextX;
					currentY = nextY;
				}

			} while (isKeepLoop);

			///// 高さが足りていなければ破棄
			if ( gridIndex < _parameters_PieceEvaluation.pcEvalInfo.reqiredHeightForPillar ) {

				// 特になにもしなくてもいいはず。

			// 高さが足りていれば、インデックスを進める
			} else {

				// 柱のサイズを記録
				_pillarMold_White_SizeList [ pillarListSize_White ]  = gridIndex;

				// インデックスを進める
				++pillarListSize_White;
			}
		}
	}

	///// 斜め＼柱
	{
		///// 柱の根本位置のリストを作成
		/*
			盤の左端を下から上へ、盤の上端を左から右へ
		*/
		vector< Position > bottomPositionList;

		// 盤の左端を下から上へ
		for ( int y = _rule.boardHeight - 1; y >= 0; --y ) {

			Position bottomPosition ( 0, y );
			bottomPositionList.push_back( bottomPosition );
		}
		// 盤の上端を左から右へ
		for ( int x = 1; x < _rule.boardWidth; ++x ) {

			Position bottomPosition (x, 0);
			bottomPositionList.push_back( bottomPosition );
		}

		///// 根本から先端へ向かう：根本でループ
		for (unsigned int i = 0; i < bottomPositionList.size(); ++i) {

			int gridIndex = 0;

			// 根本、を入れる。
			_pillarMold_White_S[pillarListSize_White][gridIndex].x = bottomPositionList[i].x;
			_pillarMold_White_S[pillarListSize_White][gridIndex].y = bottomPositionList[i].y;
			++gridIndex;

			// 根本から出発。先端へ向かう。
			int currentX = bottomPositionList[i].x;
			int currentY = bottomPositionList[i].y;

			bool isKeepLoop = true;
			do {

				// 次の位置
				int nextX = currentX + 1;
				int nextY = currentY + 1;

				// 次の位置が盤面からハミ出るならば、現在の位置が「柱の先端」
				if ( !Evaluate_PC_IsOnTheBoard( nextX, nextY ) ) {

					isKeepLoop = false;

				} else {

					// 次の位置、を柱の型、に追加する。
					_pillarMold_White_S[pillarListSize_White][gridIndex].x = nextX;
					_pillarMold_White_S[pillarListSize_White][gridIndex].y = nextY;
					++gridIndex;

					// 次の位置へ、柱を昇る
					currentX = nextX;
					currentY = nextY;
				}

			} while (isKeepLoop);


			///// 高さが足りていなければ破棄
			if ( gridIndex < _parameters_PieceEvaluation.pcEvalInfo.reqiredHeightForPillar ) {

				// 特になにもしなくてもいいはず。

			// 高さが足りていれば、インデックスを進める
			} else {

				// 柱のサイズを記録
				_pillarMold_White_SizeList [ pillarListSize_White ]  = gridIndex;

				// インデックスを進める
				++pillarListSize_White;
			}
		}
	}
	//printf ("関数末尾：pillarListSize_White : %d\n", pillarListSize_White);
}

//==========================================================
// 柱リストを作成：用意ずみの型を使って
//==========================================================
void AI::Evaluate_PC_S_MakePillarList_withPreparedMold ( 
	Position** &pillarMoldList, int attacker,
	const InnerExpression *innerExpression, Pillar* &pillarList 
	, int &pillarMoldListSize   // 柱型リストの件数
	, int* &pillarMold_SizeList // 各柱のグリッド数
	)
{


	for ( unsigned int i = 0; i < pillarMoldListSize; ++i ) {

		// 一応。
		if ( pillarMold_SizeList[i] == 0 ) {
			printf("柱の型、の座標リストが０件、おかしいですよね？\n");
			continue;
		}

		// 根本と先端の座標を入れることになっている。
		pillarList[i].bottomX = pillarMoldList[i][0].x;
		pillarList[i].bottomY = pillarMoldList[i][0].y;
		pillarList[i].topX    = pillarMoldList[i][ pillarMold_SizeList[i] - 1 ].x;
		pillarList[i].topY    = pillarMoldList[i][ pillarMold_SizeList[i] - 1 ].y;

		// 根本から先端へ辿る
		int height = 0;
		for (int n = 0; n < pillarMold_SizeList[i]; ++n) {
			
			int posX = pillarMoldList[i][n].x;
			int posY = pillarMoldList[i][n].y;

			// ナナメ柱かどうか。矢印を壁と解釈するかどうかの基準に関わる。
			bool isDiagonal = ( pillarList[i].bottomX != pillarList[i].topX );

			int pathOrWall = Evaluate_PC_Translate_THROUGHABLE_into_OneSidePath ( innerExpression->_gridList_ThrouableInfo[posY][posX], attacker, isDiagonal );

			///// 通れる、通れない、の成分
			pillarList[i].contentList.push_back ( pathOrWall );

			///// 一番最後に出てきた「壁」が、攻め側の攻めを止める「傘」の先端、ということ
			if ( pathOrWall == PILLAR_COVER::THROUGHABLE_INFO::WALL) {

				// でもすでに柱の先端だったら、傘としては機能しませんよ
				// 現財位置が先端じゃない場合のみ、「この高さに傘がある」と認識することとする。
				if ( pillarList[i].topX != posX || pillarList[i].topY != posY ) {
					pillarList[i].coverTopHeight = height;
				}
				/*
					ナナメの柱で、先端がゴールに突き刺さってないなら、先端でも傘として認めていいのかも。
					あるいは設定ファイルでのオプションとして指定するようにする？
				*/
			}

			++height;
		}

	}

}

//=========================================================
// 用意済みの型を使って、柱を作成：ついでに潜在的危険度も計算
//=========================================================
void AI::Evaluate_PC_S_MakePillarList_withPreparedMold_and_CaliculatePotentialRiskDegree ( 
	Position** &pillarMoldList, int attacker,
	const InnerExpression *innerExpression, Pillar* &pillarList 
	, int &pillarMoldListSize   // 柱型リストの件数
	, int* &pillarMold_SizeList // 各柱のグリッド数
	) 
{

	/*
		ついでに潜在的危険度を計算しても、処理速度はあまり変化なし。
		あまり変化ないなら、処理は分けておく方が、可読性のためによいか？
	*/

	//【危険度計算】ゴール位置：「攻め側」が黒か白かで変わるところ
	int goalHeight = 0;
	if      ( attacker == TURN::BLACK ) { goalHeight = 0;} 
	else if ( attacker == TURN::WHITE ) { goalHeight = _rule.boardHeight - 1;}

	for ( unsigned int i = 0; i < pillarMoldListSize; ++i ) {

		// 一応。
		if ( pillarMold_SizeList[i] == 0 ) {
			printf("柱の型、の座標リストが０件、おかしいですよね？\n");
			continue;
		}

		// 根本と先端の座標を入れることになっている。
		pillarList[i].bottomX = pillarMoldList[i][0].x;
		pillarList[i].bottomY = pillarMoldList[i][0].y;
		pillarList[i].topX    = pillarMoldList[i][ pillarMold_SizeList[i] - 1 ].x;
		pillarList[i].topY    = pillarMoldList[i][ pillarMold_SizeList[i] - 1 ].y;


		// 【危険度計算】柱の先端が相手陣にどれだけ近いかを計算
		int fromGoal = Utils_Cal::Abs ( goalHeight - pillarList[i].topY );


		// 【危険度計算】危険度の最大値：距離が遠いと、設定外だったりもする。
		if (fromGoal < _parameters_PieceEvaluation.pcEvalInfo.goalValueList.size()) {

			int maxRiskDegree = _parameters_PieceEvaluation.pcEvalInfo.goalValueList[ fromGoal ];
			pillarList[i].maxRiskDegree = maxRiskDegree;

		// 【危険度計算】危険度、設定外
		} else {

			// 内容に関わらず、危険度ゼロ。
			pillarList[i].maxRiskDegree = 0;
		}

		// 【危険度計算】通行可能マスの数を数える
		int pathNumber = 0;

		// 根本から先端へ辿る
		int height = 0;
		for (int n = 0; n < pillarMold_SizeList[i]; ++n) {
			
			int posX = pillarMoldList[i][n].x;
			int posY = pillarMoldList[i][n].y;

			// ナナメ柱かどうか。矢印を壁と解釈するかどうかの基準に関わる。
			bool isDiagonal = ( pillarList[i].bottomX != pillarList[i].topX );

			int pathOrWall = Evaluate_PC_Translate_THROUGHABLE_into_OneSidePath ( innerExpression->_gridList_ThrouableInfo[posY][posX], attacker, isDiagonal );

			///// 通れる、通れない、の成分
			pillarList[i].contentList.push_back ( pathOrWall );

			///// 一番最後に出てきた「壁」が、攻め側の攻めを止める「傘」の先端、ということ
			if ( pathOrWall == PILLAR_COVER::THROUGHABLE_INFO::WALL) {

				// でもすでに柱の先端だったら、傘としては機能しませんよ
				// 現財位置が先端じゃない場合のみ、「この高さに傘がある」と認識することとする。
				if ( pillarList[i].topX != posX || pillarList[i].topY != posY ) {
					pillarList[i].coverTopHeight = height;
				}
				/*
					ナナメの柱で、先端がゴールに突き刺さってないなら、先端でも傘として認めていいのかも。
					あるいは設定ファイルでのオプションとして指定するようにする？
				*/

			// 【危険度計算】通行可能マスの数を数える：危険度の潜在値を求める目的
			} else if ( pathOrWall == PILLAR_COVER::THROUGHABLE_INFO::PATH) {
				++pathNumber;
			}

			++height;
		}

		// 【危険度計算】潜在的危険度を計算：通行可能マスの数に基づいて
		if ( pillarList[i].maxRiskDegree != 0 ) { // 危険度、設定外

			// 通行可能マスの割合：通行可能マスが０個だったら、割合もゼロ。危険度もゼロ
			float pathRate = ( pillarList[i].contentList.size() == 0 ) ? 0.0f : (float)pathNumber / pillarList[i].contentList.size() * 100.0f;

			// 通行可能マスの割合で、危険度を決める
			pillarList[i].riskDegree = (int) ((float)pillarList[i].maxRiskDegree * pathRate / 100.0f);
		}

	}

}

