//=========================================================
//
// AI_実装ファイル_評価関数関係
//
//=========================================================
#include "pch.h"

#include <stdio.h>
#include "AI.h"
#include "InnerExpression.h"
#include "../Utils/Utils_Cal.h"
#include "../Utils/Allocator.h"


using namespace AI_Modules;

//=========================================================
// この状態から一定手数指し進めた場合の評価値を求める
//=========================================================
int AI::Evaluate_SemiMonte ( InnerExpression *innerExpression, int moveNum, int forThisTurn ) {
	
	int result = 0;
	
	// 使用する評価関数
	bool isUsingPEE = true;
	bool isUsingPC  = true;
	
	
	//Allocator *alloc = new Allocator<InnerExpression>();
	//alloc->Alloc(moveNum);
	
	//int myDown = ( forThisTurn == TURN::BLACK ) ? DIRECTION::DOWN : DIRECTION::UP;
	//int myUp   = ( forThisTurn == TURN::BLACK ) ? DIRECTION::UP   : DIRECTION::DOWN;
	int myDown;
	int myUp;
	
	
	int Saved_Evaluate_Move_by_Distance_currentMyDistance = _Evaluate_Move_by_Distance_currentMyDistance;
	int Saved_Evaluate_Move_by_Distance_currentOpDistance = _Evaluate_Move_by_Distance_currentOpDistance;
	
	InnerExpression *currentIe = innerExpression;
	
	int maxEval = 0;
	int turn = TURN::NONE;
	//vector<Move> nextList0(1500);
	vector<Move> nextList(1500);
	int moveCount = moveNum;
	while ( true ) {
		
		if ( moveCount <= 0 ) {
			break;
		}
		
		turn = currentIe->_currentTurn;
		
		myDown = ( turn == TURN::BLACK ) ? DIRECTION::DOWN : DIRECTION::UP;
		myUp   = ( turn == TURN::BLACK ) ? DIRECTION::UP   : DIRECTION::DOWN;

		//nextList0.clear();
		nextList.clear();
		currentIe->GetLegalNextMoveList (nextList);
		
		int swapTmp = _Evaluate_Move_by_Distance_currentMyDistance;
		_Evaluate_Move_by_Distance_currentMyDistance = _Evaluate_Move_by_Distance_currentOpDistance;
		_Evaluate_Move_by_Distance_currentOpDistance = swapTmp;
	
		maxEval = 0;
		Move bestMove;
		for ( unsigned int i = 0; i < nextList.size(); ++i ) {
			
			
			Move m = nextList[i];
			if      ( _cardNameList [ m.putCardId ] == "iinogare" && m.putCardDirection != myUp   ) { continue; }
			else if ( _cardNameList [ m.putCardId ] == "keno"     && m.putCardDirection != myDown ) { continue; }
			else if ( _cardNameList [ m.putCardId ] == "syoudou"  && m.putCardDirection != myUp   ) { continue; }
			else if ( _cardNameList [ m.putCardId ] == "ginen"    && m.putCardDirection == DIRECTION::DOWN  ) { continue; }
			else if ( _cardNameList [ m.putCardId ] == "ginen"    && m.putCardDirection == DIRECTION::RIGHT ) { continue; }
			
			
			currentIe->GoNext(nextList[i]);
			
			//InnerExpression *next = currentIe->GetNext ( nextList[i] );
			
			
			int eval = Evaluate_SemiMonte_EvalThisBoard ( currentIe, turn, isUsingPEE, isUsingPC );
			
			// 最大値を更新するかどうか
			if ( i == 0 || maxEval < eval ) {
				
				maxEval = eval;
				bestMove = nextList[i];
			}
			//delete next;
			currentIe->GoBack();
		}
		
		// ベストな指し手で指し進める
		currentIe->GoNext( bestMove );
		
		moveCount--;
	}
	
	
	
	// 指し終えた時点での評価値を求める
	int resultEval = maxEval; // 最後のループのときの値が残っているはずなので、これをこのまま使えばいいハズ。
	if ( turn != forThisTurn ) {
		
		resultEval = Evaluate_SemiMonte_EvalThisBoard ( currentIe, forThisTurn, isUsingPEE, isUsingPC );
		
	}
	
	// 戻しておく
	for ( unsigned int i = 0; i < moveNum; ++i ) {
		currentIe->GoBack();
	}
	_Evaluate_Move_by_Distance_currentMyDistance = Saved_Evaluate_Move_by_Distance_currentMyDistance;
	_Evaluate_Move_by_Distance_currentOpDistance = Saved_Evaluate_Move_by_Distance_currentOpDistance;
	
	
	// 加工などせずに結果とするのです？
	result = resultEval;
	
	
	//delete currentIe;
	//delete alloc;
	
	return result;
}

//=========================================================
// この状態から一定手数指し進めた場合の評価値を求める・子処理＿この局面を判定
//=========================================================
int AI::Evaluate_SemiMonte_EvalThisBoard ( const InnerExpression *innerExpression, int forThisTurn, bool isUsingPEE, bool isUsingPC ) {
	
	int eval = 0;
	
	if ( IsWin ( innerExpression, forThisTurn ) ) {
		
		eval = 99999;
		
	} else {
		
		/*
		if ( isUsingPEE ) {
		
			int evalPEE = Evaluate_Piece( innerExpression, forThisTurn );
			eval = evalPEE;
			
		}
		if ( isUsingPC ) {
		
			int evalPC  = Evaluate_PC_S ( innerExpression, forThisTurn );
			eval = evalPC;
		}
		*/
		int evalDS  =  Evaluate_DistanceDiff ( innerExpression, forThisTurn );
		eval = evalDS;
		
	}
	
	return eval;
}

//=========================================================
// 次の一手を教えて：子処理：モンテカルロ
//=========================================================
Move AI::GetNextMove_Monte( InnerExpression *innerExpression ) {

	Move result;
	
	printf ( "AI::GetNextMove_Monte Start\n" );

	vector<Move> allMoveList;
	innerExpression->GetLegalNextMoveList( allMoveList );

	int tryCount = 10;
	if      ( allMoveList.size() > 1200 ) { tryCount = 10;}
	else if ( allMoveList.size() > 1000 ) { tryCount = 50;}
	else if ( allMoveList.size() > 500 ) { tryCount = 100;}
	else if ( allMoveList.size() > 300 ) { tryCount = 200;}
	else if ( allMoveList.size() > 150 ) { tryCount = 300;}
	else if ( allMoveList.size() > 100 ) { tryCount = 400;}
	else if ( allMoveList.size() > 50 ) { tryCount = 1000;}
	else if ( allMoveList.size() > 0 ) { tryCount  = 2000;}

	int maxWinCountRecord = -1;
	float minTurnCountAvarage = 1000000.0f;

	///// 一手で勝つのがあればそれを選ぶ
	for ( unsigned int i = 0; i < allMoveList.size(); ++i ) {

		if ( IsWinMove( allMoveList[i]) ) {
			result = allMoveList[i];
			printf("[%d / %d手目] 勝つ手を選択\n", i, allMoveList.size());
			break;
		}
		// 先頭に「移動」がきてるはずなので、「移動」じゃなくなったら、見るのをやめる。
		if ( allMoveList[i].action != MOVE::ACTION::MOVE_PIECE ) {
			break;
		}
	}
	if ( result.action != 0 && result.action != MOVE::ACTION::PASS ) {
		
		printf (" 1 move to win \n ");
		return result;
	}

	///// ここでアロケータを用意。（一手で勝つのがあればそれを選ぶから、その前には用意しない）
	_allocator = new Allocator<InnerExpression>();
	_allocator->Alloc(10000);

	///// 探索
	for ( unsigned int i = 0; i < allMoveList.size(); ++i ) {

		/*
		if ( IsWinMove( allMoveList[i]) ) {
			result = allMoveList[i];
			printf("[%d / %d手目] 勝つ手を選択\n", i, allMoveList.size());
			break;
		}
		*/
		InnerExpression *nextState = innerExpression->GetNext( allMoveList[i], _allocator );

		int winCount = 0;

		// 試行
		float turnCountAvarage = 0.0f;
		for (int n = 0; n < tryCount; ++n) {

			// 残り全部勝利したとしても記録を更新できない見込みなら、打ち切る。
			if (maxWinCountRecord >= winCount + tryCount - n) {
				break;
			}

			vector<int> tryResult = GoToEnd(nextState);
			int winner    = tryResult[0];
			int turnCount = tryResult[1];
			turnCountAvarage += (float)turnCount;

			if ( winner == innerExpression->_currentTurn) {

				++winCount;
			}

		}
		turnCountAvarage /= (float)tryCount;

		// 勝率記録更新？
		bool isUpdate = false;
		if (winCount > maxWinCountRecord) {

			isUpdate = true;
			
		} else if (winCount == maxWinCountRecord) {

			if (minTurnCountAvarage > turnCountAvarage) {
				isUpdate = true;
			}
			
		}

		if ( isUpdate ) {

			maxWinCountRecord = winCount;
			result = allMoveList[i];

			if (minTurnCountAvarage > turnCountAvarage) {
				minTurnCountAvarage = turnCountAvarage;
			}
		}

		//delete nextState;
		if ( i % 10 == 0 ) {
			printf("[%d / %d手目] 勝率%d\n", i, allMoveList.size(), winCount);
		}
	}

	delete _allocator;
	_allocator = NULL;
	
	printf ( "AI::GetNextMove_Monte End\n" );

	return result;
}

//=========================================================
// この局面から終局まで指す
//【引数】InnerExpression
//【戻値】0.どっちが勝ったか？ 1.かかった手数
//=========================================================
vector<int> AI::GoToEnd(InnerExpression *innerExpression) {

	vector<int> result;
	result.push_back(0);
	result.push_back(0);

	bool isEnd     = false;
	int  turnCount = 0;

	///// コピーをとって使う。（手を進めるから）
	InnerExpression *ie = innerExpression->GetCopy(_allocator); // _allocatorはモンテカルロメソッド内で用意されている前提。
	//InnerExpression *ie = innerExpression->GetCopy();
	//InnerExpression *ie = innerExpression;//->GetCopy();

	///// 可能な選択肢置き場
	vector<Move> allMoveList;
	vector<Move> moveCandidateList;
	vector<Move> mateProcedure;

	///// 引き分けと判定するターン数
	int drawLimit = _rule.boardHeight * _rule.boardWidth;

	while ( !isEnd ) {

		// 手数がかかりすぎるときは引き分けということにする（この局面から数えて）
		if (turnCount >= drawLimit) {
			isEnd = true;
			result[0] = TURN::NONE;
			//printf("[%d] 勝負がつかない\n", turnCount);
			break;
		}
		/*
			↑終局まで、じゃなく、比較的短い手数だけ読んで、
			その時点での評価値で判定、というのでもいいのかも？
		*/

		///// 勝負あり？
		bool isEnd = false;
		if (IsWin( ie, TURN::BLACK) ) {
			isEnd = true;
			result[0] = TURN::BLACK;
		}
		else if (IsWin( ie, TURN::WHITE) ) {
			isEnd = true;
			result[0] = TURN::WHITE;
		}

		///// 可能な指し手リストを取得
		allMoveList.clear();
		ie->GetLegalNextMoveList(allMoveList);

		///// 詰み判定
		mateProcedure.clear();
		//GetMateProcedure_Thread( mateProcedure, allMoveList, ie, 3, true);
		ie->GetLegalWinMoveList(mateProcedure);

		if ( mateProcedure.size() > 0 ) {
			isEnd = true;
			result[0] = ie->_currentTurn;
			break;
		}


		/*
		if (ie->_currentTurn > 10) {

			bool isMate = ( GetMateProcedure_Thread( allMoveList, ie, 3, true).size() > 0);
			if ( isMate ) {
				result[0] = ie->_currentTurn;
				break;
			}
		}
		*/
		
		
		// 手詰まりのときは負け
		if (allMoveList.size() == 0) {
			isEnd = true;
			result[0] = SwitchTurn( ie->_currentTurn ) ;
		}
		
		/*
		// 手詰まりのときはパス
		if (allMoveList.size() == 0) {

			//printf(" [%d] パス : （%dが）\n", turnCount, ie->_currentTurn);

			// 手番を交代して
			ie->_currentTurn = SwitchTurn( ie->_currentTurn );

			// もう一度
			//allMoveList = ie->GetLegalNextMoveList();
			allMoveList.clear();
			ie->GetLegalNextMoveList(allMoveList);
		}

		// お互いにパスしたら引き分け
		if (allMoveList.size() == 0) {

			isEnd = true;
			result[0] = TURN::NONE;
			//printf("[%d] 手詰まり\n", turnCount);
		}
		*/

		if (isEnd) {
			break;
		}

		///// 次の手を選ぶ
		moveCandidateList.clear();
		for ( unsigned int i = 0; i < allMoveList.size(); ++i) {

			Move move = allMoveList[i];

			// 勝つ手があったらそれを選ぶ
			if (  IsWinMove( move ) ) {
				moveCandidateList.clear();
				moveCandidateList.push_back( move );
				break;
			}

			moveCandidateList.push_back( move );

		}
		int lotIndex = Utils_Cal::GerRandom( moveCandidateList.size());
		Move nextMove = moveCandidateList[lotIndex];


		ie->GoNext( nextMove );

		++turnCount;
	}

	result[1] = turnCount;

	//delete ie;

	return result;
}


//=========================================================
// 「この局面」で「この指し手」を選んだ場合の、モンテカルロでの勝率を取得
//=========================================================
float AI::GetWinRateByMonte ( InnerExpression *currentInnerExpression, Move thisMove ) {
	
	//printf ("Monte Start\n");
	
	float result = 0.0f;
	
	InnerExpression *nextIE = currentInnerExpression->GetNext ( thisMove );
	
	vector<Move> nextMoveList;
	nextIE->GetLegalNextMoveList( nextMoveList );
		
	int tryoutCount = 0;
	if      ( nextMoveList.size() > 1000 ) { tryoutCount = 0; }
	else if ( nextMoveList.size() > 900  ) { tryoutCount = 0; }
	else if ( nextMoveList.size() > 800  ) { tryoutCount = 0; }
	else if ( nextMoveList.size() > 700  ) { tryoutCount = 0; }
	else if ( nextMoveList.size() > 600  ) { tryoutCount = 0; }
	else if ( nextMoveList.size() > 500  ) { tryoutCount = 5; }
	else if ( nextMoveList.size() > 400  ) { tryoutCount = 7; }
	else if ( nextMoveList.size() > 300  ) { tryoutCount = 9; }
	else if ( nextMoveList.size() > 200  ) { tryoutCount = 11; }
	else if ( nextMoveList.size() > 100  ) { tryoutCount = 20; }
	else if ( nextMoveList.size() > 0    ) { tryoutCount = 100; }
	
	if ( tryoutCount <= 0.0f ) {
		return 0.0f;
	}
	
	printf ("Monte Start\n");
	
	int winCount = 0;
	
	
	printf ( "tryoutCount : %d\n", tryoutCount );
	
	// GoToEnd の中で使われるアロケータをここで用意しておくことになっているのでした。
	_allocator = new Allocator<InnerExpression>();
	_allocator->Alloc(10000);

	
	for ( unsigned int i = 0; i < tryoutCount; ++i) {
		
		if ( i > 0 && i%10 == 0 ) {
			printf ( "tryoutCount : %d/%d\n", i, tryoutCount );
		}
	
		vector<int> tryoutResult = GoToEnd ( nextIE );
		
		int winner    = tryoutResult[0];
		int turnCount = tryoutResult[1];

		if ( winner == currentInnerExpression->_currentTurn) {

			++winCount;
		}
	}
	
	result = (tryoutCount == 0.0f) ? 0.0f: (float)winCount / (float)tryoutCount * 100.0f;
	
	delete _allocator;
	_allocator = NULL;
	
	printf ("Monte WinRate %f\n", result);
	printf ("Monte End\n");
	
	return result;
}
