//=========================================================
//
// 局面、内部表現
//
//=========================================================
#include "pch.h"

#include <stdio.h>
#include <stdlib.h>
//#include <set>
//#include <iterator>
#include "InnerExpression.h"
#include "Define.h"
#include "AI.h"
#include "Card.h"
#include "../Utils/Utils_Others.h"
#include "../Utils/Utils_Cal.h"
#include "../Utils/Allocator.h"

using namespace std;
using namespace AI_Modules;

#pragma warning(disable:4018)

//=========================================================
// static
//=========================================================
//int InnerExpression::_numberOfInstances = 0;
//set<InnerExpression*> InnerExpression::_instanceList;

//char* InnerExpression::_memoryPool = NULL; 
int InnerExpression::_gridList_Init[15][15] = {0};
InnerExpression::CardOnBoard InnerExpression::_gridList_Init_Card[15][15];
int InnerExpression::_handCards_Init[100] = {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};

int InnerExpression::compare_int( const void *a, const void *b ) {
	return *(int*)a - *(int*)b;
}

/*
void InnerExpression::Initialize() {
	_memoryPool = new char[ 1000000 * sizeof(InnerExpression)];
}
void InnerExpression::Release() {

	delete _memoryPool;
	_numberOfInstances = 0;
}

InnerExpression* InnerExpression::GenerateInstance() {

	//if (_numberOfInstances == 0) {
	//	_memoryPool = new char[ 1000000 * sizeof(InnerExpression)];
	//}

	InnerExpression *result = NULL;

	result = new(_memoryPool + ( sizeof(InnerExpression) * _numberOfInstances) ) InnerExpression();

	++_numberOfInstances;

	return result;
}
*/

//=========================================================
// コンストラクタ
//=========================================================
InnerExpression::InnerExpression() {

	//++_numberOfInstances;
	//_instanceList.insert(this);

	_isThrouableInfoLatest = false;
	_totalMoveCount        = 0;
	_isPassPreviousMove    = false;
	_isPassPass            = false;
	_currentTurn           = 0;
}

//=========================================================
// デストラクタ
//=========================================================
InnerExpression::~InnerExpression() {
	
	// メモリプールやアロケータで管理すると、メモリは解放されても、デストラクタは呼ばれない。
	// となると、もう、_numberOfInstancesでインスタンス数をモニタリングする意味もないのか。
	
	//--_numberOfInstances;
	//_instanceList.erase( _instanceList.find(this) );
}
/*
//=========================================================
// 解放されてない子を解放
//=========================================================
void InnerExpression::LeakRelease() {

	printf("InnerExpression::LeakRelease() %d個あり\n", _instanceList.size());

	while ( _instanceList.size() > 0 ) {
		delete *(_instanceList.begin());
		//_instanceList.erase( _instanceList.begin() );  // ←デストラクタ内でもしている。
		--_numberOfInstances;
	}
}
*/
//=========================================================
// 初期設定
//=========================================================
void InnerExpression::Init() {
	
	///// 真っ白にする
	_currentTurn = 0;
	memcpy(_gridList_Piece,         _gridList_Init, sizeof(_gridList_Init));
	memcpy(_gridList_ThrouableInfo, _gridList_Init, sizeof(_gridList_Init));
	memcpy(_gridList_Card,          _gridList_Init_Card, sizeof(_gridList_Init_Card));
	_handPiece_BLACK = 0;
	_handPiece_WHITE = 0;
	memcpy(_handCards_BLACK, _handCards_Init, sizeof(_handCards_Init));
	memcpy(_handCards_WHITE, _handCards_Init, sizeof(_handCards_Init));
	_handCards_BLACK_Index = 0;
	_handCards_WHITE_Index = 0;

	_isThrouableInfoLatest = false;
	_totalMoveCount        = 0;
	_isPassPreviousMove    = false;
	_isPassPass            = false;

	///// 盤のサイズを合わせる
	_boardSizeX = AI::_rule.boardWidth;
	_boardSizeY = AI::_rule.boardHeight;

	/*
	for (int y = 0; y < boardSizeY; ++y) {

		vector<int>         row_gridList_ThrouableInfo;
		vector<int>         row_gridList_Piece;
		vector<CardOnBoard> row_gridList_Card;

		_gridList_ThrouableInfo.push_back ( row_gridList_ThrouableInfo );
		_gridList_Piece.push_back         ( row_gridList_Piece         );
		_gridList_Card.push_back          ( row_gridList_Card          );

		for (int x = 0; x < boardSizeX; ++x) {

			int throuableInfo = THROUGHABLE_INFO::NOT_THROUGHABLE;
			int grid          = GRID::ENPTY;
			CardOnBoard card  = CardOnBoard();

			_gridList_ThrouableInfo[y].push_back( throuableInfo );
			_gridList_Piece        [y].push_back( grid );
			_gridList_Card         [y].push_back( card );
		}
	}
	*/

}
//=========================================================
// 初期設定：現在の手番をセット
//=========================================================
void InnerExpression::Init_SetCurrentTurn( int turn ) {
	_currentTurn = turn;
}
//=========================================================
// 初期設定：カードを置く
//=========================================================
void InnerExpression::Init_PutCard( int x, int y, int cardId, int direction ) {

	_gridList_Card[y][x].cardId    = cardId;
	_gridList_Card[y][x].direction = direction;

	_isThrouableInfoLatest = false;
}
//=========================================================
// 初期設定：駒を置く
//=========================================================
void InnerExpression::Init_PutPiece( int x, int y, int piece ) {

	_gridList_Piece[y][x] = piece;
}
//=========================================================
// 初期設定：通行可能情報をセット
//=========================================================
void InnerExpression::Init_SetThrouableInfo( int x, int y, int throuableInfo ) {

	_gridList_ThrouableInfo[y][x] = throuableInfo;

	_isThrouableInfoLatest = false;
}
//=========================================================
// 初期設定：駒台情報 黒
//=========================================================
void InnerExpression::Init_SetHandPiece_BLACK( int num ) {

	_handPiece_BLACK = num;
}
//=========================================================
// 初期設定：駒台情報 白
//=========================================================
void InnerExpression::Init_SetHandPiece_WHITE( int num ) {

	_handPiece_WHITE = num;
}
//=========================================================
// 初期設定：手札情報 黒
//=========================================================
void InnerExpression::Init_AddHandCard_BLACK( int cardId ) {

	//_handCards_BLACK.push_back( cardId );

	_handCards_BLACK[_handCards_BLACK_Index] = cardId;
	++_handCards_BLACK_Index;

}
//=========================================================
// 初期設定：手札情報 白
//=========================================================
void InnerExpression::Init_AddHandCard_WHITE( int cardId ) {

	//_handCards_WHITE.push_back( cardId );
	_handCards_WHITE[_handCards_WHITE_Index] = cardId;
	++_handCards_WHITE_Index;
}

//=========================================================
// 初期設定？ カードの効果を盤面に反映させる
//=========================================================
void InnerExpression::Init_ReflectCardAffection() {

	if ( _isThrouableInfoLatest ) {
		return;
	}

	// いっぺん、初期化する必要がありますよね？
	memcpy(_gridList_ThrouableInfo, _gridList_Init, sizeof(_gridList_Init));

	for ( unsigned int y = 0; y < _boardSizeY; ++y ) {

		for ( unsigned int x = 0; x < _boardSizeX; ++x ) {

			CardOnBoard cardOnBoard = _gridList_Card[y][x];

			if (cardOnBoard.isEmpty()) {
				continue;
			}

			Card card = AI::GetCardInfo( cardOnBoard.cardId );


			// カードがあるその位置は、通行可能。
			_gridList_ThrouableInfo[y][x] = THROUGHABLE_INFO::THROUGHABLE;

			for ( unsigned int i = 0; i < card.gridAffectionList.size(); ++i) {

				int affectX = x + card.gridAffectionList[i].TurnedX( cardOnBoard.direction );
				int affectY = y + card.gridAffectionList[i].TurnedY( cardOnBoard.direction );
				int affectDirection = card.gridAffectionList[i].TurnedIndecrion( cardOnBoard.direction );

				if (IsWithinBoardLimit( affectX, affectY ) ) {
					
					_gridList_ThrouableInfo[affectY][affectX] = THROUGHABLE_INFO::THROUGHABLE;

					if      ( affectDirection == DIRECTION::UP    ) { _gridList_ThrouableInfo[affectY][affectX] = THROUGHABLE_INFO::MUST_TO_UP;    }
					else if ( affectDirection == DIRECTION::LEFT  ) { _gridList_ThrouableInfo[affectY][affectX] = THROUGHABLE_INFO::MUST_TO_LEFT;  }
					else if ( affectDirection == DIRECTION::RIGHT ) { _gridList_ThrouableInfo[affectY][affectX] = THROUGHABLE_INFO::MUST_TO_RIGHT; }
					else if ( affectDirection == DIRECTION::DOWN  ) { _gridList_ThrouableInfo[affectY][affectX] = THROUGHABLE_INFO::MUST_TO_DOWN;  }

				}
			}
		}
	}

	_isThrouableInfoLatest = true;
}

//=========================================================
// 次の局面を取得
//【引数】こう指すと
//【戻値】こうなる
//=========================================================
InnerExpression* InnerExpression::GetNext( Move move ) {

	InnerExpression *result = NULL;

	// コピーを取得して、コピーに対して手を指す
	result = GetCopy();
	result->GoNext( move );

	return result;

}
InnerExpression* InnerExpression::GetNext( Move move, Allocator<InnerExpression> *allocator ) {

	InnerExpression *result = NULL;

	// コピーを取得して、コピーに対して手を指す
	result = GetCopy(allocator);
	result->GoNext( move );

	return result;

}

//=========================================================
// コピーを取得
//=========================================================
InnerExpression* InnerExpression::GetCopy(Allocator<InnerExpression> *allocator) {

	InnerExpression *result = allocator->GenerateObj();

	result->_currentTurn            = this->_currentTurn;
	result->_handPiece_BLACK        = this->_handPiece_BLACK;
	result->_handPiece_WHITE        = this->_handPiece_WHITE;
	result->_isThrouableInfoLatest  = this->_isThrouableInfoLatest;
	result->_totalMoveCount         = this->_totalMoveCount;
	result->_isPassPreviousMove     = this->_isPassPreviousMove;
	result->_isPassPass             = this->_isPassPass;
	result->_boardSizeX             = this->_boardSizeX;
	result->_boardSizeY             = this->_boardSizeY;
	result->_handCards_BLACK_Index  = this->_handCards_BLACK_Index;
	result->_handCards_WHITE_Index  = this->_handCards_WHITE_Index;

	memcpy(result->_gridList_ThrouableInfo, this->_gridList_ThrouableInfo, sizeof(this->_gridList_ThrouableInfo));
	memcpy(result->_gridList_Piece        , this->_gridList_Piece        , sizeof(this->_gridList_Piece        ));
	memcpy(result->_gridList_Card         , this->_gridList_Card         , sizeof(this->_gridList_Card         ));
	memcpy(result->_handCards_BLACK       , this->_handCards_BLACK       , sizeof(this->_handCards_BLACK       ));
	memcpy(result->_handCards_WHITE       , this->_handCards_WHITE       , sizeof(this->_handCards_WHITE       ));

	/*
	for (int y = 0; y < 10; ++y) {
		for (int x = 0; x < 10; ++x) {
			result->_gridList_ThrouableInfo[y][x] = this->_gridList_ThrouableInfo[y][x];
			result->_gridList_Piece[y][x] = this->_gridList_Piece[y][x];
			result->_gridList_Card[y][x] = this->_gridList_Card[y][x];
		}
	}
	for (int i = 0; i < 100; ++i) {
		result->_handCards_BLACK[i] = this->_handCards_BLACK[i];
		result->_handCards_WHITE[i] = this->_handCards_WHITE[i];
	}
	*/
	/*
	result->_gridList_ThrouableInfo = this->_gridList_ThrouableInfo;
	result->_gridList_Piece         = this->_gridList_Piece;
	result->_gridList_Card          = this->_gridList_Card;
	result->_handCards_BLACK        = this->_handCards_BLACK;
	result->_handCards_WHITE        = this->_handCards_WHITE;
	*/

	return result;
}
void InnerExpression::GetCopy( InnerExpression *useThisMemory ) {

	memset(useThisMemory, NULL, sizeof(InnerExpression));
	useThisMemory = new(useThisMemory) InnerExpression();

	useThisMemory->_currentTurn            = this->_currentTurn;
	useThisMemory->_handPiece_BLACK        = this->_handPiece_BLACK;
	useThisMemory->_handPiece_WHITE        = this->_handPiece_WHITE;

	/*
	useThisMemory->_gridList_ThrouableInfo = this->_gridList_ThrouableInfo;
	useThisMemory->_gridList_Piece         = this->_gridList_Piece;
	useThisMemory->_gridList_Card          = this->_gridList_Card;
	useThisMemory->_handCards_BLACK        = this->_handCards_BLACK;
	useThisMemory->_handCards_WHITE        = this->_handCards_WHITE;
	*/

	memcpy(useThisMemory->_gridList_ThrouableInfo, this->_gridList_ThrouableInfo, sizeof(this->_gridList_ThrouableInfo));
	memcpy(useThisMemory->_gridList_Piece        , this->_gridList_Piece        , sizeof(this->_gridList_Piece        ));
	memcpy(useThisMemory->_gridList_Card         , this->_gridList_Card         , sizeof(this->_gridList_Card         ));
	memcpy(useThisMemory->_handCards_BLACK       , this->_handCards_BLACK       , sizeof(this->_handCards_BLACK       ));
	memcpy(useThisMemory->_handCards_WHITE       , this->_handCards_WHITE       , sizeof(this->_handCards_WHITE       ));

	useThisMemory->_isThrouableInfoLatest  = this->_isThrouableInfoLatest;
	useThisMemory->_totalMoveCount         = this->_totalMoveCount;
	useThisMemory->_isPassPreviousMove     = this->_isPassPreviousMove;
	useThisMemory->_isPassPass             = this->_isPassPass;
	useThisMemory->_boardSizeX             = this->_boardSizeX;
	useThisMemory->_boardSizeY             = this->_boardSizeY;
	useThisMemory->_handCards_BLACK_Index  = this->_handCards_BLACK_Index;
	useThisMemory->_handCards_WHITE_Index  = this->_handCards_WHITE_Index;

}

InnerExpression* InnerExpression::GetCopy() {

	InnerExpression *result = new InnerExpression();
	if ( result == NULL ) {
		//printf(" _numberOfInstances == %d\n ", _numberOfInstances);
		printf(" result == NULL \n");
	}
	//result->Init();
	//copy( nums1.begin(), nums1.end(), back_inserter( nums2 ) );

	//copy( this->_gridList_ThrouableInfo.begin(), this->_gridList_ThrouableInfo.end(), back_inserter( result->_gridList_ThrouableInfo ) );
	//copy( this->_gridList_Piece.begin(), this->_gridList_Piece.end(), back_inserter( result->_gridList_Piece ) );
	//copy( this->_gridList_Card.begin(), this->_gridList_Card.end(), back_inserter( result->_gridList_Card ) );

	//result->_handCards_BLACK.reserve( this->_handCards_BLACK.size() );
	//copy( this->_handCards_BLACK.begin(), this->_handCards_BLACK.end(), back_inserter( result->_handCards_BLACK ) );

	//result->_handCards_BLACK.reserve( this->_handCards_WHITE.size() );
	//copy( this->_handCards_WHITE.begin(), this->_handCards_WHITE.end(), back_inserter( result->_handCards_WHITE ) );

	
	result->_currentTurn            = this->_currentTurn;
	result->_handPiece_BLACK        = this->_handPiece_BLACK;
	result->_handPiece_WHITE        = this->_handPiece_WHITE;
	
	/*
	result->_gridList_ThrouableInfo = this->_gridList_ThrouableInfo;
	result->_gridList_Piece         = this->_gridList_Piece;
	result->_gridList_Card          = this->_gridList_Card;
	result->_handCards_BLACK        = this->_handCards_BLACK;
	result->_handCards_WHITE        = this->_handCards_WHITE;
	*/
	memcpy(result->_gridList_ThrouableInfo, this->_gridList_ThrouableInfo, sizeof(this->_gridList_ThrouableInfo));
	memcpy(result->_gridList_Piece        , this->_gridList_Piece        , sizeof(this->_gridList_Piece        ));
	memcpy(result->_gridList_Card         , this->_gridList_Card         , sizeof(this->_gridList_Card         ));
	memcpy(result->_handCards_BLACK       , this->_handCards_BLACK       , sizeof(this->_handCards_BLACK       ));
	memcpy(result->_handCards_WHITE       , this->_handCards_WHITE       , sizeof(this->_handCards_WHITE       ));

	/*
	result->_gridList_ThrouableInfo = vector<vector<int>>(this->_gridList_ThrouableInfo);
	result->_gridList_Piece         = vector<vector<int>>(this->_gridList_Piece);
	result->_gridList_Card          = vector<vector<CardOnBoard>>(this->_gridList_Card);
	result->_handCards_BLACK        = vector<int>(this->_handCards_BLACK);
	result->_handCards_WHITE        = vector<int>(this->_handCards_WHITE);
	*/

	result->_isThrouableInfoLatest  = this->_isThrouableInfoLatest;
	result->_totalMoveCount         = this->_totalMoveCount;
	result->_isPassPreviousMove     = this->_isPassPreviousMove;
	result->_isPassPass             = this->_isPassPass;
	result->_boardSizeX             = this->_boardSizeX;
	result->_boardSizeY             = this->_boardSizeY;
	result->_handCards_BLACK_Index  = this->_handCards_BLACK_Index;
	result->_handCards_WHITE_Index  = this->_handCards_WHITE_Index;

	return result;
}

//=========================================================
// 局面が同一かどうか
//【戻り値】 true で「同一」
//=========================================================
bool InnerExpression::IsEquals( InnerExpression *anotherOne ) {

	if (anotherOne->_currentTurn != this->_currentTurn ) {
		return false;
	}
	if (anotherOne->_handPiece_BLACK  != this->_handPiece_BLACK) {
		return false;
	}
	if ( anotherOne->_handPiece_WHITE != this->_handPiece_WHITE) {
		return false;
	}

	if ( anotherOne->_isThrouableInfoLatest  != this->_isThrouableInfoLatest) {
		return false;
	}
	if ( anotherOne->_totalMoveCount         != this->_totalMoveCount) {
		return false;
	}
	if ( anotherOne->_isPassPreviousMove     != this->_isPassPreviousMove) {
		return false;
	}
	if ( anotherOne->_isPassPass             != this->_isPassPass) {
		return false;
	}
	if ( anotherOne->_boardSizeX             != this->_boardSizeX) {
		return false;
	}
	if ( anotherOne->_boardSizeY             != this->_boardSizeY) {
		return false;
	}
	if ( anotherOne->_handCards_BLACK_Index  != this->_handCards_BLACK_Index) {
		return false;
	}
	if ( anotherOne->_handCards_WHITE_Index  != this->_handCards_WHITE_Index) {
		return false;
	}

	if ( memcmp(anotherOne->_gridList_Card         , this->_gridList_Card         , sizeof(this->_gridList_Card         )) != 0) {
		return false;
	}
	if ( memcmp(anotherOne->_gridList_ThrouableInfo, this->_gridList_ThrouableInfo, sizeof(this->_gridList_ThrouableInfo)) != 0) {
		return false;
	}
	if ( memcmp(anotherOne->_gridList_Piece        , this->_gridList_Piece        , sizeof(this->_gridList_Piece        )) != 0) {
		return false;
	}
	///// 手札置き場を比べるには…：ソートされてしまいますけど、構いませんよね？
	qsort ( anotherOne->_handCards_BLACK, anotherOne->_handCards_BLACK_Index, sizeof(int), InnerExpression::compare_int);
	qsort ( this->_handCards_BLACK, this->_handCards_BLACK_Index, sizeof(int), InnerExpression::compare_int);
	if ( memcmp(anotherOne->_handCards_BLACK       , this->_handCards_BLACK       , sizeof(this->_handCards_BLACK       )) != 0) {
		return false;
	}

	qsort ( anotherOne->_handCards_WHITE, anotherOne->_handCards_WHITE_Index, sizeof(int), InnerExpression::compare_int);
	qsort ( this->_handCards_WHITE, this->_handCards_WHITE_Index, sizeof(int), InnerExpression::compare_int);
	if ( memcmp(anotherOne->_handCards_WHITE       , this->_handCards_WHITE       , sizeof(this->_handCards_WHITE       )) != 0) {
		return false;
	}

	return true;
}

//=========================================================
// 次の局面になっておくれ
//【引数】こう指してね
//=========================================================
void InnerExpression::GoNext( const Move &move ) {

	/*
		可能な手かどうかの確認はしてませんよ。
	*/
	GoNext_PutPiece (move);
	GoNext_MovePiece(move);
	GoNext_PutCard  (move);
	GoNext_TakeCard (move);
	GoNext_Pass     (move);

	Init_ReflectCardAffection();
	AddTotalMoveCount();

}

//=========================================================
// 手を一つ巻き戻す
//【戻り値】Undoできたら true 
//=========================================================
bool InnerExpression::GoBack() {

	if ( !_moveForBack.isValid ) {
		return false;
	}
	GoBack_PutPiece ();
	GoBack_MovePiece();
	GoBack_PutCard  ();
	GoBack_TakeCard ();
	GoBack_Pass     ();

	/*
	int count = 0;
	if (GoBack_PutPiece ()) { ++count; }
	if (GoBack_MovePiece()) { ++count; }
	if (GoBack_PutCard  ()) { ++count; }
	if (GoBack_TakeCard ()) { ++count; }
	if (GoBack_Pass     ()) { ++count; }

	if (count != 1) {
		printf("これはおかしい！ %d\n", count);
	}
	*/
	/*
	if (!GoBack_PutPiece ()) {
		if (!GoBack_MovePiece()) {
			if (!GoBack_PutCard()) {
				if (!GoBack_TakeCard()) {
					if (!GoBack_Pass()) {
						printf("何も手戻しできず\n");
					}
				}
			}
		}
	}
	*/
	Init_ReflectCardAffection();
	DecrementTotalMoveCount();

	_moveForBack.isValid = false;

	return true;
}

//=========================================================
// 手を巻き戻して：子処理群：駒設置でした
//=========================================================
bool InnerExpression::GoBack_PutPiece  () {

	bool result = false;

	if ( _moveForBack.previousMove.action == MOVE::ACTION::PUT_PIECE ) {

		result = true;

		if ( _moveForBack.previousMove.turn == TURN::BLACK ) {

			_gridList_Piece [_moveForBack.previousMove.putPieceY] [_moveForBack.previousMove.putPieceX] = GRID::ENPTY;
			++_handPiece_BLACK;

			// 手番交代
			_currentTurn = TURN::BLACK;
		}
		else if ( _moveForBack.previousMove.turn == TURN::WHITE ) {

			_gridList_Piece [_moveForBack.previousMove.putPieceY] [_moveForBack.previousMove.putPieceX] = GRID::ENPTY;
			++_handPiece_WHITE;

			// 手番交代
			_currentTurn = TURN::WHITE;
		}

	}

	return result;
}
//=========================================================
// 手を巻き戻して：子処理群：駒移動でした
//=========================================================
bool InnerExpression::GoBack_MovePiece () {

	bool result = false;

	if ( _moveForBack.previousMove.action == MOVE::ACTION::MOVE_PIECE ) {

		result = true;

		/*
			手番は無関係
		*/
		// From に To を入れて
		_gridList_Piece [_moveForBack.previousMove.movePieceFromY] [_moveForBack.previousMove.movePieceFromX] = 
			_gridList_Piece [_moveForBack.previousMove.movePieceToY] [_moveForBack.previousMove.movePieceToX];

		// To を空にする
		_gridList_Piece [_moveForBack.previousMove.movePieceToY] [_moveForBack.previousMove.movePieceToX] = GRID::ENPTY;


		// ぶつけていた場合
		if ( _moveForBack.previousMove.movePieceAndIsCllide ) {

			_gridList_Piece [_moveForBack.cllidedY][_moveForBack.cllidedX] = _moveForBack.cllidedPieceColor;

			if      (_moveForBack.cllidedPieceColor == GRID::BLACK) { --_handPiece_BLACK; }
			else if (_moveForBack.cllidedPieceColor == GRID::WHITE) { --_handPiece_WHITE; }
		}


		// 手番交代
		if      ( _moveForBack.previousMove.turn == TURN::BLACK ) { _currentTurn = TURN::BLACK; }
		else if ( _moveForBack.previousMove.turn == TURN::WHITE ) { _currentTurn = TURN::WHITE; }

	}

	return result;
}
//=========================================================
// 手を巻き戻して：子処理群：カード設置でした
//=========================================================
bool InnerExpression::GoBack_PutCard   () {

	bool result = false;

	if ( _moveForBack.previousMove.action == MOVE::ACTION::PUT_CARD ) {

		result = true;

		if ( _moveForBack.previousMove.turn == TURN::BLACK ) { 

			// 設置位置からカードを除外して
			_gridList_Card [ _moveForBack.previousMove.putCardY ] [_moveForBack.previousMove.putCardX] = CardOnBoard();

			// 手札に加える
			Init_AddHandCard_BLACK ( _moveForBack.previousMove.putCardId );

			// 盤面のカードをいじりましたよ。
			_isThrouableInfoLatest = false;

			// 手番交代
			_currentTurn = TURN::BLACK; 

		} else if ( _moveForBack.previousMove.turn == TURN::WHITE ) { 
			
			// 設置位置からカードを除外して
			_gridList_Card [ _moveForBack.previousMove.putCardY ] [_moveForBack.previousMove.putCardX] = CardOnBoard();

			// 手札に加える
			Init_AddHandCard_WHITE ( _moveForBack.previousMove.putCardId );

			// 盤面のカードをいじりましたよ。
			_isThrouableInfoLatest = false;

			// 手番交代
			_currentTurn = TURN::WHITE; 
		}
	}

	return result;
}
//=========================================================
// 手を巻き戻して：子処理群：カード取得でした
//=========================================================
bool InnerExpression::GoBack_TakeCard  () {

	bool result = false;

	if ( _moveForBack.previousMove.action == MOVE::ACTION::TAKE_CARD ) {

		result = true;

		if ( _moveForBack.previousMove.turn == TURN::BLACK ) { 

			// 取った位置にカードを戻して
			_gridList_Card [ _moveForBack.previousMove.takeCardY ] [_moveForBack.previousMove.takeCardX].cardId    = _moveForBack.tookCardId;
			_gridList_Card [ _moveForBack.previousMove.takeCardY ] [_moveForBack.previousMove.takeCardX].direction = _moveForBack.tookCardDirection;

			// 手札から除外
			int index = GetHandCardIndexOf_Black( _moveForBack.tookCardId );
			if (index != -1) {
				ReleaseCard_ByIndex_Black(index);
			} else {
				printf("おかしい！\n");
			}

			// 盤面のカードをいじりましたよ。
			_isThrouableInfoLatest = false;

			// 手番交代
			_currentTurn = TURN::BLACK; 

		} else if ( _moveForBack.previousMove.turn == TURN::WHITE ) { 
			
			// 取った位置にカードを戻して
			_gridList_Card [ _moveForBack.previousMove.takeCardY ] [_moveForBack.previousMove.takeCardX].cardId    = _moveForBack.tookCardId;
			_gridList_Card [ _moveForBack.previousMove.takeCardY ] [_moveForBack.previousMove.takeCardX].direction = _moveForBack.tookCardDirection;

			// 手札から除外
			int index = GetHandCardIndexOf_White( _moveForBack.tookCardId );
			if (index != -1) {
				ReleaseCard_ByIndex_White(index);
			} else {
				printf("おかしいよ！\n");
			}

			// 盤面のカードをいじりましたよ。
			_isThrouableInfoLatest = false;

			// 手番交代
			_currentTurn = TURN::WHITE; 
		}
	}

	return result;
}
//=========================================================
// 手を巻き戻して：子処理群：パスでした
//=========================================================
bool InnerExpression::GoBack_Pass () {

	bool result = false;

	if ( _moveForBack.previousMove.action == MOVE::ACTION::PASS) {

		result = true;

		// 手詰まりフラグが立っていたら
		if (_isPassPass) {
			
			// パスを戻しても、やっぱりパスなのでしょう。
			_isPassPreviousMove = true;

			// しかし手詰まりフラグははずす（手詰まりフラグが立ったあとは、手を指されていない、と仮定して）
			_isPassPass = false;

		// 手詰まりフラグは立っていなかった
		} else {

			// パスはしなかったことになる。
			_isPassPreviousMove = false;
		}

		if (_currentTurn == TURN::BLACK) {

			// 手番交代
			_currentTurn = TURN::BLACK;
		}
		else if (_currentTurn == TURN::WHITE) {

			// 手番交代
			_currentTurn = TURN::WHITE;
		}
	}

	return result;
}

//=========================================================
// こう指してね：子処理：パス
//=========================================================
void InnerExpression::GoNext_Pass ( const Move &move ) {
	
	if (move.action == MOVE::ACTION::PASS) {
		
		// 前回もパスだったら、手詰まり。
		if (_isPassPreviousMove) {
			_isPassPass = true;
		}
		// 今回パスでしたね。
		_isPassPreviousMove = true;

		if (_currentTurn == TURN::BLACK) {

			// 手番交代
			_currentTurn = TURN::WHITE;
		}
		else if (_currentTurn == TURN::WHITE) {

			// 手番交代
			_currentTurn = TURN::BLACK;
		}
	}
	
}

//=========================================================
// こう指してね：子処理：駒打つ
//=========================================================
void InnerExpression::GoNext_PutPiece( const Move &move ) {
	
	if (move.action == MOVE::ACTION::PUT_PIECE) {
		
		_isPassPreviousMove = false;

		if (_currentTurn == TURN::BLACK) {

			--_handPiece_BLACK;
			_gridList_Piece[move.putPieceY][move.putPieceX] = GRID::BLACK;

			// 手番交代
			_currentTurn = TURN::WHITE;

			// 巻き戻し情報
			_moveForBack.previousMove = move;
			_moveForBack.isValid = true;
		}
		else if (_currentTurn == TURN::WHITE) {

			--_handPiece_WHITE;
			_gridList_Piece[move.putPieceY][move.putPieceX] = GRID::WHITE;

			// 手番交代
			_currentTurn = TURN::BLACK;

			// 巻き戻し情報
			_moveForBack.previousMove = move;
			_moveForBack.isValid = true;
		}

	}
}
//=========================================================
// こう指してね：子処理：駒移動
//=========================================================
void InnerExpression::GoNext_MovePiece( const Move &move ) {

	if (move.action == MOVE::ACTION::MOVE_PIECE) {
		
		_isPassPreviousMove = false;

		if (_currentTurn == TURN::BLACK) {

			// 移動
			_gridList_Piece[move.movePieceFromY][move.movePieceFromX] = GRID::ENPTY;
			_gridList_Piece[move.movePieceToY  ][move.movePieceToX  ] = GRID::BLACK;

			// 巻き戻し情報
			_moveForBack.previousMove = move;
			_moveForBack.isValid = true;


			// ぶつける場合
			if ( move.movePieceAndIsCllide ) {

				int targetX = move.movePieceToX + Utils_Cal::Sign( move.movePieceToX - move.movePieceFromX );
				int targetY = move.movePieceToY + Utils_Cal::Sign( move.movePieceToY - move.movePieceFromY );

				// 黒がぶつけたから白が増えるとは限らない。
				//++_handPiece_WHITE;
				if      (_gridList_Piece[targetY][targetX] == GRID::BLACK) { ++_handPiece_BLACK; }
				else if (_gridList_Piece[targetY][targetX] == GRID::WHITE) { ++_handPiece_WHITE; }

				// 巻き戻し情報に記録
				_moveForBack.cllidedPieceColor = _gridList_Piece[targetY][targetX];
				_moveForBack.cllidedX = targetX;
				_moveForBack.cllidedY = targetY;
				
				// 盤面から取り除く
				_gridList_Piece[targetY][targetX] = GRID::ENPTY;

			}

			// 手番交代
			_currentTurn = TURN::WHITE;
		}
		else if (_currentTurn == TURN::WHITE) {

			// 移動
			_gridList_Piece[move.movePieceFromY][move.movePieceFromX] = GRID::ENPTY;
			_gridList_Piece[move.movePieceToY  ][move.movePieceToX  ] = GRID::WHITE;

			// 巻き戻し情報
			_moveForBack.previousMove = move;
			_moveForBack.isValid = true;

			// ぶつける場合
			if ( move.movePieceAndIsCllide ) {

				int targetX = move.movePieceToX + Utils_Cal::Sign( move.movePieceToX - move.movePieceFromX );
				int targetY = move.movePieceToY + Utils_Cal::Sign( move.movePieceToY - move.movePieceFromY );


				// 白がぶつけたから黒が増えるとは限らない。
				//++_handPiece_BLACK;
				if      (_gridList_Piece[targetY][targetX] == GRID::BLACK) { ++_handPiece_BLACK; }
				else if (_gridList_Piece[targetY][targetX] == GRID::WHITE) { ++_handPiece_WHITE; }

				// 巻き戻し情報に記録
				_moveForBack.cllidedPieceColor = _gridList_Piece[targetY][targetX];
				_moveForBack.cllidedX = targetX;
				_moveForBack.cllidedY = targetY;
				
				// 盤面から取り除く
				_gridList_Piece[targetY][targetX] = GRID::ENPTY;
			}

			// 手番交代
			_currentTurn = TURN::BLACK;
		}

	}
}

//=========================================================
// 手札リスト内での位置を取得
//=========================================================
int InnerExpression::GetHandCardIndexOf_Black( int cardId) {

	int result = -1;

	int length = sizeof(_handCards_BLACK) / sizeof(int);

	for (int i = 0; i < length; ++i) {

		if (_handCards_BLACK[i] == cardId) {
			result = i;
			break;
		}
	}
	return result;
}
int InnerExpression::GetHandCardIndexOf_White( int cardId) {

	int result = -1;

	int length = sizeof(_handCards_WHITE) / sizeof(int);

	for (int i = 0; i < length; ++i) {

		if (_handCards_WHITE[i] == cardId) {
			result = i;
			break;
		}
	}
	return result;
}
//=========================================================
// このカードを手放す
//=========================================================
void InnerExpression::ReleaseCard_ByIndex_Black ( int index ) {

	bool isReleased = false;

	int length = sizeof(_handCards_BLACK) / sizeof(int);

	_handCards_BLACK[index] = -1;
	--_handCards_BLACK_Index;

	for (int i = index; i < length; ++i) {

		if ( (i+1) < length) {
			_handCards_BLACK[i] = _handCards_BLACK[i + 1];
			_handCards_BLACK[i + 1] = -1;
		}
	}
}
void InnerExpression::ReleaseCard_ByIndex_White ( int index ) {

	bool isReleased = false;

	int length = sizeof(_handCards_WHITE) / sizeof(int);

	_handCards_WHITE[index] = -1;
	--_handCards_WHITE_Index;

	for (int i = index; i < length; ++i) {

		if ( (i+1) < length) {
			_handCards_WHITE[i] = _handCards_WHITE[i + 1];
			_handCards_WHITE[i + 1] = -1;
		}
	}
}
//=========================================================
// こう指してね：子処理：カード置く
//=========================================================
void InnerExpression::GoNext_PutCard( const Move &move ) {
	
	if (move.action == MOVE::ACTION::PUT_CARD) {
		
		_isPassPreviousMove    = false;
		_isThrouableInfoLatest = false;

		if (_currentTurn == TURN::BLACK) {

			//int index = UTILS_OTHERS::indexOf<int>( _handCards_BLACK, move.putCardId);
			int index = GetHandCardIndexOf_Black( move.putCardId);
			if ( index != -1) {

				//UTILS_OTHERS::deleteFromVector<int>( _handCards_BLACK, index);
				ReleaseCard_ByIndex_Black ( index );

				/*
				CardOnBoard cardOnBoard;
				cardOnBoard.cardId    = move.putCardId;
				cardOnBoard.direction = move.putCardDirection;
				_gridList_Card [ move.putCardY ][ move.putCardX ] = cardOnBoard;
				*/
				_gridList_Card [ move.putCardY ][ move.putCardX ].cardId    = move.putCardId;
				_gridList_Card [ move.putCardY ][ move.putCardX ].direction = move.putCardDirection;

			}
			// 手番交代
			_currentTurn = TURN::WHITE;

		}
		else if (_currentTurn == TURN::WHITE) {

			//int index = UTILS_OTHERS::indexOf<int>( _handCards_WHITE, move.putCardId );
			int index = GetHandCardIndexOf_White( move.putCardId );
			if ( index != -1) {

				//UTILS_OTHERS::deleteFromVector<int>( _handCards_WHITE, index);
				ReleaseCard_ByIndex_White( index );

				/*
				CardOnBoard cardOnBoard;
				cardOnBoard.cardId    = move.putCardId;
				cardOnBoard.direction = move.putCardDirection;
				_gridList_Card [ move.putCardY ][ move.putCardX ] = cardOnBoard;
				*/
				_gridList_Card [ move.putCardY ][ move.putCardX ].cardId    = move.putCardId;
				_gridList_Card [ move.putCardY ][ move.putCardX ].direction = move.putCardDirection;
			}
			// 手番交代
			_currentTurn = TURN::BLACK;
		}


		// 巻き戻し情報
		_moveForBack.previousMove = move;
		_moveForBack.isValid      = true;
	}
	
}

//=========================================================
// こう指してね：子処理：カード取る
//=========================================================
void InnerExpression::GoNext_TakeCard( const Move &move ) {
	
	if (move.action == MOVE::ACTION::TAKE_CARD) {
		
		_isPassPreviousMove = false;
		_isThrouableInfoLatest = false;

		// 巻き戻し情報
		_moveForBack.previousMove = move;
		_moveForBack.isValid = true;
		_moveForBack.tookCardId        = _gridList_Card[move.takeCardY][move.takeCardX].cardId;
		_moveForBack.tookCardDirection = _gridList_Card[move.takeCardY][move.takeCardX].direction;

		if (_currentTurn == TURN::BLACK) {

			// 手札に加えて
			Init_AddHandCard_BLACK( _gridList_Card[move.takeCardY][move.takeCardX].cardId );
			//_handCards_BLACK.push_back(_gridList_Card[move.takeCardY][move.takeCardX].cardId);

			// 盤面から、はがす
			_gridList_Card[move.takeCardY][move.takeCardX] = CardOnBoard();

			// 手番交代
			_currentTurn = TURN::WHITE;

		}
		else if (_currentTurn == TURN::WHITE) {

			// 手札に加えて
			Init_AddHandCard_WHITE( _gridList_Card[move.takeCardY][move.takeCardX].cardId );
			//_handCards_WHITE.push_back(_gridList_Card[move.takeCardY][move.takeCardX].cardId);

			// 盤面から、はがす
			_gridList_Card[move.takeCardY][move.takeCardX] = CardOnBoard();

			// 手番交代
			_currentTurn = TURN::BLACK;
		}

	}
}


//=========================================================
// 可能な次の手を列挙
//=========================================================
/*
vector<Move> InnerExpression::GetLegalNextMoveList() {

	vector<Move> result;

	///// 駒を動かす手を生成（勝つ可能性のある手がリストの先頭近くになるように）
	GetLegalNextMoveList_MovePiece( result );

	///// 駒を打つ手を生成
	GetLegalNextMoveList_PutPiece( result );

	///// カードを置く手を生成
	GetLegalNextMoveList_PutCard( result );

	///// カードを取る手を生成
	GetLegalNextMoveList_TakeCard( result );

	///// パス
	if (result.size() == 0) {
		Move move;
		move.action = MOVE::ACTION::PASS;
		result.push_back( move );
	}

	return result;
}
*/
void InnerExpression::GetLegalNextMoveList(vector<Move> &result) {

	///// 駒を動かす手を生成（勝つ可能性のある手がリストの先頭近くになるように）
	GetLegalNextMoveList_MovePiece( result );

	///// 駒を打つ手を生成
	GetLegalNextMoveList_PutPiece( result );

	///// カードを置く手を生成
	GetLegalNextMoveList_PutCard( result );

	///// カードを取る手を生成
	GetLegalNextMoveList_TakeCard( result );

	///// パス
	if (result.size() == 0) {
		Move move;
		move.action = MOVE::ACTION::PASS;
		result.push_back( move );
	}
}
//==========================================================
// 可能な次の手を取得：手の種類を指定
//==========================================================
void InnerExpression::GetLegalNextMoveList(vector<Move> &result, int moveChoice) {

	///// 駒を動かす手を生成
	if ((moveChoice & MOVE::ACTION::MOVE_PIECE) == MOVE::ACTION::MOVE_PIECE) {
		GetLegalNextMoveList_MovePiece( result );
	}
	///// 駒を打つ手を生成
	if ((moveChoice & MOVE::ACTION::PUT_PIECE) == MOVE::ACTION::PUT_PIECE) {
		GetLegalNextMoveList_PutPiece( result );
	}
	///// カードを置く手を生成
	if ((moveChoice & MOVE::ACTION::PUT_CARD) == MOVE::ACTION::PUT_CARD) {
		GetLegalNextMoveList_PutCard( result );
	}
	///// カードを取る手を生成
	if ((moveChoice & MOVE::ACTION::TAKE_CARD) == MOVE::ACTION::TAKE_CARD) {
		GetLegalNextMoveList_TakeCard( result );
	}

	///// パス：は、フラグ指定とは無関係に、必要なら入れる
	if (result.size() == 0) {
		Move move;
		move.action = MOVE::ACTION::PASS;
		result.push_back( move );
	}
}

//=========================================================
// 可能な次の手のうち、勝つ手を取得
//（現局面に王手が生じているかどうかを判定する主旨）
//=========================================================
void InnerExpression::GetLegalWinMoveList(vector<Move> &result) {

	///// 現在、どっちの手番？ 
	if (_currentTurn == TURN::BLACK) {

		///// 駒がある場所を走査
		for ( unsigned int y = 0; y < _boardSizeY; ++y) {

			for ( unsigned int x = 0; x < _boardSizeX; ++x) {

				// 駒がある？
				if (_gridList_Piece[y][x] == GRID::BLACK ) {

					// 黒が白陣に入る可能性のある方向への移動を見る
					GetLegalNextMoveList_MovePiece_toUP_toWin       ( result, x, y );
					GetLegalNextMoveList_MovePiece_toRIGHT_UP_toWin ( result, x, y );
					GetLegalNextMoveList_MovePiece_toLEFT_UP_toWin  ( result, x, y );
				}
			}
		}

	}
	else if (_currentTurn == TURN::WHITE) {

		///// 駒がある場所を走査
		for ( unsigned int y = 0; y < _boardSizeY; ++y) {

			for ( unsigned int x = 0; x < _boardSizeX; ++x) {

				// 駒がある？
				if (_gridList_Piece[y][x] == GRID::WHITE ) {

					// 白が黒陣に入る可能性のある方向への移動を見る
					GetLegalNextMoveList_MovePiece_toDOWN_toWin       ( result, x, y );
					GetLegalNextMoveList_MovePiece_toRIGHT_DOWN_toWin ( result, x, y );
					GetLegalNextMoveList_MovePiece_toLEFT_DOWN_toWin  ( result, x, y );
				}
			}
		}	
	}


}


//=========================================================
// 可能な次の手を列挙：子処理：駒を打つ
//=========================================================
void InnerExpression::GetLegalNextMoveList_PutPiece(vector<Move> &result ) {


	///// 駒を打つ手を生成
	/*
		黒が手前で白が奥。
	*/
	if (_currentTurn == TURN::BLACK) {


		// 駒台に駒がある？
		if (_handPiece_BLACK > 0) {

			// 自陣の空いているマス目の分、手を生成
			int selfAreaIndex = _boardSizeY - 1;

			for (unsigned int  x = 0; x < _boardSizeX; ++x) {

				// 空きマスならば、置ける
				if (_gridList_Piece[selfAreaIndex][x] == GRID::ENPTY) {

					Move move;
					move.turn   = _currentTurn;
					move.action = MOVE::ACTION::PUT_PIECE;
					move.putPieceX = x;
					move.putPieceY = selfAreaIndex;

					result.push_back(move);
				}
			}
		}
	}
	else if (_currentTurn == TURN::WHITE) {


		// 駒台に駒がある？
		if (_handPiece_WHITE > 0) {

			// 自陣の空いているマス目の分、手を生成
			int selfAreaIndex = 0;

			for (unsigned int  x = 0; x < _boardSizeX; ++x) {

				// 空きマスならば、置ける
				if (_gridList_Piece[selfAreaIndex][x] == GRID::ENPTY) {

					Move move;
					move.turn   = _currentTurn;
					move.action = MOVE::ACTION::PUT_PIECE;
					move.putPieceX = x;
					move.putPieceY = selfAreaIndex;

					result.push_back(move);
				}
			}
		}
	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を動かす
//=========================================================
void InnerExpression::GetLegalNextMoveList_MovePiece (vector<Move> &result ) {

	/*
		
	*/

	///// どっちの手番？ 
	int piece;
	if (_currentTurn == TURN::BLACK) {
		piece = GRID::BLACK;
	}
	else if (_currentTurn == TURN::WHITE) {
		piece = GRID::WHITE;
	}

	///// 自分の駒がある場所を走査
	for ( unsigned int y = 0; y < _boardSizeY; ++y) {

		for ( unsigned int x = 0; x < _boardSizeX; ++x) {

			// 自分の駒がある？
			if (_gridList_Piece[y][x] == piece ) {

				// 各方向への移動を見る
				GetLegalNextMoveList_MovePiece_toUP    ( result, x, y );
				GetLegalNextMoveList_MovePiece_toDOWN  ( result, x, y );
				GetLegalNextMoveList_MovePiece_toLEFT  ( result, x, y );
				GetLegalNextMoveList_MovePiece_toRIGHT ( result, x, y );
				GetLegalNextMoveList_MovePiece_toRIGHT_UP   ( result, x, y );
				GetLegalNextMoveList_MovePiece_toRIGHT_DOWN ( result, x, y );
				GetLegalNextMoveList_MovePiece_toLEFT_UP    ( result, x, y );
				GetLegalNextMoveList_MovePiece_toLEFT_DOWN  ( result, x, y );

			}
		}
	}
}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：上へ
//=========================================================
void InnerExpression::GetLegalNextMoveList_MovePiece_toUP (vector<Move> &result, int x, int y ) {

	///// 現在地が、上移動可か？
	if ( !IsThrouableTo ( _gridList_ThrouableInfo[y][x], DIRECTION::UP ) ) {
		return;
	}

	///// 上向きに動いてみる（１つ上から開始）
	for ( int prospectiveY = y - 1; prospectiveY >= 0; --prospectiveY) {

		// 他の駒があったら入れない
		if ( _gridList_Piece[ prospectiveY ][x] != GRID::ENPTY) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( _gridList_ThrouableInfo[ prospectiveY ][ x ] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = x;
		move.movePieceToY   = prospectiveY;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextY = prospectiveY - 1;
		if (nextY >= 0 && _gridList_Piece[nextY][x] != GRID::ENPTY) {

			if ( _gridList_ThrouableInfo[nextY][x] != THROUGHABLE_INFO::NOT_THROUGHABLE ) {

				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;
				move_collide.movePieceAndCllidedPieceColor = _gridList_Piece[nextY][x];
				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( !IsThrouableTo( _gridList_ThrouableInfo [ prospectiveY ][x], DIRECTION::UP)) {
			break;
		}

	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：下へ
//=========================================================
void InnerExpression::GetLegalNextMoveList_MovePiece_toDOWN (vector<Move> &result, int x, int y ) {

	///// 現在地が、下移動可か？
	if ( !IsThrouableTo ( _gridList_ThrouableInfo[y][x], DIRECTION::DOWN ) ) {
		return;
	}

	///// 下向きに動いてみる（１つ下から開始）
	for ( int prospectiveY = y + 1; prospectiveY < _boardSizeY; ++prospectiveY) {

		// 他の駒があったら入れない
		if ( _gridList_Piece[ prospectiveY ][x] != GRID::ENPTY) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( _gridList_ThrouableInfo[ prospectiveY ][ x ] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = x;
		move.movePieceToY   = prospectiveY;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextY = prospectiveY + 1;
		if (nextY < _boardSizeY && _gridList_Piece[nextY][x] != GRID::ENPTY) {

			if ( _gridList_ThrouableInfo[nextY][x] != THROUGHABLE_INFO::NOT_THROUGHABLE ) {

				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;
				move_collide.movePieceAndCllidedPieceColor = _gridList_Piece[nextY][x];
				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( !IsThrouableTo( _gridList_ThrouableInfo [ prospectiveY ][x], DIRECTION::DOWN)) {
			break;
		}

	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：左へ
//=========================================================
void InnerExpression::GetLegalNextMoveList_MovePiece_toLEFT (vector<Move> &result, int x, int y ) {

	///// 現在地が、左移動可か？
	if ( !IsThrouableTo ( _gridList_ThrouableInfo[y][x], DIRECTION::LEFT ) ) {
		return;
	}

	///// 左向きに動いてみる（１つ左から開始）
	for ( int prospectiveX = x - 1; prospectiveX >= 0; --prospectiveX) {

		// 他の駒があったら入れない
		if ( _gridList_Piece[y][ prospectiveX] != GRID::ENPTY) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( _gridList_ThrouableInfo[y][prospectiveX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = prospectiveX;
		move.movePieceToY   = y;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextX = prospectiveX - 1;
		if (nextX >= 0 && _gridList_Piece[y][nextX] != GRID::ENPTY) {

			if ( _gridList_ThrouableInfo[y][nextX] != THROUGHABLE_INFO::NOT_THROUGHABLE ) {

				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;
				move_collide.movePieceAndCllidedPieceColor = _gridList_Piece[y][nextX];
				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( !IsThrouableTo( _gridList_ThrouableInfo [y][ prospectiveX ], DIRECTION::LEFT)) {
			break;
		}

	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：右へ
//=========================================================
void InnerExpression::GetLegalNextMoveList_MovePiece_toRIGHT (vector<Move> &result, int x, int y ) {

	///// 現在地が、右移動可か？
	if ( !IsThrouableTo ( _gridList_ThrouableInfo[y][x], DIRECTION::RIGHT ) ) {
		return;
	}

	///// 右向きに動いてみる（１つ右から開始）
	for ( int prospectiveX = x + 1; prospectiveX  < _boardSizeX; ++prospectiveX) {

		// 他の駒があったら入れない
		if ( _gridList_Piece[y][ prospectiveX] != GRID::ENPTY) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( _gridList_ThrouableInfo[y][prospectiveX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = prospectiveX;
		move.movePieceToY   = y;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextX = prospectiveX + 1;
		if (nextX < _boardSizeX && _gridList_Piece[y][nextX] != GRID::ENPTY) {

			if ( _gridList_ThrouableInfo[y][nextX] != THROUGHABLE_INFO::NOT_THROUGHABLE ) {

				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;
				move_collide.movePieceAndCllidedPieceColor = _gridList_Piece[y][nextX];
				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( !IsThrouableTo( _gridList_ThrouableInfo [y][ prospectiveX ], DIRECTION::RIGHT)) {
			break;
		}

	}

}

//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：右下へ
//=========================================================
void InnerExpression::GetLegalNextMoveList_MovePiece_toRIGHT_DOWN (vector<Move> &result, int x, int y ) {

	///// 現在地が、次へ移動可か？：矢印は４方向しかない。すなわち、「全方向通行可」のみ見る。
	if ( _gridList_ThrouableInfo[y][x] != THROUGHABLE_INFO::THROUGHABLE ) {
		return;
	}

	///// 一歩動いてみる（１つ次から開始）
	int prospectiveX = x + 1; 
	int prospectiveY = y + 1; 
	while (  prospectiveY < _boardSizeY && prospectiveX < _boardSizeX) {

		// 他の駒があったら入れない
		if ( _gridList_Piece[prospectiveY][ prospectiveX] != GRID::ENPTY) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( _gridList_ThrouableInfo[prospectiveY][prospectiveX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = prospectiveX;
		move.movePieceToY   = prospectiveY;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextX = prospectiveX + 1;
		int nextY = prospectiveY + 1;
		if ( nextY < _boardSizeY && nextX < _boardSizeX && _gridList_Piece[nextY][nextX] != GRID::ENPTY) {

			if ( _gridList_ThrouableInfo[nextY][nextX] != THROUGHABLE_INFO::NOT_THROUGHABLE ) {

				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;
				move_collide.movePieceAndCllidedPieceColor = _gridList_Piece[nextY][nextX];
				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( _gridList_ThrouableInfo [prospectiveY][ prospectiveX ] != THROUGHABLE_INFO::THROUGHABLE) {
			break;
		}

		++prospectiveX;
		++prospectiveY;
	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：右上へ
//=========================================================
void InnerExpression::GetLegalNextMoveList_MovePiece_toRIGHT_UP (vector<Move> &result, int x, int y ) {

	///// 現在地が、次へ移動可か？：矢印は４方向しかない。すなわち、「全方向通行可」のみ見る。
	if ( _gridList_ThrouableInfo[y][x] != THROUGHABLE_INFO::THROUGHABLE ) {
		return;
	}

	///// 一歩動いてみる（１つ次から開始）
	int prospectiveX = x + 1; 
	int prospectiveY = y - 1; 
	while (  prospectiveY >= 0 && prospectiveX < _boardSizeX) {

		// 他の駒があったら入れない
		if ( _gridList_Piece[prospectiveY][ prospectiveX] != GRID::ENPTY) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( _gridList_ThrouableInfo[prospectiveY][prospectiveX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = prospectiveX;
		move.movePieceToY   = prospectiveY;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextX = prospectiveX + 1;
		int nextY = prospectiveY - 1;
		if ( nextY >= 0 && nextX < _boardSizeX && _gridList_Piece[nextY][nextX] != GRID::ENPTY) {

			if ( _gridList_ThrouableInfo[nextY][nextX] != THROUGHABLE_INFO::NOT_THROUGHABLE ) {

				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;
				move_collide.movePieceAndCllidedPieceColor = _gridList_Piece[nextY][nextX];
				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( _gridList_ThrouableInfo [prospectiveY][ prospectiveX ] != THROUGHABLE_INFO::THROUGHABLE) {
			break;
		}

		++prospectiveX;
		--prospectiveY;
	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：左上へ
//=========================================================
void InnerExpression::GetLegalNextMoveList_MovePiece_toLEFT_UP (vector<Move> &result, int x, int y ) {

	///// 現在地が、次へ移動可か？：矢印は４方向しかない。すなわち、「全方向通行可」のみ見る。
	if ( _gridList_ThrouableInfo[y][x] != THROUGHABLE_INFO::THROUGHABLE ) {
		return;
	}

	///// 一歩動いてみる（１つ次から開始）
	int prospectiveX = x - 1; 
	int prospectiveY = y - 1; 
	while (  prospectiveY >= 0 && prospectiveX >= 0) {

		// 他の駒があったら入れない
		if ( _gridList_Piece[prospectiveY][ prospectiveX] != GRID::ENPTY) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( _gridList_ThrouableInfo[prospectiveY][prospectiveX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = prospectiveX;
		move.movePieceToY   = prospectiveY;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextX = prospectiveX - 1;
		int nextY = prospectiveY - 1;
		if ( nextY >= 0 && nextX >= 0 && _gridList_Piece[nextY][nextX] != GRID::ENPTY) {

			if ( _gridList_ThrouableInfo[nextY][nextX] != THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			
				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;
				move_collide.movePieceAndCllidedPieceColor = _gridList_Piece[nextY][nextX];
				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( _gridList_ThrouableInfo [prospectiveY][ prospectiveX ] != THROUGHABLE_INFO::THROUGHABLE) {
			break;
		}

		--prospectiveX;
		--prospectiveY;
	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：左下へ
//=========================================================
void InnerExpression::GetLegalNextMoveList_MovePiece_toLEFT_DOWN (vector<Move> &result, int x, int y ) {

	///// 現在地が、次へ移動可か？：矢印は４方向しかない。すなわち、「全方向通行可」のみ見る。
	if ( _gridList_ThrouableInfo[y][x] != THROUGHABLE_INFO::THROUGHABLE ) {
		return;
	}

	///// 一歩動いてみる（１つ次から開始）
	int prospectiveX = x - 1; 
	int prospectiveY = y + 1; 
	while (  prospectiveY < _boardSizeY && prospectiveX >= 0) {

		// 他の駒があったら入れない
		if ( _gridList_Piece[prospectiveY][ prospectiveX] != GRID::ENPTY) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( _gridList_ThrouableInfo[prospectiveY][prospectiveX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = prospectiveX;
		move.movePieceToY   = prospectiveY;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextX = prospectiveX - 1;
		int nextY = prospectiveY + 1;
		if ( nextY < _boardSizeY && nextX >= 0 && _gridList_Piece[nextY][nextX] != GRID::ENPTY) {

			if ( _gridList_ThrouableInfo[nextY][nextX] != THROUGHABLE_INFO::NOT_THROUGHABLE ) {

				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;
				move_collide.movePieceAndCllidedPieceColor = _gridList_Piece[nextY][nextX];
				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( _gridList_ThrouableInfo [prospectiveY][ prospectiveX ] != THROUGHABLE_INFO::THROUGHABLE) {
			break;
		}

		--prospectiveX;
		++prospectiveY;
	}

}

//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：上へ（勝つ手のみ）
//=========================================================
void InnerExpression::GetLegalNextMoveList_MovePiece_toUP_toWin (vector<Move> &result, int x, int y ) {

	///// 現在地が、上移動可か？
	if ( !IsThrouableTo ( _gridList_ThrouableInfo[y][x], DIRECTION::UP ) ) {
		return;
	}

	///// 上向きに動いてみる（１つ上から開始）
	for ( int prospectiveY = y - 1; prospectiveY >= 0; --prospectiveY) {

		// 他の駒があったら入れない
		if ( _gridList_Piece[ prospectiveY ][x] != GRID::ENPTY) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( _gridList_ThrouableInfo[ prospectiveY ][ x ] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			break;
		}

		// 入れます。
		// 相手陣に達したら、指し手リストに入れる。
		if ( prospectiveY == 0 ) {

			Move move;
			move.action = MOVE::ACTION::MOVE_PIECE;
			move.turn = _currentTurn;
			move.movePieceFromX = x;
			move.movePieceFromY = y;
			move.movePieceToX   = x;
			move.movePieceToY   = prospectiveY;
			move.movePieceAndIsCllide = false;
			result.push_back ( move );
		}

		// もう進めない？
		if ( !IsThrouableTo( _gridList_ThrouableInfo [ prospectiveY ][x], DIRECTION::UP)) {
			break;
		}

	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：下へ（勝つ手のみ）
//=========================================================
void InnerExpression::GetLegalNextMoveList_MovePiece_toDOWN_toWin (vector<Move> &result, int x, int y ) {

	///// 現在地が、下移動可か？
	if ( !IsThrouableTo ( _gridList_ThrouableInfo[y][x], DIRECTION::DOWN ) ) {
		return;
	}

	///// 下向きに動いてみる（１つ下から開始）
	for ( int prospectiveY = y + 1; prospectiveY < _boardSizeY; ++prospectiveY) {

		// 他の駒があったら入れない
		if ( _gridList_Piece[ prospectiveY ][x] != GRID::ENPTY) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( _gridList_ThrouableInfo[ prospectiveY ][ x ] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			break;
		}

		// 入れます。
		// 相手陣に達していたら、指し手に加える
		if ( prospectiveY == _boardSizeY - 1) {
			Move move;
			move.action = MOVE::ACTION::MOVE_PIECE;
			move.turn = _currentTurn;
			move.movePieceFromX = x;
			move.movePieceFromY = y;
			move.movePieceToX   = x;
			move.movePieceToY   = prospectiveY;
			move.movePieceAndIsCllide = false;
			result.push_back ( move );
		}

		// もう進めない？
		if ( !IsThrouableTo( _gridList_ThrouableInfo [ prospectiveY ][x], DIRECTION::DOWN)) {
			break;
		}

	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：左上へ（勝つ手のみ）
//=========================================================
void InnerExpression::GetLegalNextMoveList_MovePiece_toLEFT_UP_toWin (vector<Move> &result, int x, int y ) {

	///// 現在地が、次へ移動可か？：矢印は４方向しかない。すなわち、「全方向通行可」のみ見る。
	if ( _gridList_ThrouableInfo[y][x] != THROUGHABLE_INFO::THROUGHABLE ) {
		return;
	}

	///// 位置によっては、相手陣に達する見込みがない
	if ( x < y ) {
		return;
	}

	///// 一歩動いてみる（１つ次から開始）
	int prospectiveX = x - 1; 
	int prospectiveY = y - 1; 
	while (  prospectiveY >= 0 && prospectiveX >= 0) {

		// 他の駒があったら入れない
		if ( _gridList_Piece[prospectiveY][ prospectiveX] != GRID::ENPTY) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( _gridList_ThrouableInfo[prospectiveY][prospectiveX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			break;
		}

		// 入れます。
		// 相手陣に達していたら指し手に加える
		if ( prospectiveY == 0 ) {
			Move move;
			move.action = MOVE::ACTION::MOVE_PIECE;
			move.turn = _currentTurn;
			move.movePieceFromX = x;
			move.movePieceFromY = y;
			move.movePieceToX   = prospectiveX;
			move.movePieceToY   = prospectiveY;
			move.movePieceAndIsCllide = false;
			result.push_back ( move );
		}

		// もう進めない？
		if ( _gridList_ThrouableInfo [prospectiveY][ prospectiveX ] != THROUGHABLE_INFO::THROUGHABLE) {
			break;
		}

		--prospectiveX;
		--prospectiveY;
	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：左下へ（勝つ手のみ）
//=========================================================
void InnerExpression::GetLegalNextMoveList_MovePiece_toLEFT_DOWN_toWin (vector<Move> &result, int x, int y ) {

	///// 現在地が、次へ移動可か？：矢印は４方向しかない。すなわち、「全方向通行可」のみ見る。
	if ( _gridList_ThrouableInfo[y][x] != THROUGHABLE_INFO::THROUGHABLE ) {
		return;
	}

	// 位置によっては相手陣に達する見込みがない
	if ( x < (_boardSizeY - y) ) {
	}

	///// 一歩動いてみる（１つ次から開始）
	int prospectiveX = x - 1; 
	int prospectiveY = y + 1; 
	while (  prospectiveY < _boardSizeY && prospectiveX >= 0) {

		// 他の駒があったら入れない
		if ( _gridList_Piece[prospectiveY][ prospectiveX] != GRID::ENPTY) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( _gridList_ThrouableInfo[prospectiveY][prospectiveX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			break;
		}

		// 入れます。
		// 相手陣に達していたら指し手に加える
		if ( prospectiveY == (_boardSizeY - 1) )  {
			Move move;
			move.action = MOVE::ACTION::MOVE_PIECE;
			move.turn = _currentTurn;
			move.movePieceFromX = x;
			move.movePieceFromY = y;
			move.movePieceToX   = prospectiveX;
			move.movePieceToY   = prospectiveY;
			move.movePieceAndIsCllide = false;
			result.push_back ( move );
		}

		// もう進めない？
		if ( _gridList_ThrouableInfo [prospectiveY][ prospectiveX ] != THROUGHABLE_INFO::THROUGHABLE) {
			break;
		}

		--prospectiveX;
		++prospectiveY;
	}

}

//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：右下へ（勝つ手のみ）
//=========================================================
void InnerExpression::GetLegalNextMoveList_MovePiece_toRIGHT_DOWN_toWin (vector<Move> &result, int x, int y ) {

	///// 現在地が、次へ移動可か？：矢印は４方向しかない。すなわち、「全方向通行可」のみ見る。
	if ( _gridList_ThrouableInfo[y][x] != THROUGHABLE_INFO::THROUGHABLE ) {
		return;
	}
	
	///// 位置によっては相手陣に達する見込みがない
	if ( x > y ) {
		return;
	}

	///// 一歩動いてみる（１つ次から開始）
	int prospectiveX = x + 1; 
	int prospectiveY = y + 1; 
	while (  prospectiveY < _boardSizeY && prospectiveX < _boardSizeX) {

		// 他の駒があったら入れない
		if ( _gridList_Piece[prospectiveY][ prospectiveX] != GRID::ENPTY) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( _gridList_ThrouableInfo[prospectiveY][prospectiveX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			break;
		}

		// 入れます。
		// 相陣に達していたら指し手に加える
		if ( prospectiveY == ( _boardSizeY - 1 ) ) {
			Move move;
			move.action = MOVE::ACTION::MOVE_PIECE;
			move.turn = _currentTurn;
			move.movePieceFromX = x;
			move.movePieceFromY = y;
			move.movePieceToX   = prospectiveX;
			move.movePieceToY   = prospectiveY;
			move.movePieceAndIsCllide = false;
			result.push_back ( move );
		}

		// もう進めない？
		if ( _gridList_ThrouableInfo [prospectiveY][ prospectiveX ] != THROUGHABLE_INFO::THROUGHABLE) {
			break;
		}

		++prospectiveX;
		++prospectiveY;
	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：右上へ
//=========================================================
void InnerExpression::GetLegalNextMoveList_MovePiece_toRIGHT_UP_toWin (vector<Move> &result, int x, int y ) {

	///// 現在地が、次へ移動可か？：矢印は４方向しかない。すなわち、「全方向通行可」のみ見る。
	if ( _gridList_ThrouableInfo[y][x] != THROUGHABLE_INFO::THROUGHABLE ) {
		return;
	}

	///// 位置によっては相手陣に達する見込みはない
	if ( (_boardSizeX - x) < y ) {
		return;
	}

	///// 一歩動いてみる（１つ次から開始）
	int prospectiveX = x + 1; 
	int prospectiveY = y - 1; 
	while (  prospectiveY >= 0 && prospectiveX < _boardSizeX) {

		// 他の駒があったら入れない
		if ( _gridList_Piece[prospectiveY][ prospectiveX] != GRID::ENPTY) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( _gridList_ThrouableInfo[prospectiveY][prospectiveX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			break;
		}

		// 入れます。
		// 相手陣に達していたら指し手に加える
		if ( prospectiveY == 0 ) {
			Move move;
			move.action = MOVE::ACTION::MOVE_PIECE;
			move.turn = _currentTurn;
			move.movePieceFromX = x;
			move.movePieceFromY = y;
			move.movePieceToX   = prospectiveX;
			move.movePieceToY   = prospectiveY;
			move.movePieceAndIsCllide = false;
			result.push_back ( move );
		}

		// もう進めない？
		if ( _gridList_ThrouableInfo [prospectiveY][ prospectiveX ] != THROUGHABLE_INFO::THROUGHABLE) {
			break;
		}

		++prospectiveX;
		--prospectiveY;
	}

}


//=========================================================
// 各方向への移動可？
//=========================================================
bool InnerExpression::IsThrouableTo( int throuableInfo, int direction ) {

	bool result = false;

	if      ( direction == DIRECTION::UP    ) {	result = (throuableInfo == THROUGHABLE_INFO::THROUGHABLE || throuableInfo == THROUGHABLE_INFO::MUST_TO_UP);}
	else if ( direction == DIRECTION::LEFT  ) {	result = (throuableInfo == THROUGHABLE_INFO::THROUGHABLE || throuableInfo == THROUGHABLE_INFO::MUST_TO_LEFT);}
	else if ( direction == DIRECTION::RIGHT ) {	result = (throuableInfo == THROUGHABLE_INFO::THROUGHABLE || throuableInfo == THROUGHABLE_INFO::MUST_TO_RIGHT);}
	else if ( direction == DIRECTION::DOWN  ) {	result = (throuableInfo == THROUGHABLE_INFO::THROUGHABLE || throuableInfo == THROUGHABLE_INFO::MUST_TO_DOWN);}

	return result;
}

//=========================================================
// 可能な次の手を列挙：子処理：カードを置く
//=========================================================
void InnerExpression::GetLegalNextMoveList_PutCard   (vector<Move> &result ) {

	///// どっちの手番？ 
	//vector<int> handCards;
	if (_currentTurn == TURN::BLACK) {

		//handCards = _handCards_BLACK;
		GetLegalNextMoveList_PutCard_TurnDetermined( result, _handCards_BLACK, _handCards_BLACK_Index );
	}
	else if (_currentTurn == TURN::WHITE) {
		//handCards = _handCards_WHITE;
		GetLegalNextMoveList_PutCard_TurnDetermined( result, _handCards_WHITE, _handCards_WHITE_Index);
	}
}
///// ターンを決めた後
void InnerExpression::GetLegalNextMoveList_PutCard_TurnDetermined (vector<Move> &result, int handCards[], int length ) {

	/*
		
		カードがないマス目で絞り込んで、
		手札でループして、向きごとに確認。

	*/

	///// 同じIDのカードは一回しか見ませんよ。
	set<int> checkedCardId;
	for ( unsigned int i = 0; i < length; ++i ) {

		if ( checkedCardId.find( handCards[i] ) == checkedCardId.end() ) {
			checkedCardId.insert( handCards[i] );
		}
	}
	set<int>::iterator it;
	

	for ( unsigned int y = 0; y < _boardSizeY; ++y) {
		for ( unsigned int x = 0; x < _boardSizeX; ++x) {

			///// カードがなくて通行不可のマス目（他カードの影響がない）ならば、置けるかも。
			if (_gridList_Card[y][x].isEmpty() && _gridList_ThrouableInfo[y][x] == THROUGHABLE_INFO::NOT_THROUGHABLE) {

				///// 同じIDのカードは一回しか見ませんよ。
				//checkedCardId.clear();

				///// 手札でループ
				//for ( unsigned int i = 0; i < handCards.size(); ++i ) {
				for ( it = checkedCardId.begin(); it != checkedCardId.end(); ++it) {

					// すでに見たカードなら、同じ処理はしませんよ。
					//if ( checkedCardId.find( handCards[i] ) != checkedCardId.end() ) {
					//	continue;
					//}

					// 見ましたリストに入れておく。
					//checkedCardId.insert( handCards[i] );
					
					// カード番号から、カードの中身を取得
					//Card card = AI::GetInstance()->GetCardInfo( handCards[i] );
					Card card = AI::GetCardInfo( *it );

					// 影響グリッドでループ
					bool isPuttableUP    = true;
					bool isPuttableLEFT  = true;
					bool isPuttableRIGHT = true;
					bool isPuttableDOWN  = true;

					// 対称形の回転判定を省略するうまい方法はないですか…？
					if (card.gridAffectionList.size() == 0) {
						isPuttableLEFT  = false;
						isPuttableRIGHT = false;
						isPuttableDOWN  = false;
					}

					for ( unsigned int n = 0; n < card.gridAffectionList.size(); ++n) {

						// どの向きにも置けないならば終了
						if ( !isPuttableUP && !isPuttableRIGHT && !isPuttableLEFT && !isPuttableDOWN) {
							break;
						}
						// まだ UP で置けるかもしれないと思っている
						if ( isPuttableUP ) {

							// このグリッドは空いている？（通行不可）
							int affectX = x + card.gridAffectionList[n].TurnedX( DIRECTION::UP );
							int affectY = y + card.gridAffectionList[n].TurnedY( DIRECTION::UP );

							// 空いてなければ、置ける可能性を false にする（盤の範囲外なら判定しない）
							if ( IsWithinBoardLimit( affectX, affectY ) && _gridList_ThrouableInfo[affectY][affectX] != THROUGHABLE_INFO::NOT_THROUGHABLE) {

								isPuttableUP = false;
							}
						}
						
						// まだ LEFT で置けるかもしれないと思っている
						if ( isPuttableLEFT ) {

							// このグリッドは空いている？（通行不可）
							int affectX = x + card.gridAffectionList[n].TurnedX( DIRECTION::LEFT );
							int affectY = y + card.gridAffectionList[n].TurnedY( DIRECTION::LEFT );

							// 空いてなければ、置ける可能性を false にする
							bool a = IsWithinBoardLimit( affectX, affectY );
							if ( IsWithinBoardLimit( affectX, affectY ) && _gridList_ThrouableInfo[affectY][affectX] != THROUGHABLE_INFO::NOT_THROUGHABLE) {

								isPuttableLEFT = false;
							}
						}
						// まだ RIGHTで置けるかもしれないと思っている
						if ( isPuttableRIGHT ) {

							// このグリッドは空いている？（通行不可）
							int affectX = x + card.gridAffectionList[n].TurnedX( DIRECTION::RIGHT );
							int affectY = y + card.gridAffectionList[n].TurnedY( DIRECTION::RIGHT );

							// 空いてなければ、置ける可能性を false にする
							bool a = IsWithinBoardLimit( affectX, affectY );
							if ( IsWithinBoardLimit( affectX, affectY ) && _gridList_ThrouableInfo[affectY][affectX] != THROUGHABLE_INFO::NOT_THROUGHABLE) {

								isPuttableRIGHT = false;
							}
						}
						// まだ DOWNで置けるかもしれないと思っている
						if ( isPuttableDOWN ) {

							// このグリッドは空いている？（通行不可）
							int affectX = x + card.gridAffectionList[n].TurnedX( DIRECTION::DOWN );
							int affectY = y + card.gridAffectionList[n].TurnedY( DIRECTION::DOWN );

							// 空いてなければ、置ける可能性を false にする
							if ( IsWithinBoardLimit( affectX, affectY ) && _gridList_ThrouableInfo[affectY][affectX] != THROUGHABLE_INFO::NOT_THROUGHABLE) {

								isPuttableDOWN = false;
							}
						}
						

					} // 影響グリッドでループ

					// 上向きに置ける
					if ( isPuttableUP ) {

						Move move;
						move.turn   = _currentTurn;
						move.action = MOVE::ACTION::PUT_CARD;
						move.putCardX = x;
						move.putCardY = y;
						move.putCardId = card.processId;
						move.putCardDirection = DIRECTION::UP;
						
						result.push_back(move);
					}
					
					// 右向きに置ける
					if ( isPuttableRIGHT ) {

						Move move;
						move.turn   = _currentTurn;
						move.action = MOVE::ACTION::PUT_CARD;
						move.putCardX = x;
						move.putCardY = y;
						move.putCardId = card.processId;
						move.putCardDirection = DIRECTION::RIGHT;
						
						result.push_back(move);
					}
					// 左向きに置ける
					if ( isPuttableLEFT ) {

						Move move;
						move.turn   = _currentTurn;
						move.action = MOVE::ACTION::PUT_CARD;
						move.putCardX = x;
						move.putCardY = y;
						move.putCardId = card.processId;
						move.putCardDirection = DIRECTION::LEFT;
						
						result.push_back(move);
					}
					// 下向きに置ける
					if ( isPuttableDOWN ) {

						Move move;
						move.turn   = _currentTurn;
						move.action = MOVE::ACTION::PUT_CARD;
						move.putCardX = x;
						move.putCardY = y;
						move.putCardId = card.processId;
						move.putCardDirection = DIRECTION::DOWN;
						
						result.push_back(move);
					}
					

				}


			}


		}
	}

}
//=========================================================
// 盤の範囲内？
//=========================================================
bool InnerExpression::IsWithinBoardLimit( int x, int y ) {

	bool result = false;

	if ( y >= 0 && y < _boardSizeY ) {

		if ( x >= 0 && x < _boardSizeX ) {
			result = true;
		}
	}

	return result;
}

//=========================================================
// 可能な次の手を列挙：子処理：カードを取る
//=========================================================
void InnerExpression::GetLegalNextMoveList_TakeCard  (vector<Move> &result ){

	/*
		自分の駒があって、カードがあるマス目の分、手を生成
	*/

	if (_currentTurn == TURN::BLACK) {

		for ( unsigned int y = 0; y < _boardSizeY; ++y) {

			for ( unsigned int x = 0; x < _boardSizeX; ++x) {

				// 自分の駒があって
				if (_gridList_Piece[y][x] == GRID::BLACK ) {

					// カードがあれば、取れる。
					if ( !_gridList_Card[y][x].isEmpty() ) {

						Move move;
						move.turn   = _currentTurn;
						move.action = MOVE::ACTION::TAKE_CARD;
						move.takeCardX = x;
						move.takeCardY = y;

						result.push_back( move );
					}
				}
			}
		}
	}
	else if (_currentTurn == TURN::WHITE) {

		for ( unsigned int y = 0; y < _boardSizeY; ++y) {

			for ( unsigned int x = 0; x < _boardSizeX; ++x) {

				// 自分の駒があって
				if (_gridList_Piece[y][x] == GRID::WHITE ) {

					// カードがあれば、取れる。
					if ( !_gridList_Card[y][x].isEmpty() ) {

						Move move;
						move.turn   = _currentTurn;
						move.action = MOVE::ACTION::TAKE_CARD;
						move.takeCardX = x;
						move.takeCardY = y;

						result.push_back( move );
					}
				}
			}
		}
	}
}

//==========================================================
// 王手になる手だけを取得（現状、王手になってない前提）
// 手番は、現在の手番を使う。
// 王手した結果、相手から反撃されて負ける手までは考慮していない。
//==========================================================
void InnerExpression::GetCheckMoveList ( InnerExpression *currentState, vector<Move> &result ) {

	///// 使いまわせる値を求めておく
	vector < pair<int, int> > piecePositionListMy;
	vector < pair<int, int> > piecePositionListOpponent;

	if ( currentState->_currentTurn == TURN::BLACK ) {
		GetPiecePositionList ( currentState, piecePositionListMy, piecePositionListOpponent );
	}
	else if ( currentState->_currentTurn == TURN::WHITE ) {
		GetPiecePositionList ( currentState, piecePositionListOpponent, piecePositionListMy );
	}

	GetCheckMoveList_PutCard           ( currentState, result, piecePositionListMy, piecePositionListOpponent );
	GetCheckMoveList_MovePiece         ( currentState, result, piecePositionListMy, piecePositionListOpponent );
	GetCheckMoveList_MovePiece_Collide ( currentState, result, piecePositionListMy, piecePositionListOpponent );
	GetCheckMoveList_PutPiece          ( currentState, result);

}
//==========================================================
// 王手になる手だけを取得
// カードを置く手
//==========================================================
void InnerExpression::GetCheckMoveList_PutCard ( InnerExpression *currentState, vector<Move> &result, vector < pair<int, int> > &piecePositionListMy, vector < pair<int, int> > &piecePositionListOpponent ) {

	//InnerExpression *currentState = currentState_Arg->GetCopy();

	///// 盤上に自駒が出てない場合は、なし
	if ( piecePositionListMy.size() == 0 ) {
		return;
	}

	int myHandCardIndex = 0;
	set<int> cardIdList;

	if ( currentState->_currentTurn == TURN::BLACK ) {
		myHandCardIndex = currentState->_handCards_BLACK_Index;
	}
	else if ( currentState->_currentTurn == TURN::WHITE ) {
		myHandCardIndex = currentState->_handCards_WHITE_Index;
	}

	///// 手札がなかったら、なし
	if ( myHandCardIndex == 0 ) {
		return;
	}


	///// カードIDリストを取得
	GetCardIdList( currentState, currentState->_currentTurn, cardIdList);

	///// パネルを置いてゴールできるかもしれない候補の列リストを取得
	vector< pair<vector< pair<int, int>>, int>> courseList;
	GetGoalCourseListWithPanel ( currentState, courseList, piecePositionListMy, piecePositionListOpponent );


	///// コースでループ
	for ( unsigned int i = 0; i < courseList.size(); ++i ) {

		pair<vector< pair<int, int> >, int> &course = courseList[i];

		// カードでループ
		int count = 0;
		for ( set<int>::iterator it = cardIdList.begin(); it != cardIdList.end(); ++it ) {

			// このカードで、このコースを埋める手を取得
			// result に追記していってもらう。
			GetCheckMoveList_PutCard_ToThisCourse ( currentState, course, *(it), result);

			++count;
		}

	}

	//delete currentState;
}

//==========================================================
// このカードでこのコースを埋める手を取得
//==========================================================
void InnerExpression::GetCheckMoveList_PutCard_ToThisCourse ( InnerExpression *currentState, pair<vector<pair<int, int>>, int> &course, int cardId, vector<Move> &result ) {

	/*
		コースはコースとして成立している前提。
		リストにある座標は全て空きマス。
		空きマスがある以外は、壁なし。

	*/
	Card card = AI::GetCardInfo( cardId );

	// このカードで最大、何マス埋めることができるか？
	int maxFillGridNum = card.gridAffectionList.size() + 1;

	// 何マス埋めなければならないか？
	int emptyGridNum = course.first.size();

	// 埋められるわけがない？
	if ( maxFillGridNum < emptyGridNum ) {
		return;
	}

	// 矢印を気にしなくてもいい位置（ゴール）
	int goalY = 0;
	if ( currentState->_currentTurn == TURN::BLACK ) {
		goalY = 0;
	} else if ( currentState->_currentTurn == TURN::WHITE ) {
		goalY = currentState->_boardSizeY - 1;
	}

	///// カードの向きリスト
	vector<int> cardDirectionList;
	if ( card.gridAffectionList.size() == 0 ) {
		cardDirectionList.push_back ( DIRECTION::UP );
	} else {
		cardDirectionList.push_back ( DIRECTION::UP    );
		cardDirectionList.push_back ( DIRECTION::LEFT  );
		cardDirectionList.push_back ( DIRECTION::RIGHT );
		cardDirectionList.push_back ( DIRECTION::DOWN  );
	}


	///// カードを置く向きでループ
	for ( int i = 0; i < cardDirectionList.size(); ++i ) {

		///// カードを置く位置でループ
		for ( int y = 0; y < currentState->_boardSizeY; ++y ) { for ( int x = 0; x < currentState->_boardSizeX; ++x ) {

			// 柱の空きマスが１つでも残るなら、ダメ
			bool isAllEmptyFull = true;
			
			for ( int n = 0; n < course.first.size(); ++n ) {

				int emptyX = course.first[n].first;
				int emptyY = course.first[n].second;

				// カードの位置？
				if ( emptyX == x && emptyY == y) {
					continue;
				}

				// 効果範囲でループ
				bool isFulFilledByEffect = false;
				for ( unsigned int e = 0; e < card.gridAffectionList.size(); ++e ) {

					int affectX         = x + card.gridAffectionList[e].TurnedX(cardDirectionList[i]);
					int affectY         = y + card.gridAffectionList[e].TurnedY(cardDirectionList[i]);
					int affectDirection = card.gridAffectionList[e].TurnedIndecrion(cardDirectionList[i]);

					// 空きマスが埋まる
					if ( affectX == emptyX && affectY == emptyY ) {

						// 矢印、大丈夫？（最後のマス（ゴール）以外では、矢印を気にする）
						if ( emptyY != goalY && affectDirection != DIRECTION::NONE && affectDirection != course.second) {
							break;
						} else {
							isFulFilledByEffect = true;
							break;
						}
					}
				}

				// どの効果範囲でも満たされない空きマスがあった。ダメ。
				if ( !isFulFilledByEffect ) {
					isAllEmptyFull = false;
					break;
				}
			}

			// 柱の空きマスが全部埋まる
			if ( isAllEmptyFull ) {

				// 盤面的な意味で、そこにカードを置ける？
				bool isPutOk = false;
				
				if ( currentState->_gridList_ThrouableInfo[y][x] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {

					isPutOk = true;

					for ( unsigned int e = 0; e < card.gridAffectionList.size(); ++e ) {

						int affectX = x + card.gridAffectionList[e].TurnedX(cardDirectionList[i]);
						int affectY = y + card.gridAffectionList[e].TurnedY(cardDirectionList[i]);

						// 効果範囲が盤からハミ出るのは、よい。
						if ( !currentState->IsWithinBoardLimit( affectX, affectY )) {

							// よい

						} else {

							if ( currentState->_gridList_ThrouableInfo[affectY][affectX] != THROUGHABLE_INFO::NOT_THROUGHABLE ) {
								isPutOk = false;
								break;
							}
						}
					}
				}
				// 置ける
				if (isPutOk) {

					Move move;
					move.action = MOVE::ACTION::PUT_CARD;
					move.putCardX = x;
					move.putCardY = y;
					move.putCardId = cardId;
					move.putCardDirection = cardDirectionList[i];

					result.push_back( move );
				}
			}

		}}

	}

}


//==========================================================
// カードIDリストを取得
//==========================================================
void InnerExpression::GetCardIdList( InnerExpression *currentState, int turn, set<int> &result ) {

	int handCardIndex     = 0;

	if ( turn == TURN::BLACK ) {

		handCardIndex   = currentState->_handCards_BLACK_Index;

		set<int>::iterator it;
		for ( int i = 0; i < handCardIndex; ++i ) {

			int id = currentState->_handCards_BLACK[i];

			it = result.find(id);
			if ( it == result.end() ) {
				result.insert(id);
			}
		}
	}
	else if ( turn == TURN::WHITE ) {

		handCardIndex   = currentState->_handCards_WHITE_Index;

		set<int>::iterator it;
		for ( int i = 0; i < handCardIndex; ++i ) {

			int id = currentState->_handCards_WHITE[i];

			it = result.find(id);
			if ( it == result.end() ) {
				result.insert(id);
			}
		}
	}

}


//==========================================================
// パネルを置いてゴールできるかもしれない列のリストを取得
//==========================================================
void InnerExpression::GetGoalCourseListWithPanel ( InnerExpression *currentState, vector< pair<vector< pair<int, int>>, int> > &result, vector < pair<int, int> > &piecePositionListMy, vector < pair<int, int> > &piecePositionListOpponent ) {

	/*
		列の根本には自駒がある、ということ。
		列の末尾はゴールになる。

		実際にデータとして入れるのは、空きマスの位置だけ、とする。

		それだけだと方向がわからないので、あってもいい矢印もつけておく。
		pair
		<
			vector<pair<int,int>>.
			あってもいい矢印：カードの方向なので、DIRECTION を入れる。THROUGHABLE_INFO ではなく。なしなら　NONE
		>
	*/

	
	///// 手番で入れ替わる値群
	//
	int goalY = 0;
	vector<pair<int, int>> direcitonList;

	///// 手番でデータを振り分ける
	if ( currentState->_currentTurn == TURN::BLACK ) {

		goalY = 0;

		direcitonList.push_back( pair<int, int>(-1, -1) ); // 左上へ
		direcitonList.push_back( pair<int, int>( 0, -1) ); // 真上へ
		direcitonList.push_back( pair<int, int>( 1, -1) ); // 右上へ

	} else if ( currentState->_currentTurn == TURN::WHITE ) {

		goalY = currentState->_boardSizeY - 1;

		direcitonList.push_back( pair<int, int>(-1, 1) ); // 左下へ
		direcitonList.push_back( pair<int, int>( 0, 1) ); // 真下へ
		direcitonList.push_back( pair<int, int>( 1, 1) ); // 右下へ
	}


	///// 自駒でループ
	for ( unsigned int i = 0; i < piecePositionListMy.size(); ++i ) {

		int pieceX = piecePositionListMy[i].first;
		int pieceY = piecePositionListMy[i].second;

		///// ゴールに向かって３方向
		for ( unsigned int n = 0; n < direcitonList.size(); ++n ) {

			vector<pair<int, int>> course;
			bool isCouseOk = false;

			int searchX = pieceX;
			int searchY = pieceY;

			do {

				// 現地
				int panel = currentState->_gridList_ThrouableInfo[searchY][searchX];

				// 空きマスならばコースに入れる。
				if ( panel == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
					course.push_back( pair<int, int>( searchX, searchY) );
				}

				// 無印パネルでも空きマスでもない：次に進めるかどうか、という観点
				if ( panel != THROUGHABLE_INFO::THROUGHABLE && panel != THROUGHABLE_INFO::NOT_THROUGHABLE ) {

					// 直線コース？
					if ( direcitonList[n].first == 0 ) {

						// 上向きコース？
						if ( direcitonList[n].second == -1 ) {

							// 上向き矢印じゃないならダメ
							if ( panel != THROUGHABLE_INFO::MUST_TO_UP) {
								break;
							}
						}
						// 下向きコース？
						else if ( direcitonList[n].second == 1 ) {

							// 下向き矢印じゃないならダメ
							if ( panel != THROUGHABLE_INFO::MUST_TO_DOWN) {
								break;
							}
						}
					// 斜めコース
					} else { break; }
				}

				// 次に進んでみる
				int nextX = searchX + direcitonList[n].first;
				int nextY = searchY + direcitonList[n].second;

				// 盤からハミ出る
				if ( !currentState->IsWithinBoardLimit(nextX, nextY) ) {
					break;
				}

				// 他の駒があったらダメ
				if ( currentState->_gridList_Piece[nextY][nextX] != GRID::ENPTY) {
					break;
				}


				// 進む
				searchX = nextX;
				searchY = nextY;

				// ゴールしていたら終了
				if ( searchY == goalY ) {

					// ゴール位置はコースに入れる。空きマスならば
					if ( currentState->_gridList_ThrouableInfo[nextY][nextX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
						course.push_back( pair<int, int>( nextX, nextY) );
					}
					isCouseOk = true;
					break;

				// まだゴールしてない
				} else {
					// うんうん。
				}

			} while (true);

			///// コースを辿り終えました。コースとして成立してましたか？
			if (isCouseOk) {

				// 直線コース？
				if ( direcitonList[n].first == 0 ) {

					// 上向きコース？
					if ( direcitonList[n].second == -1 ) {
						result.push_back ( pair<vector<pair<int,int>>, int>(course, DIRECTION::UP) );
					}
					// 下向きコース？
					else if ( direcitonList[n].second == 1 ) {
						result.push_back ( pair<vector<pair<int,int>>, int>(course, DIRECTION::DOWN) );
					}
				// 斜めコース
				} else { 
					result.push_back ( pair<vector<pair<int,int>>, int>(course, DIRECTION::NONE) );
				}
			}

		}
	}


}

//==========================================================
// 王手になる手だけを取得
// 駒を置く手
//==========================================================
void InnerExpression::GetCheckMoveList_PutPiece ( InnerExpression *currentState, vector<Move> &result) {

	///// 手駒を持っていない場合は、なし
	if      ( currentState->_currentTurn == TURN::BLACK ) { if ( currentState->_handPiece_BLACK == 0 ) { return; }}
	else if ( currentState->_currentTurn == TURN::WHITE ) { if ( currentState->_handPiece_WHITE == 0 ) { return; }}


	// 縦移動の際、通行可能な矢印
	int throuableVerticalArrow = 0;

	// 縦移動情報
	int verticalY_Start = 0; // 駒を置く高さでもある
	int verticalY_End   = 0;
	int verticalDirection = 0;

	// 斜め移動がありえるか？：盤の縦幅の方が小さいなら、ありえる。
	bool isDiagonalOk = ( currentState->_boardSizeX >= currentState->_boardSizeY );

	// ／での駒設置王手情報
	int slashRightUp_StartX, slashRightUp_StartY;
	int slashRightUp_EndX, slashRightUp_EndY;
	int slashRightUp_DirectionX;
	int slashRightUp_DirectionY;

	// ＼の駒設置王手情報
	int slashLeftUp_StartX, slashLeftUp_StartY;
	int slashLeftUp_EndX, slashLeftUp_EndY;
	int slashLeftUp_DirectionX;
	int slashLeftUp_DirectionY;

	///// 黒番
	if        ( currentState->_currentTurn == TURN::BLACK ) {

		throuableVerticalArrow = THROUGHABLE_INFO::MUST_TO_UP;
		verticalY_Start = currentState->_boardSizeY - 1;
		verticalY_End   = 0;
		verticalDirection = Utils_Cal::Sign ( verticalY_End - verticalY_Start );

		// ／での駒設置王手情報
		if (isDiagonalOk) {
			slashRightUp_StartX    = currentState->_boardSizeX - currentState->_boardSizeY;
			slashRightUp_StartY    = currentState->_boardSizeY - 1;
			slashRightUp_EndX      = currentState->_boardSizeX - 1;
			slashRightUp_EndY      = 0;
			slashRightUp_DirectionX = 1;
			slashRightUp_DirectionY = -1;
		}
		// ＼での駒設置王手情報
		if (isDiagonalOk) {
			slashLeftUp_StartX    = currentState->_boardSizeY - 1;
			slashLeftUp_StartY    = currentState->_boardSizeY - 1;
			slashLeftUp_EndX      = 0;
			slashLeftUp_EndY      = 0;
			slashLeftUp_DirectionX = -1;
			slashLeftUp_DirectionY = -1;
		}

	///// 白番
	} else if ( currentState->_currentTurn == TURN::WHITE) {

		throuableVerticalArrow = THROUGHABLE_INFO::MUST_TO_DOWN;
		verticalY_Start = 0;
		verticalY_End   = currentState->_boardSizeY - 1;
		verticalDirection = Utils_Cal::Sign ( verticalY_End - verticalY_Start );

		// ／での駒設置王手情報
		if (isDiagonalOk) {
			slashRightUp_StartX    = currentState->_boardSizeX - 1;
			slashRightUp_StartY    = 0;
			slashRightUp_EndX      = currentState->_boardSizeX - currentState->_boardSizeY;
			slashRightUp_EndY      = currentState->_boardSizeY - 1;
			slashRightUp_DirectionX = -1;
			slashRightUp_DirectionY = 1;
		}
		// ＼での駒設置王手情報
		if (isDiagonalOk) {
			slashLeftUp_StartX    = 0;
			slashLeftUp_StartY    = 0;
			slashLeftUp_EndX      = currentState->_boardSizeY - 1;
			slashLeftUp_EndY      = currentState->_boardSizeY - 1;
			slashLeftUp_DirectionX = 1;
			slashLeftUp_DirectionY = 1;
		}
	}


	///// 縦移動
	for ( int x = 0; x < currentState->_boardSizeX; ++x ) {

		bool isOk = false;

		int y = verticalY_Start;
		do {

			int grid  = currentState->_gridList_ThrouableInfo[y][x];
			int piece = currentState->_gridList_Piece[y][x];

			// 途中に他の駒があったらダメ
			if ( piece != GRID::ENPTY ) {
				break;
			}
			// 途中に空きマスがあったらダメ
			if ( grid == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				break;
			}

			// 最後のマス目です。（相手陣地）
			if ( y == verticalY_End ) { 
			
				// ここまで来ているということは、ここも駒がなく、空きマスでもない。
				// 最後のマス目だけは、通れない矢印でもよい。
				
				isOk = true;
				break; 

			// 最後のマス目ではない
			} else {

				// 通れない矢印だったらダメ
				if ( grid != THROUGHABLE_INFO::THROUGHABLE && grid != throuableVerticalArrow ) {
					break;
				}
			}

			y += verticalDirection;

		} while (true);

		// 縦移動を見越して、駒を置く手が王手になる。
		if (isOk) {
			Move move;
			move.action = MOVE::ACTION::PUT_PIECE;
			move.putPieceX = x;
			move.putPieceY = verticalY_Start;
			move.turn      = currentState->_currentTurn;

			result.push_back( move );
		}
	}

	///// 斜め／
	if ( isDiagonalOk ) {

		bool isOk = false;

		int x = slashRightUp_StartX;
		int y = slashRightUp_StartY;
		do {

			int grid  = currentState->_gridList_ThrouableInfo[y][x];
			int piece = currentState->_gridList_Piece[y][x];

			// 途中に他の駒があったらダメ
			if ( piece != GRID::ENPTY ) {
				break;
			}
			// 途中に空きマスがあったらダメ
			if ( grid == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				break;
			}

			// 最後のマス目です。（相手陣地）
			if ( y == slashRightUp_EndY ) { 
			
				// ここまで来ているということは、ここも駒がなく、空きマスでもない。
				// 最後のマス目だけは、通れない矢印でもよい。
				
				isOk = true;
				break; 

			// 最後のマス目ではない
			} else {

				// 通れない矢印だったらダメ
				if ( grid != THROUGHABLE_INFO::THROUGHABLE ) {
					break;
				}
			}

			y += slashRightUp_DirectionY;
			x += slashRightUp_DirectionX;

		} while (true);

		// 駒を置く手が王手になる。
		if (isOk) {
			Move move;
			move.action = MOVE::ACTION::PUT_PIECE;
			move.putPieceX = slashRightUp_StartX;
			move.putPieceY = slashRightUp_StartY;
			move.turn      = currentState->_currentTurn;

			result.push_back( move );
		}

	}
	///// 斜め＼
	if ( isDiagonalOk ) {

		bool isOk = false;

		int x = slashLeftUp_StartX;
		int y = slashLeftUp_StartY;
		do {

			int grid  = currentState->_gridList_ThrouableInfo[y][x];
			int piece = currentState->_gridList_Piece[y][x];

			// 途中に他の駒があったらダメ
			if ( piece != GRID::ENPTY ) {
				break;
			}
			// 途中に空きマスがあったらダメ
			if ( grid == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
				break;
			}

			// 最後のマス目です。（相手陣地）
			if ( y == slashLeftUp_EndY ) { 
			
				// ここまで来ているということは、ここも駒がなく、空きマスでもない。
				// 最後のマス目だけは、通れない矢印でもよい。
				
				isOk = true;
				break; 

			// 最後のマス目ではない
			} else {

				// 通れない矢印だったらダメ
				if ( grid != THROUGHABLE_INFO::THROUGHABLE ) {
					break;
				}
			}

			y += slashLeftUp_DirectionY;
			x += slashLeftUp_DirectionX;

		} while (true);

		// 駒を置く手が王手になる。
		if (isOk) {
			Move move;
			move.action = MOVE::ACTION::PUT_PIECE;
			move.putPieceX = slashLeftUp_StartX;
			move.putPieceY = slashLeftUp_StartY;
			move.turn      = currentState->_currentTurn;

			result.push_back( move );
		}

	}

}
//==========================================================
// 王手になる手だけを取得
// 駒を動かす手。ぶつけない。
//==========================================================
void InnerExpression::GetCheckMoveList_MovePiece ( InnerExpression *currentState, vector<Move> &result, vector<pair<int, int>>  &piecePositionListMy, vector<pair<int, int>>  &piecePositionListOpponent ) {

	///// 手番で入れ替わる値群
	//
	int goalY = 0;

	///// 手番でデータを振り分ける
	if ( currentState->_currentTurn == TURN::BLACK ) {

		goalY = 0;

	} else if ( currentState->_currentTurn == TURN::WHITE ) {

		goalY = currentState->_boardSizeY - 1;
	}

	///// 盤面に駒が出ていない場合は、なし
	if ( piecePositionListMy.size() == 0) { return; }


	///// 相手陣から伸びている経路リストを求める
	vector<vector<pair<int, int>>> courseList;
	GetToGoalCourseList ( currentState, courseList);


	///// 自駒を、そのコース上のマス目に移動させることができるか？
	for ( int i = 0; i < piecePositionListMy.size(); ++i ) {

		int pieceX = piecePositionListMy[i].first;
		int pieceY = piecePositionListMy[i].second;

		///// コースでループ
		for ( unsigned int n = 0; n < courseList.size(); ++n ) {

			///// コース内のマス目でループ
			for ( unsigned int g = 0; g < courseList[n].size(); ++g ) {

				int gridX = courseList[n][g].first;
				int gridY = courseList[n][g].second;

				// そこへ行ける？
				if (IsMovable ( currentState, pieceX, pieceY, gridX, gridY )) {

					// 王手になる手としてカウントする
					Move move;
					move.action = MOVE::ACTION::MOVE_PIECE;
					move.movePieceAndIsCllide = false;
					move.movePieceFromX = pieceX;
					move.movePieceFromY = pieceY;
					move.movePieceToX = gridX;
					move.movePieceToY = gridY;

					result.push_back ( move );
				}
			}
		}
	}
}

//==========================================================
// 指定位置に駒があるとして、指定位置に移動させることができるか？
//==========================================================
bool InnerExpression::IsMovable ( InnerExpression *currentState, int pieceX, int pieceY, int toX, int toY ) {
	
	pair<int, int> p;
	p.first  = -1;
	p.second = -1;
	return IsMovable(currentState, pieceX, pieceY, toX, toY, p);
}
///// 無視する位置を指定
bool InnerExpression::IsMovable ( InnerExpression *currentState, int pieceX, int pieceY, int toX, int toY, pair<int, int> &ignoredPiecePosition ) {

	bool result = false;

	/*
		指定開始位置には駒があるもの、と仮定する。

		両位置とも、盤の範囲内であると仮定する。
		両位置が異なっているものと仮定する。
	*/

	///// 角度によって切り替わる値群
	int directionX = 0;
	int directionY = 0;
	int throuableArrow = THROUGHABLE_INFO::THROUGHABLE;

	///// 縦？
	if ( pieceX == toX ) {

		// 上へ
		if ( pieceY > toY ) {
			directionX = 0;
			directionY = -1;
			throuableArrow = THROUGHABLE_INFO::MUST_TO_UP;
		// 下へ
		} else {
			directionX = 0;
			directionY = 1;
			throuableArrow = THROUGHABLE_INFO::MUST_TO_DOWN;
		}

	///// 横？
	} else if ( pieceY == toY ) {

		// 右へ
		if ( pieceX < toX ) {
			directionX = 1;
			directionY = 0;
			throuableArrow = THROUGHABLE_INFO::MUST_TO_RIGHT;
		// 左へ
		} else {
			directionX = -1;
			directionY = 0;
			throuableArrow = THROUGHABLE_INFO::MUST_TO_LEFT;
		}

	///// 斜め／？
	} else if ( (toX - pieceX) == (pieceY - toY ) ) {

		// 右上へ
		if ( pieceY > toY ) {
			directionX = 1;
			directionY = -1;
			throuableArrow = -1; // 無効、と言いたい。
		// 左下へ
		} else {
			directionX = -1;
			directionY = 1;
			throuableArrow = -1; // 無効、と言いたい。
		}


	///// 斜め＼？
	} else if ( (toX - pieceX) == (toY - pieceY ) ) {

		// 左上へ
		if ( pieceY > toY ) {
			directionX = -1;
			directionY = -1;
			throuableArrow = -1; // 無効、と言いたい。
		// 右下へ
		} else {
			directionX = 1;
			directionY = 1;
			throuableArrow = -1; // 無効、と言いたい。
		}

	///// それ以外。角度的に移動不可
	} else {
		result = false;
		return result;
	}

	///// 辿る。
	int searchX = pieceX;
	int searchY = pieceY;

	result = false;
	do {

		// 足元のパネル
		int grid = currentState->_gridList_ThrouableInfo[searchY][searchX];
		
		// 動けないパネル？  ：　駒を動かす、だから、移動前に、足元のパネルを見る
		if ( grid != THROUGHABLE_INFO::THROUGHABLE && grid != throuableArrow ) {
			break;
		}

		// 移動先
		int nextX = searchX + directionX;
		int nextY = searchY + directionY;

		// 移動先に他の駒がある
		if ( currentState->_gridList_Piece[nextY][nextX] != GRID::ENPTY ) {

			// 無視してもいい場所でもない
			if ( ignoredPiecePosition.first != nextX || ignoredPiecePosition.second != nextY ) {
				break;
			}
		}

		// 移動先が空きマス
		if ( currentState->_gridList_ThrouableInfo[nextY][nextX] == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
			break;
		}

		// 移動先が目的地
		if ( nextX == toX && nextY == toY ) {
			result = true;
			break;
		}

		// 移動
		searchX = nextX;
		searchY = nextY;

	} while (true);


	return result;
}


//==========================================================
// 相手陣地に一手で行けるコースを求める
//==========================================================
void InnerExpression::GetToGoalCourseList ( InnerExpression *currentState, vector<vector<pair<int, int>>> &result) {


	///// 手番で入れ替わる値群
	int goalY = 0;
	vector<pair<int, int>> courseDirectionList;  // ３通り。黒なら、真下、左下、右下
	int throuableArrow;                          // 直線経路の場合、通れる矢印。黒なら UP


	///// 手番でデータを振り分ける
	if ( currentState->_currentTurn == TURN::BLACK ) {

		goalY = 0;

		courseDirectionList.push_back( pair<int, int>( -1, 1 ) ); // 相手陣から左下へ
		courseDirectionList.push_back( pair<int, int>(  0, 1 ) ); // 相手陣から真下へ
		courseDirectionList.push_back( pair<int, int>(  1, 1 ) ); // 相手陣から右下へ
		throuableArrow = THROUGHABLE_INFO::MUST_TO_UP;

	} else if ( currentState->_currentTurn == TURN::WHITE ) {

		goalY = currentState->_boardSizeY - 1;

		courseDirectionList.push_back( pair<int, int>( -1, -1 ) ); // 相手陣から左上へ
		courseDirectionList.push_back( pair<int, int>(  0, -1 ) ); // 相手陣から真上へ
		courseDirectionList.push_back( pair<int, int>(  1, -1 ) ); // 相手陣から右上へ
		throuableArrow = THROUGHABLE_INFO::MUST_TO_DOWN;
	}


	///// 相手陣から伸びている経路リストを求める
	for ( int x = 0; x < currentState->_boardSizeX; ++x ) {

		// 入り口（相手陣）
		int grid = currentState->_gridList_ThrouableInfo[ goalY ][ x ];

		// 入り口が空きマスなら辿らない
		if ( grid == THROUGHABLE_INFO::NOT_THROUGHABLE ) { continue; }

		// 入り口に他の駒があったら辿らない
		if ( currentState->_gridList_Piece[ goalY ][ x ] != GRID::ENPTY ) { continue; }

		///// 入り口（相手陣）が空いている箇所だけ、探索。
		///// 入り口から、何かにぶつかるまで辿る
		for ( unsigned int n = 0; n < courseDirectionList.size(); ++n ) {

			vector < pair<int, int> > course; // 相手陣そのものは経路として入れなくていい。

			int searchX = x;
			int searchY = goalY;

			do {
				searchX += courseDirectionList[n].first;
				searchY += courseDirectionList[n].second;

				// 盤からハミ出たら終了。
				if (!currentState->IsWithinBoardLimit( searchX, searchY ) ) {
					break;
				}

				// 他の駒にぶつかったら終了
				if ( currentState->_gridList_Piece [ searchY ][ searchX ] != GRID::ENPTY ) {
					break;
				}

				grid = currentState->_gridList_ThrouableInfo[ searchY ][ searchX ];

				// 通行不可だったら終了
				if ( grid == THROUGHABLE_INFO::NOT_THROUGHABLE ) {
					break;
				}

				// 無印パネルじゃない
				if ( grid != THROUGHABLE_INFO::THROUGHABLE ) {

					// 直線コース？
					if ( courseDirectionList[n].first == 0 ) {

						// 通れる矢印でもないなら、終了
						if ( grid != throuableArrow ) {	break;}

					// 斜めコースなら、終了
					} else {break;}
				}

				// ここまで来たなら、経路に入れる。
				course.insert ( course.begin(), pair<int, int>(searchX, searchY) );
				//course.push_back ( pair<int, int>(searchX, searchY) );

			} while (true);
		
			// 経路として記録。
			if ( course.size() > 0 ) {
				result.push_back(course);
			}

		} ///// 入り口から、何かにぶつかるまで辿る、閉じ

	}

}

//==========================================================
// 盤面上に出ている駒の位置リストを求める
//==========================================================
void InnerExpression::GetPiecePositionList ( InnerExpression *currentState, vector<pair<int, int>> &resultBlack, vector<pair<int, int>> &resultWhite) {

	for ( int y = 0; y < currentState->_boardSizeY; ++y ) {
		for ( int x = 0; x < currentState->_boardSizeX; ++x ) {

			// 黒駒があった
			if ( currentState->_gridList_Piece[y][x] == GRID::BLACK) {

				resultBlack.push_back ( pair<int, int>(x, y) );

			// 白駒があった
			} else if ( currentState->_gridList_Piece[y][x] == GRID::WHITE) {

				resultWhite.push_back ( pair<int, int>(x, y) );
			}
		}
	}




}


//==========================================================
// 王手になる手だけを取得
// 駒をぶつける手
//==========================================================
void InnerExpression::GetCheckMoveList_MovePiece_Collide ( InnerExpression *currentState, vector<Move> &result, vector < pair<int, int> > &piecePositionListMy, vector < pair<int, int> > &piecePositionListOpponent ) {

	///// どちらか片方でも、駒が盤上になければ、なし
	if ( piecePositionListMy.size() == 0 || piecePositionListOpponent.size() == 0 ) {
		return;
	}

	///// 手番で切り替わる値
	int goalY = 0;
	int opponentColor = 0;

	if ( currentState->_currentTurn == TURN::BLACK ) {

		goalY = 0;
		opponentColor = GRID::WHITE;

	} else if ( currentState->_currentTurn == TURN::WHITE ) {

		goalY = currentState->_boardSizeY - 1;
		opponentColor = GRID::BLACK;
	}


	///// ぶつける手があるか？
	for (int i = 0; i < piecePositionListOpponent.size(); ++i ) {

		int pieceOpponentX = piecePositionListOpponent[i].first;
		int pieceOpponentY = piecePositionListOpponent[i].second;

		for (int n = 0; n < piecePositionListMy.size(); ++n ) {
	
			int pieceMyX = piecePositionListMy[n].first;
			int pieceMyY = piecePositionListMy[n].second;

			///// ぶつけることができる？
			int moveToCollideX, moveToCollideY;
			if ( IsCollidable ( currentState, pieceMyX, pieceMyY, pieceOpponentX, pieceOpponentY, moveToCollideX, moveToCollideY ) ) {


				/*
					ぶつけるのに使った自駒の位置は、元の位置のままにしておいても結果は同じ。
					どうせ同じ方向に動くから。
				*/


				// 一時的に、ぶつけた駒を盤上から取り除く
				//currentState->_gridList_Piece[pieceOpponentY][pieceOpponentX] = GRID::ENPTY;
				// これをしてしまうと、スレッドセーフじゃなくなるので、
				// 特定の位置の駒を、ぶつけられたことにして無視してもらう
				pair<int, int> ignoredPiecePosition ( pieceOpponentX, pieceOpponentY );

				// 再び自駒でループ
				for (int g = 0; g < piecePositionListMy.size(); ++g ) {
	
					int pX = piecePositionListMy[g].first;
					int pY = piecePositionListMy[g].second;

					// ぶつけた駒があった場所を通って、ゴールできる？
					if (ToGoalThroughThere(currentState, pX, pY, pieceOpponentX, pieceOpponentY, ignoredPiecePosition) ) {

						Move move;
						move.action = MOVE::ACTION::MOVE_PIECE;
						move.movePieceAndIsCllide = true;
						move.movePieceFromX = pieceMyX;
						move.movePieceFromY = pieceMyY;
						move.movePieceToX   = moveToCollideX;
						move.movePieceToY   = moveToCollideY;

						result.push_back ( move );

						// ぶつけたことでゴールできるようになる駒が１つでもあれば、それでいい。
						break;
					}
				}

				// ぶつけた駒を戻す
				//currentState->_gridList_Piece[pieceOpponentY][pieceOpponentX] = opponentColor;
			}
		}
	}

}

//==========================================================
// 特定の場所を通ってゴールにたどり着けるか？
//==========================================================
bool InnerExpression::ToGoalThroughThere ( InnerExpression *currentState, int pieceX, int pieceY, int checkPointX, int checkPointY, pair<int, int> &ignoredPiecePosition ) {

	bool result = false;

	int verticalDirection = 0;
	int goalX, goalY;

	if ( currentState->_currentTurn == TURN::BLACK ) {
		verticalDirection = -1;
		goalY = 0;
	}
	else if ( currentState->_currentTurn == TURN::WHITE ) {
		verticalDirection = 1;
		goalY = currentState->_boardSizeY - 1;
	}

	///// 縦の位置関係でふるいにかける
	if ( Utils_Cal::Sign ( checkPointY - pieceY ) != verticalDirection ) {
		return false;
	}


	///// 縦
	if ( pieceX == checkPointX ) {

		goalX = pieceX;
	}
	///// 斜め
	else {

		goalX = pieceX +  (Utils_Cal::Abs( goalY - pieceY ) * Utils_Cal::Sign( checkPointX - pieceX ));

	}

	///// ゴールの位置が、盤の範囲内？
	if ( currentState->IsWithinBoardLimit ( goalX, goalY  ) ) {

		///// ゴールにたどり着ける？
		if ( IsMovable ( currentState, pieceX, pieceY, goalX, goalY, ignoredPiecePosition ) ) {
			result = true;
		}

	}

	return result;
}

//==========================================================
// ぶつけることができるか？
//==========================================================
bool InnerExpression::IsCollidable ( InnerExpression *currentState, int pieceX, int pieceY, int toX, int toY, int &moveToCollideX, int &moveToCollideY ) {

	bool result = false;

	/*
		指定の両位置にはぶつける対象となる駒があるとする。
		ぶつけることができなかった場合、moveToCollideX, moveToCollideY の値がどうなるかは保証しない。
	*/

	///// 位置関係的にぶつけることができるとして、移動先
	moveToCollideX = 0;
	moveToCollideY = 0;
	bool isCollidableForPosition = false;

	///// 横向きに
	if ( pieceY == toY && Utils_Cal::Abs( pieceX - toX ) > 1) {

		moveToCollideX = toX + Utils_Cal::Sign( pieceX - toX );
		moveToCollideY = pieceY;
		isCollidableForPosition = true;
	}
	///// 縦向きに
	else if ( pieceX == toX && Utils_Cal::Abs( pieceY - toY ) > 1) {

		moveToCollideX = pieceX;
		moveToCollideY = toY + Utils_Cal::Sign( pieceY - toY );
		isCollidableForPosition = true;
	}
	///// 斜め向きに／
	else if ( (pieceX - toX) == -(pieceY - toY) && Utils_Cal::Abs( pieceY - toY ) > 1) {

		moveToCollideX = toX + Utils_Cal::Sign( pieceX - toX );
		moveToCollideY = toY + Utils_Cal::Sign( pieceY - toY );
		isCollidableForPosition = true;
	}
	///// 斜め向きに＼
	else if ( (pieceX - toX) == (pieceY - toY) && Utils_Cal::Abs( pieceY - toY ) > 1) {

		moveToCollideX = toX + Utils_Cal::Sign( pieceX - toX );
		moveToCollideY = toY + Utils_Cal::Sign( pieceY - toY );
		isCollidableForPosition = true;
	}


	///// 位置的にはぶつけることができる
	if ( isCollidableForPosition ) {

		// 移動可能か？
		if (IsMovable ( currentState, pieceX, pieceY, moveToCollideX, moveToCollideY )) {
			result = true;
		}
	}

	return result;
}
















//=========================================================
// コンソールに様子を表示：デバッグ用
//=========================================================
void InnerExpression::ShowToConsole() {

	printf("-----------------------------------------\n");
	for ( unsigned int y = 0; y < _boardSizeY; ++y ) {

		for ( unsigned int x = 0; x < _boardSizeX; ++x ) {

			printf( "%d", _gridList_Piece[y][x]);
		}
		printf("\n");
	}
	printf("-----------------------------------------\n");

}






