//=========================================================
//
// 局面、内部表現（解釈）
//
//=========================================================
#include "pch.h"

#include <stdio.h>
#include <stdlib.h>
//#include <set>
//#include <iterator>
#include "InnerInterPretation.h"
#include "Define.h"
#include "AI.h"
#include "Card.h"
#include "../Utils/Utils_Others.h"
#include "../Utils/Utils_Cal.h"
#include "../Utils/Allocator.h"

using namespace std;
using namespace AI_Modules;

#pragma warning(disable:4018)

//=========================================================
// static
//=========================================================
int InnerInterPretation::_numberOfInstances = 0;

int InnerInterPretation::_handCards_Init[100] = {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};

int InnerInterPretation::compare_int( const void *a, const void *b ) {
	return *(int*)a - *(int*)b;
}
int InnerInterPretation::compare_CardOnBoard( const void *a, const void *b ) {

	/*
		本当にあってます？？？
	*/
	CardOnBoard objA = *(CardOnBoard*)a;
	CardOnBoard objB = *(CardOnBoard*)b;

	return (objA.cardId - objB.cardId) + (objA.direction - objB.direction);

}

//=========================================================
// コンストラクタ
//=========================================================
InnerInterPretation::InnerInterPretation() {

	++_numberOfInstances;

	_isThrouableInfoLatest = false;
	_totalMoveCount        = 0;
	_isPassPreviousMove    = false;
	_isPassPass            = false;
	_currentTurn           = 0;
}

//=========================================================
// デストラクタ
//=========================================================
InnerInterPretation::~InnerInterPretation() {
	
	--_numberOfInstances;
}
//=========================================================
// 初期設定
//=========================================================
void InnerInterPretation::Init() {
	
	///// 真っ白にする
	_currentTurn = 0;
	//memcpy(_gridList_Piece,         _gridList_Init, sizeof(_gridList_Init));
	//memcpy(_gridList_ThrouableInfo, _gridList_Init, sizeof(_gridList_Init));
	//memcpy(_gridList_Card,          _gridList_Init_Card, sizeof(_gridList_Init_Card));
	_handPiece_BLACK = 0;
	_handPiece_WHITE = 0;
	memcpy(_handCards_BLACK, _handCards_Init, sizeof(_handCards_Init));
	memcpy(_handCards_WHITE, _handCards_Init, sizeof(_handCards_Init));
	_handCards_BLACK_Index = 0;
	_handCards_WHITE_Index = 0;

	_isThrouableInfoLatest = false;
	_totalMoveCount        = 0;
	_isPassPreviousMove    = false;
	_isPassPass            = false;

	///// 盤のサイズを合わせる
	//_boardSizeX = AI::_rule.borardWidth;
	//_boardSizeY = AI::_rule.borardHeight;
	_boardSizeX = 3;
	_boardSizeY = 3;


}
//=========================================================
// 初期設定：現在の手番をセット
//=========================================================
void InnerInterPretation::Init_SetCurrentTurn( int turn ) {
	_currentTurn = turn;
}
//=========================================================
// 初期設定：カードを置く
//=========================================================
void InnerInterPretation::Init_PutCard( int x, int y, int cardId, int direction ) {

	int index = _areaList[y][x].cardNumber;

	// CardOnBoardをインスタンス生成して上書きしなくていい？ 多分いいと思うのだけれどー。
	_areaList[y][x].cardList[ index ].cardId    = cardId;
	_areaList[y][x].cardList[ index ].direction = direction;

	_isThrouableInfoLatest = false;
}
//=========================================================
// 初期設定？：じゃない気がしますけども、カードを取り除く
//=========================================================
void InnerInterPretation::Init_RemoveCard( int x, int y, int cardId ) {

	int limit = _areaList[y][x].cardNumber;
	for ( int i = 0; i < limit; ++i) {
		
		// 指定の番号のカードがあった
		if ( _areaList[y][x].cardList[i].cardId == cardId ) {

			// 一つ分、間を詰めましょう
			if ( (i + 1) < limit ) {
				size_t size = sizeof(CardOnBoard) * (limit - i);
				memcpy ( &_areaList[y][x].cardList[i], &_areaList[y][x].cardList[i + 1], size);
			}
			--_areaList[y][x].cardNumber;

			break;
		}
	}
}
// &directionは、指定IDのカードがあった場合に、どの方向であったかを入れる戻り値用
void InnerInterPretation::Init_RemoveCard( int x, int y, int cardId, int &direction) {

	int limit = _areaList[y][x].cardNumber;
	for ( int i = 0; i < limit; ++i) {
		
		// 指定の番号のカードがあった
		if ( _areaList[y][x].cardList[i].cardId == cardId ) {

			// 戻り値。どの方向で設置されていたかを入れる。
			direction = _areaList[y][x].cardList[i].direction;

			// 一つ分、間を詰めましょう
			if ( (i + 1) < limit ) {
				size_t size = sizeof(CardOnBoard) * (limit - i);
				memcpy ( &_areaList[y][x].cardList[i], &_areaList[y][x].cardList[i + 1], size);
			}
			--_areaList[y][x].cardNumber;

			break;
		}
	}
}

//=========================================================
// 初期設定：駒を置く
//=========================================================
void InnerInterPretation::Init_PutPiece( int x, int y, int piece ) {

	if ( piece == GRID::BLACK ) {

		++_areaList[y][x].blackNumber;

	} else if ( piece == GRID::WHITE ) {

		++_areaList[y][x].whiteNumber;

	}

}
//=========================================================
// 初期設定：通行可能情報をセット
//=========================================================
void InnerInterPretation::Init_SetThrouableInfo( int x, int y, int throuableInfo ) {

	/*
		本当にこれでいい？
		これだと、単に各通行状態であるマス目の数を増やしているだけだけれども、
		もともとの処理
		_gridList_ThrouableInfo[y][x] = throuableInfo;
		は、通行可能状態の値を上書きする、というものなのですよね。
	*/

	if      ( throuableInfo == THROUGHABLE_INFO::THROUGHABLE     ) { ++_areaList[y][x].throuable_Number;       }
	else if ( throuableInfo == THROUGHABLE_INFO::MUST_TO_UP    ) { ++_areaList[y][x].throuable_UP_Number;    }
	else if ( throuableInfo == THROUGHABLE_INFO::MUST_TO_DOWN  ) { ++_areaList[y][x].throuable_DOWN_Number;  }
	else if ( throuableInfo == THROUGHABLE_INFO::MUST_TO_LEFT  ) { ++_areaList[y][x].throuable_LEFT_Number;  }
	else if ( throuableInfo == THROUGHABLE_INFO::MUST_TO_RIGHT ) { ++_areaList[y][x].throuable_RIGHT_Number; }

	
	// カードと通行可能情報の対応関係は保証できなくなりましたよ、と。
	_isThrouableInfoLatest = false;
}
//=========================================================
// 初期設定：駒台情報 黒
//=========================================================
void InnerInterPretation::Init_SetHandPiece_BLACK( int num ) {

	_handPiece_BLACK = num;
}
//=========================================================
// 初期設定：駒台情報 白
//=========================================================
void InnerInterPretation::Init_SetHandPiece_WHITE( int num ) {

	_handPiece_WHITE = num;
}
//=========================================================
// 初期設定：手札情報 黒
//=========================================================
void InnerInterPretation::Init_AddHandCard_BLACK( int cardId ) {

	//_handCards_BLACK.push_back( cardId );

	_handCards_BLACK[_handCards_BLACK_Index] = cardId;
	++_handCards_BLACK_Index;

}
//=========================================================
// 初期設定：手札情報 白
//=========================================================
void InnerInterPretation::Init_AddHandCard_WHITE( int cardId ) {

	//_handCards_WHITE.push_back( cardId );
	_handCards_WHITE[_handCards_WHITE_Index] = cardId;
	++_handCards_WHITE_Index;
}

//=========================================================
// 初期設定？ カードの効果を盤面に反映させる
//=========================================================
void InnerInterPretation::Init_ReflectCardAffection() {

	if ( _isThrouableInfoLatest ) {
		return;
	}

	for ( unsigned int y = 0; y < _boardSizeY; ++y ) {

		for ( unsigned int x = 0; x < _boardSizeX; ++x ) {

			// まずは初期化：カードの効果はエリアをまたがないことにするので、これでよい。
			_areaList[y][x].throuable_Number       = 0;
			_areaList[y][x].throuable_UP_Number    = 0;
			_areaList[y][x].throuable_DOWN_Number  = 0;
			_areaList[y][x].throuable_LEFT_Number  = 0;
			_areaList[y][x].throuable_RIGHT_Number = 0;

			int cardNumber = _areaList[y][x].cardNumber;
			for ( int i = 0; i < cardNumber; ++i ) {
	
				CardOnBoard cardOnBoard = _areaList[y][x].cardList[i];
				if (cardOnBoard.isEmpty()) {
					continue;
				}
				Card card = AI::GetCardInfo( cardOnBoard.cardId );

				// カードがあるその位置は、通行可能。
				++_areaList[y][x].throuable_Number;

				/*
					カードの範囲は エリアをまたがずに、
					このエリア内で完結することとする。
				*/

				for ( unsigned int i = 0; i < card.gridAffectionList.size(); ++i) {

					int affectDirection = card.gridAffectionList[i].TurnedIndecrion( cardOnBoard.direction );

					if      ( affectDirection == DIRECTION::UP    ) { ++_areaList[y][x].throuable_UP_Number;    }
					else if ( affectDirection == DIRECTION::LEFT  ) { ++_areaList[y][x].throuable_LEFT_Number;  }
					else if ( affectDirection == DIRECTION::RIGHT ) { ++_areaList[y][x].throuable_RIGHT_Number; }
					else if ( affectDirection == DIRECTION::DOWN  ) { ++_areaList[y][x].throuable_DOWN_Number;  }
					else    { ++_areaList[y][x].throuable_Number;  }

				}
			}
		}
	}

	// 最新ですよ。
	_isThrouableInfoLatest = true;
}

//=========================================================
// 次の局面を取得
//【引数】こう指すと
//【戻値】こうなる
//=========================================================
InnerInterPretation* InnerInterPretation::GetNext( Move move ) {

	InnerInterPretation *result = NULL;

	// コピーを取得して、コピーに対して手を指す
	result = GetCopy();
	result->GoNext( move );

	return result;

}
InnerInterPretation* InnerInterPretation::GetNext( Move move, Allocator<InnerInterPretation> *allocator ) {

	InnerInterPretation *result = NULL;

	// コピーを取得して、コピーに対して手を指す
	result = GetCopy(allocator);
	result->GoNext( move );

	return result;

}

//=========================================================
// コピーを取得
//=========================================================
InnerInterPretation* InnerInterPretation::GetCopy(Allocator<InnerInterPretation> *allocator) {

	InnerInterPretation *result = allocator->GenerateObj();

	result->_currentTurn            = this->_currentTurn;
	result->_handPiece_BLACK        = this->_handPiece_BLACK;
	result->_handPiece_WHITE        = this->_handPiece_WHITE;
	result->_isThrouableInfoLatest  = this->_isThrouableInfoLatest;
	result->_totalMoveCount         = this->_totalMoveCount;
	result->_isPassPreviousMove     = this->_isPassPreviousMove;
	result->_isPassPass             = this->_isPassPass;
	result->_boardSizeX             = this->_boardSizeX;
	result->_boardSizeY             = this->_boardSizeY;
	result->_handCards_BLACK_Index  = this->_handCards_BLACK_Index;
	result->_handCards_WHITE_Index  = this->_handCards_WHITE_Index;

	memcpy(result->_areaList, this->_areaList, sizeof(this->_areaList));
	memcpy(result->_handCards_BLACK, this->_handCards_BLACK, sizeof(this->_handCards_BLACK));
	memcpy(result->_handCards_WHITE, this->_handCards_WHITE, sizeof(this->_handCards_WHITE));

	return result;
}
void InnerInterPretation::GetCopy( InnerInterPretation *useThisMemory ) {

	useThisMemory = new(useThisMemory) InnerInterPretation();

	useThisMemory->_currentTurn            = this->_currentTurn;
	useThisMemory->_handPiece_BLACK        = this->_handPiece_BLACK;
	useThisMemory->_handPiece_WHITE        = this->_handPiece_WHITE;

	memcpy(useThisMemory->_areaList, this->_areaList, sizeof(this->_areaList));
	memcpy(useThisMemory->_handCards_BLACK, this->_handCards_BLACK, sizeof(this->_handCards_BLACK       ));
	memcpy(useThisMemory->_handCards_WHITE, this->_handCards_WHITE, sizeof(this->_handCards_WHITE       ));

	useThisMemory->_isThrouableInfoLatest  = this->_isThrouableInfoLatest;
	useThisMemory->_totalMoveCount         = this->_totalMoveCount;
	useThisMemory->_isPassPreviousMove     = this->_isPassPreviousMove;
	useThisMemory->_isPassPass             = this->_isPassPass;
	useThisMemory->_boardSizeX             = this->_boardSizeX;
	useThisMemory->_boardSizeY             = this->_boardSizeY;
	useThisMemory->_handCards_BLACK_Index  = this->_handCards_BLACK_Index;
	useThisMemory->_handCards_WHITE_Index  = this->_handCards_WHITE_Index;

}

InnerInterPretation* InnerInterPretation::GetCopy() {

	InnerInterPretation *result = new InnerInterPretation();
	if ( result == NULL ) {
		printf(" _numberOfInstances == %d\n ", _numberOfInstances);
		printf(" result == NULL \n");
	}
	
	result->_currentTurn            = this->_currentTurn;
	result->_handPiece_BLACK        = this->_handPiece_BLACK;
	result->_handPiece_WHITE        = this->_handPiece_WHITE;
	
	memcpy(result->_areaList, this->_areaList, sizeof(this->_areaList));
	memcpy(result->_handCards_BLACK, this->_handCards_BLACK, sizeof(this->_handCards_BLACK));
	memcpy(result->_handCards_WHITE, this->_handCards_WHITE, sizeof(this->_handCards_WHITE));

	result->_isThrouableInfoLatest  = this->_isThrouableInfoLatest;
	result->_totalMoveCount         = this->_totalMoveCount;
	result->_isPassPreviousMove     = this->_isPassPreviousMove;
	result->_isPassPass             = this->_isPassPass;
	result->_boardSizeX             = this->_boardSizeX;
	result->_boardSizeY             = this->_boardSizeY;
	result->_handCards_BLACK_Index  = this->_handCards_BLACK_Index;
	result->_handCards_WHITE_Index  = this->_handCards_WHITE_Index;

	return result;
}

//=========================================================
// 局面が同一かどうか
//【戻り値】 true で「同一」
//=========================================================
bool InnerInterPretation::IsEquals( InnerInterPretation *anotherOne ) {

	if (anotherOne->_currentTurn != this->_currentTurn ) {
		return false;
	}
	if (anotherOne->_handPiece_BLACK  != this->_handPiece_BLACK) {
		return false;
	}
	if ( anotherOne->_handPiece_WHITE != this->_handPiece_WHITE) {
		return false;
	}

	if ( anotherOne->_isThrouableInfoLatest  != this->_isThrouableInfoLatest) {
		return false;
	}
	if ( anotherOne->_totalMoveCount         != this->_totalMoveCount) {
		return false;
	}
	if ( anotherOne->_isPassPreviousMove     != this->_isPassPreviousMove) {
		return false;
	}
	if ( anotherOne->_isPassPass             != this->_isPassPass) {
		return false;
	}
	if ( anotherOne->_boardSizeX             != this->_boardSizeX) {
		return false;
	}
	if ( anotherOne->_boardSizeY             != this->_boardSizeY) {
		return false;
	}
	if ( anotherOne->_handCards_BLACK_Index  != this->_handCards_BLACK_Index) {
		return false;
	}
	if ( anotherOne->_handCards_WHITE_Index  != this->_handCards_WHITE_Index) {
		return false;
	}


	///// 手札置き場を比べるには…：ソートされてしまいますけど、構いませんよね？
	qsort ( anotherOne->_handCards_BLACK, anotherOne->_handCards_BLACK_Index, sizeof(int), InnerInterPretation::compare_int);
	qsort ( this->_handCards_BLACK, this->_handCards_BLACK_Index, sizeof(int), InnerInterPretation::compare_int);
	if ( memcmp(anotherOne->_handCards_BLACK       , this->_handCards_BLACK       , sizeof(this->_handCards_BLACK       )) != 0) {
		return false;
	}

	qsort ( anotherOne->_handCards_WHITE, anotherOne->_handCards_WHITE_Index, sizeof(int), InnerInterPretation::compare_int);
	qsort ( this->_handCards_WHITE, this->_handCards_WHITE_Index, sizeof(int), InnerInterPretation::compare_int);
	if ( memcmp(anotherOne->_handCards_WHITE       , this->_handCards_WHITE       , sizeof(this->_handCards_WHITE       )) != 0) {
		return false;
	}


	for (int y = 0; y < this->_boardSizeY; ++y) {
		for (int x = 0; x < this->_boardSizeX; ++x) {

			if ( ! IsEquals_Area( this->_areaList[y][x], anotherOne->_areaList[y][x]) ) {
				return false;
			}
		}
	}

	return true;
}
//=========================================================
// Area が同一かどうか
//=========================================================
bool InnerInterPretation::IsEquals_Area ( Area &a, Area &b) {

	// 同一だったら true
	bool result = false;

	if ( a.gridNumber_X != b.gridNumber_X ) {
		return false;
	}
	if ( a.gridNumber_Y != b.gridNumber_Y ) {
		return false;
	}
	if ( a.blackNumber != b.blackNumber ) {
		return false;
	}
	if ( a.whiteNumber != b.whiteNumber ) {
		return false;
	}
	if ( a.cardNumber != b.cardNumber ) {
		return false;
	}

	if ( a.throuable_Number != b.cardNumber ) {
		return false;
	}
	if ( a.throuable_UP_Number != b.cardNumber ) {
		return false;
	}
	if ( a.throuable_DOWN_Number != b.throuable_DOWN_Number ) {
		return false;
	}
	if ( a.throuable_RIGHT_Number != b.throuable_RIGHT_Number ) {
		return false;
	}
	if ( a.throuable_LEFT_Number != b.throuable_LEFT_Number ) {
		return false;
	}

	qsort ( a.cardList, a.cardNumber, sizeof(CardOnBoard), InnerInterPretation::compare_CardOnBoard);
	qsort ( b.cardList, b.cardNumber, sizeof(CardOnBoard), InnerInterPretation::compare_CardOnBoard);
	if ( memcmp(a.cardList, b.cardList, sizeof(a.cardList)) != 0) {
		return false;
	}

	return result;
}

//=========================================================
// 次の局面になっておくれ
//【引数】こう指してね
//=========================================================
void InnerInterPretation::GoNext( const Move &move ) {

	/*
		可能な手かどうかの確認はしてませんよ。
	*/
	GoNext_PutPiece (move);
	GoNext_MovePiece(move);
	GoNext_PutCard  (move);
	GoNext_TakeCard (move);
	GoNext_Pass     (move);

	Init_ReflectCardAffection();
	AddTotalMoveCount();
}

//=========================================================
// 手を一つ巻き戻す
//【戻り値】Undoできたら true 
//=========================================================
bool InnerInterPretation::GoBack() {

	if ( !_moveForBack.isValid ) {
		return false;
	}

	GoBack_PutPiece ();
	GoBack_MovePiece();
	GoBack_PutCard  ();
	GoBack_TakeCard ();
	GoBack_Pass     ();

	Init_ReflectCardAffection();
	DecrementTotalMoveCount();

	_moveForBack.isValid = false;

	return true;
}

//=========================================================
// 手を巻き戻して：子処理群：駒設置でした
//=========================================================
bool InnerInterPretation::GoBack_PutPiece  () {

	bool result = false;

	if ( _moveForBack.previousMove.action == MOVE::ACTION::PUT_PIECE ) {

		result = true;

		if ( _moveForBack.previousMove.turn == TURN::BLACK ) {

			--_areaList [_moveForBack.previousMove.putPieceY] [_moveForBack.previousMove.putPieceX].blackNumber;
			++_handPiece_BLACK;

			// 手番交代
			_currentTurn = TURN::BLACK;
		}
		else if ( _moveForBack.previousMove.turn == TURN::WHITE ) {

			--_areaList [_moveForBack.previousMove.putPieceY] [_moveForBack.previousMove.putPieceX].whiteNumber;
			++_handPiece_WHITE;

			// 手番交代
			_currentTurn = TURN::WHITE;
		}

	}

	return result;
}
//=========================================================
// 手を巻き戻して：子処理群：駒移動でした
//=========================================================
bool InnerInterPretation::GoBack_MovePiece () {

	/*
		Interpretation となると、手番関係ありますね。
		「ぶつける」は、もしかすると、ない、と見せかけて、やっぱりある。
		移動先に、他駒がたくさんあったら、ぶつけられるかもしれない、という判断。
	*/

	bool result = false;

	if ( _moveForBack.previousMove.action == MOVE::ACTION::MOVE_PIECE ) {

		result = true;

		// 前回、黒番でした。
		if ( _moveForBack.previousMove.turn == TURN::BLACK ) {

			// From を減らして、Toを増やす
			--_areaList[ _moveForBack.previousMove.movePieceFromY ][ _moveForBack.previousMove.movePieceFromX].blackNumber;
			++_areaList[ _moveForBack.previousMove.movePieceToY ][ _moveForBack.previousMove.movePieceToX].blackNumber;

			// ぶつけていた場合
			if ( _moveForBack.previousMove.movePieceAndIsCllide) {

				// To にある相手の駒を減らして、手駒を増やす、でいいですよね？
				--_areaList[ _moveForBack.previousMove.movePieceToY ][ _moveForBack.previousMove.movePieceToX].whiteNumber;
				++_handPiece_WHITE;
			}

			// 手番交代
			 _currentTurn = TURN::BLACK;
		}
		// 前回、白番でした。
		else if ( _moveForBack.previousMove.turn == TURN::WHITE ) {

			// From を減らして、Toを増やす
			--_areaList[ _moveForBack.previousMove.movePieceFromY ][ _moveForBack.previousMove.movePieceFromX].whiteNumber;
			++_areaList[ _moveForBack.previousMove.movePieceToY ][ _moveForBack.previousMove.movePieceToX].whiteNumber;

			// ぶつけていた場合
			if ( _moveForBack.previousMove.movePieceAndIsCllide) {

				// To にある相手の駒を減らして、手駒を増やす、でいいですよね？
				--_areaList[ _moveForBack.previousMove.movePieceToY ][ _moveForBack.previousMove.movePieceToX].blackNumber;
				++_handPiece_BLACK;
			}

			// 手番交代
			 _currentTurn = TURN::WHITE;
		}
	} 

	return result;
}
//=========================================================
// 手を巻き戻して：子処理群：カード設置でした
//=========================================================
bool InnerInterPretation::GoBack_PutCard   () {

	bool result = false;

	if ( _moveForBack.previousMove.action == MOVE::ACTION::PUT_CARD ) {

		result = true;

		if ( _moveForBack.previousMove.turn == TURN::BLACK ) { 

			// 設置位置からカードを除外して
			Init_RemoveCard ( 
				_moveForBack.previousMove.putCardX, 
				_moveForBack.previousMove.putCardY, 
				_moveForBack.previousMove.putCardId 
			);

			// 手札に加える
			Init_AddHandCard_BLACK ( _moveForBack.previousMove.putCardId );

			// 盤面のカードをいじりましたよ。
			_isThrouableInfoLatest = false;

			// 手番交代
			_currentTurn = TURN::BLACK; 

		} else if ( _moveForBack.previousMove.turn == TURN::WHITE ) { 
			
			// 設置位置からカードを除外して
			Init_RemoveCard ( 
				_moveForBack.previousMove.putCardX, 
				_moveForBack.previousMove.putCardY, 
				_moveForBack.previousMove.putCardId 
			);

			// 手札に加える
			Init_AddHandCard_WHITE ( _moveForBack.previousMove.putCardId );

			// 盤面のカードをいじりましたよ。
			_isThrouableInfoLatest = false;

			// 手番交代
			_currentTurn = TURN::WHITE; 
		}
	}

	return result;
}
//=========================================================
// 手を巻き戻して：子処理群：カード取得でした
//=========================================================
bool InnerInterPretation::GoBack_TakeCard  () {

	bool result = false;

	if ( _moveForBack.previousMove.action == MOVE::ACTION::TAKE_CARD ) {

		result = true;

		if ( _moveForBack.previousMove.turn == TURN::BLACK ) { 

			// 取った位置にカードを戻して
			Init_PutCard(
				_moveForBack.previousMove.takeCardX,
				_moveForBack.previousMove.takeCardY,
				_moveForBack.tookCardId,
				_moveForBack.tookCardDirection
			);

			// 手札から除外
			int index = GetHandCardIndexOf_Black( _moveForBack.tookCardId );
			if (index != -1) {
				ReleaseCard_ByIndex_Black(index);
			} else {
				printf("おかしい！\n");
			}

			// 盤面のカードをいじりましたよ。
			_isThrouableInfoLatest = false;

			// 手番交代
			_currentTurn = TURN::BLACK; 

		} else if ( _moveForBack.previousMove.turn == TURN::WHITE ) { 
			
			// 取った位置にカードを戻して
			Init_PutCard(
				_moveForBack.previousMove.takeCardX,
				_moveForBack.previousMove.takeCardY,
				_moveForBack.tookCardId,
				_moveForBack.tookCardDirection
			);

			// 手札から除外
			int index = GetHandCardIndexOf_White( _moveForBack.tookCardId );
			if (index != -1) {
				ReleaseCard_ByIndex_White(index);
			} else {
				printf("おかしいよ！\n");
			}

			// 盤面のカードをいじりましたよ。
			_isThrouableInfoLatest = false;

			// 手番交代
			_currentTurn = TURN::WHITE; 
		}
	}

	return result;
}
//=========================================================
// 手を巻き戻して：子処理群：パスでした
//=========================================================
bool InnerInterPretation::GoBack_Pass () {

	bool result = false;

	if ( _moveForBack.previousMove.action == MOVE::ACTION::PASS) {

		result = true;

		// 手詰まりフラグが立っていたら
		if (_isPassPass) {
			
			// パスを戻しても、やっぱりパスなのでしょう。
			_isPassPreviousMove = true;

			// しかし手詰まりフラグははずす（手詰まりフラグが立ったあとは、手を指されていない、と仮定して）
			_isPassPass = false;

		// 手詰まりフラグは立っていなかった
		} else {

			// パスはしなかったことになる。
			_isPassPreviousMove = false;
		}

		if (_currentTurn == TURN::BLACK) {

			// 手番交代
			_currentTurn = TURN::BLACK;
		}
		else if (_currentTurn == TURN::WHITE) {

			// 手番交代
			_currentTurn = TURN::WHITE;
		}
	}

	return result;
}

//=========================================================
// こう指してね：子処理：パス
//=========================================================
void InnerInterPretation::GoNext_Pass ( const Move &move ) {

	if (move.action == MOVE::ACTION::PASS) {

		// 前回もパスだったら、手詰まり。
		if (_isPassPreviousMove) {
			_isPassPass = true;
		}
		// 今回パスでしたね。
		_isPassPreviousMove = true;

		if (_currentTurn == TURN::BLACK) {

			// 手番交代
			_currentTurn = TURN::WHITE;
		}
		else if (_currentTurn == TURN::WHITE) {

			// 手番交代
			_currentTurn = TURN::BLACK;
		}
	}
}

//=========================================================
// こう指してね：子処理：駒打つ
//=========================================================
void InnerInterPretation::GoNext_PutPiece( const Move &move ) {

	if (move.action == MOVE::ACTION::PUT_PIECE) {

		_isPassPreviousMove = false;

		if (_currentTurn == TURN::BLACK) {

			--_handPiece_BLACK;
			++_areaList[move.putPieceY][move.putPieceX].blackNumber;

			// 手番交代
			_currentTurn = TURN::WHITE;

			// 巻き戻し情報
			_moveForBack.previousMove = move;
			_moveForBack.isValid = true;
		}
		else if (_currentTurn == TURN::WHITE) {

			--_handPiece_WHITE;
			++_areaList[move.putPieceY][move.putPieceX].whiteNumber;

			// 手番交代
			_currentTurn = TURN::BLACK;

			// 巻き戻し情報
			_moveForBack.previousMove = move;
			_moveForBack.isValid = true;
		}

	}
}
//=========================================================
// こう指してね：子処理：駒移動
//=========================================================
void InnerInterPretation::GoNext_MovePiece( const Move &move ) {

	if (move.action == MOVE::ACTION::MOVE_PIECE) {

		_isPassPreviousMove = false;

		if (_currentTurn == TURN::BLACK) {

			// 移動
			--_areaList[move.movePieceFromY][move.movePieceFromX].blackNumber;
			++_areaList[move.movePieceToY][move.movePieceToX].blackNumber;

			// 巻き戻し情報
			_moveForBack.previousMove = move;
			_moveForBack.isValid = true;

			// 手番交代
			_currentTurn = TURN::WHITE;
		}
		else if (_currentTurn == TURN::WHITE) {

			// 移動
			--_areaList[move.movePieceFromY][move.movePieceFromX].blackNumber;
			++_areaList[move.movePieceToY][move.movePieceToX].blackNumber;

			// 巻き戻し情報
			_moveForBack.previousMove = move;
			_moveForBack.isValid = true;


			// 手番交代
			_currentTurn = TURN::BLACK;
		}

		/*
			ぶつける処理は黒番白番関係ないですよね？ 
		*/
		// ぶつける場合：移動先のエリア内の駒にぶつける、と、みなす。
		if ( move.movePieceAndIsCllide ) {

			/*
				何色の駒にぶつけるの？
				「エリア」で解釈する場合、何色のにぶつける、というのも情報に必要なのですよね。
			*/
			if ( move.movePieceAndCllidedPieceColor == GRID::BLACK) { 
	
				// 手駒を増やして
				++_handPiece_BLACK; 

				// 盤面から取り除く
				--_areaList[move.movePieceToY][move.movePieceToX].blackNumber;
			}
			else if ( move.movePieceAndCllidedPieceColor == GRID::WHITE) { 

				// 手駒を増やして
				++_handPiece_WHITE; 

				// 盤面から取り除く
				--_areaList[move.movePieceToY][move.movePieceToX].whiteNumber;
			}

			// 巻き戻し情報に記録
			_moveForBack.cllidedPieceColor = move.movePieceAndCllidedPieceColor;
			_moveForBack.cllidedX = move.movePieceToX;
			_moveForBack.cllidedY = move.movePieceToY;
		}
	}
}

//=========================================================
// 手札リスト内での位置を取得
//=========================================================
int InnerInterPretation::GetHandCardIndexOf_Black( int cardId) {

	int result = -1;

	int length = sizeof(_handCards_BLACK) / sizeof(int);

	for (int i = 0; i < length; ++i) {

		if (_handCards_BLACK[i] == cardId) {
			result = i;
			break;
		}
	}
	return result;
}
int InnerInterPretation::GetHandCardIndexOf_White( int cardId) {

	int result = -1;

	int length = sizeof(_handCards_WHITE) / sizeof(int);

	for (int i = 0; i < length; ++i) {

		if (_handCards_WHITE[i] == cardId) {
			result = i;
			break;
		}
	}
	return result;
}
//=========================================================
// このカードを手放す
//=========================================================
void InnerInterPretation::ReleaseCard_ByIndex_Black ( int index ) {

	bool isReleased = false;

	int length = sizeof(_handCards_BLACK) / sizeof(int);

	_handCards_BLACK[index] = -1;
	--_handCards_BLACK_Index;

	for (int i = index; i < length; ++i) {

		if ( (i+1) < length) {
			_handCards_BLACK[i] = _handCards_BLACK[i + 1];
			_handCards_BLACK[i + 1] = -1;
		}
	}
}
void InnerInterPretation::ReleaseCard_ByIndex_White ( int index ) {

	bool isReleased = false;

	int length = sizeof(_handCards_WHITE) / sizeof(int);

	_handCards_WHITE[index] = -1;
	--_handCards_WHITE_Index;

	for (int i = index; i < length; ++i) {

		if ( (i+1) < length) {
			_handCards_WHITE[i] = _handCards_WHITE[i + 1];
			_handCards_WHITE[i + 1] = -1;
		}
	}
}
//=========================================================
// こう指してね：子処理：カード置く
//=========================================================
void InnerInterPretation::GoNext_PutCard( const Move &move ) {

	if (move.action == MOVE::ACTION::PUT_CARD) {

		_isPassPreviousMove    = false;
		_isThrouableInfoLatest = false;

		if (_currentTurn == TURN::BLACK) {

			// 置くつもりのカード、手札にある？
			int index = GetHandCardIndexOf_Black( move.putCardId);
			if ( index != -1) {

				// 手札から取り除いて
				ReleaseCard_ByIndex_Black ( index );

				// 盤面に置く
				Init_PutCard(
					move.putCardX,
					move.putCardY,
					move.putCardId,
					move.putCardDirection
				);

			}
			// 手番交代
			_currentTurn = TURN::WHITE;

		}
		else if (_currentTurn == TURN::WHITE) {

			// 置くつもりのカード、手札にある？
			int index = GetHandCardIndexOf_White( move.putCardId);
			if ( index != -1) {

				// 手札から取り除いて
				ReleaseCard_ByIndex_White ( index );

				// 盤面に置く
				Init_PutCard(
					move.putCardX,
					move.putCardY,
					move.putCardId,
					move.putCardDirection
				);

			}
			// 手番交代
			_currentTurn = TURN::BLACK;
		}


		// 巻き戻し情報
		_moveForBack.previousMove = move;
		_moveForBack.isValid      = true;
	}
}

//=========================================================
// こう指してね：子処理：カード取る
//=========================================================
void InnerInterPretation::GoNext_TakeCard( const Move &move ) {

	/*
		結局、エリア内にあるカードごとに「取る」という選択肢が生じる。
		手数が多くなってしまいません？
		解釈版では、いっそのこと、「取る」はナシにしてはどうか？
	*/

	if (move.action == MOVE::ACTION::TAKE_CARD) {

		_isPassPreviousMove = false;

		// 盤面からはがして、方向を覚えておく。
		int direction = DIRECTION::NONE;
		Init_RemoveCard ( move.takeCardX, move.takeCardY, move.takeCardCardId, direction );

		// 巻き戻し情報
		_moveForBack.previousMove = move;
		_moveForBack.isValid = true;
		_moveForBack.tookCardId        = move.takeCardCardId;
		_moveForBack.tookCardDirection = direction;

		if (_currentTurn == TURN::BLACK) {

			// 手札に加える
			Init_AddHandCard_BLACK( move.takeCardCardId );

			// 手番交代
			_currentTurn = TURN::WHITE;

		}
		else if (_currentTurn == TURN::WHITE) {

			// 手札に加える
			Init_AddHandCard_WHITE( move.takeCardCardId );

			// 手番交代
			_currentTurn = TURN::BLACK;
		}

	}
}


//=========================================================
// 可能な次の手を列挙
//=========================================================
vector<Move> InnerInterPretation::GetLegalNextMoveList() {

	vector<Move> result;

	///// 駒を動かす手を生成（勝つ可能性のある手がリストの先頭近くになるように）
	GetLegalNextMoveList_MovePiece( result );

	///// 駒を打つ手を生成
	GetLegalNextMoveList_PutPiece( result );

	///// カードを置く手を生成
	GetLegalNextMoveList_PutCard( result );

	///// カードを取る手を生成
	GetLegalNextMoveList_TakeCard( result );

	///// パス
	if (result.size() == 0) {
		Move move;
		move.action = MOVE::ACTION::PASS;
		result.push_back( move );
	}

	return result;
}
void InnerInterPretation::GetLegalNextMoveList(vector<Move> &result) {

	///// 駒を動かす手を生成（勝つ可能性のある手がリストの先頭近くになるように）
	GetLegalNextMoveList_MovePiece( result );

	///// 駒を打つ手を生成
	GetLegalNextMoveList_PutPiece( result );

	///// カードを置く手を生成
	GetLegalNextMoveList_PutCard( result );

	///// カードを取る手を生成
	GetLegalNextMoveList_TakeCard( result );

	///// パス
	if (result.size() == 0) {
		Move move;
		move.action = MOVE::ACTION::PASS;
		result.push_back( move );
	}
}

//=========================================================
// 可能な次の手を列挙：子処理：駒を打つ
//=========================================================
void InnerInterPretation::GetLegalNextMoveList_PutPiece(vector<Move> &result ) {


	///// 駒を打つ手を生成
	/*
		黒が手前で白が奥。
	*/
	if (_currentTurn == TURN::BLACK) {

		// 駒台に駒がある？
		if (_handPiece_BLACK > 0) {

			// 自陣側のエリア、X軸でループ
			int selfAreaIndex = _boardSizeY - 1;

			for (unsigned int  x = 0; x < _boardSizeX; ++x) {

				int blackNumber = _areaList[selfAreaIndex][x].blackNumber;
				int whiteNumber = _areaList[selfAreaIndex][x].whiteNumber;

				// 自陣マスの個数
				int gridNumber_X = _areaList[selfAreaIndex][x].gridNumber_X;

				int gridNumber_Y = _areaList[selfAreaIndex][x].gridNumber_Y;


				/*
					自陣に入っている可能性のある駒は自駒だけであると決め付ける
				*/
				// 自駒の数が自陣マスの個数を下回っている → 設置可能
				if ( blackNumber < gridNumber_X ) {

					Move move;
					move.turn   = _currentTurn;
					move.action = MOVE::ACTION::PUT_PIECE;
					move.putPieceX = x;
					move.putPieceY = selfAreaIndex;

					result.push_back(move);

					continue;
				}

				// 自陣じゃないマスの数
				int nonTeritorryNumber_MAX = (gridNumber_X * gridNumber_Y) - gridNumber_X;

				// 相手駒は全て、そこに入っているから、その分を引く
				int nonTeritorryNumber = nonTeritorryNumber_MAX - whiteNumber;

				// 自陣じゃないマス側に入っていなければならない自駒の個数
				int norma = blackNumber - (gridNumber_X - 1);

				// 自陣じゃないマス側に入っている確率・分子
				// (nonTeritorryNumber) Ｐ (norma) 
				int  numerator = Utils_Cal::Permutation ( nonTeritorryNumber, norma );

				// 自陣じゃないマス側に入っている確率・分母
				// (nonTeritorryNumber + gridNumber_X) Ｐ (norma) 
				int  denominator = Utils_Cal::Permutation ( nonTeritorryNumber + gridNumber_X, norma );

				// さて、くじびき
				int lot = Utils_Cal::GerRandom( denominator );

				// あたり？
				if ( lot < numerator ) {

					Move move;
					move.turn   = _currentTurn;
					move.action = MOVE::ACTION::PUT_PIECE;
					move.putPieceX = x;
					move.putPieceY = selfAreaIndex;

					result.push_back(move);
				}
			}
		}
	}
	else if (_currentTurn == TURN::WHITE) {


		// 駒台に駒がある？
		if (_handPiece_WHITE > 0) {

			// 自陣側のエリア、X軸でループ
			int selfAreaIndex = 0;

			for (unsigned int  x = 0; x < _boardSizeX; ++x) {

				int blackNumber = _areaList[selfAreaIndex][x].blackNumber;
				int whiteNumber = _areaList[selfAreaIndex][x].whiteNumber;

				// 自陣マスの個数
				int gridNumber_X = _areaList[selfAreaIndex][x].gridNumber_X;

				int gridNumber_Y = _areaList[selfAreaIndex][x].gridNumber_Y;


				/*
					自陣に入っている可能性のある駒は自駒だけであると決め付ける
				*/
				// 自駒の数が自陣マスの個数を下回っている → 設置可能
				if ( whiteNumber < gridNumber_X ) {

					Move move;
					move.turn   = _currentTurn;
					move.action = MOVE::ACTION::PUT_PIECE;
					move.putPieceX = x;
					move.putPieceY = selfAreaIndex;

					result.push_back(move);

					continue;
				}

				// 自陣じゃないマスの数
				int nonTeritorryNumber_MAX = (gridNumber_X * gridNumber_Y) - gridNumber_X;

				// 相手駒は全て、そこに入っているから、その分を引く
				int nonTeritorryNumber = nonTeritorryNumber_MAX - blackNumber;

				// 自陣じゃないマス側に入っていなければならない自駒の個数
				int norma = whiteNumber - (gridNumber_X - 1);

				// 自陣じゃないマス側に入っている確率・分子
				// (nonTeritorryNumber) Ｐ (norma) 
				int  numerator = Utils_Cal::Permutation ( nonTeritorryNumber, norma );

				// 自陣じゃないマス側に入っている確率・分母
				// (nonTeritorryNumber + gridNumber_X) Ｐ (norma) 
				int  denominator = Utils_Cal::Permutation ( nonTeritorryNumber + gridNumber_X, norma );

				// さて、くじびき
				int lot = Utils_Cal::GerRandom( denominator );

				// あたり？
				if ( lot < numerator ) {

					Move move;
					move.turn   = _currentTurn;
					move.action = MOVE::ACTION::PUT_PIECE;
					move.putPieceX = x;
					move.putPieceY = selfAreaIndex;

					result.push_back(move);
				}
			}
		}
	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を動かす
//=========================================================
void InnerInterPretation::GetLegalNextMoveList_MovePiece (vector<Move> &result ) {

	///// エリアごとの自分の駒の個数（どっちの手番かによって切り替える）
	int myPieceNum = 0;

	///// 自分の駒がある場所を走査
	for ( unsigned int y = 0; y < _boardSizeY; ++y) {

		for ( unsigned int x = 0; x < _boardSizeX; ++x) {

			// 自分の駒の個数
			if (_currentTurn == TURN::BLACK) {
				myPieceNum = _areaList[y][x].blackNumber;
			}
			else if (_currentTurn == TURN::WHITE) {
				myPieceNum = _areaList[y][x].whiteNumber;
			}

			// 自分の駒がある？
			if ( myPieceNum > 0 ) {

				// 各方向への移動を見る
				GetLegalNextMoveList_MovePiece_toUP    ( result, x, y );
				GetLegalNextMoveList_MovePiece_toDOWN  ( result, x, y );
				GetLegalNextMoveList_MovePiece_toLEFT  ( result, x, y );
				GetLegalNextMoveList_MovePiece_toRIGHT ( result, x, y );
				GetLegalNextMoveList_MovePiece_toRIGHT_UP   ( result, x, y );
				GetLegalNextMoveList_MovePiece_toRIGHT_DOWN ( result, x, y );
				GetLegalNextMoveList_MovePiece_toLEFT_UP    ( result, x, y );
				GetLegalNextMoveList_MovePiece_toLEFT_DOWN  ( result, x, y );

			}
		}
	}
}

//=========================================================
// このエリアは、指定の方向への移動可？
//【引数】
// Area エリア
// direction この方向
//=========================================================
bool InnerInterPretation::IsThrouableTo_Area( Area &area, int direction ) {

	bool result = false;

	// 全マス数
	int allGridNum = area.gridNumber_X * area.gridNumber_Y;

	// 通行不可のマス数
	int unThrouableNum = allGridNum - ( area.throuable_Number +	area.throuable_UP_Number + area.throuable_RIGHT_Number + area.throuable_LEFT_Number + area.throuable_DOWN_Number );

	///// 全方向へ移動可なら、行きたい方向がどちらでも、「通行可」
	// 「全方向へ移動可」が最大数であるならば
	if ( Utils_Cal::IsMax( 5, area.throuable_Number , unThrouableNum, area.throuable_UP_Number, area.throuable_DOWN_Number, area.throuable_LEFT_Number, area.throuable_RIGHT_Number)) {
		result = true;
		return result;
	}

	///// 移動不可である場合、ここで打ち切る
	if ( Utils_Cal::IsMax( 5, unThrouableNum, area.throuable_Number, area.throuable_UP_Number, area.throuable_DOWN_Number, area.throuable_LEFT_Number, area.throuable_RIGHT_Number)) {
		result = false;
		return result;
	}

	/*
		引数 direction に DIRECTION::NONE を入れた場合、
		以下の どのif にもひっかからず、結果は false となる。
	*/

	///// 行きたい方向ごとに：UP
	if (direction == DIRECTION::UP) {

		if ( Utils_Cal::IsMax( 5
				, area.throuable_UP_Number
				, area.throuable_Number
				, unThrouableNum
				, area.throuable_DOWN_Number
				, area.throuable_LEFT_Number
				, area.throuable_RIGHT_Number)
		) 
		{
			result = true;
			return result;
		}
	}
	///// 行きたい方向ごとに：DOWN
	if (direction == DIRECTION::DOWN) {

		if ( Utils_Cal::IsMax( 5
				, area.throuable_DOWN_Number
				, area.throuable_UP_Number
				, area.throuable_Number
				, unThrouableNum
				, area.throuable_LEFT_Number
				, area.throuable_RIGHT_Number)
		) 
		{
			result = true;
			return result;
		}
	}
	///// 行きたい方向ごとに：LEFT
	if (direction == DIRECTION::LEFT) {

		if ( Utils_Cal::IsMax( 5
				, area.throuable_LEFT_Number
				, area.throuable_DOWN_Number
				, area.throuable_UP_Number
				, area.throuable_Number
				, unThrouableNum
				, area.throuable_RIGHT_Number)
		) 
		{
			result = true;
			return result;
		}
	}
	///// 行きたい方向ごとに：RIGHT
	if (direction == DIRECTION::RIGHT) {

		if ( Utils_Cal::IsMax( 5
				, area.throuable_RIGHT_Number
				, area.throuable_LEFT_Number
				, area.throuable_DOWN_Number
				, area.throuable_UP_Number
				, area.throuable_Number
				, unThrouableNum
				)
		) 
		{
			result = true;
			return result;
		}
	}

	return result;
}


//=========================================================
// このエリアは他の駒があって通れない？
//【結果】
// true で、空きがある
//=========================================================
bool InnerInterPretation::IsEmpty_Area( Area &area) {

	bool result = true;

	int allGridNum  = area.gridNumber_X * area.gridNumber_Y;
	int allPieceNum = area.blackNumber + area.whiteNumber;

	/*
		半分以上あったら通れないことにする？
		乱数でいく？
		私情をさしはさむのは恐れ多いので、乱数にrely on しましょう。
	*/

	int lot = Utils_Cal::GerRandom( allGridNum  );
	if ( lot < allPieceNum ) {
		result = false;
	}

	return result;
}

//=========================================================
// このエリアに、入れる・通行可不可の意味で
//【結果】
// true で、入れる
//=========================================================
bool InnerInterPretation::IsEnter_Area_Throuable( Area &area ) {

	bool result = false;

	int allGridNum     = area.gridNumber_X * area.gridNumber_Y;
	int onPanelGridNum = area.throuable_Number + area.throuable_UP_Number  + area.throuable_DOWN_Number  + area.throuable_RIGHT_Number  + area.throuable_LEFT_Number;

	int lot = Utils_Cal::GerRandom( allGridNum );
	if (lot < onPanelGridNum) {
		result = true;
	}

	return result;
}



//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：上へ
//=========================================================
void InnerInterPretation::GetLegalNextMoveList_MovePiece_toUP (vector<Move> &result, int x, int y ) {

	///// 現在地が、上移動可か？
	//「エリア」単位で「大雑把に」把握する。
	if ( !IsThrouableTo_Area ( _areaList[y][x], DIRECTION::UP ) ) {
		return;
	}

	///// 上向きに動いてみる（１つ上から開始）
	for ( int prospectiveY = y - 1; prospectiveY >= 0; --prospectiveY) {

		// 他の駒があったら入れない
		if ( !IsEmpty_Area(_areaList[ prospectiveY ][x])) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( !IsEnter_Area_Throuable( _areaList[ prospectiveY ][ x ]) ) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = x;
		move.movePieceToY   = prospectiveY;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextY = prospectiveY - 1;
		if (nextY >= 0 && !IsEmpty_Area( _areaList[nextY][x])) {

			if ( IsEnter_Area_Throuable(_areaList[nextY][x])) {

				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;
				// 何色の駒にぶつける？
				move_collide.movePieceAndCllidedPieceColor = GetLegalNextMoveList_MovePiece_CollidePieceColor( _areaList[nextY][x].blackNumber, _areaList[nextY][x].whiteNumber );
				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( !IsThrouableTo_Area( _areaList[ prospectiveY ][x], DIRECTION::UP)) {
			break;
		}

	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：下へ
//=========================================================
void InnerInterPretation::GetLegalNextMoveList_MovePiece_toDOWN (vector<Move> &result, int x, int y ) {

	///// 現在地が、下移動可か？
	if ( !IsThrouableTo_Area ( _areaList[y][x], DIRECTION::DOWN ) ) {
		return;
	}

	///// 下向きに動いてみる（１つ下から開始）
	for ( int prospectiveY = y + 1; prospectiveY < _boardSizeY; ++prospectiveY) {

		// 他の駒があったら入れない
		if ( !IsEmpty_Area( _areaList[ prospectiveY ][x])) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( !IsEnter_Area_Throuable( _areaList[ prospectiveY ][ x ]) ) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = x;
		move.movePieceToY   = prospectiveY;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextY = prospectiveY + 1;
		if (nextY < _boardSizeY && !IsEmpty_Area( _areaList[nextY][x])) {

			if ( IsEnter_Area_Throuable( _areaList[nextY][x])) {

				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;
				// 何色の駒にぶつける？
				move_collide.movePieceAndCllidedPieceColor = GetLegalNextMoveList_MovePiece_CollidePieceColor( _areaList[nextY][x].blackNumber, _areaList[nextY][x].whiteNumber );
				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( !IsThrouableTo_Area( _areaList[ prospectiveY ][x], DIRECTION::DOWN)) {
			break;
		}

	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：左へ
//=========================================================
void InnerInterPretation::GetLegalNextMoveList_MovePiece_toLEFT (vector<Move> &result, int x, int y ) {

	///// 現在地が、左移動可か？
	if ( !IsThrouableTo_Area ( _areaList[y][x], DIRECTION::LEFT ) ) {
		return;
	}

	///// 左向きに動いてみる（１つ左から開始）
	for ( int prospectiveX = x - 1; prospectiveX >= 0; --prospectiveX) {

		// 他の駒があったら入れない
		if ( !IsEmpty_Area(_areaList[y][ prospectiveX])) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( !IsEnter_Area_Throuable (_areaList[y][prospectiveX]) ) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = prospectiveX;
		move.movePieceToY   = y;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextX = prospectiveX - 1;
		if (nextX >= 0 && !IsEmpty_Area(_areaList[y][nextX])) {

			if ( IsEnter_Area_Throuable( _areaList[y][nextX])) {

				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;
				// 何色の駒にぶつける？
				move_collide.movePieceAndCllidedPieceColor = GetLegalNextMoveList_MovePiece_CollidePieceColor( _areaList[y][nextX].blackNumber, _areaList[y][nextX].whiteNumber );
				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( !IsThrouableTo_Area( _areaList[y][ prospectiveX ], DIRECTION::LEFT)) {
			break;
		}

	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：右へ
//=========================================================
void InnerInterPretation::GetLegalNextMoveList_MovePiece_toRIGHT (vector<Move> &result, int x, int y ) {

	///// 現在地が、右移動可か？
	if ( !IsThrouableTo_Area ( _areaList[y][x], DIRECTION::RIGHT ) ) {
		return;
	}

	///// 右向きに動いてみる（１つ右から開始）
	for ( int prospectiveX = x + 1; prospectiveX  < _boardSizeX; ++prospectiveX) {

		// 他の駒があったら入れない
		if ( !IsEmpty_Area( _areaList[y][ prospectiveX])) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( !IsEnter_Area_Throuable( _areaList[y][prospectiveX])) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = prospectiveX;
		move.movePieceToY   = y;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextX = prospectiveX + 1;
		if (nextX < _boardSizeX && !IsEmpty_Area(_areaList[y][nextX])) {

			if ( IsEnter_Area_Throuable(_areaList[y][nextX]) ) {

				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;
				// 何色の駒にぶつける？
				move_collide.movePieceAndCllidedPieceColor = GetLegalNextMoveList_MovePiece_CollidePieceColor( _areaList[y][nextX].blackNumber, _areaList[y][nextX].whiteNumber );
				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( !IsThrouableTo_Area( _areaList[y][ prospectiveX ], DIRECTION::RIGHT)) {
			break;
		}

	}

}

//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：右下へ
//=========================================================
void InnerInterPretation::GetLegalNextMoveList_MovePiece_toRIGHT_DOWN (vector<Move> &result, int x, int y ) {

	///// 現在地が、次へ移動可か？：矢印は４方向しかない。すなわち、「全方向通行可」のみ見る。
	if ( !IsThrouableTo_Area(_areaList[y][x], DIRECTION::NONE) ) {
		return;
	}

	///// 一歩動いてみる（１つ次から開始）
	int prospectiveX = x + 1; 
	int prospectiveY = y + 1; 
	while (  prospectiveY < _boardSizeY && prospectiveX < _boardSizeX) {

		// 他の駒があったら入れない
		if ( !IsEmpty_Area(_areaList[prospectiveY][ prospectiveX])) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( !IsEnter_Area_Throuable (_areaList[prospectiveY][prospectiveX])) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = prospectiveX;
		move.movePieceToY   = prospectiveY;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextX = prospectiveX + 1;
		int nextY = prospectiveY + 1;
		if ( nextY < _boardSizeY && nextX < _boardSizeX && !IsEmpty_Area( _areaList[nextY][nextX])) {

			if ( IsEnter_Area_Throuable (_areaList[nextY][nextX]) ) {

				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;
				// 何色の駒にぶつける？
				move_collide.movePieceAndCllidedPieceColor = GetLegalNextMoveList_MovePiece_CollidePieceColor( _areaList[nextY][nextX].blackNumber, _areaList[nextY][nextX].whiteNumber );
				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( !IsThrouableTo_Area(_areaList[prospectiveY][ prospectiveX ], DIRECTION::NONE)) {
			break;
		}

		++prospectiveX;
		++prospectiveY;
	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：右上へ
//=========================================================
void InnerInterPretation::GetLegalNextMoveList_MovePiece_toRIGHT_UP (vector<Move> &result, int x, int y ) {

	///// 現在地が、次へ移動可か？：矢印は４方向しかない。すなわち、「全方向通行可」のみ見る。
	if ( !IsThrouableTo_Area( _areaList[y][x], DIRECTION::NONE)) {
		return;
	}

	///// 一歩動いてみる（１つ次から開始）
	int prospectiveX = x + 1; 
	int prospectiveY = y - 1; 
	while (  prospectiveY >= 0 && prospectiveX < _boardSizeX) {

		// 他の駒があったら入れない
		if ( !IsEmpty_Area( _areaList[prospectiveY][ prospectiveX])) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( !IsEnter_Area_Throuable( _areaList[prospectiveY][prospectiveX])) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = prospectiveX;
		move.movePieceToY   = prospectiveY;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextX = prospectiveX + 1;
		int nextY = prospectiveY - 1;
		if ( nextY >= 0 && nextX < _boardSizeX && !IsEmpty_Area(_areaList[nextY][nextX])) {

			if ( IsEnter_Area_Throuable(_areaList[nextY][nextX]) ) {

				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;
				// 何色の駒にぶつける？
				move_collide.movePieceAndCllidedPieceColor = GetLegalNextMoveList_MovePiece_CollidePieceColor( _areaList[nextY][nextX].blackNumber, _areaList[nextY][nextX].whiteNumber );
				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( !IsThrouableTo_Area( _areaList[prospectiveY][ prospectiveX ], DIRECTION::NONE)) {
			break;
		}

		++prospectiveX;
		--prospectiveY;
	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：左上へ
//=========================================================
void InnerInterPretation::GetLegalNextMoveList_MovePiece_toLEFT_UP (vector<Move> &result, int x, int y ) {

	///// 現在地が、次へ移動可か？：矢印は４方向しかない。すなわち、「全方向通行可」のみ見る。
	if ( !IsThrouableTo_Area( _areaList[y][x], DIRECTION::NONE)) {
		return;
	}

	///// 一歩動いてみる（１つ次から開始）
	int prospectiveX = x - 1; 
	int prospectiveY = y - 1; 
	while (  prospectiveY >= 0 && prospectiveX >= 0) {

		// 他の駒があったら入れない
		if ( !IsEmpty_Area(_areaList[prospectiveY][ prospectiveX])) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( !IsEnter_Area_Throuable(_areaList[prospectiveY][prospectiveX])) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = prospectiveX;
		move.movePieceToY   = prospectiveY;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextX = prospectiveX - 1;
		int nextY = prospectiveY - 1;
		if ( nextY >= 0 && nextX >= 0 && !IsEmpty_Area(_areaList[nextY][nextX])) {

			if ( IsEnter_Area_Throuable( _areaList[nextY][nextX])) {
			
				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;

				// 何色の駒にぶつける？
				move_collide.movePieceAndCllidedPieceColor = GetLegalNextMoveList_MovePiece_CollidePieceColor( _areaList[nextY][nextX].blackNumber, _areaList[nextY][nextX].whiteNumber );

				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( !IsThrouableTo_Area(_areaList[prospectiveY][ prospectiveX ], DIRECTION::NONE)) {
			break;
		}

		--prospectiveX;
		--prospectiveY;
	}

}

//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：左下へ
//=========================================================
void InnerInterPretation::GetLegalNextMoveList_MovePiece_toLEFT_DOWN (vector<Move> &result, int x, int y ) {

	///// 現在地が、次へ移動可か？：矢印は４方向しかない。すなわち、「全方向通行可」のみ見る。
	if ( !IsThrouableTo_Area( _areaList[y][x], DIRECTION::NONE)) {
		return;
	}

	///// 一歩動いてみる（１つ次から開始）
	int prospectiveX = x - 1; 
	int prospectiveY = y + 1; 
	while (  prospectiveY < _boardSizeY && prospectiveX >= 0) {

		// 他の駒があったら入れない
		if ( !IsEmpty_Area( _areaList[prospectiveY][ prospectiveX])) {
			break;
		}
		// 通れないマス目だったら入れない
		if ( !IsEnter_Area_Throuable( _areaList[prospectiveY][prospectiveX])) {
			break;
		}

		// 入れます。
		Move move;
		move.action = MOVE::ACTION::MOVE_PIECE;
		move.turn = _currentTurn;
		move.movePieceFromX = x;
		move.movePieceFromY = y;
		move.movePieceToX   = prospectiveX;
		move.movePieceToY   = prospectiveY;
		move.movePieceAndIsCllide = false;
		result.push_back ( move );

		// 次のマス目に他の駒がいる場合、ぶつける選択肢もある。
		int nextX = prospectiveX - 1;
		int nextY = prospectiveY + 1;
		if ( nextY < _boardSizeY && nextX >= 0 && !IsEmpty_Area(_areaList[nextY][nextX])) {

			if ( IsEnter_Area_Throuable( _areaList[nextY][nextX])) {

				Move move_collide = move;
				move_collide.movePieceAndIsCllide = true;
				// 何色の駒にぶつける？
				move_collide.movePieceAndCllidedPieceColor = GetLegalNextMoveList_MovePiece_CollidePieceColor( _areaList[nextY][nextX].blackNumber, _areaList[nextY][nextX].whiteNumber );

				result.push_back ( move_collide );
			}
		}

		// もう進めない？
		if ( !IsThrouableTo_Area(_areaList[prospectiveY][ prospectiveX ], DIRECTION::NONE)) {
			break;
		}

		--prospectiveX;
		++prospectiveY;
	}

}
//=========================================================
// 可能な次の手を列挙：子処理：駒を移動：子処理：ぶつけるばあい、何色のにぶつけるか？
//=========================================================
int InnerInterPretation::GetLegalNextMoveList_MovePiece_CollidePieceColor ( const int &blackNumber, const int &whiteNumber ) {

	int result = GRID::BLACK;

	int lot = Utils_Cal::GerRandom( blackNumber + whiteNumber );
	if ( lot < whiteNumber ) {
		result = GRID::WHITE;
	}

	return result;
}
//=========================================================
// 各方向への移動可？
//=========================================================
bool InnerInterPretation::IsThrouableTo( int throuableInfo, int direction ) {

	bool result = false;

	if      ( direction == DIRECTION::UP    ) {	result = (throuableInfo == THROUGHABLE_INFO::THROUGHABLE || throuableInfo == THROUGHABLE_INFO::MUST_TO_UP);}
	else if ( direction == DIRECTION::LEFT  ) {	result = (throuableInfo == THROUGHABLE_INFO::THROUGHABLE || throuableInfo == THROUGHABLE_INFO::MUST_TO_LEFT);}
	else if ( direction == DIRECTION::RIGHT ) {	result = (throuableInfo == THROUGHABLE_INFO::THROUGHABLE || throuableInfo == THROUGHABLE_INFO::MUST_TO_RIGHT);}
	else if ( direction == DIRECTION::DOWN  ) {	result = (throuableInfo == THROUGHABLE_INFO::THROUGHABLE || throuableInfo == THROUGHABLE_INFO::MUST_TO_DOWN);}

	return result;
}

//=========================================================
// 可能な次の手を列挙：子処理：カードを置く
//=========================================================
void InnerInterPretation::GetLegalNextMoveList_PutCard   (vector<Move> &result ) {

	///// どっちの手番？ 
	//vector<int> handCards;
	if (_currentTurn == TURN::BLACK) {

		//handCards = _handCards_BLACK;
		GetLegalNextMoveList_PutCard_TurnDetermined( result, _handCards_BLACK, _handCards_BLACK_Index );
	}
	else if (_currentTurn == TURN::WHITE) {
		//handCards = _handCards_WHITE;
		GetLegalNextMoveList_PutCard_TurnDetermined( result, _handCards_WHITE, _handCards_WHITE_Index);
	}
}
///// ターンを決めた後
void InnerInterPretation::GetLegalNextMoveList_PutCard_TurnDetermined (vector<Move> &result, int handCards[], int length ) {

	/*
		
		カードがないマス目で絞り込んで、
		手札でループして、向きごとに確認。

	*/

	///// 同じIDのカードは一回しか見ませんよ。
	set<int> checkedCardId;
	for ( unsigned int i = 0; i < length; ++i ) {

		if ( checkedCardId.find( handCards[i] ) == checkedCardId.end() ) {
			checkedCardId.insert( handCards[i] );
		}
	}
	set<int>::iterator it;
	

	for ( unsigned int y = 0; y < _boardSizeY; ++y) {
		for ( unsigned int x = 0; x < _boardSizeX; ++x) {

			/*
				全体分の空きマス数を効果範囲の数で累乗。
				(空きマス数 / 全マス数)^効果範囲の数
			*/
			// このエリアの全マス数
			int allGridNum = _areaList[y][x].gridNumber_X + _areaList[y][x].gridNumber_Y;

			// 空きマス数が欲しい：空きマス＝通行不可のマス
			int blankGridNum = allGridNum - _areaList[y][x].throuable_Number - _areaList[y][x].throuable_UP_Number - _areaList[y][x].throuable_DOWN_Number - _areaList[y][x].throuable_LEFT_Number - _areaList[y][x].throuable_RIGHT_Number;

			// 空きマスがない場合は置けるわけがない
			if ( blankGridNum == 0 ) {
				continue;
			}

			///// 手札でループ
			for ( it = checkedCardId.begin(); it != checkedCardId.end(); ++it) {

				// カード番号から、カードの中身を取得
				Card card = AI::GetCardInfo( *it );

				// 影響マスリストの数
				int effectListSize = card.gridAffectionList.size();

				// 影響マスが０の場合は、方向が無関係。空きマスがありさえすれば置ける。
				if ( effectListSize == 0 ) {

					Move move;
					move.turn   = _currentTurn;
					move.action = MOVE::ACTION::PUT_CARD;
					move.putCardX = x;
					move.putCardY = y;
					move.putCardId = card.processId;
					move.putCardDirection = DIRECTION::UP;
						
					result.push_back(move);

					continue;
				}

				// UP向きで置けるかどうか、くじびき
				if (GetLegalNextMoveList_PutCard_Lot( blankGridNum, allGridNum, effectListSize)) {

					Move move;
					move.turn   = _currentTurn;
					move.action = MOVE::ACTION::PUT_CARD;
					move.putCardX = x;
					move.putCardY = y;
					move.putCardId = card.processId;
					move.putCardDirection = DIRECTION::UP;
						
					result.push_back(move);
				}
				// DOWN向きで置けるかどうか、くじびき
				if (GetLegalNextMoveList_PutCard_Lot( blankGridNum, allGridNum, effectListSize)) {

					Move move;
					move.turn   = _currentTurn;
					move.action = MOVE::ACTION::PUT_CARD;
					move.putCardX = x;
					move.putCardY = y;
					move.putCardId = card.processId;
					move.putCardDirection = DIRECTION::DOWN;
						
					result.push_back(move);
				}
				// LEFT向きで置けるかどうか、くじびき
				if (GetLegalNextMoveList_PutCard_Lot( blankGridNum, allGridNum, effectListSize)) {

					Move move;
					move.turn   = _currentTurn;
					move.action = MOVE::ACTION::PUT_CARD;
					move.putCardX = x;
					move.putCardY = y;
					move.putCardId = card.processId;
					move.putCardDirection = DIRECTION::LEFT;
						
					result.push_back(move);
				}
				// RIGHT向きで置けるかどうか、くじびき
				if (GetLegalNextMoveList_PutCard_Lot( blankGridNum, allGridNum, effectListSize)) {

					Move move;
					move.turn   = _currentTurn;
					move.action = MOVE::ACTION::PUT_CARD;
					move.putCardX = x;
					move.putCardY = y;
					move.putCardId = card.processId;
					move.putCardDirection = DIRECTION::RIGHT;
						
					result.push_back(move);
				}
				
			} ///// 手札でループ
		} // for X
	} // for Y
}
//=========================================================
// 全体分の空きマス数を効果範囲の数で累乗。
// (空きマス数 / 全マス数)^効果範囲の数
//=========================================================
bool InnerInterPretation::GetLegalNextMoveList_PutCard_Lot ( int blankGridNum, int allGridNum, int effectGridListNum) {

	bool result = false;

	int numerator   = Utils_Cal::Pow(blankGridNum, effectGridListNum);
	int denominator = Utils_Cal::Pow(allGridNum, effectGridListNum);

	int lot = Utils_Cal::GerRandom( denominator );

	if (lot < numerator) {
		result = true;
	}

	return result;
}


//=========================================================
// 盤の範囲内？
//=========================================================
bool InnerInterPretation::IsWithinBoardLimit( int x, int y ) {

	bool result = false;

	if ( y >= 0 && y < _boardSizeY ) {

		if ( x >= 0 && x < _boardSizeX ) {
			result = true;
		}
	}

	return result;
}

//=========================================================
// 可能な次の手を列挙：子処理：カードを取る
//=========================================================
void InnerInterPretation::GetLegalNextMoveList_TakeCard  (vector<Move> &result ){

	/*
		自分の駒があって、カードがあるマス目の分、手を生成
	*/

	set<int> takenCatdIndexList;
	set<int>::iterator takenCatdIndexList_It;

	if (_currentTurn == TURN::BLACK) {

		for ( unsigned int y = 0; y < _boardSizeY; ++y) {

			for ( unsigned int x = 0; x < _boardSizeX; ++x) {

				// 最低限、自分の駒と、カードがあることが前提
				if ( _areaList[y][x].blackNumber > 0 && _areaList[y][x].cardNumber > 0) {

					// 何枚取れるのかをシミュレート
					int takenCardNum = 
						GetLegalNextMoveList_TakeCard_HowManyCardsCanITake (
							_areaList[y][x].gridNumber_X * _areaList[y][x].gridNumber_Y,
							_areaList[y][x].cardNumber,
							_areaList[y][x].blackNumber
						);

					// では具体的に、どのカードを取るのか？
					if ( takenCardNum > 0 ) {

						takenCatdIndexList.clear();

						Utils_Cal::GetRandom_WithoutDuplicate ( takenCatdIndexList, takenCardNum, 0, _areaList[y][x].cardNumber );

						takenCatdIndexList_It = takenCatdIndexList.begin();
						while ( takenCatdIndexList_It != takenCatdIndexList.end() ) {

							int index = *takenCatdIndexList_It;

							Move move;
							move.takeCardCardId = _areaList[y][x].cardList[ index ].cardId;
							move.turn   = _currentTurn;
							move.action = MOVE::ACTION::TAKE_CARD;
							move.takeCardX = x;
							move.takeCardY = y;

							result.push_back( move );

							++takenCatdIndexList_It;
						}

					}

				}
			}
		}
	}
	else if (_currentTurn == TURN::WHITE) {

		for ( unsigned int y = 0; y < _boardSizeY; ++y) {

			for ( unsigned int x = 0; x < _boardSizeX; ++x) {

				// 最低限、自分の駒と、カードがあることが前提
				if ( _areaList[y][x].whiteNumber > 0 && _areaList[y][x].cardNumber > 0) {

					// 何枚取れるのかをシミュレート
					int takenCardNum = 
						GetLegalNextMoveList_TakeCard_HowManyCardsCanITake (
							_areaList[y][x].gridNumber_X * _areaList[y][x].gridNumber_Y,
							_areaList[y][x].cardNumber,
							_areaList[y][x].whiteNumber
						);

					// では具体的に、どのカードを取るのか？
					if ( takenCardNum > 0 ) {

						takenCatdIndexList.clear();

						Utils_Cal::GetRandom_WithoutDuplicate ( takenCatdIndexList, takenCardNum, 0, _areaList[y][x].cardNumber );

						takenCatdIndexList_It = takenCatdIndexList.begin();
						while ( takenCatdIndexList_It != takenCatdIndexList.end() ) {

							int index = *takenCatdIndexList_It;

							Move move;
							move.takeCardCardId = _areaList[y][x].cardList[ index ].cardId;
							move.turn   = _currentTurn;
							move.action = MOVE::ACTION::TAKE_CARD;
							move.takeCardX = x;
							move.takeCardY = y;

							result.push_back( move );

							++takenCatdIndexList_It;
						}

					}

				}
			}
		}
	}

}
//=========================================================
// 何枚のカードを取れるか、シミュレーション
//=========================================================
int InnerInterPretation::GetLegalNextMoveList_TakeCard_HowManyCardsCanITake ( int allGridNum, int cardNum, int pieceNum ) {

	int result = 0;

	int larger  = ( cardNum > pieceNum ) ? cardNum : pieceNum;
	int smaller = ( cardNum > pieceNum ) ? pieceNum : cardNum;

	for ( int i = 0; i < smaller; ++i ) {

		int lot = Utils_Cal::GerRandom( allGridNum );

		// 入った？
		if ( lot < larger ) {
			++result;
			--larger;
		}

		--allGridNum;
	}

	return result;
}
//=========================================================
// どのカードを取るのか？ シミュレート
//=========================================================
void InnerInterPretation::GetLegalNextMoveList_WhichCardWllITake ( int *result, int cardNum, int takenCardNum ) {



}


//=========================================================
// コンソールに様子を表示：デバッグ用
//=========================================================
void InnerInterPretation::ShowToConsole() {

	printf("-----------------------------------------\n");
	for ( unsigned int y = 0; y < _boardSizeY; ++y ) {

		for ( unsigned int x = 0; x < _boardSizeX; ++x ) {

			printf( "黒%d 白%d", _areaList[y][x].blackNumber, _areaList[y][x].whiteNumber);
		}
		printf("\n");
	}
	printf("-----------------------------------------\n");

}






