//=========================================================
//
// 指し手
//
//=========================================================

#ifndef _MOVE_
#define _MOVE_

namespace AI_Modules {

	struct Move {

		int turn; // 黒が？ 白が？

		// 何をする？ 駒を打つ・カードを置く・駒を動かす・カードを取る
		int action;

		// 駒を打つ場合：どこへ？
		int putPieceX;
		int putPieceY;

		// カードを置く場合：どのカードを？ どこへ？ どの向きに？
		int putCardId;
		int putCardX;
		int putCardY;
		int putCardDirection;

		// 駒を動かす場合：どこから？ どこへ？ ぶつける？
		int movePieceFromX;
		int movePieceFromY;
		int movePieceToX;
		int movePieceToY;
		bool movePieceAndIsCllide;
		int movePieceAndCllidedPieceColor; // GRID 「エリア」で解釈する場合に必要。直視する場合は不要。

		// カードを取る場合：どこの？
		int takeCardX;
		int takeCardY;
		int takeCardCardId; // 「エリア」で解釈する場合に必要。直視する場合には不要。


		Move() {
			turn = 0;
			action = 0;
			putPieceX = 0;
			putPieceY = 0;
			putCardId = 0;
			putCardX = 0;
			putCardY = 0;
			putCardDirection = 0;
			movePieceFromX = 0;
			movePieceFromY = 0;
			movePieceToX = 0;
			movePieceToY = 0;
			movePieceAndIsCllide = false;
			movePieceAndCllidedPieceColor = 0;
			takeCardX = 0;
			takeCardY = 0;
			takeCardCardId = -1;
		}
	};

	///// 巻き戻し用
	struct MoveForBack {
		
		Move previousMove;
		int tookCardId;
		int tookCardDirection; // どの向きに置かれていたか？
		int cllidedPieceColor; // GRID		
		int cllidedX;
		int cllidedY;
		
		bool isValid; 

		MoveForBack() {
			tookCardId = -1;
			tookCardDirection = 0;
			cllidedPieceColor = 0;
			cllidedX = -1;
			cllidedY = -1;
			isValid = false;
		}
	};

};
#endif

