//=========================================================
//
// Button (declare)
//
//=========================================================

#ifndef _BUTTON_
#define _BUTTON_

#include <map>
#include <vector>
#include <string>

#include <SFML/Window.hpp>
#include <SFML/Graphics.hpp>

using namespace std;

namespace GUI_SFML {

	namespace BUTTON {
		namespace STATE {
			const int NONAL = 0;
			const int OVER  = 1;
			const int PUSH  = 2;
			const int RELEASE  = 3;
		};
	};

	class Button {

		public:
			
			// 画像を使う場合のデータ構造体
			struct ImageProperty {
		
				string       imageFile;
				sf::Vector2f size;
				sf::IntRect  rect_Normal;
				sf::IntRect  rect_Over;
				sf::IntRect  rect_Push;
				
				ImageProperty () {
					imageFile = "";
				}
			};
			void SetImageData ( ImageProperty prop );

			Button(string label, sf::Vector2f size, int labelFontSize = 14);
			~Button();

			void Update(sf::RenderWindow &window);
			void Draw(sf::RenderWindow &window);

			void SetPosition(sf::Vector2f arg);
			void SetPositionX( float x ) { _position.x = x; SetPosition(_position); }
			void SetPositionY( float y ) { _position.y = y; SetPosition(_position); }
			void SetSize(sf::Vector2f arg);
			void SetSpritePositionOffset(sf::Vector2f arg);

			bool IsPush();
			bool IsOver();
			bool IsRelease();
			bool IsNomal();

			void SetColor_Nomal( sf::Color color );
			void SetColor_Over ( sf::Color color );
			void SetColor_Push ( sf::Color color );
			
			void SetVisible(bool value) {_isVisible = value;}
	protected:

			bool _isVisible;

			int _currentState;

			sf::Vector2f _position;
			sf::Vector2f _size;
			int          _fontSize;

			string      _label;
			/*
			sf::Image   _labelImage;
			sf::Texture _labelTexture;
			sf::Sprite _sprite;
			*/
			ImageProperty _imageData;
			sf::Texture _labelTexture;
			sf::RectangleShape _labelSprite;
			
			sf::Vector2f _spritePositionOffset;

			sf::Color _color_Nomal;
			sf::Color _color_Over;
			sf::Color _color_Push;
			
			sf::Text _labelText;

			sf::RectangleShape _base;
			
			bool _pushedWhenMouseOut;
	};
}
#endif

