//=========================================================
//
// Imagae Manager (implement)
//
//=========================================================

//#include "StdAfx.h"
#include "ImageManager.h"

map<string, sf::Image*> ImageManager::_imageList;

//=========================================================
// release
//=========================================================
void ImageManager::Release() {

	while ( _imageList.size() > 0 ) {

		delete _imageList.begin()->second;
		_imageList.erase( _imageList.begin() );
	}

}

//=========================================================
// GetImage with transparent background color
//=========================================================
sf::Image* ImageManager::GetImage( string fileName, sf::Color maskColor ) {

	sf::Image* result = GetImage( fileName );
	result->createMaskFromColor( maskColor );
	return result;
}

//=========================================================
// GetImage
//=========================================================
sf::Image* ImageManager::GetImage( string fileName ) {
	
	//printf("画像を開くぞ (%s)\n", fileName.c_str());
	
	sf::Image* result = NULL;

	map<string, sf::Image*>::iterator findIt = _imageList.find(fileName);

	if ( findIt != _imageList.end() ) {

		result = findIt->second;

	} else {

		result = new sf::Image();
		bool r = result->loadFromFile( fileName );
		//result->setSmooth(false);
		
		_imageList.insert( pair<string, sf::Image*>( fileName, result ) );
		
		if (!r) { printf("画像開けず：%s\n", fileName.c_str()); }
		
	}

	return result;
}



