//=========================================================
//
// Slider (declare)
//
//=========================================================

#ifndef _SLIDER_
#define _SLIDER_

#include <map>
#include <vector>
#include <string>

#include <SFML/Window.hpp>
#include <SFML/Graphics.hpp>

using namespace std;

namespace GUI_SFML {

class Button;
class Button;

class Slider {

public:

	struct InitProp {
		
		float length;
		int range_min;
		int range_max;
		
		sf::Color railColor;
		sf::Color trigerColor;
		
		sf::Vector2f position;
		int value;
		
		bool isButton;

		InitProp() {
			
			length = 100.0f;
			value = 0;
			range_min = 0;
			range_max = 100;
			position = sf::Vector2f (0.0f, 0.0f);
			railColor   = sf::Color(128, 64,32,255);
			trigerColor = sf::Color(255,128,64,255);
			isButton = false;
		}

	};

	Slider(InitProp initProp);
	~Slider();

	void Update(sf::RenderWindow &window);
	void Draw(sf::RenderWindow &window);

	int  GetCurrentValue();
	void SetCurrentValue( int value );

	void SetPosition( sf::Vector2f pos );

private:

	sf::Vector2f _position;
	float        _length;

	sf::RectangleShape _rail;
	sf::RectangleShape _trigger;

	sf::Vector2f _trigerSize;

	int _range_min;
	int _range_max;

	float _currentTriggerPosition;


	bool _isGrabbing;
	int _mouseX_previous;
	
	bool _isMousePressed;
	
	bool _isMousePushedOnThis;

	bool _isButton;
	Button *_button_toMin;
	Button *_button_toMax;


	bool isMouseOverTheTriger( int mouseX, int mouseY );
	bool isMouseOverTheTriger_LeftPart( int mouseX, int mouseY );
	bool isMouseOverTheTriger_RightPart( int mouseX, int mouseY );

	
	float GetOnePointLength();

};
};

#endif
