//=========================================================
//
// 簡易サウンドプレイヤー
//
//=========================================================

#include "SoundPlayer.h"

using namespace GUI_SFML;

//=========================================================
// 宣言
//=========================================================
map<string, sf::SoundBuffer> SoundPlayer::_soundBufferList;
vector<sf::Sound*>            SoundPlayer::_soundChannelList;
float SoundPlayer::_volume = 100.0f;



//=========================================================
// 音量設定
//=========================================================
void  SoundPlayer::SetVolume( float value ) { 
	
	_volume = value; 
	
	for (unsigned int i = 0; i < _soundChannelList.size(); ++i) {
		_soundChannelList[i]->setVolume( _volume );
	}
}
float SoundPlayer::GetVolume() { return _volume; }
		

//=========================================================
// 後始末
//=========================================================
void SoundPlayer::Release() {

	for ( unsigned int i = 0; i < _soundChannelList.size(); ++i ) {

		_soundChannelList[i]->stop();

		delete _soundChannelList[i];
	}
	_soundChannelList.clear();
}
//=========================================================
// 音を鳴らす
//=========================================================
void SoundPlayer::Play( string file ) {

	// 最初だけ、チャンネルを生成
	if ( _soundChannelList.size() == 0 ) {

		for (int i = 0; i < 10; ++i) {
			sf::Sound *sound = new sf::Sound();
			sound->setVolume(_volume);
			_soundChannelList.push_back ( sound );
		}

	}
	// 音を鳴らす？
	if ( file == "" ) {
		return;
	}


	// バッファになければ登録
	if ( _soundBufferList.find(file) == _soundBufferList.end() ) {
		_soundBufferList[file].loadFromFile (file);
	}

	int useIndex = 0;
	for ( unsigned int i = 0; i < _soundChannelList.size(); ++i ) {

		if ( _soundChannelList[i]->getStatus() == sf::Sound::Status::Stopped) {
			useIndex = i;
			break;
		}
	}
	_soundChannelList[useIndex]->stop();
	_soundChannelList[useIndex]->setBuffer(_soundBufferList[file]);
	_soundChannelList[useIndex]->play();

}


