//=========================================================
//
// エフェクトリスト
//
//=========================================================

#include "EffectList.h"
#include "Application.h"
#include "EffectManager.h"

//=========================================================
// コンストラクタ
//=========================================================
EffectList::EffectList( map< unsigned int, IEffect*> effectList ) {

	_effectList = effectList;

	_isEnd = false;
	_frameCount = 0;
}

//=========================================================
// デストラクタ
//=========================================================
EffectList::~EffectList () {

	while ( _effectList.size() > 0 ) {

		delete _effectList.begin()->second;
		_effectList.erase(_effectList.begin());
	}
}

//=========================================================
// 更新
//=========================================================
bool EffectList::Update(sf::RenderWindow &window) {

	if ( _isEnd ) { return _isEnd; }

	map<unsigned int, IEffect*>::iterator findIt = _effectList.find ( _frameCount );
	if ( findIt != _effectList.end() ) {

		Application::GetInstance()->_effectManager->Add ( findIt->second );

		_effectList.erase ( findIt );
	}

	if ( _effectList.size() == 0 ) {
		_isEnd = true;
	}


	++_frameCount;

	return _isEnd;
}

//=========================================================
// 描画
//=========================================================
void EffectList::Draw(sf::RenderWindow &window) {

	// なし
}

