//=========================================================
//
// フェード（アウトもインも）
//
//=========================================================

#ifndef _FADE_
#define _FADE_

#include <SFML/Graphics.hpp>
#include <string>

using namespace std;

class Fade {

public:

	Fade();
	~Fade();

	void Update ( sf::RenderWindow &window );
	void Draw   ( sf::RenderWindow &window );

	void FadeOut( int speed );
	void FadeIn ( int speed );

	bool IsStabilized();
	
	void Stabilize(); // つまり早送りのとき用：強制的にその時点の動きを完遂させる。フェードインならフェードインしきる。

	void SetFadeTexture ( string fileName );
	void SetColor_FadeInStart  ( sf::Color color ) { _color_FadeInStart  = color; }
	void SetColor_FadeOutStart ( sf::Color color ) { _color_FadeOutStart = color; }
	
	string GetFadeTexture () { return _textureFileName; }
	sf::Color GetColor_FadeInStart  () { return _color_FadeInStart; }
	sf::Color GetColor_FadeOutStart () { return _color_FadeOutStart; }
	

private:

	///// FadeOut用のデータ
	struct Prop_FadeOut {
		int speed;
	};
	Prop_FadeOut _prop_FadeOut;
	///// FadeIn用のデータ
	struct Prop_FadeIn {
		int speed;
	};
	Prop_FadeOut _prop_FadeIn;

	///// 今何をしているところなのか？ を表す定数
	const static int STATE_FADE_OUT_ing = 1;
	const static int STATE_FADE_OUT_ed  = 2;
	const static int STATE_FADE_IN_ing  = 3;
	const static int STATE_FADE_IN_ed   = 4;


	int _currentState; // 初期状態は STATE_FADE_IN_ed

	sf::RectangleShape _rectangleShape;
	sf::Texture _texture;
	string _textureFileName;

	sf::Color _color_FadeOutStart;
	sf::Color _color_FadeInStart;

	//=========================================================
	// 各動作を開始するときの処理。前準備
	//=========================================================
	void ToStart_FadeOut();
	void ToStart_FadeIn();

	//=========================================================
	// 各動作の処理
	//=========================================================
	void Process_FadeOut();
	void Process_FadeIn();

};
#endif
