//=========================================================
//
// セーブデータ間で共有のデータ、のセーブデータ
//
//=========================================================

#ifndef _GLOBAL_SAVE_DATA_
#define _GLOBAL_SAVE_DATA_

#include <string>
#include <map>

#include "SaveData.h"
#include "ScriptEngine.h"
#include "ReadTextManager.h"

using namespace std;


class GlobalSaveData {

public:

	//=========================================================
	// コンストラクタ
	// ファイル名を必ず受け取るのです。
	//=========================================================
	GlobalSaveData( string fileName );

	//=========================================================
	// デストラクタ
	//=========================================================
	~GlobalSaveData();

	//=========================================================
	// 読み込み
	// ファイルを読み込んで内容を受け取る。
	// もともと持っていた変数の値とかは、消される。
	//=========================================================
	void Load();

	//=========================================================
	// 書き込み
	// ファイルに書き込む。
	// ファイルのもともとの内容は、消される。
	//=========================================================
	void Save();

	//=========================================================
	// セーブ（このSaveDataオブジェクトに、状態を）
	//=========================================================
	void Save_GlobalVariable_Int    ( map <string, int>    &variable_Global_Int    );
	void Save_GlobalVariable_String ( map <string, string> &variable_Global_String );
	void Save_ReadData              ( ReadTextManager *readTextManager  );


	//=========================================================
	// ロード（この SaveDataオブジェクトから、状態を）
	//=========================================================
	void Load_GlobalVariable_Int    ( map <string, int>    &variable_Global_Int    );
	void Load_GlobalVariable_String ( map <string, string> &variable_Global_String );
	void Load_ReadData              ( ReadTextManager *readTextManager  );

private:

	///// バインド？ わかちがたく関連づけられるファイルのファイル名。ファイルのファイル名。
	string _fileName;

	///// セーブする中身
	map < string, int>        _saveData_variable_Int;       // ローカル変数：数値
	map < string, string>     _saveData_variable_String;    // ローカル変数：文字列
	vector<ReadTextManager::SaveData> _saveData_readData;   // 既読データ

	//=========================================================
	// 書き込める形式で書き込む
	//=========================================================
	void WriteSaveData ( vector<SaveData::SaveDataUnit> &saveDataUnit );

	//=========================================================
	// ともかく読み込みます。
	//=========================================================
	void ReadSaveData ( map<string, SaveData::SaveDataUnit> &result );

};

#endif

