//=========================================================
//
// 口出しモードの状況表示パネル
//
//=========================================================

#include "InterfereModePanel.h"
#include "../GUI_SFML/TextImageFactory.h"
#include "TextLabel.h"
#include "Image.h"
#include "../Utils/Utils_Convert.h"

//=========================================================
// コンストラクタ
//=========================================================
InterfereModePanel::InterfereModePanel() {
	
	_backImage = new Image();
	_backImage->ChangeImage ( "./image/textMessageWindow/vita-chi.net/avg1_blue_half.png", Image::CHANGE_IMAGE_EFFECT_NONE );
	
	_textLabel = new TextLabel("");
	_textLabel->SetFont ( TextImageFactory::_font);
	_textLabel->SetText("口出しモード");
	_textLabel->SetSize ( 24 );
	_textLabel->SetColor ( sf::Color(255,255,255,255) );
	
	SetPosition ( sf::Vector2f(0.0f, 0.0f) );
	
	
	_caption = "口出し回数 残り：";
	_maxTimes = 0;
	_currentTimes = 0;
	ToBeTextUpToDate();
	
}

//=========================================================
// 表示文字列を作成
//=========================================================
void InterfereModePanel::ToBeTextUpToDate() {
	
	_tobeText = _caption + Utils_Convert::Int_to_String( _maxTimes - _currentTimes) + "回";
}
//=========================================================
// デストラクタ
//=========================================================
InterfereModePanel::~InterfereModePanel() {
	
	delete _backImage;
	delete _textLabel;
}

//=========================================================
// 更新
//=========================================================
void InterfereModePanel::Update ( sf::RenderWindow &window ) {
	
	string currentText = _textLabel->GetText();
	
	if ( currentText != _tobeText ) {

		_textLabel->SetText ( _tobeText );
		
		 sf::Vector2f rect = _textLabel->GetBoundarySize();
		 
		 sf::Vector2f backPos = _backImage->GetCurrentPosition();

		_textLabel->SetPosition (
			sf::Vector2f(
						backPos.x - rect.x/2,
						backPos.y - rect.y/2
						)
		);
	}
	
	
	_backImage->Update(window);
	_textLabel->Update(window);
	
}

//=========================================================
// 描画
//=========================================================
void InterfereModePanel::Draw   ( sf::RenderWindow &window ) {

	_backImage->Draw(window);
	_textLabel->Draw(window);
	
}


//=========================================================
// 位置を設定
//=========================================================
void InterfereModePanel::SetPosition  ( sf::Vector2f pos ) { 
	
	_position = pos;

	_backImage->SetPosition ( _position );
	
	
	 sf::Vector2f rect = _textLabel->GetBoundarySize();
	 
	_textLabel->SetPosition (
		sf::Vector2f(
					_position.x - rect.x/2.0f,
					_position.y - rect.y/2.0f
					)
	);

}

//=========================================================
// 値を設定
//=========================================================
void InterfereModePanel::SetMaxTimes ( int arg ) {

	_maxTimes = arg;
	
	ToBeTextUpToDate();
}
void InterfereModePanel::SetCurrentTimes ( int arg ) {

	_currentTimes = arg;
	
	ToBeTextUpToDate();
	
}











