//=========================================================
//
// 口出しモードの状況表示パネル
//
//=========================================================

#ifndef _INTERFARE_MODE_PANEL_
#define _INTERFARE_MODE_PANEL_

#include <SFML/Graphics.hpp>

#include <vector>
#include <string>

using namespace std;

class Image;
class TextLabel;

class InterfereModePanel {

public:

	InterfereModePanel();
	~InterfereModePanel();

	void Update ( sf::RenderWindow &window );
	void Draw   ( sf::RenderWindow &window );

	sf::Vector2f GetPosition() { return _position; }
	void SetPosition  ( sf::Vector2f pos );
	void SetPosition  ( float x, float y ) { SetPosition ( sf::Vector2f(x, y) ); }
	void SetPositionX ( float x )          { SetPosition ( x, _position.y); }
	void SetPositionY ( float y )          { SetPosition ( _position.x, y); }

	//=========================================================
	// 値を設定
	//=========================================================
	void SetMaxTimes ( int arg );
	void SetCurrentTimes ( int arg );


private:

	///// 位置
	sf::Vector2f _position;
	
	///// グラフィック的なもの：背景画像と文言
	Image *_backImage;
	TextLabel *_textLabel;
	
	///// 表示するデータ的なもの
	/*
		口出し回数残り
	*/
	string _caption;
	int _currentTimes;
	int _maxTimes;
	
	string _tobeText;    // あるべき文言
	
	
	void ToBeTextUpToDate();
	
	

};


#endif
