//=========================================================
//
// メニューでの設定項目
//
//=========================================================

#ifndef _MENU_ITEM_
#define _MENU_ITEM_

#include <SFML/Graphics.hpp>

#include <vector>
#include <string>

using namespace std;

class MenuItemOption;

class MenuItem {

public:

	//=========================================================
	// ラベルと値のセットを受け取る
	//【引数】
	// この項目の名前と、選択肢のリスト
	//=========================================================
	MenuItem( string name, vector < pair <string, string> > initData, string label );
	~MenuItem();

	void Update ( sf::RenderWindow &window );
	void Draw   ( sf::RenderWindow &window );

	sf::Vector2f GetPosition() { return _position; }
	void SetPosition  ( sf::Vector2f pos ) { _position = pos; }
	void SetPositionX ( float x )          { _position.x = x; }
	void SetPositionY ( float y )          { _position.y = y; }

	//=========================================================
	// 値をセット。該当の値と一致する選択肢を選択状態にする
	//=========================================================
	void SetValue ( string arg );

	//=========================================================
	// 選択されている項目の値を取得
	//=========================================================
	string GetValue();

	string GetName() { return _name; }

private:

	struct ImageSet {
		sf::Image image;
		sf::Texture texture;
		sf::Sprite sprite;

		void Update () {
			texture.loadFromImage(image);
			sprite = sf::Sprite();
			sprite.setTexture(texture);
		}
	};
	
	///// 位置
	sf::Vector2f _position;

	string _name;

	vector < MenuItemOption* > _optionList;

	//ImageSet _imageSet;
	sf::Text _label;

	//=========================================================
	// 選択肢の選択状態を監視
	//=========================================================
	void ObserveOptionsSelectState();
};


#endif
