//=========================================================
//
// メニューでの設定項目の選択肢
//
//=========================================================

#ifndef _MENU_ITEM_OPTION_
#define _MENU_ITEM_OPTION_

#include <SFML/Graphics.hpp>

#include <string>

using namespace std;

class MenuItemOption {

public:

	MenuItemOption ( string label, string value );
	~MenuItemOption();

	void Update ( sf::RenderWindow &window );
	void Draw   ( sf::RenderWindow &window );

	void SetSelected ( bool arg = true ) {_isSelected = arg;}
	bool IsSelected () { return _isSelected; }
	
	string GetValue() { return _value; }

	sf::Vector2f GetPosition() { return _position; }
	void SetPosition  ( sf::Vector2f pos ) { _position = pos; }
	void SetPositionX ( float x )          { _position.x = x; }
	void SetPositionY ( float y )          { _position.y = y; }

	bool IsMouseOver() { return _isMouseOver; }

	sf::Vector2f GetSize() { return _frame.getSize();}

private:

	struct ImageSet {
		sf::Image image;
		sf::Texture texture;
		sf::Sprite sprite;

		void Update () {
			texture.loadFromImage(image);
			sprite = sf::Sprite();
			sprite.setTexture(texture);
		}
	};

	///// 値はですね、もうですね、文字列で持つことにしてしまうのですー。文字列大好き！
	string _value;

	///// 選択されている状態？
	bool _isSelected;
	
	///// 見た目
	ImageSet _imageSet;
	sf::RectangleShape _frame;
	string _label;
	sf::RectangleShape _frame_Selected;

	///// マウスが乗っている？
	bool _isMouseOver;

	///// 位置
	sf::Vector2f _position;


	//=========================================================
	// マウスが乗っているかどうかを監視
	//=========================================================
	void ObserveMouseOver();
};

#endif