//=========================================================
//
// 既読管理クラス Read は 過去形または過去分詞の Read
//
//=========================================================

#ifndef _READ_TEXT_MANAGER_
#define _READ_TEXT_MANAGER_

#include <map>
#include <vector>
#include <string>

using namespace std;

class ReadTextManager {

public:

	//=========================================================
	// なんだか定数
	//=========================================================
	static const int ALL_FINISHED;

	ReadTextManager();
	~ReadTextManager();

	//=========================================================
	// このユニットは既読になりました
	//=========================================================
	void Finished ( string processLabel, int unitIndex );

	//=========================================================
	// このユニットのｎ文字目まで既読になりました
	//=========================================================
	void Finished ( string processLabel, int unitIndex, int byThisCharIndex );

	//=========================================================
	// このユニットは既読ですか？
	//=========================================================
	bool IsFinished ( string processLabel, int unitIndex );

	//=========================================================
	// このユニットは何文字目まで既読ですか？
	//=========================================================
	int GetReadFinishedLength ( string processLabel, int unitIndex );


	//=========================================================
	// セーブ/ロード用のインターフェイス
	//=========================================================
	struct SaveData {

		string processLabel;  // このプロセスの
		int    unitIndex;     // このユニット（Textタグ）の
		int    byCharIndex;   // ここまで既読ですよ。

		SaveData () {
			processLabel = "";
			unitIndex    = 0;
			byCharIndex  = 0;
		}
	};
	vector<SaveData> GetSaveData ();
	void Load ( vector<SaveData> &saveDataList );

private:

	///// 既読データ
	/*
		map < プロセスラベル, map < ユニット番号, 何文字目まで既読> >

		ユニットごと全部既読のときは、何文字目、を、-1でも入れておく？ うん。それで。
	*/
	map < string, map <int, int> > _readData;


	//=========================================================
	// このレコードある？ なければ作成。
	//=========================================================
	int  GetRecord ( string processLabel, int unitIndex );

};
#endif
