//=========================================================
//
// セーブデータさんへのアクセスはこの私をお通し下さい。
//
//=========================================================

#include "Application.h"
#include "Define.h"
#include "SaveDataManager.h"
#include "SaveData.h"
#include "ScriptEngine.h"
#include "../GUI_SFML/TextImageFactory.h"
#include "../GUI_SFML/SFML_Utils.h"
#include "ClickableImage.h"

//// WIN API
#include <time.h>
#include <windows.h>
#include <process.h>

using namespace GUI_SFML;
using namespace std;

//=========================================================
// セーブ？ ロード？ キミは何がしたいんだい？
//=========================================================
const int SaveDataManager::MODE_NONE = 0; // つまり非表示
const int SaveDataManager::MODE_SAVE = 1; 
const int SaveDataManager::MODE_LOAD = 2;

//=========================================================
// コンストラクタ
//=========================================================
SaveDataManager::SaveDataManager( ScriptEngine *scriptEngine ) {

	// ようこそー。
	_scriptEngine = scriptEngine;

	_mode = MODE_NONE;
	_position.x = 130;
	_position.y = 20;
	
	_scrollBar = NULL;
	_isGetSaveDataListDone = false;
	_progressBar = new ProgressBar(sf::Vector2f(200, 20), 100.0f, "%");
	_progressBar->SetValue(0.0f);
	_progressBar->SetPosition ( sf::Vector2f(300, 300) );
	
	/*
	///// 読み込みスレッドを作成・開始
	(HANDLE)_beginthreadex ( NULL, 0, SaveDataManager::GetSaveDataList_Entrance, this, 0, NULL );

	//_getSaveDataList_ThreadHandle = std::thread ( SaveDataManager::GetSaveDataList_Entrance, this );
	//_getSaveDataList_ThreadHandle.detach();
	*/
	
	// スレッド化をあきらめる。
	GetSaveDataList();
	
/*
	///// セーブデータをいっぱい持ってみるー
	for ( int i = 0; i < 100; ++i ) {

		string fileName = "";
		char str[512];

		sprintf ( str, "./data/save/saveData%03d.sav", i );
		fileName = str;

		SaveData *saveData = new SaveData ( fileName, i );
		saveData->LoadAppearance();

		_saveDataList.push_back ( saveData );
	}


	_scrollBar = new ScrollBar();
	//_scrollBar->SetMaxLength(_saveDataList.size());
	_scrollBar->SetActualLength(_saveDataList.size());
	//_scrollBar->SetLengthOfOneItem(100.0f);
	_scrollBar->SetDisplayLength(5);// LengthOfOneItem(100.0f);
	_scrollBar->SetFrameSize(sf::Vector2f(20.0f, 500.0f));
	_scrollBar->SetPosition( sf::Vector2f(670.0f, 70.0f) );
	_scrollBar->IsUpDownButton(false);
*/

	/*
	TextImageFactory::Create ( _modeLabel_Load.image, "Load", 20, sf::Color ( 255,255,255,255 ) );
	_modeLabel_Load.Update();
	_modeLabel_Load.sprite.setPosition ( sf::Vector2f ( 100, 25 ) );

	TextImageFactory::Create ( _modeLabel_Save.image, "Save", 20, sf::Color ( 255,255,255,255 ) );
	_modeLabel_Save.Update();
	_modeLabel_Save.sprite.setPosition ( sf::Vector2f ( 100, 25 ) );
	*/
	
	/*
	_modeLabel_Load.setFont ( *_scriptEngine->GetFont() );
	_modeLabel_Load.setString ( GUI_SFML::SFML_Utils::GetSfString("[Load]") );
	_modeLabel_Load.setColor ( sf::Color::White );
	_modeLabel_Load.setCharacterSize(22);
	_modeLabel_Load.setPosition( sf::Vector2f(130,40));
	
	_modeLabel_Save.setFont ( *_scriptEngine->GetFont() );
	_modeLabel_Save.setString ( GUI_SFML::SFML_Utils::GetSfString("[Save]") );
	_modeLabel_Save.setColor ( sf::Color::White );
	_modeLabel_Save.setPosition( sf::Vector2f(130,40));
	_modeLabel_Save.setCharacterSize( 22 );
	*/
	_modeLabel_Load.texture.loadFromFile ( "./image/menu/windowCaption_load.png" );
	_modeLabel_Load.sprite.setTexture    ( _modeLabel_Load.texture );
	_modeLabel_Load.sprite.setOrigin     ( _modeLabel_Load.texture.getSize().x/2, _modeLabel_Load.texture.getSize().y/2 );
	_modeLabel_Load.sprite.setPosition   ( 400, 45  );

	_modeLabel_Save.texture.loadFromFile ( "./image/menu/windowCaption_save.png" );
	_modeLabel_Save.sprite.setTexture    ( _modeLabel_Save.texture );
	_modeLabel_Save.sprite.setOrigin     ( _modeLabel_Save.texture.getSize().x/2, _modeLabel_Save.texture.getSize().y/2 );
	_modeLabel_Save.sprite.setPosition   ( 400, 45  );

	{
		ClickableImage::Property closeButtonProp;
		
		closeButtonProp.imageFile = "./image/menu/backFromSaveloadWindow.png";
		closeButtonProp.size = sf::Vector2f(100.0f, 30.0f);
		closeButtonProp.rect_Normal = sf::IntRect ( 0, 0,  100, 30 );
		closeButtonProp.rect_Over   = sf::IntRect ( 0, 30, 100, 30 );
		closeButtonProp.rect_Push   = sf::IntRect ( 0, 60, 100, 30 );
		
		_closeButton = new ClickableImage(closeButtonProp);
		
		_closeButton->SetPosition ( sf::Vector2f(695, 540) );
	}
	
	
	_saveData_pushed = NULL;
	
	
	_isConfirmDisplay_Save = false;
	_isConfirmDisplay_Load = false;
	
	_saveData_SaveConfirmed = NULL;
	_saveData_LoadConfirmed = NULL;
	
	_button_yes = NULL;
	_button_no  = NULL;
}

//=========================================================
///// 最初にセーブデータを読み込む処理のスレッド
//=========================================================
static unsigned int SaveDataManager::GetSaveDataList_Entrance ( void *obj ) {
	
	///// インスタンスを取得
	SaveDataManager *self = (SaveDataManager*)obj;

	///// インスタンスごとの処理を呼ぶ。
	self->GetSaveDataList();

	return 0;

}
void SaveDataManager::GetSaveDataList () {
	
	///// セーブデータをいっぱい持ってみるー
	int num = 100;
	for ( int i = 0; i < num; ++i ) {

		string fileName = "";
		char str[512];

		sprintf ( str, "./data/save/saveData%03d.sav", i );
		fileName = str;

		SaveData *saveData = new SaveData ( fileName, i );
		saveData->LoadAppearance();

		_saveDataList.push_back ( saveData );
		
		_GetSaveData_ProgressRate =  float(i) / (float)num * 100.0f;
		//_progressBar->SetValue ( float(i) / (float)num * 100.0f );
		
	}
	
	_scrollBar = new ScrollBar();
	//_scrollBar->SetMaxLength(_saveDataList.size());
	_scrollBar->SetActualLength(_saveDataList.size());
	//_scrollBar->SetLengthOfOneItem(100.0f);
	_scrollBar->SetDisplayLength(5);// LengthOfOneItem(100.0f);
	_scrollBar->SetFrameSize(sf::Vector2f(20.0f, 500.0f));
	_scrollBar->SetPosition( sf::Vector2f(670.0f, 70.0f) );
	_scrollBar->IsUpDownButton(false);
	
	
	_isGetSaveDataListDone = true;
}
	

//=========================================================
// 上書き確認ウィンドウをセットアップ
//=========================================================
void SaveDataManager::SetupConfirmWindow_Save ( SaveData *saveData ) {
	
	_isConfirmDisplay_Save = true;
	
	_saveData_SaveConfirmed = saveData;
		
	int slotNum = _saveData_SaveConfirmed->GetSlotNum();
	string slotNumStr = to_string (slotNum);
	for ( int i = 0; i < 2 - slotNumStr.size(); ++i) {
		slotNumStr = "0" + slotNumStr;
	}
		
	_back_confirmWindow = sf::RectangleShape ( sf::Vector2f ( 400, 200 ) );
	_back_confirmWindow.setFillColor ( sf::Color ( 50,50,150,150 ) );
	_back_confirmWindow.setOutlineThickness (0.0f);
	_back_confirmWindow.setOutlineColor ( sf::Color ( 0,0,0,0 ) );
	_back_confirmWindow.setPosition ( sf::Vector2f ( APPLICATION::WINDOW_SIZE::WIDTH/2, APPLICATION::WINDOW_SIZE::HEIGHT/2 ) );
	_back_confirmWindow.setOrigin ( _back_confirmWindow.getGlobalBounds().width/2, _back_confirmWindow.getGlobalBounds().height/2 );
	
	_text_confirm = TextImageFactory::Create ( "[" + slotNumStr + "]番に上書きします", 24);
	_text_confirm.setFillColor   ( sf::Color::White );
	_text_confirm.setOutlineColor( sf::Color::Black );
	_text_confirm.setOutlineThickness ( 1.0f );
	_text_confirm.setPosition ( 250, 250 );

	if ( _button_yes != NULL ) { delete  _button_yes; }
	if ( _button_no  != NULL ) { delete  _button_no; }

	_button_yes = new Button ( "する",     sf::Vector2f ( 150, 40 ), 24 );
	_button_no  = new Button ( "しない", sf::Vector2f ( 150, 40 ), 24 );
	_button_yes->SetPosition ( sf::Vector2f ( 235, 320 ) );
	_button_no ->SetPosition ( sf::Vector2f ( 405, 320 ) );

}

//=========================================================
// ロード確認ウィンドウをセットアップ
//=========================================================
void SaveDataManager::SetupConfirmWindow_Load ( SaveData *saveData ) {

	_isConfirmDisplay_Load = true;
	
	_saveData_LoadConfirmed = saveData;
		
	int slotNum = _saveData_LoadConfirmed->GetSlotNum();
	string slotNumStr = to_string (slotNum);
	for ( int i = 0; i < 2 - slotNumStr.size(); ++i) {
		slotNumStr = "0" + slotNumStr;
	}
		
	_back_confirmWindow = sf::RectangleShape ( sf::Vector2f ( 400, 200 ) );
	_back_confirmWindow.setFillColor ( sf::Color ( 50,50,150,150 ) );
	_back_confirmWindow.setOutlineThickness (0.0f);
	_back_confirmWindow.setOutlineColor ( sf::Color ( 0,0,0,0 ) );
	_back_confirmWindow.setPosition ( sf::Vector2f ( APPLICATION::WINDOW_SIZE::WIDTH/2, APPLICATION::WINDOW_SIZE::HEIGHT/2 ) );
	_back_confirmWindow.setOrigin ( _back_confirmWindow.getGlobalBounds().width/2, _back_confirmWindow.getGlobalBounds().height/2 );
	
	_text_confirm = TextImageFactory::Create ( "[" + slotNumStr + "]番をロードします", 24);
	_text_confirm.setFillColor   ( sf::Color::White );
	_text_confirm.setOutlineColor( sf::Color::Black );
	_text_confirm.setOutlineThickness ( 1.0f );
	_text_confirm.setPosition ( 250, 250 );
	
	if ( _button_yes != NULL ) { delete  _button_yes; }
	if ( _button_no  != NULL ) { delete  _button_no; }
	
	_button_yes = new Button ( "する",     sf::Vector2f ( 150, 40 ), 24 );
	_button_no  = new Button ( "しない", sf::Vector2f ( 150, 40 ), 24 );
	_button_yes->SetPosition ( sf::Vector2f ( 235, 320 ) );
	_button_no ->SetPosition ( sf::Vector2f ( 405, 320 ) );
}

//=========================================================
// デストラクタ
//=========================================================
SaveDataManager::~SaveDataManager() {

	if ( _button_yes != NULL ) { delete  _button_yes; }
	if ( _button_no  != NULL ) { delete  _button_no; }

	delete _scrollBar;
	delete _closeButton;
	delete _progressBar;
}

//=========================================================
// 更新
//=========================================================
void SaveDataManager::Update ( sf::RenderWindow &window ) {
	
	///// 非表示なら、何もしませんよ
	if ( _mode == MODE_NONE ) {
		return;
	}
	
	if ( _isGetSaveDataListDone ) {
		
		///// 上書き確認中
		if ( _isConfirmDisplay_Save ) {
			
			_button_yes -> Update(window);
			_button_no  -> Update(window);

			///// NOボタン押下？
			if ( _button_no->IsRelease() ) {
			
				printf("上書きしない押下\n");
				_isConfirmDisplay_Save = false;
				_saveData_SaveConfirmed = NULL;
				return;
			}

			///// YESボタン押下？
			if ( _button_yes->IsRelease() ) {

				printf("上書き実行\n");
				_isConfirmDisplay_Save = false;
				
				SaveTo ( _saveData_SaveConfirmed  );
				//_scriptEngine->SystemMessage ( "保存しました" );
				
				_saveData_SaveConfirmed = NULL;
				
			}
			return;
		} 
		
		///// ロード確認中
		if ( _isConfirmDisplay_Load ) {
			
			_button_yes -> Update(window);
			_button_no  -> Update(window);

			///// NOボタン押下？
			if ( _button_no->IsRelease() ) {
			
				printf("ロードしない押下\n");
				_isConfirmDisplay_Load = false;
				_saveData_LoadConfirmed = NULL;
				return;
			}

			///// YESボタン押下？
			if ( _button_yes->IsRelease() ) {

				printf("ロード実行\n");
				_isConfirmDisplay_Load = false;
				
				LoadFrom ( _saveData_LoadConfirmed  );
				
				_saveData_LoadConfirmed = NULL;
				
			}
			return;
		} 
		
		
		
		// ホイールでスクロールしたい
		int mouseX = Application::GetInstance()->_mouseX;
		int mouseY = Application::GetInstance()->_mouseY;
		bool isMouseOver = 
		(
			mouseX > 0 && mouseX < APPLICATION::WINDOW_SIZE::WIDTH
			&&
			mouseY > 0 && mouseY < APPLICATION::WINDOW_SIZE::HEIGHT
		);
		if ( isMouseOver ) {
			int mouseWheel = Application::GetInstance()->_mouseWheel;
			_scrollBar->MoveUp(mouseWheel);
		}


		_scrollBar->Update ( window );
		

		//printf ("%d\n", _scrollBar->GetCurrentIndex());

		// 選んだかな？
		SaveData *selectedSaveData = NULL;

		for ( int i = 0; i < 5; ++i  ) {

			int index = i + _scrollBar->GetCurrentIndex();
			if ( index >= _saveDataList.size() ) {
				break;
			}

			_saveDataList[index]->SetPosition( sf::Vector2f( _position.x, _position.y + 50 + i * 100) );
			_saveDataList[index]->Update ( window );
			
			
			/*
				選択判定：押したときのデータと離したときのデータが同一であれば「選択した」ことにする
			*/
			if ( _saveDataList[index]->IsMousePushed() ) {
				_saveData_pushed = _saveDataList[index];
			}
			
			// 選んだかな？
			if ( _saveDataList[index]->IsMouseReleased() ) {
				
				if ( _saveDataList[index] == _saveData_pushed ) {
					selectedSaveData = _saveDataList[index];
				}
			}
			
			/*
			if ( _saveDataList[index]->IsSelected() ) {
				selectedSaveData = _saveDataList[index];
			}
			*/
		}

		///// 選んだかな？
		if ( selectedSaveData != NULL ) {


			if ( _mode == MODE_SAVE ) {

				bool isComitOk = true;

				// すでにデータがある。上書き確認
				if ( selectedSaveData->IsValid() ) {

					/*
						確認ダイアログでも出す？
					*/
					SetupConfirmWindow_Save ( selectedSaveData );
					
					//printf("上書きします\n");
					//isComitOk = true;

				} else {
					
					SaveTo ( selectedSaveData  );
					//_scriptEngine->SystemMessage("保存しました");
				
				}

				//if (isComitOk) {
				//	SaveTo ( selectedSaveData  );
				//}

			}
			else if ( _mode == MODE_LOAD ) {

				// 有効なデータ？
				if ( selectedSaveData->IsValid() ) {
					
					SetupConfirmWindow_Load ( selectedSaveData );
					
					//LoadFrom ( selectedSaveData  );
					
				} else {
					
					_scriptEngine->SystemMessage("無効なデータです");
					printf ("無効なデータ\n");
				}
			}

		}
	} else {
		_progressBar->SetValue_Forsibly ( _GetSaveData_ProgressRate );
		_progressBar->Update(window);
	}

	_closeButton->Update ( window );


	///// 右クリックで、非表示に戻る。
	if ( Application::GetInstance()->_mouseState_Right == MOUSE::BUTTON::STATE::RELEASE ) {
		SetMode ( MODE_NONE );
	}
	
	///// 閉じるボタンもあるよ
	if ( _closeButton->IsClick() ) {
		SetMode ( MODE_NONE );
	}

}


//=========================================================
// このセーブデータにセーブします
//=========================================================
void SaveDataManager::SaveTo ( SaveData *saveData ) {

	_scriptEngine->SaveTo ( saveData );
}

//=========================================================
// このセーブデータからロードします
//=========================================================
void SaveDataManager::LoadFrom ( SaveData *saveData ) {

	_scriptEngine->LoadFrom ( saveData );
}

//=========================================================
// 描画
//=========================================================
void SaveDataManager::Draw   ( sf::RenderWindow &window ) {

	///// 非表示なら、何もしませんよ
	if ( _mode == MODE_NONE ) {
		return;
	}
	


	if ( _isGetSaveDataListDone ) {
	
		for ( int i = 0; i < 5; ++i  ) {

			int index = i + _scrollBar->GetCurrentIndex();
			if ( index >= _saveDataList.size() ) {
				break;
			}

			_saveDataList[index]->Draw ( window );
		}
		
		
	} else {
		
		// 読み込み未完了
		_progressBar->Draw(window);
		
	}

	if ( _mode == MODE_SAVE ) {
		window.draw ( _modeLabel_Save.sprite );
		//window.draw ( _modeLabel_Save );
	}
	else if ( _mode == MODE_LOAD ) {
		window.draw ( _modeLabel_Load.sprite );
		//window.draw ( _modeLabel_Load );
	}

	if ( _scrollBar != NULL ) {
		_scrollBar->Draw ( window );
	}
	
	_closeButton->Draw ( window );
	
	if ( _isConfirmDisplay_Save || _isConfirmDisplay_Load ) {
		
		window.draw ( _back_confirmWindow );
		window.draw ( _text_confirm );
		_button_yes->Draw ( window );
		_button_no->Draw ( window );
	}
}

//=========================================================
// モードをセット
//=========================================================
void SaveDataManager::SetMode ( int mode ) {

	// うのみにしますよ。
	_mode = mode;
}








