//=========================================================
//
// セーブデータさんへのアクセスはこの私をお通し下さい。
//
//=========================================================

#ifndef _SAVE_DATA_MANAGER_
#define _SAVE_DATA_MANAGER_

#include <SFML/Graphics.hpp>

#include "../GUI_SFML/ScrollBar.h"
#include "../GUI_SFML/ProgressBar.h"

#include <thread>

class SaveData;
class ScriptEngine;
class ClickableImage;

class SaveDataManager {

public:

	//=========================================================
	// セーブ？ ロード？ キミは何がしたいんだい？
	//=========================================================
	static const int MODE_NONE; // つまり非表示
	static const int MODE_SAVE;
	static const int MODE_LOAD;

	SaveDataManager( ScriptEngine *scriptEngine );
	~SaveDataManager();

	void Update ( sf::RenderWindow &window );
	void Draw   ( sf::RenderWindow &window );

	void SetMode ( int mode );
	int  GetMode () { return _mode; }

private:

	struct Image_Set {
		sf::Image   image;
		sf::Texture texture;
		sf::Sprite  sprite;

		void Update() {
			texture.loadFromImage(image);
			sprite = sf::Sprite();
			sprite.setTexture(texture);
		}
	};
	
	///// 最初にセーブデータを読み込む処理のスレッド
	static unsigned int GetSaveDataList_Entrance ( void *obj );
	void                GetSaveDataList ();
	std::thread _getSaveDataList_ThreadHandle;
	bool _isGetSaveDataListDone;
	float _GetSaveData_ProgressRate;

	ScriptEngine *_scriptEngine;

	int _mode;

	sf::Vector2f _position;

	vector < SaveData* > _saveDataList;


	GUI_SFML::ScrollBar *_scrollBar;
	GUI_SFML::ProgressBar *_progressBar;
	
	Image_Set _modeLabel_Load;
	Image_Set _modeLabel_Save;

	//sf::Text _modeLabel_Load;
	//sf::Text _modeLabel_Save;
	
	
	 SaveData *_saveData_pushed; // 押したときのデータと離したときのデータが一致するとき「選択した」ことにする

	 
	///// 確認ウィンドウ関連
	bool _isConfirmDisplay_Save;
	bool _isConfirmDisplay_Load;
	GUI_SFML::Button *_button_yes;
	GUI_SFML::Button *_button_no;
	sf::Text _text_confirm;
	sf::RectangleShape _back_confirmWindow;	
	
	void SetupConfirmWindow_Save ( SaveData *saveData );
	void SetupConfirmWindow_Load ( SaveData *saveData );
	
	SaveData *_saveData_SaveConfirmed;
	SaveData *_saveData_LoadConfirmed;
	
	ClickableImage *_closeButton;  // 戻るボタンというか、機能的には閉じるボタン
		 
	//=========================================================
	// このセーブデータにセーブします
	//=========================================================
	void SaveTo ( SaveData *saveData );

	//=========================================================
	// このセーブデータからロードします
	//=========================================================
	void LoadFrom ( SaveData *saveData );

};
#endif







