//=========================================================
//
// スクリプトの処理ユニット
//
//=========================================================

#ifndef _SCRIPT_UNIT_
#define _SCRIPT_UNIT_

#include "../Utils/NotXML.h"
#include "Define.h"

struct ScriptUnit {

	//=========================================================
	// ユニットとしてのインターフェイス
	//=========================================================
	string type;           // 何の処理か？：SCRIPT::UNIT_TYPE::
	string label;          // このユニットについているラベル
	string nextUnitLabel;  // 次に処理するユニットのラベル：空文字＝順番通りに進める（デフォルト）

	//=========================================================
	// ユニットの種類ごとに固有のもの
	//=========================================================
	NotXML::Tag unitTag;   // 設定ファイルに書かれているユニットタグそのもの。解釈は type ごとに異なる。

	//=========================================================
	// コンストラクタ
	//=========================================================
	ScriptUnit () {
		type          = SCRIPT::UNIT_TYPE::NONE;
		label         = "";
		nextUnitLabel = "";
	}
};
#endif

