//=========================================================
//
// 選択肢リスト？
//
//=========================================================

#ifndef _SELECT_
#define _SELECT_

#include <SFML/Graphics.hpp>
#include <vector>
#include "../AI/Move.h"

using namespace std;

class SelectOption;
class IScenarioLogger;
class ScriptEngine;

class Select {

public:

	Select ( ScriptEngine *scriptEndine );
	~Select();

	void SetUpSelectOptions ( vector<SelectOption*> selectOptionList );

	void Update ( sf::RenderWindow &window );
	void Draw   ( sf::RenderWindow &window );

	//=========================================================
	// 選択された選択肢のジャンプ先ラベルを取得：未選択なら空文字
	//=========================================================
	string GetSelectOption();
	string GetSelectText(); // ログに出すときには文字列が欲しい
	string GetMouseoverOptionJumpLabel();

	//=========================================================
	// クリア
	//=========================================================
	void Clear();


	//=========================================================
	// セーブ/ロード用のインターフェイス
	//=========================================================
	struct SaveData {

		vector <pair < string, string> > optionList; // pair < 文言, 飛び先ラベル > のリスト。順番を保存したいので mapではない。
		vector <AI_Modules::Move> moveList;
		/*
			ロード時には、上記の情報を使って、自前で、SetUpSelectOptions を呼び出す。
		*/

		int positionX;
		int positionY;
		string gameBoardId;
	};
	SaveData GetSaveData ();
	void Load ( SaveData &saveData );

	void SetScenarioLogger(IScenarioLogger *obj) { _scenarioLogger = obj; }

	// どうしても表示位置を動かしたい場合がある。口出しモードのときとか。
	void Move ( float x, float y  );

	// 選択肢設定前に設定のこと
	void SetRowGap ( int arg ) { _rowGap = arg; }

    void SetGameBoardId ( string gameBoardId ) { _gameBoardId = gameBoardId ;}



private:

	// インスタンスが欲しい。。。
	ScriptEngine *_scriptEngine;

	///// 表示位置：外部からは受け取らない。内部で、表示内容に合わせて、よきにはからう。
	sf::Vector2f _position;

	///// 表示位置：中央からの相対位置。
	sf::Vector2f _position_FromCenter;
	sf::Vector2f _position_FromCenter_default; // の、デフォルト値

	///// 表示位置：セーブ/ロード用の保存値
    int _posX_forSave;
    int _posY_forSave;


	///// 選択肢リストですよね？ うんうん。
	vector<SelectOption*> _selectOptionList;

	///// 行間？
	int _rowGap;


	string _gameBoardId;


	IScenarioLogger *_scenarioLogger;


};
#endif
