//=========================================================
//
// 効果音管理クラス
//
//=========================================================

#ifndef _SOUND_MANAGER_FOR_SCRIPT_ENGINE_
#define _SOUND_MANAGER_FOR_SCRIPT_ENGINE_

#include <map>
#include <vector>
#include <SFML/Audio.hpp>

using namespace std;

class SoundManager {

public:

	SoundManager();
	~SoundManager();

	void Play ( string fileName, bool preload = false );
	void Play_FromLabel ( string label, bool preload = false  );

	void Regist ( string label, string fileName );
	
	void SetVolume ( float value );
	float GetVolume();


	//=========================================================
	// セーブ/ロード用のインターフェイス
	//=========================================================
	struct SaveData {

		//map < string, string> labelList;           // ラベルリスト 
	};
	SaveData GetSaveData ();
	void Load ( SaveData &saveData );

private:
	
	///// バッファリスト。
	map < string, sf::SoundBuffer* > _soundBufferList;

	///// 実際に音を出すためのチャンネルとして。
	vector < sf::Sound* > _soundList;


	///// ラベルリスト： < ラベル文字列, ファイル名 >
	map <string, string> _labelList;
	
	///// 音量
	float _volume;
};
#endif
