//=========================================================
//
// テキストラベル
//
//=========================================================

#ifndef _TEXT_LABEL_
#define _TEXT_LABEL_

#include "IDrawable.h"

#include <./SFML/Graphics.hpp>

using namespace std;

class TextLabel : public IDrawable {

public:
	
	TextLabel(string name);
	~TextLabel();
	
	void Update(sf::RenderWindow &window, sf::Vector2f pos);
	void Update(sf::RenderWindow &window);
	void Draw(sf::RenderWindow &window);
	
	void SetText ( string text, sf::Font &font );
	void SetText ( string text );
	string GetText () { return _string; }
	
	void SetFont ( sf::Font &font );
	
	void SetColor    ( sf::Color color );
	void SetColor    ( string color );
	void SetSize     ( int size );
	void SetPosition ( sf::Vector2f pos );
	sf::Vector2f GetPosition () { return _text.getPosition(); }
	
	
	sf::Vector2f GetBoundarySize ();

	
	//=========================================================
	// セーブ/ロード用のインターフェイス
	//=========================================================
	struct SaveData {
		
		string name;
		sf::Vector2f position;
		int size;
		sf::Color color;
		string text;
	};
	SaveData GetSaveData (); // ロードはScriptEngine側で担当してもらう。
	
private:
	
	sf::Text _text;
	
	// 管理用・ロード時に戻すためのもの。
	string _name;
	string _string;
	
};

#endif











