//=========================================================
//
// Effect_BattleLose
//
//=========================================================

#include "Effect_BattleLose.h"
#include "../GUI_SFML/TextImageFactory.h"
#include <Define.h>
#include "../Utils/Utils_Cal.h"

const int Effect_BattleLose::STATE_TO_GOAL1 = 0;
const int Effect_BattleLose::STATE_GOAL1    = 1;
const int Effect_BattleLose::STATE_TO_GOAL2 = 2;
const int Effect_BattleLose::STATE_GOAL2    = 3;


//=========================================================
// コンストラクタ
//=========================================================
Effect_BattleLose::Effect_BattleLose() {

	_isEnd = false;
	_state = STATE_TO_GOAL1;
	_frameCount = 0;

	_message_Texture.loadFromFile ( "./image/gameBoard/roundCall_lose.png" );
	_message_Sprite.setTexture ( _message_Texture );
	_message_Sprite.setOrigin (
		_message_Sprite.getGlobalBounds().width/2, _message_Sprite.getGlobalBounds().height/2
	);
	
/*
	_shape = sf::RectangleShape ( sf::Vector2f (200, 70) );
	_shape.setOutlineColor ( sf::Color(255,255,255,255) );
	_shape.setOutlineThickness ( 2.0f );
	_shape.setFillColor ( sf::Color ( 255,255,0, 150 ) );
	_shape.setOrigin ( _shape.getSize().x / 2, _shape.getSize().y / 2);

	TextImageFactory::Create ( _message_Image, "LOSE", 30, sf::Color(0,0,255,255) );
	_message_Texture.loadFromImage ( _message_Image );
	_message_Sprite.setTexture (_message_Texture);
	_message_Sprite.setOrigin ( _message_Image.getSize().x / 2, _message_Image.getSize().y / 2 );
*/

	_position_Current = sf::Vector2f( -200,                                  APPLICATION::WINDOW_SIZE::HEIGHT / 2  -60);
	_position_Goal1   = sf::Vector2f( APPLICATION::WINDOW_SIZE::WIDTH / 2  , APPLICATION::WINDOW_SIZE::HEIGHT / 2  -60);
	_position_Goal2   = sf::Vector2f( APPLICATION::WINDOW_SIZE::WIDTH + 200, APPLICATION::WINDOW_SIZE::HEIGHT / 2  -60);

}

//=========================================================
// デストラクタ
//=========================================================
Effect_BattleLose::~Effect_BattleLose() {


}

//=========================================================
// 更新
//=========================================================
bool Effect_BattleLose::Update(sf::RenderWindow &window) {

	if (_isEnd) {
		return _isEnd;
	}
	++_frameCount;


	///// 状態１：画面中央へ
	if ( _state == STATE_TO_GOAL1 ) {

		pair<float, float> moveResult = 
			Utils_Cal::MoveTo ( _position_Current.x, _position_Current.y, _position_Goal1.x, _position_Goal1.y, 40 );

		_position_Current.x = moveResult.first;
		_position_Current.y = moveResult.second;

		if ( _position_Current == _position_Goal1 ) {
			_state = STATE_GOAL1;
			_frameCount = 0;
		}

	///// 状態２：画面中央
	} else if ( _state == STATE_GOAL1 ) {

		if ( _frameCount > 30 ) {
			_state = STATE_TO_GOAL2;
			_frameCount = 0;
		}

	///// 状態３：画面右へ去る
	} else if ( _state == STATE_TO_GOAL2 ) {

		pair<float, float> moveResult = 
			Utils_Cal::MoveTo ( _position_Current.x, _position_Current.y, _position_Goal2.x, _position_Goal2.y, 40 );

		_position_Current.x = moveResult.first;
		_position_Current.y = moveResult.second;

		if ( _position_Current == _position_Goal2 ) {
			_state = STATE_GOAL2;
			_frameCount = 0;
		}

	///// 状態４：画面右へ去った後
	} else if ( _state == STATE_GOAL2 ) {
		_isEnd = true;
	}

	//_shape.setPosition ( _position_Current );
	_message_Sprite.setPosition ( _position_Current );

	return _isEnd;
}

//=========================================================
// 描画
//=========================================================
void Effect_BattleLose::Draw(sf::RenderWindow &window) {

	//window.draw ( _shape );
	window.draw ( _message_Sprite );
}





