//=========================================================
//
// カットインエフェクト実験
//
//=========================================================

#include "IEffect.h"

#include <./SFML/Graphics.hpp>
#include "../GUI_SFML/Animation.h"
#include "../GUI_SFML/TextMessageWindow.h"
#include <string>

using namespace std;


class Effect_CuiInTest002 : public IEffect {

public:

	Effect_CuiInTest002();
	~Effect_CuiInTest002();

	bool Update(sf::RenderWindow &window);
	void Draw(sf::RenderWindow &window);


	GUI_SFML::TextMessageWindow *_textMessageWindow;

private:

	struct ImageSet {

		sf::Image   image;
		sf::Texture texture;
		sf::Sprite  sprite;

		ImageSet () {
		}
		ImageSet( string file ) {
			image.loadFromFile(file);
			texture.loadFromImage(image);
			sprite.setTexture(texture);
		}

		void ToCenter() {
			sprite.setOrigin ( image.getSize().x / 2, image.getSize().y / 2 );
		}

	};

	bool _isEnd;

	GUI_SFML::Animation *_animationBack;


	int _frameCount;

	ImageSet _imageBack;
	sf::IntRect _rect_Back;
	sf::Vector2f _positionBack;


	ImageSet _imageFace;
	sf::Vector2f _positionFace;

	string _state;


	
};

