//=========================================================
//
// カットインエフェクト：COME_AND_GO
//
//=========================================================

#include "IEffect.h"

#include <./SFML/Graphics.hpp>
#include "../GUI_SFML/Animation.h"
#include "../GUI_SFML/TextMessageWindow.h"
#include <string>
#include <map>
#include "Delegate.h"

using namespace std;


class Effect_CutIn_COME_AND_GO : public IEffect {

public:

	Effect_CutIn_COME_AND_GO ( DelegateBase *endMethod, int effectLevel, GUI_SFML::TextMessageWindow *textMessageWindow, map<string, string> parameters );
	~Effect_CutIn_COME_AND_GO ();

	bool Update(sf::RenderWindow &window);
	void Draw(sf::RenderWindow &window);

private:

	struct ImageSet {

		sf::Image   image;
		sf::Texture texture;
		sf::Sprite  sprite;

		ImageSet () {
		}
		ImageSet( string file ) {
			image.loadFromFile(file);
			texture.loadFromImage(image);
			sprite.setTexture(texture);
		}

		void ToCenter() {
			sprite.setOrigin ( image.getSize().x / 2, image.getSize().y / 2 );
		}

	};

	bool _isEnd;
	int  _frameCount;

	ImageSet _imageBack;
	sf::IntRect _rect_Back;
	sf::Vector2f _positionBack;


	ImageSet _imageFace;
	sf::Vector2f _positionFace;

	string _state;

	///// 終了時に呼ぶメソッド：つまり着手・エフェクトレベル(int) を１つ渡すメソッド。
	DelegateBase *_endMethod;
	int           _effectLevel;

	///// 移動方向
	string _direction;

	// 開始位置 / 終了位置
	sf::Vector2f _position_Start;
	sf::Vector2f _position_End;

	// パート2として停止する位置(X)
	int _part2StayPositionX;

	// 全体の位置Y
	int _positionY;

	// 背景として使用する画像
	string _backImageFile;
	int    _backImageAlpha;

	// キャラ画像・パート1〜3用
	sf::Color _fameImageMask;
	string _faceImageFile1;
	string _faceImageFile2;
	string _faceImageFile3;

	// セリフ・パート1〜3開始時
	string _phrase1;
	string _phrase2;
	string _phrase3;

	// 効果音・パート1〜3開始時
	string _sound1;
	string _sound2;
	string _sound3;

	// 1フレーム毎の移動増分（速度）
	int _speed1to2;
	int _speed2;
	int _speed2to3;

	// パート2に停止しているフレーム数
	int _part2FrameCount;

	// 追加アニメーションエフェクト・ファイル名で指定・パート1〜3開始時
	string _animation1;
	string _animation2;
	string _animation3;
	
	// セリフの名札
	string _nameLabel = "";

	// テキスト欄
	GUI_SFML::TextMessageWindow *_textMessageWindow;

	//=========================================================
	// 各パートの開始準備処理
	//=========================================================
	void Preparation_forPart1();
	void Preparation_forPart2();
	void Preparation_forPart3();
	
};

