//=========================================================
//
// 画面ゆれ
//
//=========================================================

#ifndef _EFFECT_SHAKE_
#define _EFFECT_SHAKE_

#include "IEffect.h"
#include "../GUI_SFML/TextMessageWindow.h"

class Camera;

class Effect_Shake : public IEffect {

public:

	struct Property {
		
		int frameCount;
		sf::RenderWindow *window;
		int magnitude;
		int interval;
		string *isShakeEnd;
		
		Camera *camera;
		GUI_SFML::TextMessageWindow *textWindow;
		
		Property() {
			magnitude  = 20;
			frameCount = 30;
			interval = 0;
			isShakeEnd = NULL;
			camera = NULL;
			textWindow = NULL;
		}
	};

	Effect_Shake ( Property prop );
	~Effect_Shake();

	bool Update(sf::RenderWindow &window);
	void Draw(sf::RenderWindow &window);
	
	
	///// テキスト欄にも揺れを反映させたいので、テキスト欄側から取得するための迂回データ。もう適当。
	static int _shakeXforTheWorld;
	static int _shakeYforTheWorld;

private:

	Property _prop;
	bool _isEnd;

	int _frameCount;
	int _interval;
	
	//sf::View _originalView;    // 終了時に戻すもの
	sf::View _viewOfBeginning; // エフェクト開始時のビュー
	

};
#endif

