//=========================================================
//
// 簡易パーティクル
//
//=========================================================

#ifndef _EFFECT_SIMPLE_PARTICLE_
#define _EFFECT_SIMPLE_PARTICLE_

#include "IEffect.h"
#include <SFML/Graphics.hpp>

class Effect_SimpleParticle : public IEffect {

public:

	struct Property {

		string imageFile;
		string imageMask;
		bool   imageAlphaGenerate_baseBlack; // 黒っぽいところほど透明にする処理

		sf::Color color_Start;
		sf::Color color_End;
		int totalFrameCount;

		sf::Vector2f position;


		Property() {
			imageFile = "";
			totalFrameCount = 0;
			imageMask  = "";
			imageAlphaGenerate_baseBlack = false;
		}
	};

	Effect_SimpleParticle ( Property prop );
	~Effect_SimpleParticle();

	bool Update(sf::RenderWindow &window);
	void Draw(sf::RenderWindow &window);



private:

	struct ImageSet {
		
		sf::Image   image;
		sf::Texture texture;
		sf::Sprite  sprite;

	};

	bool      _isEnd;
	Property  _prop;
	ImageSet  _imageSet;
	int       _currentFrameCount;

	// 1フレームごとに加算する値
	float _color_frameAddingAmount_r;
	float _color_frameAddingAmount_g;
	float _color_frameAddingAmount_b;
	float _color_frameAddingAmount_a;

};

#endif
