//=========================================================
//
// カードの裏側に説明文が書いてある、というイメージで。
//
//=========================================================

#ifndef _CARD_BACK_DISPLAY_PANEL_
#define _CARD_BACK_DISPLAY_PANEL_

#include "Card.h"

#include <SFML/Graphics.hpp>

#include <IDrawable.h>

class CardBackDisplayPanel : public IDrawable {

public:

	struct MiniGrid {

		sf::RectangleShape shape;

		sf::Vector2f size;

		sf::Image   *moveDirectionImage;
		sf::Texture  moveDirectionTexture;
		sf::Sprite   moveDirectionSprite;
		
		MiniGrid() {
			size = sf::Vector2f( 12.0f,  12.0f);
			moveDirectionImage = NULL;
		}

	};

	CardBackDisplayPanel();
	~CardBackDisplayPanel();

	void SetCardProperty(Card::Property cardProp);

	void Show();
	void Hide();

	void Update(sf::RenderWindow &window, sf::Vector2f position) { Update( window ); } // IDrawable としてインターフェイスをそろえるためのもの。
	void Update(sf::RenderWindow &window);
	void Draw(sf::RenderWindow &window);
	void DrawActual(sf::RenderWindow &window);

	string GetCurrentShowingCardName();

private:

	sf::RectangleShape _panelBase_Shape;
	map<int, map<int, MiniGrid>> _gridList;

	sf::Vector2f _position;

	Card::Property _currentShowingCardProp;

	bool _isShow;

	//=========================================================
	// MiniGrid を生成
	//=========================================================
	MiniGrid GenerateMiniGrid_Blank();
	MiniGrid GenerateMiniGrid_Card();
	MiniGrid GenerateMiniGrid_Througable( int modeDirection = 0 );

};
#endif
