//=========================================================
//
// カード置き場
//
//=========================================================

#ifndef _CARD_BOX_
#define _CARD_BOX_

#include <SFML/Graphics.hpp>

#include <vector>

using namespace std;

class Card;

class CardBox {

public:

	//=========================================================
	// 同じ種類のカードをまとめておく入れ物
	//=========================================================
	struct CardFolder {
		vector<Card*> cardList;
	};

	CardBox( bool isDisplayReverse = false );
	~CardBox();

	void Update(sf::RenderWindow &window, sf::Vector2f pos);
	void Draw(sf::RenderWindow &window);

	//void AddPiece(Card *obj) { _cardList.push_back( obj ); }
	void AddCard(Card *obj);

	vector<int> GetAllCardIdList();
	Card* TakeCard( int cardId );
	Card* TakeCard( Card *obj );

	string Output();
	void Read( string data );

	void SetAutonomous ( bool arg ) { _isAutonomous = arg; }
	bool IsAutonomous  ()           { return _isAutonomous; }

	vector<Card*> GetAllCards();

	int GetBoxWidth () { return _boxSize.x; }
	int GetBoxHeight() { return _boxSize.y; }

	sf::Vector2f GetPosition () { return _box.getPosition(); }

private:

	sf::RectangleShape _box;
	sf::Vector2f _boxSize;
	bool _isDisplayReverse;

	//vector<Card*> _cardList;
	vector<CardFolder> _cardFolderList;

	bool _isMouseOver;
	Card *_mouseOverCard;

	bool _isAutonomous;

	//=========================================================
	// マウスオーバー判定
	//=========================================================
	void MouseOverCheck();

	//=========================================================
	// カードを消す（オブジェクトを指定）
	//=========================================================
	void RemoveCard( Card *obj );

	//=========================================================
	// 自治処理
	//=========================================================
	void AutonomousUpdate ( sf::RenderWindow &window );
};
#endif













