//=========================================================
//
// カード生成管理
//
//=========================================================

#ifndef _CARD_FACTORY_
#define _CARD_FACTORY_

#include <map>
#include <set>

//#include <SFML/Graphics.hpp>

using namespace std;

#include "Card.h"

class CardFactory {

public:

	///// 最初に呼ぶ。設定ファイルを読み込む
	static void Init();

	///// 最後に呼ぶ。カードを解放する。
	static void Release();

	///// カードをオブジェクト指定で解放
	static void Release( Card *obj );

	///// カードをください
	static Card* GetCard( string cardName );

	///// オブジェクトの存在を確認：まだある？ 解放されてる？
	static bool IsExist ( Card *obj );

	///// ちょっと、プロパティを見せて
	static Card::Property GetCardProperty ( int cardID );

	static map<string, int> _cardName_cardId_mapping;
	static map<int, Card::Property> _cardPropertyList;

	///// カード名からIDを参照
	static int GetCardID ( string cardName );
	

private:


	// 生成したカードリスト。後でまとめて解放したり。
	static set<Card*> _generatedCardList;



	//=========================================================
	// 文字列 → sf::Color
	//=========================================================
	//static sf::Color String_to_sfColor(string str, string splitter = ",");

	//=========================================================
	// 文字列 → DIRECTION
	//=========================================================
	static int String_to_DIRECTION(string str);
};
#endif

