//=========================================================
//
// 駒
//
//=========================================================

#ifndef _PIECE_
#define _PIECE_

#include <SFML/Graphics.hpp>

#include "IMouseClingableObject.h"
#include "IDrawable.h"

class Piece : public IMouseClingableObject, public IDrawable {

public:

	//=========================================================
	// 駒の色
	//=========================================================
	struct Color {

		static const int BLACK = 1;
		static const int WHITE = 2;

	};

	//=========================================================
	// プロパティ
	//=========================================================
	struct Property {

		int color;
		float size;

		Property() {
			color = Color::BLACK;
			size = 10;
		}
	};

	Piece( int color );
	~Piece();

	void Update(sf::RenderWindow &window, sf::Vector2f pos);
	void Draw(sf::RenderWindow &window);
	void DrawActual(sf::RenderWindow &window);

	void DrawDemonstration(sf::RenderWindow &window, sf::Vector2f pos);
	void DrawLastCollidedHighlight();

	int GetColor() { return _prop.color; }

	void         SetPosition ( sf::Vector2f pos);
	sf::Vector2f GetCurrentPosition () { return _position_Current;}
	sf::Vector2f GetGoalPosition    () { return _position_Goal;}

	bool IsMouseOver() { return _isMouseOver; }

	float GetMouseDrawOffsetX() { return 0.0f; }
	float GetMouseDrawOffsetY() { return 0.0f; }


	void SetOffset ( int x, int y ) { _position_Offset.x = x; _position_Offset.y = y; }
	void SetOffsetX ( int x ) { _position_Offset.x = x; }
	void SetOffsetY ( int y ) { _position_Offset.y = y; }
	sf::Vector2f GetOffset() { return _position_Offset; }

	bool IsMovingStop() { return ( _position_Current == _position_Goal ); }
	
	// 現在のびよーんを省略せよ（このときだけ）
	void WarpToGoal() { _isWarpToGoal = true; }
	
private:

	Property _prop;
	/*
	sf::CircleShape _pieceBlack;
	sf::CircleShape _pieceWhite;

	sf::Sprite  _nameLabel_Sprite;
	sf::Texture _nameLabel_Texture;
	sf::Image   _nameLabel;
	*/

	sf::Sprite  _sprite;
	sf::Texture _texture_Black;
	sf::Texture _texture_White;
	
	sf::CircleShape _shape_lastCollidedHighlight;

	sf::Vector2f _position_Goal;    // あるべき位置
	sf::Vector2f _position_Current; // 実際の位置
	sf::Vector2f _position_Offset;  // オフセット

	bool _isMouseOver;
	
	
	bool _isWarpToGoal;
	
	bool _isReservedToDrawLastCollidedHighlight; 
	void DrawLastCollidedHighlight(sf::RenderWindow &window);
	

	//=========================================================
	// マウスオーバー判定
	//=========================================================
	void MouseOverCheck();

};

#endif


