//=========================================================
//
// 駒置き場
//
//=========================================================

#ifndef _PIECE_BOX_
#define _PIECE_BOX_

#include <SFML/Graphics.hpp>

#include <vector>

using namespace std;

class Piece;

class PieceBox {

public:

	PieceBox();
	~PieceBox();

	void Update(sf::RenderWindow &window, sf::Vector2f pos);
	void Draw(sf::RenderWindow &window);

	void AddPiece(Piece *obj) { _pieceList.push_back( obj ); }

	int GetNumberOfPieces() { return  _pieceList.size(); }

	Piece* TakePiece();             // 一つ取り出す
	Piece* TakePiece( Piece *obj ); // オブジェクトを指定して、一つ取り出す

	vector<Piece*> GetPieceList() { return _pieceList;}

	string Output();
	void Read( string data );

	bool IsMouseOver() { return _isMouseOver; }

	void SetAutonomous ( bool arg ) { _isAutonomous = arg; }
	bool IsAutonomous  ()           { return _isAutonomous; }

	int GetBoxWidth () { return _boxSize.x; }
	int GetBoxHeight() { return _boxSize.y; }
	
	sf::Vector2f GetPosition () { return _box.getPosition(); }

private:

	sf::RectangleShape _box;
	sf::Vector2f _boxSize;

	vector<Piece*> _pieceList;

	bool _isMouseOver;
	Piece *_mouseOverPiece;

	bool _isAutonomous;

	//=========================================================
	// マウスオーバー判定
	//=========================================================
	void MouseOverCheck();

	//=========================================================
	// 駒を消す（オブジェクトを指定）
	//=========================================================
	void RemovePiece( Piece *obj );

	//=========================================================
	// 自治処理
	//=========================================================
	void AutonomousUpdate ( sf::RenderWindow &window );
};

#endif






