//=========================================================
//
// 投了ボタン
//
//=========================================================

#ifndef _RESIGN_BUTTON_
#define _RESIGN_BUTTON_

#include <SFML/Graphics.hpp>
#include <string>

#include "../GUI_SFML/Button.h"

//#include "../Utils/Utils_Cal.h"

class ClickableImage;

using namespace std;
using namespace GUI_SFML;

class ResignButton {

public:

	ResignButton();
	~ResignButton();
	
	
	void Update ( sf::RenderWindow &window );
	void Draw   ( sf::RenderWindow &window );
	
	void SetActive ( bool arg );
	
	bool IsResignDesided() { return _isResignDecided; }
	
	bool IsComfirmWindowDisplaying();
	
	void SetPosition ( int x, int y );
	void SetPositionX ( int x );
	void SetPositionY ( int y );
	void SetPositionToDefault ();
	
private:
	
	/*
		状態：
			・表示しない
			・投了ボタンを表示中（受付中）
			・確認ウィンドウを表示中（受付中）
	*/
	string _state;
	
	static const string STATE_HIDDEN;
	static const string STATE_RESIGN_BUTTON;
	static const string STATE_CONFIRM_WINDOW;
	
	ClickableImage *_resignButton;
	
	sf::RectangleShape _rectForConfirmWindow;
	sf::Text           _labelForConfirmWindow;
	
	Button *_buttonYes;
	Button *_buttonNo;
	
	sf::Vector2f _defaultPosition;
	
	bool _isResignDecided;
	
};
#endif


