//=========================================================
//
// シーンインターフェイス（宣言）
//
//=========================================================

#ifndef _ISCENE_
#define _ISCENE_

#include <string>

using namespace std;

namespace SCENE {

	namespace UPDATE_RESULT {
		const int UPDATE_RESULT_NONE = 0;
		const int UPDATE_RESULT_CHANGE_SCENE = 1;
		const int UPDATE_RESULT_END_APPLICATION = 2;
	}
	
	namespace STATE {

		const int STOP = 0;
		const int RUN  = 1;

	};
};

class IScene {

public:


	virtual ~IScene(){}
	virtual int Update(sf::RenderWindow &window) = 0;
	virtual void Draw(sf::RenderWindow &window) = 0;
	virtual void Ready(sf::RenderWindow &window) = 0;
	virtual void Clear(sf::RenderWindow &window) = 0;
	virtual bool IsRendered() { return true; }
	
	virtual string GetNextScene() {
		return _nextScene;
	}


protected:

	string _nextScene;
	int _state;
};

#endif

