//=========================================================
//
// Util_Convert (declare)
//
//=========================================================


#ifndef _UTIL_CONVERT_
#define _UTIL_CONVERT_

#include <map>
#include <vector>
#include <string>

//#include <SFML/Window.hpp>
//#include <SFML/Graphics.hpp>


using namespace std;

class Utils_Convert {

public:

	//=========================================================
	// string -> int
	//=========================================================
	static int String_to_Int( string str, int defaultValue = 0 );
	static long String_to_Long( string str, long defaultValue = 0 );

	//=========================================================
	// int -> string
	//=========================================================
	static string Int_to_String( int arg );
	static string Long_to_String( long arg );

	//=========================================================
	// string -> float
	//=========================================================
	static float String_to_Float( string str, float defaultValue = 0.0f );

	//=========================================================
	// float -> string
	//=========================================================
	static string Float_to_String( float arg );

	//=========================================================
	// 文字列 → sf::Color
	//=========================================================
	//static sf::Color String_to_sfColor(string str, string splitter = ",");

	//==========================================================
	// string -> bool
	//==========================================================
	static bool String_to_bool( string str );

	//==========================================================
	// bool -> string
	//==========================================================
	static string Bool_to_string( bool arg );


	//=========================================================
	// map < string, string > -> string
	//=========================================================
	static string map_string_string_to_string ( map < string, string > src );

	//=========================================================
	// string -> map < string, string >
	//=========================================================
	static  map < string, string > string_to_map_string_string ( string src );


	//=========================================================
	// map < string, string > -> string
	//=========================================================
	static string pairList_string_string_to_string ( vector < pair < string, string > > src );

	//=========================================================
	// string -> vector < pair < string, string > >
	//=========================================================
	static  vector < pair <string, string > > string_to_pairList_string_string ( string src );


	//=========================================================
	// string -> map<string, string>
	//=========================================================
	static map<string, string> ReadStringAsMap ( string &src, string delimiter = ",", string equal = "=" );

	//=========================================================
	// vector<string> -> comma separated string
	//=========================================================
	static string vectorString_to_string ( vector<string> &list, string delimiter = "," );

	//=========================================================
	// vector<int> -> comma separated string
	//=========================================================
	static string vectorInt_to_string ( vector<int> &list, string delimiter = "," );
	
	
	//=========================================================
	// UNIXタイムスタンプ文字列から日付情報を取得
	//=========================================================
	static map<string, int> String_to_TimeInfo ( string unixTimestamp );
	static map<string, int> Long_to_TimeInfo ( long unixTimestamp );
	
	
};
#endif
